/**
 * @preserve
 * LIGHTSTREAMER - www.lightstreamer.com
 * Lightstreamer Web Client
 * Version 9.0.0-beta.6+20230622
 * Copyright (c) Lightstreamer Srl. All Rights Reserved.
 * Contains: LightstreamerClient, Subscription, ConsoleLogLevel,
 * ConsoleLoggerProvider, Logger, LoggerProvider, ClientListener,
 * ClientMessageListener, ItemUpdate, SubscriptionListener
 * UMD
 */
!function(t,e){var s,i=(s=function(t){"use strict";"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self&&self;var e,s={exports:{}};
/* @preserve
	 * JSONPatch.js
	 *
	 * A Dharmafly project written by Thomas Parslow
	 * <tom@almostobsolete.net> and released with the kind permission of
	 * NetDev.
	 *
	 * Copyright 2011-2013 Thomas Parslow. All rights reserved.
	 * Permission is hereby granted,y free of charge, to any person obtaining a copy
	 * of this software and associated documentation files (the "Software"), to
	 * deal in the Software without restriction, including without limitation the
	 * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
	 * sell copies of the Software, and to permit persons to whom the Software is
	 * furnished to do so, subject to the following conditions:
	 *
	 * The above copyright notice and this permission notice shall be included in
	 * all copies or substantial portions of the Software.
	 *
	 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
	 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
	 * IN THE SOFTWARE.
	 *
	 * Implements the JSON Patch IETF RFC 6902 as specified at:
	 *
	 *   http://tools.ietf.org/html/rfc6902
	 *
	 * Also implements the JSON Pointer IETF RFC 6901 as specified at:
	 *
	 *   http://tools.ietf.org/html/rfc6901
	 *
	 */
e=s,function(t,s){s(e.exports)}(0,(function(t){var e,s,i,n;function r(t){Error.call(this,t),this.message=t}function a(t){Error.call(this,t),this.message=t}function o(t){var e,s;if(n(t))return t.slice();if(null===t)return t;if("object"==typeof t){for(s in e={},t)Object.hasOwnProperty.call(t,s)&&(e[s]=t[s]);return e}return t}function h(t,e){var s;if(t===e)return!0;if(typeof t!=typeof e)return!1;if("object"==typeof t){var i=n(t);if(i!==n(e))return!1;if(i){if(t.length!=e.length)return!1;for(var r=0;r<t.length;r++)if(!h(t[r],e[r]))return!1;return!0}for(s in t)if(Object.hasOwnProperty(t,s)&&(!Object.hasOwnProperty(e,s)||!h(t[s],e[s])))return!1;for(s in e)if(Object.hasOwnProperty(e,s)&&!Object.hasOwnProperty(t,s))return!1;return!0}return!1}function l(t){var e,s;if(!t.op)throw new r("Operation missing!");if(!i.hasOwnProperty(t.op))throw new r("Invalid operation!");if(!("path"in t))throw new r("Path missing!");for(s=i[t.op],e=0;e<s.length;e++)if(!(s[e]in t))throw new r(t.op+" must have key "+s[e])}function c(t,e){l(t);var i=t.op,n=new s(t.path),o=t.value,c=t.from?new s(t.from):null;switch(i){case"add":return function(t){return n.add(t,o,e)};case"remove":return function(t){return n.remove(t,e)};case"replace":return function(t){return n.replace(t,o,e)};case"move":if(n.subsetOf(c))throw new r("destination must not be a child of source");return function(t){var s=c.get(t),i=c.remove(t,e);return n.add(i,s,e)};case"copy":return function(t){var s=c.get(t);return n.add(t,s,e)};case"test":return function(t){if(!h(n.get(t),o))throw new a("Test operation failed. Value did not match.");return t}}}n=Array.isArray||function(t){return"[object Array]"==Object.prototype.toString.call(t)},t.apply_patch=function(t,s){return new e(s).apply(t)},t.InvalidPatch=r,r.prototype=new Error,t.PatchApplyError=a,a.prototype=new Error,t.JSONPointer=s=function(t){var e,s,i=[];if(""!==(s=t.split("/"))[0])throw new r("JSONPointer must start with a slash (or be an empty string)!");for(e=1;e<s.length;e++)i[e-1]=s[e].replace(/~1/g,"/").replace(/~0/g,"~");this.path=i,this.length=i.length},s.prototype._get_segment=function(t,e){var s=this.path[t];if(n(e))if("-"===s)s=e.length;else{if(!s.match(/^0$|^[1-9][0-9]*$/))throw new a("Expected a number to segment an array");s=parseInt(s,10)}return s},s.prototype._action=function(t,e,s){var i=this;function r(t,h){var l,c;if(s||(t=o(t)),l=i._get_segment(h,t),h==i.path.length-1)t=e(t,l);else{if(n(t)){if(t.length<=l)throw new a("Path not found in document")}else{if("object"!=typeof t)throw new a("Path not found in document");if(!Object.hasOwnProperty.call(t,l))throw new a("Path not found in document")}c=r(t[l],h+1),s||(t[l]=c)}return t}return r(t,0)},s.prototype.add=function(t,e,s){return 0===this.length?e:this._action(t,(function(t,s){if(n(t)){if(s>t.length)throw new a("Add operation must not attempt to create a sparse array!");t.splice(s,0,e)}else t[s]=e;return t}),s)},s.prototype.remove=function(t,e){if(0!==this.length)return this._action(t,(function(t,e){if(!Object.hasOwnProperty.call(t,e))throw new a("Remove operation must point to an existing value!");return n(t)?t.splice(e,1):delete t[e],t}),e)},s.prototype.replace=function(t,e,s){return 0===this.length?e:this._action(t,(function(t,s){if(!Object.hasOwnProperty.call(t,s))throw new a("Replace operation must point to an existing value!");return n(t)?t.splice(s,1,e):t[s]=e,t}),s)},s.prototype.get=function(t){var e;return 0===this.length?t:(this._action(t,(function(t,s){if(!Object.hasOwnProperty.call(t,s))throw new a("Path not found in document");return e=t[s],t}),!0),e)},s.prototype.subsetOf=function(t){if(this.length<=t.length)return!1;for(var e=0;e<t.length;e++)if(t.path[e]!==this.path[e])return!1;return!0},i={add:["value"],replace:["value"],test:["value"],remove:[],move:["from"],copy:["from"]},t.JSONPatch=e=function(t,e){this._compile(t,e)},e.prototype._compile=function(t,e){var s,i=this;if(this.compiledOps=[],"string"==typeof t&&(t=JSON.parse(t)),!n(t))throw new r("Patch must be an array of operations");for(s=0;s<t.length;s++){var a=c(t[s],e);i.compiledOps.push(a)}},t.JSONPatch.prototype.apply=function(t){var e;for(e=0;e<this.compiledOps.length;e++)t=this.compiledOps[e](t);return t}}));var i=function(){};i.prototype={fatal:function(t,e){},isFatalEnabled:function(){},error:function(t,e){},isErrorEnabled:function(){},warn:function(t,e){},isWarnEnabled:function(){},info:function(t,e){},isInfoEnabled:function(){},debug:function(t,e){},isDebugEnabled:function(){},trace:function(t,e){},isTraceEnabled:function(){}};var n=function(){};function r(){}function a(){}n.prototype={getLogger:function(t){}},r.prototype={onServerError:function(t,e){},onStatusChange:function(t){},onPropertyChange:function(t){},onListenStart:function(){},onListenEnd:function(){},onServerKeepalive:function(){}},a.prototype={onAbort:function(t,e){},onError:function(t){},onDiscarded:function(t){},onDeny:function(t,e,s){},onProcessed:function(t){}};var o=function(){};o.prototype={getItemName:function(){},getItemPos:function(){},getValue:function(t){},getValueAsJSONPatchIfAvailable:function(t){return null},isValueChanged:function(t){},isSnapshot:function(){},forEachChangedField:function(t){},forEachField:function(t){}};var h=function(){};h.prototype={onItemUpdate:function(t){},onItemLostUpdates:function(t,e,s){},onCommandSecondLevelItemLostUpdates:function(t,e){},onEndOfSnapshot:function(t,e){},onClearSnapshot:function(t,e){},onSubscription:function(){},onUnsubscription:function(){},onSubscriptionError:function(t,e){},onCommandSecondLevelSubscriptionError:function(t,e,s){},onListenStart:function(){},onListenEnd:function(){},onRealMaxFrequency:function(t){}};var l={};!function(t){var e,r=function(){return Ps.__string_rec(this,"")},a=a||{};function c(t,e){var s=Object.create(t);for(var i in e)s[i]=e[i];return e.toString!==Object.prototype.toString&&(s.toString=e.toString),s}var u=function(t,e){this.r=new RegExp(t,e.split("u").join(""))};u.__name__="EReg",u.prototype={match:function(t){return this.r.global&&(this.r.lastIndex=0),this.r.m=this.r.exec(t),this.r.s=t,null!=this.r.m},__class__:u};var _=function(){};_.__name__="HxOverrides",_.dateStr=function(t){var e=t.getMonth()+1,s=t.getDate(),i=t.getHours(),n=t.getMinutes(),r=t.getSeconds();return t.getFullYear()+"-"+(e<10?"0"+e:""+e)+"-"+(s<10?"0"+s:""+s)+" "+(i<10?"0"+i:""+i)+":"+(n<10?"0"+n:""+n)+":"+(r<10?"0"+r:""+r)},_.cca=function(t,e){var s=t.charCodeAt(e);if(s==s)return s},_.substr=function(t,e,s){if(null==s)s=t.length;else if(s<0){if(0!=e)return"";s=t.length+s}return t.substr(e,s)},_.remove=function(t,e){var s=t.indexOf(e);return-1!=s&&(t.splice(s,1),!0)},_.now=function(){return Date.now()};var d=function(t,e){this.min=t,this.max=e};d.__name__="IntIterator",d.prototype={hasNext:function(){return this.min<this.max},next:function(){return this.min++},__class__:d};var m=function(){};m.__name__="Lambda",m.has=function(t,e){for(var s=Ms(t);s.hasNext();)if(s.next()==e)return!0;return!1},m.exists=function(t,e){for(var s=Ms(t);s.hasNext();)if(e(s.next()))return!0;return!1},m.count=function(t,e){var s=0;if(null==e)for(var i=Ms(t);i.hasNext();)i.next(),++s;else for(var n=Ms(t);n.hasNext();)e(n.next())&&++s;return s},m.empty=function(t){return!Ms(t).hasNext()},m.find=function(t,e){for(var s=Ms(t);s.hasNext();){var i=s.next();if(e(i))return i}return null},Math.__name__="Math";var f=function(){};f.__name__="Reflect",f.field=function(t,e){try{return t[e]}catch(t){return is.lastError=t,null}},f.fields=function(t){var e=[];if(null!=t){var s=Object.prototype.hasOwnProperty;for(var i in t)"__id__"!=i&&"hx__closures__"!=i&&s.call(t,i)&&e.push(i)}return e},f.copy=function(t){if(null==t)return null;for(var e={},s=0,i=f.fields(t);s<i.length;){var n=i[s];++s,e[n]=f.field(t,n)}return e};var g=function(){};g.__name__="Std",g.string=function(t){return Ps.__string_rec(t,"")},g.parseInt=function(t){var e=parseInt(t);return isNaN(e)?null:e},g.random=function(t){return t<=0?0:Math.floor(Math.random()*t)};var p=function(){this.b=""};p.__name__="StringBuf",p.prototype={__class__:p};var v=function(){};v.__name__="StringTools",v.startsWith=function(t,e){return t.length>=e.length&&0==t.lastIndexOf(e,0)},v.endsWith=function(t,e){var s=e.length,i=t.length;return i>=s&&t.indexOf(e,i-s)==i-s},v.isSpace=function(t,e){var s=_.cca(t,e);return s>8&&s<14||32==s},v.ltrim=function(t){for(var e=t.length,s=0;s<e&&v.isSpace(t,s);)++s;return s>0?_.substr(t,s,e-s):t},v.rtrim=function(t){for(var e=t.length,s=0;s<e&&v.isSpace(t,e-s-1);)++s;return s>0?_.substr(t,0,e-s):t},v.trim=function(t){return v.ltrim(v.rtrim(t))},v.replace=function(t,e,s){return t.split(e).join(s)};var S=function(){};S.__name__="Type",S.enumEq=function(t,e){if(t==e)return!0;try{var s=t.__enum__;if(null==s||s!=e.__enum__)return!1;if(t._hx_index!=e._hx_index)return!1;for(var i=a[s].__constructs__[t._hx_index].__params__,n=0;n<i.length;){var r=i[n];if(++n,!S.enumEq(t[r],e[r]))return!1}}catch(n){return is.lastError=n,!1}return!0};var y=l.LSConnectionDetails=function(t){this.serverAddress=Ks,this.client=t,this.lock=t.lock};y.__name__="LSConnectionDetails",y.prototype={getServerAddress:function(){return this.serverAddress},setServerAddress:function(t){var e=E.fromString(t);ai.isInfoEnabled()&&ai.info("serverAddress changed: "+e);var s=this.serverAddress;this.serverAddress=e,this.client.eventDispatcher.onPropertyChange("serverAddress"),s!=e&&this.client.machine.evtServerAddressChanged()},getAdapterSet:function(){return this.adapterSet},setAdapterSet:function(t){ai.isInfoEnabled()&&ai.info("adapterSet changed: "+t),this.adapterSet=t,this.client.eventDispatcher.onPropertyChange("adapterSet")},getUser:function(){return this.user},setUser:function(t){ai.isInfoEnabled()&&ai.info("user changed: "+t),this.user=t,this.client.eventDispatcher.onPropertyChange("user")},setPassword:function(t){ai.isInfoEnabled()&&ai.info("password changed"),this.password=t,this.client.eventDispatcher.onPropertyChange("password")},getSessionId:function(){return this.sessionId},setSessionId:function(t){this.sessionId=t,this.client.eventDispatcher.onPropertyChange("sessionId")},getServerInstanceAddress:function(){return this.serverInstanceAddress},setServerInstanceAddress:function(t){this.serverInstanceAddress=t,this.client.eventDispatcher.onPropertyChange("serverInstanceAddress")},getServerSocketName:function(){return this.serverSocketName},setServerSocketName:function(t){this.serverSocketName=t,this.client.eventDispatcher.onPropertyChange("serverSocketName")},getClientIp:function(){return this.clientIp},setClientIp:function(t){this.clientIp=t,this.client.eventDispatcher.onPropertyChange("clientIp")},toString:function(){var t=Yt._new();return Yt.set(t,"serverAddress",this.serverAddress),Yt.set(t,"adapterSet",this.adapterSet),Yt.set(t,"user",this.user),Yt.set(t,"sessionId",this.sessionId),Yt.set(t,"serverInstanceAddress",this.serverInstanceAddress),Yt.set(t,"serverSocketName",this.serverSocketName),Yt.set(t,"clientIp",this.clientIp),Yt.set(t,"libVersion",C.LIB_NAME+" "+C.LIB_VERSION),cs.stringify(t.h)},__class__:y};var b=function(){};b.__name__="js.Browser",b.get_supported=function(){return"undefined"!=typeof window&&void 0!==window.location&&"string"==typeof window.location.protocol};var E={_new:function(t){return t},fromString:function(t){if(null==t)return null;if(v.startsWith(t,"http://")||v.startsWith(t,"https://"))return t;throw new T("address is malformed")}},w=function(t,e,s){Error.call(this,t),this.message=t,this.__previousException=e,this.__nativeException=null!=s?s:this,this.__skipStack=0;var i=Error.prepareStackTrace;if(Error.prepareStackTrace=function(t){return t.stack},s instanceof Error)this.stack=s.stack;else{var n=null;if(Error.captureStackTrace)Error.captureStackTrace(this,w),n=this;else if(void 0===(n=new Error).stack){try{throw n}catch(t){}this.__skipStack++}this.stack=n.stack}Error.prepareStackTrace=i};w.__name__="haxe.Exception",w.caught=function(t){return t instanceof w?t:t instanceof Error?new w(t.message,null,t):new rs(t,null,t)},w.thrown=function(t){if(t instanceof w)return t.get_native();if(t instanceof Error)return t;var e=new rs(t);return e.__skipStack++,e},w.__super__=Error,w.prototype=c(Error.prototype,{toString:function(){return this.get_message()},details:function(){if(null==this.get_previous()){var t="Exception: "+this.toString(),e=this.get_stack();return t+(null==e?"null":es.toString(e))}for(var s="",i=this,n=null;null!=i;){if(null==n)s="Exception: "+i.get_message()+(null==(t=i.get_stack())?"null":es.toString(t))+s;else{var r=es.subtract(i.get_stack(),n.get_stack());s="Exception: "+i.get_message()+(null==r?"null":es.toString(r))+"\n\nNext "+s}n=i,i=i.get_previous()}return s},__shiftStack:function(){this.__skipStack++},get_message:function(){return this.message},get_previous:function(){return this.__previousException},get_native:function(){return this.__nativeException},get_stack:function(){var t=this.__exceptionStack;if(null==t){var e=is.toHaxe(is.normalize(this.stack),this.__skipStack);return this.setProperty("__exceptionStack",e),e}return t},setProperty:function(t,e){try{Object.defineProperty(this,t,{value:e})}catch(s){this[t]=e}},__class__:w});var T=function(t,e,s){w.call(this,t,e,s),this.__skipStack++};T.__name__="com.lightstreamer.internal.IllegalArgumentException",T.__super__=w,T.prototype=c(w.prototype,{__class__:T});var x=l.LSConnectionOptions=function(t){this.cookieHandlingRequired=!1,this.slowingEnabled=!1,this.serverInstanceAddressIgnored=!1,this.httpExtraHeadersOnSessionCreationOnly=!1,this.stalledTimeout=2e3,this.sessionRecoveryTimeout=15e3,this.reverseHeartbeatInterval=0,this.retryDelay=4e3,this.reconnectTimeout=3e3,this.pollingInterval=0,this.realMaxBandwidth=null,this.requestedMaxBandwidth=Ee.BWUnlimited,this.keepaliveInterval=0,this.idleTimeout=19e3,this.httpExtraHeaders=null,this.forcedTransport=null,this.firstRetryMaxDelay=100,this.contentLength=5e7,this.client=t,this.lock=t.lock};x.__name__="LSConnectionOptions",x.prototype={getContentLength:function(){return this.contentLength},setContentLength:function(t){var e=ye.fromIntGt0(t);ai.isInfoEnabled()&&ai.info("contentLength changed: "+e),this.contentLength=e,this.client.eventDispatcher.onPropertyChange("contentLength")},getFirstRetryMaxDelay:function(){return this.firstRetryMaxDelay},setFirstRetryMaxDelay:function(t){var e=Se.fromIntGt0(t);ai.isInfoEnabled()&&ai.info("firstRetryMaxDelay changed: "+e),this.firstRetryMaxDelay=e,this.client.eventDispatcher.onPropertyChange("firstRetryMaxDelay")},getForcedTransport:function(){return this.forcedTransport},setForcedTransport:function(t){var e=be.fromString(t);ai.isInfoEnabled()&&ai.info("forcedTransport changed: "+e),this.forcedTransport=e,this.client.eventDispatcher.onPropertyChange("forcedTransport"),this.client.machine.evtExtSetForcedTransport()},getHttpExtraHeaders:function(){return null==this.httpExtraHeaders?null:Jt.fromMapToDynamicAccess(this.httpExtraHeaders)},setHttpExtraHeaders:function(t){ai.isInfoEnabled()&&ai.info("httpExtraHeaders changed: "+g.string(t)),this.httpExtraHeaders=null==t?null:Jt.toHaxe(t),this.client.eventDispatcher.onPropertyChange("httpExtraHeaders")},getIdleTimeout:function(){return this.idleTimeout},setIdleTimeout:function(t){var e=Se.fromIntGtEq0(t);ai.isInfoEnabled()&&ai.info("idleTimeout changed: "+e),this.idleTimeout=e,this.client.eventDispatcher.onPropertyChange("idleTimeout")},getKeepaliveInterval:function(){return this.keepaliveInterval},setKeepaliveInterval:function(t){var e=Se.fromIntGtEq0(t);ai.isInfoEnabled()&&ai.info("keepaliveInterval changed: "+e),this.keepaliveInterval=e,this.client.eventDispatcher.onPropertyChange("keepaliveInterval")},getRequestedMaxBandwidth:function(){return we.toString(this.requestedMaxBandwidth)},setRequestedMaxBandwidth:function(t){null!=t&&(t=null==t?"null":""+t);var e=we.fromString(t);ai.isInfoEnabled()&&ai.info("requestedMaxBandwidth changed: "+we.toString(e)),this.requestedMaxBandwidth=e,this.client.eventDispatcher.onPropertyChange("requestedMaxBandwidth"),this.client.machine.evtExtSetRequestedMaxBandwidth()},getRealMaxBandwidth:function(){return Ne.toString(this.realMaxBandwidth)},setRealMaxBandwidth:function(t){this.realMaxBandwidth=t,this.client.eventDispatcher.onPropertyChange("realMaxBandwidth")},getPollingInterval:function(){return this.pollingInterval},setPollingInterval:function(t){var e=Se.fromIntGtEq0(t);ai.isInfoEnabled()&&ai.info("pollingInterval changed: "+e),this.pollingInterval=e,this.client.eventDispatcher.onPropertyChange("pollingInterval")},getReconnectTimeout:function(){return this.reconnectTimeout},setReconnectTimeout:function(t){var e=Se.fromIntGt0(t);ai.isInfoEnabled()&&ai.info("reconnectTimeout changed: "+e),this.reconnectTimeout=e,this.client.eventDispatcher.onPropertyChange("reconnectTimeout")},getRetryDelay:function(){return this.retryDelay},setRetryDelay:function(t){var e=Se.fromIntGt0(t);ai.isInfoEnabled()&&ai.info("retryDelay changed: "+e),this.retryDelay=e,this.client.eventDispatcher.onPropertyChange("retryDelay")},getReverseHeartbeatInterval:function(){return this.reverseHeartbeatInterval},setReverseHeartbeatInterval:function(t){var e=Se.fromIntGtEq0(t);ai.isInfoEnabled()&&ai.info("reverseHeartbeatInterval changed: "+e),this.reverseHeartbeatInterval=e,this.client.eventDispatcher.onPropertyChange("reverseHeartbeatInterval"),this.client.machine.evtExtSetReverseHeartbeatInterval()},getSessionRecoveryTimeout:function(){return this.sessionRecoveryTimeout},setSessionRecoveryTimeout:function(t){var e=Se.fromIntGtEq0(t);ai.isInfoEnabled()&&ai.info("sessionRecoveryTimeout changed: "+e),this.sessionRecoveryTimeout=e,this.client.eventDispatcher.onPropertyChange("sessionRecoveryTimeout")},getStalledTimeout:function(){return this.stalledTimeout},setStalledTimeout:function(t){var e=Se.fromIntGt0(t);ai.isInfoEnabled()&&ai.info("stalledTimeout changed: "+e),this.stalledTimeout=e,this.client.eventDispatcher.onPropertyChange("stalledTimeout")},isHttpExtraHeadersOnSessionCreationOnly:function(){return this.httpExtraHeadersOnSessionCreationOnly},setHttpExtraHeadersOnSessionCreationOnly:function(t){ai.isInfoEnabled()&&ai.info("httpExtraHeadersOnSessionCreationOnly changed: "+(null==t?"null":""+t)),this.httpExtraHeadersOnSessionCreationOnly=t,this.client.eventDispatcher.onPropertyChange("httpExtraHeadersOnSessionCreationOnly")},isServerInstanceAddressIgnored:function(){return this.serverInstanceAddressIgnored},setServerInstanceAddressIgnored:function(t){ai.isInfoEnabled()&&ai.info("serverInstanceAddressIgnored changed: "+(null==t?"null":""+t)),this.serverInstanceAddressIgnored=t,this.client.eventDispatcher.onPropertyChange("serverInstanceAddressIgnored")},setCookieHandlingRequired:function(t){ai.isInfoEnabled()&&ai.info("cookieHandlingRequired changed: "+(null==t?"null":""+t)),this.cookieHandlingRequired=t,this.client.eventDispatcher.onPropertyChange("cookieHandlingRequired")},isCookieHandlingRequired:function(){return this.cookieHandlingRequired},isSlowingEnabled:function(){return this.slowingEnabled},setSlowingEnabled:function(t){ai.isInfoEnabled()&&ai.info("slowingEnabled changed: "+(null==t?"null":""+t)),this.slowingEnabled=t,this.client.eventDispatcher.onPropertyChange("slowingEnabled")},toString:function(){var t=Yt._new();return Yt.set(t,"forcedTransport",this.forcedTransport),Yt.set(t,"requestedMaxBandwidth",this.requestedMaxBandwidth),Yt.set(t,"realMaxBandwidth",this.realMaxBandwidth),Yt.set(t,"retryDelay",this.retryDelay),Yt.set(t,"firstRetryMaxDelay",this.firstRetryMaxDelay),Yt.set(t,"sessionRecoveryTimeout",this.sessionRecoveryTimeout),Yt.set(t,"reverseHeartbeatInterval",this.reverseHeartbeatInterval),Yt.set(t,"stalledTimeout",this.stalledTimeout),Yt.set(t,"reconnectTimeout",this.reconnectTimeout),Yt.set(t,"keepaliveInterval",this.keepaliveInterval),Yt.set(t,"pollingInterval",this.pollingInterval),Yt.set(t,"idleTimeout",this.idleTimeout),Yt.set(t,"contentLength",this.contentLength),Yt.set(t,"slowingEnabled",this.slowingEnabled),Yt.set(t,"serverInstanceAddressIgnored",this.serverInstanceAddressIgnored),Yt.set(t,"HTTPExtraHeadersOnSessionCreationOnly",this.httpExtraHeadersOnSessionCreationOnly),Yt.set(t,"HTTPExtraHeaders",this.httpExtraHeaders),Yt.set(t,"cookieHandlingRequired",this.cookieHandlingRequired),cs.stringify(t.h)},__class__:x};var R=function(){this.listeners=[]};R.__name__="com.lightstreamer.internal.EventDispatcher",R.prototype={addListener:function(t){return-1==this.listeners.indexOf(t)&&(this.listeners.push(t),!0)},removeListener:function(t){return _.remove(this.listeners,t)},getListeners:function(){return this.listeners},dispatchToAll:function(t){for(var e=0,s=this.listeners;e<s.length;)this.dispatchToOne(s[e++],t)},dispatchToOne:function(t,e){ti.submit(Ds.a((function(){try{e(t)}catch(t){var s=w.caught(t);ai.isErrorEnabled()&&ai.error("Uncaught exception\n"+s.details())}})))},__class__:R};var I=function(){R.call(this)};I.__name__="com.lightstreamer.client.ClientEventDispatcher",I.__super__=R,I.prototype=c(R.prototype,{removeListenerAndFireOnListenEnd:function(t,e){this.removeListener(t)&&this.dispatchToOne(t,(function(t){null!=t.onListenEnd&&t.onListenEnd(e)}))},addListenerAndFireOnListenStart:function(t,e){this.addListener(t)&&this.dispatchToOne(t,(function(t){null!=t.onListenStart&&t.onListenStart(e)}))},onServerError:function(t,e){this.dispatchToAll((function(s){null!=s.onServerError&&s.onServerError(t,e)}))},onStatusChange:function(t){this.dispatchToAll((function(e){null!=e.onStatusChange&&e.onStatusChange(t)}))},onPropertyChange:function(t){this.dispatchToAll((function(e){null!=e.onPropertyChange&&e.onPropertyChange(t)}))},onServerKeepalive:function(){this.dispatchToAll((function(t){null!=t.onServerKeepalive&&t.onServerKeepalive()}))},__class__:I});var C=l.LSLightstreamerClient=function(t,e){this.lock=new Xe,this.eventDispatcher=new I,this.connectionDetails=new y(this),this.connectionOptions=new x(this),this.machine=new N(this,Fs(this,this.createWsClient),Fs(this,this.createHttpClient),Fs(this,this.createHttpClient),Fs(this,this.createTimer),Fs(this,this.randomMillis),Fs(this,this.createReachabilityManager)),null!=t&&this.connectionDetails.setServerAddress(t),null!=e&&this.connectionDetails.setAdapterSet(e)};C.__name__="LSLightstreamerClient",C.setLoggerProvider=function(t){$e.setLoggerProvider(t)},C.prototype={addListener:function(t){this.eventDispatcher.addListenerAndFireOnListenStart(t,this)},removeListener:function(t){this.eventDispatcher.removeListenerAndFireOnListenEnd(t,this)},getListeners:function(){return this.eventDispatcher.getListeners().slice()},connect:function(){this.machine.connect()},disconnect:function(){this.machine.disconnect()},getStatus:function(){return this.machine.getStatus()},sendMessage:function(t,e,s,i,n){null==n&&(n=!1),null==s&&(s=-1),this.machine.sendMessage(t,e,null!=s?s:-1,i,null!=n&&n)},subscribe:function(t){this.machine.subscribeExt(t)},unsubscribe:function(t){this.machine.unsubscribe(t)},getSubscriptions:function(){return this.machine.getSubscriptions().slice()},getSubscriptionWrappers:function(){for(var t=[],e=0,s=this.machine.getSubscriptions();e<s.length;){var i=s[e];++e,null!=i.wrapper&&t.push(i.wrapper)}return t.slice()},createWsClient:function(t,e,s,i,n){return new Be(t,s,i,n)},createHttpClient:function(t,e,s,i,n,r){return new Gt(t,e,s,this.connectionOptions.isCookieHandlingRequired(),i,n,r)},createReachabilityManager:function(t){return new ie},createTimer:function(t,e,s){return new pe(t,e,s)},randomMillis:function(t){return g.random(t)},__class__:C};var L=a["com.lightstreamer.client._Subscription.SubscriptionState"]={__ename__:!0,__constructs__:null,Inactive:{_hx_name:"Inactive",_hx_index:0,__enum__:"com.lightstreamer.client._Subscription.SubscriptionState",toString:r},Active:{_hx_name:"Active",_hx_index:1,__enum__:"com.lightstreamer.client._Subscription.SubscriptionState",toString:r},Subscribed:{_hx_name:"Subscribed",_hx_index:2,__enum__:"com.lightstreamer.client._Subscription.SubscriptionState",toString:r}};L.__constructs__=[L.Inactive,L.Active,L.Subscribed];var D=function(){R.call(this)};D.__name__="com.lightstreamer.client._Subscription.SubscriptionEventDispatcher",D.__super__=R,D.prototype=c(R.prototype,{onClearSnapshot:function(t,e){this.dispatchToAll((function(s){null!=s.onClearSnapshot&&s.onClearSnapshot(t,e)}))},onCommandSecondLevelItemLostUpdates:function(t,e){this.dispatchToAll((function(s){null!=s.onCommandSecondLevelItemLostUpdates&&s.onCommandSecondLevelItemLostUpdates(t,e)}))},onCommandSecondLevelSubscriptionError:function(t,e,s){this.dispatchToAll((function(i){null!=i.onCommandSecondLevelSubscriptionError&&i.onCommandSecondLevelSubscriptionError(t,e,s)}))},onEndOfSnapshot:function(t,e){this.dispatchToAll((function(s){null!=s.onEndOfSnapshot&&s.onEndOfSnapshot(t,e)}))},onItemLostUpdates:function(t,e,s){this.dispatchToAll((function(i){null!=i.onItemLostUpdates&&i.onItemLostUpdates(t,e,s)}))},onItemUpdate:function(t){this.dispatchToAll((function(e){null!=e.onItemUpdate&&e.onItemUpdate(t)}))},removeListenerAndFireOnListenEnd:function(t,e){this.removeListener(t)&&this.dispatchToOne(t,(function(t){null!=t.onListenEnd&&t.onListenEnd(e)}))},addListenerAndFireOnListenStart:function(t,e){this.addListener(t)&&this.dispatchToOne(t,(function(t){null!=t.onListenStart&&t.onListenStart(e)}))},onSubscription:function(){this.dispatchToAll((function(t){null!=t.onSubscription&&t.onSubscription()}))},onSubscriptionError:function(t,e){this.dispatchToAll((function(s){null!=s.onSubscriptionError&&s.onSubscriptionError(t,e)}))},onUnsubscription:function(){this.dispatchToAll((function(t){null!=t.onUnsubscription&&t.onUnsubscription()}))},onRealMaxFrequency:function(t){this.dispatchToAll((function(e){null!=e.onRealMaxFrequency&&e.onRealMaxFrequency(t)}))},__class__:D});var O=l.LSSubscription=function(t,e,s,i){this.lock=new Xe,this.m_internal=!1,this.state=L.Inactive,this.eventDispatcher=new D,this.wrapper=i,this.mode=Pe.fromString(t),this.initSnapshot(),this.initItemsAndFields("string"==typeof e?[e].slice():e,s)};O.__name__="LSSubscription",O.prototype={initSnapshot:function(){this.snapshot="RAW"==this.mode?null:Re.SnpYes},initItemsAndFields:function(t,e){if(null!=t){if(null==e)throw new T("Please specify a valid field list");if(this.items=ke.fromArray(t.slice()),this.fields=Me.fromArray(e.slice()),"COMMAND"==this.mode&&-1==this.fields.indexOf("key"))throw new T("Field 'key' is missing");if("COMMAND"==this.mode&&-1==this.fields.indexOf("command"))throw new T("Field 'command' is missing")}else if(null!=e)throw new T("Please specify a valid item or item list")},addListener:function(t){this.eventDispatcher.addListenerAndFireOnListenStart(t,this)},removeListener:function(t){this.eventDispatcher.removeListenerAndFireOnListenEnd(t,this)},getListeners:function(){return this.eventDispatcher.getListeners().slice()},isActive:function(){return this.state!=L.Inactive},isSubscribed:function(){return this.state==L.Subscribed},getDataAdapter:function(){return this.dataAdapter},setDataAdapter:function(t){this.checkActive(),this.dataAdapter=Fe.fromString(t)},getMode:function(){return this.mode},getItems:function(){return null==this.items?null:this.items.slice()},setItems:function(t){this.checkActive(),this.items=ke.fromArray(null==t?null:t.slice()),this.group=null},getItemGroup:function(){return this.group},setItemGroup:function(t){this.checkActive(),this.group=Fe.fromString(t),this.items=null},getFields:function(){return null==this.fields?null:this.fields.slice()},setFields:function(t){this.checkActive();var e=Me.fromArray(null==t?null:t.slice());if("COMMAND"==this.mode&&null!=e){if(-1==e.indexOf("command"))throw new T("Field 'command' is missing");if(-1==e.indexOf("key"))throw new T("Field 'key' is missing")}this.fields=e,this.schema=null},getFieldSchema:function(){return this.schema},setFieldSchema:function(t){this.checkActive(),this.schema=Fe.fromString(t),this.fields=null},getRequestedBufferSize:function(){return xe.toString(this.bufferSize)},setRequestedBufferSize:function(t){null!=t&&(t=null==t?"null":""+t),this.checkActive(),this.bufferSize=xe.fromString(t)},getRequestedSnapshot:function(){return Ie.toString(this.snapshot)},setRequestedSnapshot:function(t){null!=t&&(t=null==t?"null":""+t),this.checkActive();var e=Ie.fromString(t);switch(this.mode){case"COMMAND":case"MERGE":if(null!=e&&null!=e&&2==e._hx_index)throw new T("Snapshot length is not permitted if MERGE or COMMAND was specified as mode");break;case"RAW":if(null!=e)throw new T("Snapshot is not permitted if RAW was specified as mode")}this.snapshot=e},getRequestedMaxFrequency:function(){return Le.toString(this.requestedMaxFrequency)},setRequestedMaxFrequency:function(t){var e,s=this;null!=t&&(t=null==t?"null":""+t),se.synchronized(this.lock,(function(){var i=Le.fromString(t);switch(s.mode){case"COMMAND":case"DISTINCT":case"MERGE":break;default:throw new T("The operation in only available on MERGE, DISTINCT and COMMAND Subscripitons")}if(s.isActive()&&(null==i||i==Ce.FreqUnfiltered||s.requestedMaxFrequency==Ce.FreqUnfiltered))throw new T("Cannot change the frequency from/to 'unfiltered' or to null while the Subscription is active");return null!=s.subId&&hi.isInfoEnabled()&&hi.info("Subscription "+s.subId+" requested max frequency changed: "+t),s.requestedMaxFrequency=i,e=s.manager})),null!=e&&e.evtExtConfigure()},getSelector:function(){return this.selector},setSelector:function(t){this.checkActive(),this.selector=Fe.fromString(t)},getCommandPosition:function(){if(this.checkCommand(),null==this.cmdIdx)throw new Qt("The position of the command field is currently unknown");return this.cmdIdx},getKeyPosition:function(){if(this.checkCommand(),null==this.keyIdx)throw new Qt("The position of the key field is currently unknown");return this.keyIdx},getCommandSecondLevelDataAdapter:function(){return this.dataAdapter2},setCommandSecondLevelDataAdapter:function(t){this.checkActive(),this.checkCommand(),this.dataAdapter2=Fe.fromString(t)},getCommandSecondLevelFields:function(){return null==this.fields2?null:this.fields2.slice()},setCommandSecondLevelFields:function(t){this.checkActive(),this.checkCommand(),this.fields2=Me.fromArray(null==t?null:t.slice()),this.schema2=null},getCommandSecondLevelFieldSchema:function(){return this.schema2},setCommandSecondLevelFieldSchema:function(t){this.checkActive(),this.checkCommand(),this.schema2=Fe.fromString(t),this.fields2=null},getValue:function(t,e){var s="number"==typeof t&&(0|t)===t,i="string"==typeof t,n="number"==typeof e&&(0|e)===e,r="string"==typeof e;if(s&&n)return this.getValuePosPos(t,e);if(s&&r)return this.getValuePosName(t,e);if(i&&n)return this.getValueNamePos(t,e);if(i&&r)return this.getValueNameName(t,e);throw new T("Invalid argument type")},getCommandValue:function(t,e,s){var i="number"==typeof t&&(0|t)===t,n="string"==typeof t,r="number"==typeof s&&(0|s)===s,a="string"==typeof s;if(i&&r)return this.getCommandValuePosPos(t,e,s);if(i&&a)return this.getCommandValuePosName(t,e,s);if(n&&r)return this.getCommandValueNamePos(t,e,s);if(n&&a)return this.getCommandValueNameName(t,e,s);throw new T("Invalid argument type")},getValuePosPos:function(t,e){var s,i=this;if(t<1||e<1)throw new T("The specified position is out of bounds");return se.synchronized(this.lock,(function(){return s=i.manager})),null!=s?s.getValue(t,e):null},getValuePosName:function(t,e){var s=this;return this.getValuePosPos(t,se.synchronized(this.lock,(function(){return s.getFieldPos(e)})))},getValueNamePos:function(t,e){var s=this;return this.getValuePosPos(se.synchronized(this.lock,(function(){return s.getItemPos(t)})),e)},getValueNameName:function(t,e){var s=this;return this.getValuePosPos(se.synchronized(this.lock,(function(){return s.getItemPos(t)})),se.synchronized(this.lock,(function(){return s.getFieldPos(e)})))},getCommandValuePosPos:function(t,e,s){var i,n=this;if(this.checkCommand(),t<1||s<1)throw new T("The specified position is out of bounds");return se.synchronized(this.lock,(function(){return i=n.manager})),null!=i?i.getCommandValue(t,e,s):null},getCommandValuePosName:function(t,e,s){var i=this;return this.getCommandValuePosPos(t,e,se.synchronized(this.lock,(function(){return i.getFieldPos(s)})))},getCommandValueNamePos:function(t,e,s){var i=this;return this.getCommandValuePosPos(se.synchronized(this.lock,(function(){return i.getItemPos(t)})),e,s)},getCommandValueNameName:function(t,e,s){var i=this;return this.getCommandValuePosPos(se.synchronized(this.lock,(function(){return i.getItemPos(t)})),e,se.synchronized(this.lock,(function(){return i.getFieldPos(s)})))},getItemPos:function(t){var e;if(null==this.items||-1==(e=ke.getPos(this.items,t)))throw new T("Unknown item name");return e},getFieldPos:function(t){var e;if(null==this.fields||-1==(e=Me.getPos(this.fields,t)))throw new T("Unknown field name");return e},checkActive:function(){if(this.isActive())throw new Qt("Cannot modify an active Subscription. Please unsubscribe before applying any change")},checkCommand:function(){if("COMMAND"!=this.mode)throw new Qt("This method can only be used on COMMAND subscriptions")},fetch_mode:function(){return this.mode},fetch_requestedBufferSize:function(){return this.bufferSize},fetch_requestedSnapshot:function(){return this.snapshot},fetch_requestedMaxFrequency:function(){return this.requestedMaxFrequency},fetch_nItems:function(){return this.nItems},fetch_subManager:function(){return this.manager},setActive:function(){this.state=L.Active},setInactive:function(){this.state=L.Inactive,this.subId=null,this.cmdIdx=null,this.keyIdx=null,this.nItems=null,this.nFields=null},setSubscribed:function(t,e,s){this.state=L.Subscribed,this.subId=t,this.nItems=e,this.nFields=s},setSubscribedCMD:function(t,e,s,i,n){this.state=L.Subscribed,this.subId=t,this.cmdIdx=i,this.keyIdx=n,this.nItems=e,this.nFields=s},fetch_nFields:function(){return this.nFields},isInternal:function(){return this.m_internal},setInternal:function(){this.m_internal=!0},getItemName:function(t){return null!=this.items?this.items[t-1]:null},relate:function(t){this.manager=t},unrelate:function(t){this.manager==t&&(this.manager=null)},hasSnapshot:function(){return!(null==this.snapshot||this.snapshot==Re.SnpNo)},getItemNameOrPos:function(t){return null!=this.items?this.items[t-1]:""+t},fireOnSubscription:function(t){hi.isInfoEnabled()&&hi.info("Subscription "+t+" added"),this.eventDispatcher.onSubscription()},fireOnUnsubscription:function(t){hi.isInfoEnabled()&&hi.info("Subscription "+t+" deleted"),this.eventDispatcher.onUnsubscription()},fireOnSubscriptionError:function(t,e,s){hi.isWarnEnabled()&&hi.warn("Subscription "+t+" failed: "+e+" - "+s),this.eventDispatcher.onSubscriptionError(e,s)},fireOnEndOfSnapshot:function(t,e){hi.isDebugEnabled()&&hi.debug("Subscription "+e+":"+this.getItemNameOrPos(t)+": snapshot ended"),this.eventDispatcher.onEndOfSnapshot(this.getItemName(t),t)},fireOnClearSnapshot:function(t,e){hi.isDebugEnabled()&&hi.debug("Subscription "+e+":"+this.getItemNameOrPos(t)+": snapshot cleared"),this.eventDispatcher.onClearSnapshot(this.getItemName(t),t)},fireOnLostUpdates:function(t,e,s){hi.isDebugEnabled()&&hi.debug("Subscription "+s+":"+this.getItemNameOrPos(t)+": lost "+e+" updates"),this.eventDispatcher.onItemLostUpdates(this.getItemName(t),t,e)},fireOnItemUpdate:function(t,e){hi.isDebugEnabled()&&hi.debug("Subscription "+e+":"+this.getItemNameOrPos(t.getItemPos())+" update: "+g.string(t)),this.eventDispatcher.onItemUpdate(t)},fireOnRealMaxFrequency:function(t,e){hi.isDebugEnabled()&&hi.debug("Subscription "+e+" real max frequency changed: "+g.string(t)),this.eventDispatcher.onRealMaxFrequency(qe(t))},fireOnSubscriptionError2Level:function(t,e,s,i,n){hi.isWarnEnabled()&&hi.warn("Subscription "+i+":"+this.getItemNameOrPos(n)+":"+t+" failed: "+e+" - "+s),this.eventDispatcher.onCommandSecondLevelSubscriptionError(e,s,t)},fireOnLostUpdates2Level:function(t,e,s,i){hi.isDebugEnabled()&&hi.debug("Subscription "+s+":"+this.getItemNameOrPos(i)+":"+t+": lost "+e+" updates"),this.eventDispatcher.onCommandSecondLevelItemLostUpdates(e,t)},toString:function(){var t=Yt._new();return Yt.set(t,"mode",this.mode),Yt.set(t,"items",null!=this.items?g.string(this.items):this.group),Yt.set(t,"fields",null!=this.fields?g.string(this.fields):this.schema),Yt.set(t,"dataAdapter",this.dataAdapter),Yt.set(t,"requestedBufferSize",this.bufferSize),Yt.set(t,"requestedSnapshot",this.snapshot),Yt.set(t,"requestedMaxFrequency",this.requestedMaxFrequency),Yt.set(t,"selector",this.selector),Yt.set(t,"secondLevelFields",null!=this.fields2?g.string(this.fields2):this.schema2),Yt.set(t,"secondLevelDataAdapter",this.dataAdapter2),cs.stringify(t.h)},__class__:O};var N=function(t,e,s,i,n,r,a){this.slw_m=.5,this.slw_hugeDelayMs=2e4,this.slw_maxAvgDelayMs=7e3,this.slw_avgDelayMs=0,this.slw_refTime=0,this.rec_clientProg=0,this.rec_serverProg=0,this.subscriptionManagers=Vt._new(),this.messageManagers=jt._new(),this.sequenceMap=new cs,this.disabledTransports=new ae,this.suspendedTransports=new ae,this.ctrl_connectTs=0,this.recoverTs=0,this.connectTs=0,this.m_nextSubId=0,this.m_nextReqId=0,this.m_status="DISCONNECTED",this.delayCounter=new mt,this.state=new j,this.client=t,this.lock=t.lock,this.details=t.connectionDetails,this.options=t.connectionOptions,this.wsFactory=e,this.httpFactory=s,this.ctrlFactory=i,this.timerFactory=n,this.randomGenerator=r,this.reachabilityFactory=a,this.clientEventDispatcher=t.eventDispatcher,this.switchRequest=new U(this),this.constrainRequest=new H(this),this.delayCounter.reset(this.options.retryDelay)};N.__name__="com.lightstreamer.client.internal.ClientMachine",N.prototype={disposeSession:function(){this.disposeWS(),this.disposeHTTP(),this.disposeCtrl(),this.details.serverInstanceAddress=null,this.details.serverSocketName=null,this.details.clientIp=null,this.details.sessionId=null,this.options.realMaxBandwidth=null,this.lastKnownClientIp=null,this.resetSequenceMap(),this.rec_serverProg=0,this.rec_clientProg=0,this.bw_lastReqId=null,this.bw_requestedMaxBandwidth=null,this.swt_lastReqId=null},disposeClient:function(){this.sessionId=null,this.enableAllTransports(),this.resetCurrentRetryDelay(),this.resetSequenceMap(),this.cause=null},evtExtConnect:function(){this.traceEvent("connect");var t=!0;100==this.state.s_m&&(this.cause="api",this.resetCurrentRetryDelay(),this.state.s_m=101,this.state.traceState(),t=this.evtExtConnect_NextRegion(),this.evtSelectCreate()),t&&(t=this.evtExtConnect_NextRegion())},evtExtConnect_NextRegion:function(){return this.evtExtConnect_NetworkReachabilityRegion()},evtExtConnect_NetworkReachabilityRegion:function(){var t=this;if(1400==this.state.s_nr){var e=new We(this.getServerAddress()).get_hostname();this.nr_reachabilityManager=this.reachabilityFactory(e),this.state.s_nr=1410,this.state.traceState(),this.nr_reachabilityManager.startListening((function(s){switch(s._hx_index){case 0:t.evtNetworkReachable(e);break;case 1:t.evtNetworkNotReachable(e)}}))}return!1},evtNetworkNotReachable:function(t){oi.isInfoEnabled()&&oi.info(t+" is NOT reachable"),this.traceEvent("nr:network.not.reachable"),(1410==this.state.s_nr||1412==this.state.s_nr)&&(this.state.s_nr=1411,this.state.traceState())},evtNetworkReachable:function(t){oi.isInfoEnabled()&&oi.info(t+" is reachable"),this.traceEvent("nr:network.reachable"),1410==this.state.s_nr?(this.state.s_nr=1412,this.state.traceState()):1411==this.state.s_nr&&(this.state.s_nr=1412,this.state.traceState(),this.evtOnlineAgain())},evtOnlineAgain:function(){this.traceEvent("online.again"),112==this.state.s_m?(this.state.s_m=116,this.state.traceState(),this.cancel_evtRetryTimeout(),this.evtSelectCreate()):1003==this.state.s_rec&&(this.sendRecovery(),this.state.s_rec=1001,this.state.traceState(),this.cancel_evtRetryTimeout(),this.schedule_evtTransportTimeout(this.options.retryDelay))},evtServerAddressChanged:function(){var t=this;switch(this.traceEvent("nr:serverAddress.changed"),this.state.s_nr){case 1410:case 1411:case 1412:var e=this.nr_reachabilityManager,s=new We(this.getServerAddress()).get_hostname();this.nr_reachabilityManager=this.reachabilityFactory(s),this.state.s_nr=1410,this.state.traceState(),null!=e&&e.stopListening(),this.nr_reachabilityManager.startListening((function(e){switch(e._hx_index){case 0:t.evtNetworkReachable(s);break;case 1:t.evtNetworkNotReachable(s)}}))}},evtExtDisconnect:function(t){switch(this.traceEvent("disconnect: cause="+g.string(t)),this.state.s_m){case 110:case 111:case 112:case 113:case 114:case 115:case 116:this.notifyStatus("DISCONNECTED"),this.notifyServerErrorIfCauseIsError(t),this.state.s_m=100,this.state.traceState(),this.cancel_evtRetryTimeout(),this.evtTerminate(t);break;case 120:case 121:case 122:this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerErrorIfCauseIsError(t),this.state.s_m=100,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtTerminate(t);break;case 130:case 140:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerErrorIfCauseIsError(t),this.state.s_m=100,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtTerminate(t);break;case 150:var e=this.state.s_tr;if(null!=e)switch(e){case 210:this.sendDestroyWS(),this.closeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerErrorIfCauseIsError(t),this.state.clear_w(),this.state.goto_m_from_session(100),this.exit_w(),this.evtEndSession(),this.evtTerminate(t);break;case 220:case 230:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerErrorIfCauseIsError(t),this.state.goto_m_from_session(100),this.cancel_evtTransportTimeout(),this.evtEndSession(),this.evtTerminate(t);break;case 240:var s;if(500==(null!=(n=this.state.s_ws)?n.m:null))this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerErrorIfCauseIsError(t),this.state.goto_m_from_ws(100),this.exit_ws_to_m(),this.evtTerminate(t);else(n=!!(i=501==(null!=(s=this.state.s_ws)?s.m:null)||502==(null!=(s=this.state.s_ws)?s.m:null))||503==(null!=(i=this.state.s_ws)?i.m:null))&&(this.sendDestroyWS(),this.closeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerErrorIfCauseIsError(t),this.state.goto_m_from_ws(100),this.exit_ws_to_m(),this.evtTerminate(t));break;case 250:var i,n;(n=600==(null!=(i=this.state.s_wp)?i.m:null)||601==(null!=(i=this.state.s_wp)?i.m:null))?(this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerErrorIfCauseIsError(t),this.state.goto_m_from_wp(100),this.exit_ws_to_m(),this.evtTerminate(t)):602==(null!=(n=this.state.s_wp)?n.m:null)&&(this.sendDestroyWS(),this.closeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerErrorIfCauseIsError(t),this.state.goto_m_from_wp(100),this.exit_wp_to_m(),this.evtTerminate(t));break;case 260:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerErrorIfCauseIsError(t),this.state.goto_m_from_rec(100),this.exit_rec_to_m(),this.evtTerminate(t);break;case 270:710==this.state.s_h?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerErrorIfCauseIsError(t),this.state.goto_m_from_hs(100),this.exit_hs_to_m(),this.evtTerminate(t)):720==this.state.s_h&&(this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerErrorIfCauseIsError(t),this.state.goto_m_from_hp(100),this.exit_hp_to_m(),this.evtTerminate(t))}}},evtSelectCreate:function(){if(this.traceEvent("select.create"),101==this.state.s_m||116==this.state.s_m)switch(this.getBestForCreating()._hx_index){case 0:this.notifyStatus("CONNECTING"),this.openWS_Create(),this.state.s_m=120,this.state.traceState(),this.evtCreate(),this.schedule_evtTransportTimeout(this.delayCounter.get_currentRetryDelay());break;case 1:this.notifyStatus("CONNECTING"),this.sendCreateHTTP(),this.state.s_m=130,this.state.traceState(),this.evtCreate(),this.schedule_evtTransportTimeout(this.delayCounter.get_currentRetryDelay());break;case 2:this.notifyStatus("DISCONNECTED"),this.state.s_m=100,this.state.traceState(),this.evtTerminate(q.TC_otherError("Unable to select a transport"))}},evtWSOpen:function(){var t;this.traceEvent("ws.open"),120==this.state.s_m?(this.sendCreateWS(),this.state.s_m=121,this.state.traceState()):500==(null!=(t=this.state.s_ws)?t.m:null)?(this.sendBindWS_Streaming(),this.state.s_ws.m=501,this.state.traceState()):600==(null!=(t=this.state.s_wp)?t.m:null)&&(Xt.sure(this.ws).send("wsok"),this.state.s_wp.m=601,this.state.traceState())},evtMessage:function(t){var e=!0;if(v.startsWith(t,"U,")){var s=ot(t);this.evtU(s.subId,s.itemIdx,s.values,t)}else if(v.startsWith(t,"REQOK"))"REQOK"==t?this.evtREQOK_withoutReqId():this.evtREQOK(rt(t.split(",")[1]));else if(v.startsWith(t,"PROBE"))this.evtPROBE();else if(v.startsWith(t,"LOOP"))this.evtLOOP(rt(t.split(",")[1]));else if(v.startsWith(t,"CONOK")){var i=t.split(",");this.evtCONOK(i[1],rt(i[2]),rt(i[3]),i[4])}else if(v.startsWith(t,"WSOK"))this.evtWSOK();else if(v.startsWith(t,"SERVNAME"))this.evtSERVNAME(t.split(",")[1]);else if(v.startsWith(t,"CLIENTIP"))this.evtCLIENTIP(t.split(",")[1]);else if(v.startsWith(t,"CONS")){var n=t.split(",")[1];switch(n){case"unlimited":this.evtCONS(Oe.BWUnlimited);break;case"unmanaged":this.evtCONS(Oe.BWUnmanaged);break;default:this.evtCONS(Oe.BWLimited(at(n)))}}else if(v.startsWith(t,"MSGDONE"))"*"==(r=(i=t.split(","))[1])&&(r="UNORDERED_MESSAGES"),this.evtMSGDONE(r,rt(i[2]));else if(v.startsWith(t,"MSGFAIL")){var r;"*"==(r=(i=t.split(","))[1])&&(r="UNORDERED_MESSAGES"),this.evtMSGFAIL(r,rt(i[2]),rt(i[3]),lt(i[4]))}else if(v.startsWith(t,"REQERR"))i=t.split(","),this.evtREQERR(rt(i[1]),rt(i[2]),lt(i[3]));else if(v.startsWith(t,"PROG"))this.evtPROG(rt(t.split(",")[1]));else if(v.startsWith(t,"SUBOK"))i=t.split(","),this.evtSUBOK(rt(i[1]),rt(i[2]),rt(i[3]));else if(v.startsWith(t,"SUBCMD"))i=t.split(","),this.evtSUBCMD(rt(i[1]),rt(i[2]),rt(i[3]),rt(i[4]),rt(i[5]));else if(v.startsWith(t,"UNSUB"))this.evtUNSUB(rt(t.split(",")[1]));else if(v.startsWith(t,"CONF")){var a=rt((i=t.split(","))[1]);"unlimited"==i[2]?this.evtCONF(a,De.RFreqUnlimited):this.evtCONF(a,De.RFreqLimited(at(i[2])))}else v.startsWith(t,"EOS")?(i=t.split(","),this.evtEOS(rt(i[1]),rt(i[2]))):v.startsWith(t,"CS")?(i=t.split(","),this.evtCS(rt(i[1]),rt(i[2]))):v.startsWith(t,"OV")?(i=t.split(","),this.evtOV(rt(i[1]),rt(i[2]),rt(i[3]))):v.startsWith(t,"NOOP")?this.evtNOOP():v.startsWith(t,"CONERR")?(i=t.split(","),this.evtCONERR(rt(i[1]),lt(i[2]))):v.startsWith(t,"END")?(i=t.split(","),this.evtEND(rt(i[1]),lt(i[2]))):v.startsWith(t,"ERROR")?(i=t.split(","),this.evtERROR(rt(i[1]),lt(i[2]))):v.startsWith(t,"SYNC")?this.evtSYNC(rt(t.split(",")[1])):e=!1;return e},evtCtrlMessage:function(t){if(v.startsWith(t,"REQOK"))"REQOK"==t?this.evtREQOK_withoutReqId():this.evtREQOK(rt(t.split(",")[1]));else if(v.startsWith(t,"REQERR")){var e=t.split(",");this.evtREQERR(rt(e[1]),rt(e[2]),lt(e[3]))}else v.startsWith(t,"ERROR")&&(e=t.split(","),this.evtERROR(rt(e[1]),lt(e[2])))},evtTransportTimeout:function(){switch(this.traceEvent("transport.timeout"),this.state.s_m){case 120:case 121:this.suspendWS_Streaming(),this.disposeWS(),this.cause="ws.unavailable",this.state.s_m=115,this.state.traceState(),this.cancel_evtTransportTimeout(),this.entry_m115(F.ws_unavailable);break;case 122:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.timeout",this.state.s_m=112,this.state.traceState(),this.cancel_evtTransportTimeout(),this.entry_m112(F.ws_timeout);break;case 130:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.timeout",this.state.s_m=112,this.state.traceState(),this.cancel_evtTransportTimeout(),this.entry_m112(F.http_timeout);break;case 140:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ttl.timeout";var t=this.waitingInterval(this.delayCounter.get_currentRetryDelay(),this.connectTs);this.state.s_m=111,this.state.traceState(),this.cancel_evtTransportTimeout(),this.entry_m111(F.http_error,t);break;case 150:if(null!=(s=this.state.s_tr))switch(s){case 220:0==this.options.sessionRecoveryTimeout?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.timeout",this.state.goto_m_from_session(112),this.cancel_evtTransportTimeout(),this.evtEndSession(),this.entry_m112(F.http_timeout)):(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="http.timeout",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec(),this.cancel_evtTransportTimeout(),this.entry_rec(t,F.http_timeout));break;case 230:0==this.options.sessionRecoveryTimeout?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ttl.timeout",this.state.goto_m_from_session(112),this.cancel_evtTransportTimeout(),this.evtEndSession(),this.entry_m112(F.http_timeout)):(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="ttl.timeout",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec(),this.cancel_evtTransportTimeout(),this.entry_rec(t,F.http_error));break;case 240:if(null!=(s=null!=(e=this.state.s_ws)?e.m:null))switch(s){case 500:this.disableWS(),this.disposeWS(),this.cause="ws.unavailable",this.state.clear_ws(),this.state.s_tr=200,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtSwitchTransport();break;case 501:0==this.options.sessionRecoveryTimeout?(this.disableWS(),this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.unavailable",this.state.goto_m_from_ws(112),this.exit_ws_to_m(),this.entry_m112(F.ws_unavailable)):(this.disableWS(),this.disposeWS(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="ws.unavailable",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_ws(),this.exit_ws(),this.entry_rec(t,F.ws_unavailable));break;case 502:0==this.options.sessionRecoveryTimeout?(this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.timeout",this.state.goto_m_from_ws(112),this.exit_ws_to_m(),this.entry_m112(F.ws_timeout)):(this.disposeWS(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="ws.timeout",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_ws(),this.exit_ws(),this.entry_rec(t,F.ws_timeout))}break;case 250:if(null!=(s=null!=(e=this.state.s_wp)?e.m:null))switch(s){case 600:case 601:this.disableWS(),this.disposeWS(),this.cause="ws.unavailable",this.state.clear_wp(),this.state.s_tr=200,this.state.traceState(),this.exit_wp(),this.evtSwitchTransport()}break;case 260:1001==this.state.s_rec&&(this.disposeHTTP(),this.state.s_rec=1002,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtCheckRecoveryTimeout(A.RRC_transport_timeout));break;case 270:var e,s;if(null!=(s=this.state.s_h)&&710==s&&null!=(s=null!=(e=this.state.s_hs)?e.m:null))switch(s){case 800:this.disableHTTP_Streaming(),this.cause="http.streaming.unavailable",this.state.s_hs.m=801,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtForcePolling(),this.schedule_evtTransportTimeout(this.options.retryDelay);break;case 801:0==this.options.sessionRecoveryTimeout?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.timeout",this.state.goto_m_from_hs(112),this.exit_hs_to_m(),this.entry_m112(F.http_timeout)):(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="http.timeout",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_hs(),this.exit_hs_to_rec(),this.entry_rec(t,F.http_timeout))}}}},evtTransportError:function(){switch(this.traceEvent("transport.error"),this.state.s_m){case 120:case 121:this.suspendWS_Streaming(),this.disposeWS(),this.cause="ws.unavailable",this.state.s_m=115,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtRetry(F.ws_unavailable),this.evtRetryTimeout();break;case 122:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.error";var t=this.waitingInterval(this.delayCounter.get_currentRetryDelay(),this.connectTs);this.state.s_m=112,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtRetry(F.ws_error,t),this.schedule_evtRetryTimeout(t);break;case 130:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.error",t=this.waitingInterval(this.delayCounter.get_currentRetryDelay(),this.connectTs),this.state.s_m=112,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtRetry(F.http_error,t),this.schedule_evtRetryTimeout(t);break;case 140:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ttl.error",t=this.waitingInterval(this.delayCounter.get_currentRetryDelay(),this.connectTs),this.state.s_m=111,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtRetry(F.http_error,t),this.schedule_evtRetryTimeout(t);break;case 150:var e=this.state.s_tr;if(null!=e)switch(e){case 210:0==this.options.sessionRecoveryTimeout?(this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.error",this.state.clear_w(),this.state.goto_m_from_session(113),this.exit_w(),this.evtEndSession(),this.entry_m113(F.ws_error)):(this.disposeWS(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="ws.error",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.clear_w(),this.state.s_tr=260,this.state.s_rec=1e3,this.state.traceState(),this.exit_w(),this.entry_rec(t,F.ws_error));break;case 220:0==this.options.sessionRecoveryTimeout?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.error",t=this.waitingInterval(this.delayCounter.get_currentRetryDelay(),this.connectTs),this.state.goto_m_from_session(112),this.cancel_evtTransportTimeout(),this.evtEndSession(),this.evtRetry(F.http_error,t),this.schedule_evtRetryTimeout(t)):(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="http.error",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec(),this.cancel_evtTransportTimeout(),this.entry_rec(t,F.http_error));break;case 230:0==this.options.sessionRecoveryTimeout?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ttl.error",t=this.waitingInterval(this.delayCounter.get_currentRetryDelay(),this.connectTs),this.state.goto_m_from_session(112),this.cancel_evtTransportTimeout(),this.evtEndSession(),this.evtRetry(F.http_error,t),this.schedule_evtRetryTimeout(t)):(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="ttl.error",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec(),this.cancel_evtTransportTimeout(),this.entry_rec(t,F.http_error));break;case 240:switch(Xt.sure(this.state.s_ws).m){case 500:this.disableWS(),this.disposeWS(),this.cause="ws.unavailable",this.state.clear_ws(),this.state.s_tr=200,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtSwitchTransport();break;case 501:0==this.options.sessionRecoveryTimeout?(this.disableWS(),this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.unavailable",this.state.goto_m_from_ws(112),this.exit_ws_to_m(),this.entry_m112(F.ws_unavailable)):(this.disableWS(),this.disposeWS(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="ws.unavailable",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_ws(),this.exit_ws(),this.entry_rec(t,F.ws_unavailable));break;case 502:0==this.options.sessionRecoveryTimeout?(this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.error",this.state.goto_m_from_ws(112),this.exit_ws_to_m(),this.entry_m112(F.ws_error)):(this.disposeWS(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="ws.error",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_ws(),this.cancel_evtTransportTimeout(),this.entry_rec(t,F.ws_error));break;case 503:0==this.options.sessionRecoveryTimeout?(this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.error",this.state.goto_m_from_ws(113),this.exit_ws_to_m(),this.entry_m113(F.ws_error)):(this.disposeWS(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="ws.error",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_ws(),this.exit_ws(),this.entry_rec(t,F.ws_error))}break;case 250:switch(Xt.sure(this.state.s_wp).m){case 600:case 601:this.disableWS(),this.disposeWS(),this.cause="ws.unavailable",this.state.clear_wp(),this.state.s_tr=200,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtSwitchTransport();break;case 602:0==this.options.sessionRecoveryTimeout?(this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.error",this.state.goto_m_from_wp(113),this.exit_wp_to_m(),this.entry_m113(F.ws_error)):(this.disposeWS(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="ws.error",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_wp(),this.exit_wp(),this.entry_rec(t,F.ws_error))}break;case 260:1001==this.state.s_rec&&(this.disposeHTTP(),this.state.s_rec=1002,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtCheckRecoveryTimeout(A.RRC_transport_error));break;case 270:switch(Xt.sure(this.state.s_h)){case 710:switch(Xt.sure(this.state.s_hs).m){case 800:case 801:0==this.options.sessionRecoveryTimeout?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.error",this.state.goto_m_from_hs(112),this.exit_hs_to_m(),this.entry_m112(F.http_error)):(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="http.error",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_hs(),this.exit_hs_to_rec(),this.entry_rec(t,F.http_error));break;case 802:0==this.options.sessionRecoveryTimeout?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.error",this.state.goto_m_from_hs(113),this.exit_hs_to_m(),this.entry_m113(F.http_error)):(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="http.error",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_hs(),this.exit_hs_to_rec(),this.entry_rec(t,F.http_error))}break;case 720:switch(Xt.sure(this.state.s_hp).m){case 900:case 901:case 902:case 903:case 904:0==this.options.sessionRecoveryTimeout?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.error",this.state.goto_m_from_hp(112),this.exit_hp_to_m(),this.entry_m112(F.http_error)):(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="http.error",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_hp(),this.exit_hp_to_rec(),this.entry_rec(t,F.http_error))}}}}},evtIdleTimeout:function(){if(this.traceEvent("idle.timeout"),null==(i=null!=(s=this.state.s_wp)?s.p:null))e=!1;else switch(i){case 610:case 611:case 613:e=!0;break;default:e=!1}if(e)if(0==this.options.sessionRecoveryTimeout)this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.idle.timeout",this.state.goto_m_from_wp(113),this.exit_wp_to_m(),this.entry_m113(F.idle_timeout);else{this.disposeWS(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="ws.idle.timeout";var t=this.randomGenerator(this.options.firstRetryMaxDelay);this.state.goto_rec_from_wp(),this.exit_wp(),this.entry_rec(t,F.idle_timeout)}else{var e,s,i;if(null==(i=null!=(s=this.state.s_hp)?s.m:null))e=!1;else switch(i){case 900:case 901:case 903:e=!0;break;default:e=!1}e&&(0==this.options.sessionRecoveryTimeout?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.idle.timeout",this.state.goto_m_from_hp(112),this.exit_hp_to_m(),this.entry_m112(F.idle_timeout)):(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="http.idle.timeout",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_hp(),this.exit_hp_to_rec(),this.entry_rec(t,F.idle_timeout)))}},evtPollingTimeout:function(){var t;this.traceEvent("polling.timeout"),612==(null!=(t=this.state.s_wp)?t.p:null)?(this.sendBindWS_Polling(),this.state.s_wp.p=613,this.state.traceState(),this.cancel_evtPollingTimeout(),this.schedule_evtIdleTimeout(Se.plus(Xt.sure(this.idleTimeout),this.options.retryDelay))):902==(null!=(t=this.state.s_hp)?t.m:null)&&(this.sendBindHTTP_Polling(),this.state.s_hp.m=903,this.state.traceState(),this.cancel_evtPollingTimeout(),this.schedule_evtIdleTimeout(Se.plus(Xt.sure(this.idleTimeout),this.options.retryDelay)))},evtKeepaliveTimeout:function(){var t;this.traceEvent("keepalive.timeout"),310==(null!=(t=this.state.s_w)?t.k:null)?(this.state.s_w.k=311,this.state.traceState(),this.cancel_evtKeepaliveTimeout(),this.schedule_evtStalledTimeout(this.options.stalledTimeout)):520==(null!=(t=this.state.s_ws)?t.k:null)?(this.state.s_ws.k=521,this.state.traceState(),this.cancel_evtKeepaliveTimeout(),this.schedule_evtStalledTimeout(this.options.stalledTimeout)):820==(null!=(t=this.state.s_hs)?t.k:null)&&(this.state.s_hs.k=821,this.state.traceState(),this.cancel_evtKeepaliveTimeout(),this.schedule_evtStalledTimeout(this.options.stalledTimeout))},evtStalledTimeout:function(){var t;this.traceEvent("stalled.timeout"),311==(null!=(t=this.state.s_w)?t.k:null)?(this.state.s_w.k=312,this.state.traceState(),this.cancel_evtStalledTimeout(),this.schedule_evtReconnectTimeout(this.options.reconnectTimeout)):521==(null!=(t=this.state.s_ws)?t.k:null)?(this.state.s_ws.k=522,this.state.traceState(),this.cancel_evtStalledTimeout(),this.schedule_evtReconnectTimeout(this.options.reconnectTimeout)):821==(null!=(t=this.state.s_hs)?t.k:null)&&(this.state.s_hs.k=822,this.state.traceState(),this.cancel_evtStalledTimeout(),this.schedule_evtReconnectTimeout(this.options.reconnectTimeout))},evtReconnectTimeout:function(){var t;if(this.traceEvent("reconnect.timeout"),312==(null!=(t=this.state.s_w)?t.k:null))if(0==this.options.sessionRecoveryTimeout)this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.stalled",this.state.goto_m_from_w(113),this.exit_w_to_m(),this.entry_m113(F.stalled_timeout);else{this.disposeWS(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="ws.stalled";var e=this.randomGenerator(this.options.firstRetryMaxDelay);this.state.goto_rec_from_w(),this.exit_w(),this.entry_rec(e,F.stalled_timeout)}else 522==(null!=(t=this.state.s_ws)?t.k:null)?0==this.options.sessionRecoveryTimeout?(this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.stalled",this.state.goto_m_from_ws(113),this.exit_ws_to_m(),this.entry_m113(F.stalled_timeout)):(this.disposeWS(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="ws.stalled",e=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_ws(),this.exit_ws(),this.entry_rec(e,F.stalled_timeout)):822==(null!=(t=this.state.s_hs)?t.k:null)&&(0==this.options.sessionRecoveryTimeout?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.stalled",this.state.goto_m_from_hs(113),this.exit_hs_to_m(),this.entry_m113(F.stalled_timeout)):(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="http.stalled",e=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_hs(),this.exit_hs_to_rec(),this.entry_rec(e,F.stalled_timeout)))},evtRestartKeepalive:function(){var t;this.traceEvent("restart.keepalive"),null!=(null!=(t=this.state.s_w)?t.k:null)?(this.state.s_w.k=310,this.state.traceState(),this.exit_keepalive_unit(),this.schedule_evtKeepaliveTimeout(Xt.sure(this.keepaliveInterval))):null!=(null!=(t=this.state.s_ws)?t.k:null)?(this.state.s_ws.k=520,this.state.traceState(),this.exit_keepalive_unit(),this.schedule_evtKeepaliveTimeout(Xt.sure(this.keepaliveInterval))):null!=(null!=(t=this.state.s_hs)?t.k:null)&&(this.state.s_hs.k=820,this.state.traceState(),this.exit_keepalive_unit(),this.schedule_evtKeepaliveTimeout(Xt.sure(this.keepaliveInterval)))},evtWSOK:function(){switch(this.traceEvent("WSOK"),ii.isDebugEnabled()&&ii.debug("WSOK"),this.state.s_m){case 121:this.state.s_m=122,this.state.traceState();break;case 150:if(null!=(e=this.state.s_tr))switch(e){case 240:null!=(e=null!=(t=this.state.s_ws)?t.m:null)&&501==e&&(this.state.s_ws.m=502,this.state.traceState());break;case 250:var t,e;null!=(e=null!=(t=this.state.s_wp)?t.m:null)&&601==e&&(this.sendBindWS_FirstPolling(),this.state.s_wp.m=602,this.state.s_wp.p=610,this.state.s_wp.c=620,this.state.s_wp.s=630,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtSendPendingControls(),this.evtSendPendingMessages(),this.schedule_evtIdleTimeout(Se.plus(Xt.sure(this.idleTimeout),this.options.retryDelay)))}}},evtCONERR:function(t,e){this.traceEvent("CONERR"),ii.isDebugEnabled()&&ii.debug("CONERR "+t+" "+e);var s=F.standardError(t,e),i=q.TC_standardError(t,e);if(122==this.state.s_m)switch(t){case 5:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.conerr."+t,this.state.s_m=110,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtRetry(s),this.evtRetryTimeout();break;case 4:case 6:case 20:case 40:case 41:case 48:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.conerr."+t;var n=this.waitingInterval(this.delayCounter.get_currentRetryDelay(),this.connectTs);this.state.s_m=112,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtRetry(s,n),this.schedule_evtRetryTimeout(n);break;default:this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_CONERR(t,e),this.state.s_m=100,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtTerminate(i)}else if(130==this.state.s_m)switch(t){case 5:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.conerr."+t,this.state.s_m=110,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtRetry(s),this.evtRetryTimeout();break;case 4:case 6:case 20:case 40:case 41:case 48:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.conerr."+t,n=this.waitingInterval(this.delayCounter.get_currentRetryDelay(),this.connectTs),this.state.s_m=112,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtRetry(s,n),this.schedule_evtRetryTimeout(n);break;default:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_CONERR(t,e),this.state.s_m=100,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtTerminate(i)}else if(140==this.state.s_m)switch(t){case 5:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ttl.conerr."+t,this.state.s_m=110,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtRetry(s),this.evtRetryTimeout();break;case 4:case 6:case 20:case 40:case 41:case 48:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ttl.conerr."+t,n=this.waitingInterval(this.delayCounter.get_currentRetryDelay(),this.connectTs),this.state.s_m=112,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtRetry(s,n),this.schedule_evtRetryTimeout(n);break;default:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_CONERR(t,e),this.state.s_m=100,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtTerminate(i)}else{var r,a;if(502==(null!=(r=this.state.s_ws)?r.m:null))switch(t){case 4:case 6:case 20:case 40:case 41:case 48:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.conerr."+t,this.state.goto_m_from_ws(112),this.exit_ws_to_m(),this.entry_m112(F.standardError(t,e));break;default:this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_CONERR(t,e),this.state.goto_m_from_ws(100),this.exit_ws_to_m(),this.evtTerminate(i)}else if(r=610==(null!=(a=this.state.s_wp)?a.p:null)||613==(null!=(a=this.state.s_wp)?a.p:null))switch(t){case 4:case 6:case 20:case 40:case 41:case 48:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.conerr."+t,this.state.goto_m_from_wp(112),this.exit_wp_to_m(),this.entry_m112(F.standardError(t,e));break;default:this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_CONERR(t,e),this.state.goto_m_from_wp(100),this.exit_wp_to_m(),this.evtTerminate(i)}else if(r=800==(null!=(a=this.state.s_hs)?a.m:null)||801==(null!=(a=this.state.s_hs)?a.m:null))switch(t){case 4:case 6:case 20:case 40:case 41:case 48:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.conerr."+t,this.state.goto_m_from_hs(112),this.exit_hs_to_m(),this.entry_m112(F.standardError(t,e));break;default:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_CONERR(t,e),this.state.goto_m_from_hs(100),this.exit_hs_to_m(),this.evtTerminate(i)}else if(r=900==(null!=(a=this.state.s_hp)?a.m:null)||903==(null!=(a=this.state.s_hp)?a.m:null))switch(t){case 4:case 6:case 20:case 40:case 41:case 48:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.conerr."+t,this.state.goto_m_from_hp(112),this.exit_hp_to_m(),this.entry_m112(F.standardError(t,e));break;default:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_CONERR(t,e),this.state.goto_m_from_hp(100),this.exit_hp_to_m(),this.evtTerminate(i)}else if(1001==this.state.s_rec)switch(t){case 4:case 6:case 20:case 40:case 41:case 48:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="recovery.conerr."+t,this.state.goto_m_from_rec(113),this.exit_rec_to_m(),this.entry_m113(s);break;default:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_CONERR(t,e),this.state.goto_m_from_rec(100),this.exit_rec_to_m(),this.evtTerminate(i)}}},evtEND:function(t,e){this.traceEvent("END"),ii.isDebugEnabled()&&ii.debug("END "+t+" "+e);var s=F.standardError(t,e),i=q.TC_standardError(t,e);if(300==(null!=(a=this.state.s_w)?a.p:null))switch(t){case 41:case 48:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.end."+t;var n=this.randomGenerator(this.options.firstRetryMaxDelay);this.state.clear_w(),this.state.goto_m_from_session(113),this.exit_w(),this.evtEndSession(),this.evtRetry(F.standardError(t,e),n),this.schedule_evtRetryTimeout(n);break;default:this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_END(t,e),this.state.clear_w(),this.state.goto_m_from_session(100),this.exit_w(),this.evtEndSession(),this.evtTerminate(i)}else if(502==(null!=(a=this.state.s_ws)?a.m:null))switch(t){case 41:case 48:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.end."+t,this.state.goto_m_from_ws(112),this.exit_ws_to_m(),this.entry_m112(F.standardError(t,e));break;default:this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_END(t,e),this.state.goto_m_from_ws(100),this.exit_ws_to_m(),this.evtTerminate(i)}else if(510==(null!=(a=this.state.s_ws)?a.p:null))switch(t){case 41:case 48:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.end."+t,this.state.goto_m_from_ws(113),this.exit_ws_to_m(),this.entry_m113(s);break;default:this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_END(t,e),this.state.goto_m_from_ws(100),this.exit_ws_to_m(),this.evtTerminate(i)}else if(a=610==(null!=(r=this.state.s_wp)?r.p:null)||613==(null!=(r=this.state.s_wp)?r.p:null))switch(t){case 41:case 48:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.end."+t,this.state.goto_m_from_wp(112),this.exit_wp_to_m(),this.entry_m112(F.standardError(t,e));break;default:this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_END(t,e),this.state.goto_m_from_wp(100),this.exit_wp_to_m(),this.evtTerminate(i)}else if(611==(null!=(a=this.state.s_wp)?a.p:null))switch(t){case 41:case 48:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.end."+t,this.state.goto_m_from_wp(113),this.exit_wp_to_m(),this.entry_m113(s);break;default:this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_END(t,e),this.state.goto_m_from_wp(100),this.exit_wp_to_m(),this.evtTerminate(i)}else if(a=800==(null!=(r=this.state.s_hs)?r.m:null)||801==(null!=(r=this.state.s_hs)?r.m:null))switch(t){case 41:case 48:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.end."+t,this.state.goto_m_from_hs(112),this.exit_hs_to_m(),this.entry_m112(F.standardError(t,e));break;default:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_END(t,e),this.state.goto_m_from_hs(100),this.exit_hs_to_m(),this.evtTerminate(i)}else if(810==(null!=(a=this.state.s_hs)?a.p:null))switch(t){case 41:case 48:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.end."+t,this.state.goto_m_from_hs(113),this.exit_hs_to_m(),this.entry_m113(s);break;default:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_END(t,e),this.state.goto_m_from_hs(100),this.exit_hs_to_m(),this.evtTerminate(i)}else{var r,a;if(a=900==(null!=(r=this.state.s_hp)?r.m:null)||903==(null!=(r=this.state.s_hp)?r.m:null))switch(t){case 41:case 48:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.end."+t,this.state.goto_m_from_hp(112),this.exit_hp_to_m(),this.entry_m112(F.standardError(t,e));break;default:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_END(t,e),this.state.goto_m_from_hp(100),this.exit_hp_to_m(),this.evtTerminate(i)}else if(901==(null!=(a=this.state.s_hp)?a.m:null))switch(t){case 41:case 48:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.end."+t,this.state.goto_m_from_hp(113),this.exit_hp_to_m(),this.entry_m113(s);break;default:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_END(t,e),this.state.goto_m_from_hp(100),this.exit_hp_to_m(),this.evtTerminate(i)}else if(1001==this.state.s_rec)switch(t){case 41:case 48:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="recovery.end."+t,this.state.goto_m_from_rec(113),this.exit_rec_to_m(),this.entry_m113(s);break;default:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_END(t,e),this.state.goto_m_from_rec(100),this.exit_rec_to_m(),this.evtTerminate(i)}}},evtERROR:function(t,e){this.traceEvent("ERROR"),ii.isDebugEnabled()&&ii.debug("ERROR "+t+" "+e);var s,i=q.TC_standardError(t,e);300==(null!=(s=this.state.s_w)?s.p:null)?(this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_ERROR(t,e),this.state.clear_w(),this.state.goto_m_from_session(100),this.exit_w(),this.evtEndSession(),this.evtTerminate(i)):510==(null!=(s=this.state.s_ws)?s.p:null)?(this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_ERROR(t,e),this.state.goto_m_from_ws(100),this.exit_ws_to_m(),this.evtTerminate(i)):620==(null!=(s=this.state.s_wp)?s.c:null)?(this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_ERROR(t,e),this.state.goto_m_from_wp(100),this.exit_wp_to_m(),this.evtTerminate(i)):1102==this.state.s_ctrl&&(this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_ERROR(t,e),this.state.goto_m_from_ctrl(100),this.exit_ctrl_to_m(),this.evtTerminate(i))},evtREQOK_withoutReqId:function(){this.traceEvent("REQOK"),ii.isDebugEnabled()&&ii.debug("REQOK"),1102==this.state.s_ctrl&&(this.state.s_ctrl=1102,this.state.traceState())},evtREQOK:function(t){this.traceEvent("REQOK"),ii.isDebugEnabled()&&ii.debug("REQOK "+t);var e=!0;1302==this.state.s_swt&&t==this.swt_lastReqId?(this.state.s_swt=1303,this.state.traceState(),e=this.evtREQOK_TransportRegion(t)):1202==this.state.s_bw&&t==this.bw_lastReqId?(this.state.s_bw=1200,this.state.traceState(),e=this.evtREQOK_TransportRegion(t),this.evtCheckBW()):e=this.evtREQOK_Forward(t),e&&this.evtREQOK_TransportRegion(t)},evtREQOK_Forward:function(t){return!0},evtREQOK_TransportRegion:function(t){var e;return 300==(null!=(e=this.state.s_w)?e.p:null)?(this.state.s_w.p=300,this.state.traceState(),this.doREQOK(t),this.evtRestartKeepalive()):510==(null!=(e=this.state.s_ws)?e.p:null)?(this.state.s_ws.p=510,this.state.traceState(),this.doREQOK(t),this.evtRestartKeepalive()):620==(null!=(e=this.state.s_wp)?e.c:null)?(this.state.s_wp.c=620,this.state.traceState(),this.doREQOK(t)):1102==this.state.s_ctrl&&(this.state.s_ctrl=1102,this.state.traceState(),this.doREQOK(t)),!1},evtREQERR:function(t,e,s){this.traceEvent("REQERR"),ii.isDebugEnabled()&&ii.debug("REQERR "+t+" "+e+" "+s);var i=!0;1302==this.state.s_swt&&t==this.swt_lastReqId?(this.state.s_swt=1301,this.state.traceState(),i=this.evtREQERR_TransportRegion(t,e,s)):1202==this.state.s_bw&&t==this.bw_lastReqId?(this.state.s_bw=1200,this.state.traceState(),i=this.evtREQERR_TransportRegion(t,e,s),this.evtCheckBW()):i=this.evtREQERR_Forward(t,e,s),i&&this.evtREQERR_TransportRegion(t,e,s)},evtREQERR_Forward:function(t,e,s){return!0},evtREQERR_TransportRegion:function(t,e,s){var i,n=F.standardError(e,s),r=q.TC_standardError(e,s);if(300==(null!=(i=this.state.s_w)?i.p:null))switch(e){case 20:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.reqerr."+e;var a=this.randomGenerator(this.options.firstRetryMaxDelay);this.state.clear_w(),this.state.goto_m_from_session(113),this.exit_w(),this.evtEndSession(),this.evtRetry(F.standardError(e,s),a),this.schedule_evtRetryTimeout(a);break;case 11:case 65:case 67:this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_REQERR(e,s),this.state.clear_w(),this.state.goto_m_from_session(100),this.exit_w(),this.evtEndSession(),this.evtTerminate(r);break;default:this.state.s_w.p=300,this.state.traceState(),this.doREQERR(t,e,s),this.evtRestartKeepalive()}else if(510==(null!=(i=this.state.s_ws)?i.p:null))switch(e){case 20:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.reqerr."+e+")",this.state.goto_m_from_ws(113),this.exit_ws_to_m(),this.entry_m113(n);break;case 11:case 65:case 67:this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_REQERR(e,s),this.state.goto_m_from_ws(100),this.exit_ws_to_m(),this.evtTerminate(r);break;default:this.state.s_ws.p=510,this.state.traceState(),this.doREQERR(t,e,s),this.evtRestartKeepalive()}else if(620==(null!=(i=this.state.s_wp)?i.c:null))switch(e){case 20:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.reqerr."+e,this.state.goto_m_from_wp(113),this.exit_wp_to_m(),this.entry_m113(n);break;case 11:case 65:case 67:this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_REQERR(e,s),this.state.goto_m_from_wp(100),this.exit_wp_to_m(),this.evtTerminate(r);break;default:this.state.s_wp.c=620,this.state.traceState(),this.doREQERR(t,e,s)}else if(1102==this.state.s_ctrl)switch(e){case 20:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.reqerr."+e,this.state.goto_m_from_ctrl(113),this.exit_ctrl_to_m(),this.entry_m113(n);break;case 11:case 65:case 67:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_REQERR(e,s),this.state.goto_m_from_ctrl(100),this.exit_ctrl_to_m(),this.evtTerminate(r);break;default:this.state.s_ctrl=1102,this.state.traceState(),this.doREQERR(t,e,s)}return!1},evtPROG:function(t){this.traceEvent("PROG");var e=F.prog_mismatch(this.rec_serverProg,t);if(ii.isDebugEnabled()&&ii.debug("PROG "+t),300==(null!=(s=this.state.s_w)?s.p:null))t!=this.rec_serverProg?(this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="prog.mismatch."+t+"."+this.rec_serverProg,this.state.clear_w(),this.state.goto_m_from_session(113),this.exit_w(),this.evtEndSession(),this.entry_m113(e)):(this.state.s_w.p=300,this.state.traceState(),this.evtRestartKeepalive());else if(220==this.state.s_tr)t!=this.rec_serverProg?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="prog.mismatch."+t+"."+this.rec_serverProg,this.state.goto_m_from_session(113),this.cancel_evtTransportTimeout(),this.evtEndSession(),this.entry_m113(e)):(this.state.s_tr=220,this.state.traceState());else if(230==this.state.s_tr)t!=this.rec_serverProg?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="prog.mismatch."+t+"."+this.rec_serverProg,this.state.goto_m_from_session(113),this.cancel_evtTransportTimeout(),this.evtEndSession(),this.entry_m113(e)):(this.state.s_tr=230,this.state.traceState());else{var s;510==(null!=(s=this.state.s_ws)?s.p:null)?t!=this.rec_serverProg?(this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="prog.mismatch."+t+"."+this.rec_serverProg,this.state.goto_m_from_ws(113),this.exit_ws_to_m(),this.entry_m113(e)):(this.state.s_ws.p=510,this.state.traceState(),this.evtRestartKeepalive()):611==(null!=(s=this.state.s_wp)?s.p:null)?t!=this.rec_serverProg?(this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="prog.mismatch."+t+"."+this.rec_serverProg,this.state.goto_m_from_wp(113),this.exit_wp_to_m(),this.entry_m113(e)):(this.state.s_wp.p=611,this.state.traceState()):810==(null!=(s=this.state.s_hs)?s.p:null)?t!=this.rec_serverProg?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="prog.mismatch."+t+"."+this.rec_serverProg,this.state.goto_m_from_hs(113),this.exit_hs_to_m(),this.entry_m113(e)):(this.state.s_hs.p=810,this.state.traceState(),this.evtRestartKeepalive()):901==(null!=(s=this.state.s_hp)?s.m:null)?t!=this.rec_serverProg?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="prog.mismatch."+t+"."+this.rec_serverProg,this.state.goto_m_from_hp(113),this.exit_hp_to_m(),this.entry_m113(e)):(this.state.s_hp.m=901,this.state.traceState()):1001==this.state.s_rec&&(t>this.rec_clientProg?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="prog.mismatch."+t+"."+this.rec_serverProg,this.state.goto_m_from_rec(113),this.exit_rec_to_m(),this.entry_m113(e)):(this.state.s_rec=1001,this.state.traceState(),this.doPROG(t)))}},evtLOOP:function(t){if(this.traceEvent("LOOP"),ii.isDebugEnabled()&&ii.debug("LOOP "+t),300==(null!=(e=this.state.s_w)?e.p:null))this.closeWS(),this.cause="ws.loop",this.state.clear_w(),this.state.s_tr=200,this.state.traceState(),this.exit_w(),this.evtSwitchTransport();else if(220==this.state.s_tr)this.closeHTTP(),this.cause="http.loop",this.state.s_tr=200,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtSwitchTransport();else if(230==this.state.s_tr)this.closeHTTP(),this.cause="ttl.loop",this.state.s_tr=200,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtSwitchTransport();else{var e;510==(null!=(e=this.state.s_ws)?e.p:null)?(this.closeWS(),this.cause="ws.loop",this.state.clear_ws(),this.state.s_tr=200,this.state.traceState(),this.exit_ws(),this.evtSwitchTransport()):611==(null!=(e=this.state.s_wp)?e.p:null)?this.isSwitching()?(this.closeWS(),this.cause="ws.loop",this.state.clear_wp(),this.state.s_tr=200,this.state.traceState(),this.exit_wp(),this.evtSwitchTransport()):(this.doLOOP(t),this.state.s_wp.p=612,this.state.traceState(),this.cancel_evtIdleTimeout(),this.schedule_evtPollingTimeout(this.options.pollingInterval)):810==(null!=(e=this.state.s_hs)?e.p:null)?(this.closeHTTP(),this.cause="http.loop",this.state.s_hs.p=811,this.state.traceState(),this.evtSwitchTransport()):901==(null!=(e=this.state.s_hp)?e.m:null)?this.isSwitching()?(this.closeHTTP(),this.state.s_hp.m=904,this.state.traceState(),this.cancel_evtIdleTimeout(),this.evtSwitchTransport()):(this.doLOOP(t),this.closeHTTP(),this.state.s_hp.m=902,this.state.traceState(),this.cancel_evtIdleTimeout(),this.schedule_evtPollingTimeout(this.options.pollingInterval)):1001==this.state.s_rec&&(this.closeHTTP(),this.cause="recovery.loop",this.state.goto_200_from_rec(),this.exit_rec(),this.evtSwitchTransport())}},evtCONOK:function(t,e,s,i){if(this.traceEvent("CONOK"),ii.isDebugEnabled()&&ii.debug("CONOK "+t+" "+e+" "+s+" "+i),122==this.state.s_m)this.doCONOK_CreateWS(t,e,s,i),this.resetCurrentRetryDelay(),this.notifyStatus("CONNECTED:WS-STREAMING"),this.state.s_m=150,this.state.s_tr=210,this.state.s_w=new V(300,310,340),this.state.s_rhb=320,this.state.s_slw=330,this.state.s_swt=1300,this.state.s_bw=1200,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtSendPendingControls(),this.evtSendPendingMessages(),this.evtStartSession(),this.schedule_evtKeepaliveTimeout(Xt.sure(this.keepaliveInterval)),this.evtSelectRhb(),this.evtCheckTransport(),this.evtCheckBW();else if(130==this.state.s_m)this.doCONOK_CreateHTTP(t,e,s,i),this.resetCurrentRetryDelay(),this.notifyStatus("CONNECTED:STREAM-SENSING"),this.state.s_m=150,this.state.s_tr=220,this.state.s_swt=1300,this.state.s_bw=1200,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtStartSession(),this.schedule_evtTransportTimeout(this.options.retryDelay),this.evtCheckTransport(),this.evtCheckBW();else if(140==this.state.s_m)this.doCONOK_CreateHTTP(t,e,s,i),this.resetCurrentRetryDelay(),this.notifyStatus("CONNECTED:STREAM-SENSING"),this.state.s_m=150,this.state.s_tr=230,this.state.s_swt=1300,this.state.s_bw=1200,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtStartSession(),this.schedule_evtTransportTimeout(this.options.retryDelay),this.evtCheckTransport(),this.evtCheckBW();else{var n;502==(null!=(n=this.state.s_ws)?n.m:null)?(this.doCONOK_BindWS_Streaming(t,e,s,i),this.notifyStatus("CONNECTED:WS-STREAMING"),this.state.s_ws.m=503,this.state.s_ws.p=510,this.state.s_ws.k=520,this.state.s_ws.s=550,this.state.s_rhb=320,this.state.s_slw=330,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtSendPendingControls(),this.evtSendPendingMessages(),this.schedule_evtKeepaliveTimeout(Xt.sure(this.keepaliveInterval)),this.evtSelectRhb()):610==(null!=(n=this.state.s_wp)?n.p:null)?(this.doCONOK_BindWS_Polling(t,e,s,i),this.notifyStatus("CONNECTED:WS-POLLING"),this.state.s_wp.p=611,this.state.traceState()):613==(null!=(n=this.state.s_wp)?n.p:null)?(this.doCONOK_BindWS_Polling(t,e,s,i),this.state.s_wp.p=611,this.state.traceState()):800==(null!=(n=this.state.s_hs)?n.m:null)||801==(null!=(n=this.state.s_hs)?n.m:null)?(this.doCONOK_BindHTTP_Streaming(t,e,s,i),this.notifyStatus("CONNECTED:HTTP-STREAMING"),this.state.s_hs.m=802,this.state.s_hs.p=810,this.state.s_hs.k=820,this.state.s_rhb=320,this.state.s_slw=330,this.state.traceState(),this.cancel_evtTransportTimeout(),this.schedule_evtKeepaliveTimeout(Xt.sure(this.keepaliveInterval)),this.evtSelectRhb()):900==(null!=(n=this.state.s_hp)?n.m:null)?(this.doCONOK_BindHTTP_Polling(t,e,s,i),this.notifyStatus("CONNECTED:HTTP-POLLING"),this.state.s_hp.m=901,this.state.traceState()):903==(null!=(n=this.state.s_hp)?n.m:null)&&(this.doCONOK_BindHTTP_Polling(t,e,s,i),this.state.s_hp.m=901,this.state.traceState())}},evtSERVNAME:function(t){this.traceEvent("SERVNAME"),ii.isDebugEnabled()&&ii.debug("SERVNAME "+t),this.state.inPushing()&&(this.doSERVNAME(t),this.state.inStreaming()&&this.evtRestartKeepalive())},evtCLIENTIP:function(t){this.traceEvent("CLIENTIP"),ii.isDebugEnabled()&&ii.debug("CLIENTIP "+t),this.state.inPushing()&&(this.doCLIENTIP(t),this.state.inStreaming()&&this.evtRestartKeepalive())},evtCONS:function(t){this.traceEvent("CONS"),ii.isDebugEnabled()&&ii.debug("CONS "+g.string(t)),this.state.inPushing()&&(this.doCONS(t),this.state.inStreaming()&&this.evtRestartKeepalive())},evtPROBE:function(){this.traceEvent("PROBE"),ii.isDebugEnabled()&&ii.debug("PROBE"),this.clientEventDispatcher.onServerKeepalive(),this.state.inPushing()&&this.state.inStreaming()&&this.evtRestartKeepalive()},evtNOOP:function(){this.traceEvent("NOOP"),this.state.inPushing()&&this.state.inStreaming()&&this.evtRestartKeepalive()},evtSYNC:function(t){this.traceEvent("SYNC"),ii.isDebugEnabled()&&ii.debug("SYNC "+t);var e,s,i=!0;(s=300==(null!=(e=this.state.s_w)?e.p:null)||510==(null!=(e=this.state.s_ws)?e.p:null),!s&&810!=(null!=(s=this.state.s_hs)?s.p:null))?(!!(s=220==this.state.s_tr||230==this.state.s_tr||611==(null!=(e=this.state.s_wp)?e.p:null))||901==(null!=(s=this.state.s_hp)?s.m:null)||1001==this.state.s_rec)&&(i=this.evtSYNC_PushingRegion(t)):(i=this.evtSYNC_PushingRegion(t),this.evtRestartKeepalive());i&&this.evtSYNC_PushingRegion(t)},evtSYNC_PushingRegion:function(t){var e=1e3*t;if(null!=this.state.s_slw){var s=this.state.s_slw;if(null!=s)switch(s){case 330:this.doSYNC(e),this.state.s_slw=331,this.state.traceState();break;case 331:var i=this.doSYNC_G(e);this.state.s_slw=332,this.state.traceState(),this.evtCheckAvg(i);break;case 333:i=this.doSYNC_NG(e),this.state.s_slw=332,this.state.traceState(),this.evtCheckAvg(i)}}return!1},evtMSGDONE:function(t,e){this.traceEvent("MSGDONE"),ii.isDebugEnabled()&&ii.debug("MSGDONE "+t+" "+e),this.state.inPushing()&&(this.isFreshData()?(this.doMSGDONE(t,e),this.state.inStreaming()&&this.evtRestartKeepalive()):(this.onStaleData(),this.state.inStreaming()&&this.evtRestartKeepalive()))},evtMSGFAIL:function(t,e,s,i){this.traceEvent("MSGFAIL"),ii.isDebugEnabled()&&ii.debug("MSGFAIL "+t+" "+e+" "+s+" "+i),this.state.inPushing()&&(this.isFreshData()?(this.doMSGFAIL(t,e,s,i),this.state.inStreaming()&&this.evtRestartKeepalive()):(this.onStaleData(),this.state.inStreaming()&&this.evtRestartKeepalive()))},evtU:function(t,e,s,i){this.traceEvent("U"),ii.isDebugEnabled()&&ii.debug(""+i),this.state.inPushing()&&(this.isFreshData()?(this.doU(t,e,s),this.state.inStreaming()&&this.evtRestartKeepalive()):(this.onStaleData(),this.state.inStreaming()&&this.evtRestartKeepalive()))},evtSUBOK:function(t,e,s){this.traceEvent("SUBOK"),ii.isDebugEnabled()&&ii.debug("SUBOK "+t+" "+e+" "+s),this.state.inPushing()&&(this.isFreshData()?(this.doSUBOK(t,e,s),this.state.inStreaming()&&this.evtRestartKeepalive()):(this.onStaleData(),this.state.inStreaming()&&this.evtRestartKeepalive()))},evtSUBCMD:function(t,e,s,i,n){this.traceEvent("SUBCMD"),ii.isDebugEnabled()&&ii.debug("SUBCMD "+t+" "+e+" "+s+" "+i+" "+n),this.state.inPushing()&&(this.isFreshData()?(this.doSUBCMD(t,e,s,i,n),this.state.inStreaming()&&this.evtRestartKeepalive()):(this.onStaleData(),this.state.inStreaming()&&this.evtRestartKeepalive()))},evtUNSUB:function(t){this.traceEvent("UNSUB"),ii.isDebugEnabled()&&ii.debug("UNSUB "+t),this.state.inPushing()&&(this.isFreshData()?(this.doUNSUB(t),this.state.inStreaming()&&this.evtRestartKeepalive()):(this.onStaleData(),this.state.inStreaming()&&this.evtRestartKeepalive()))},evtEOS:function(t,e){this.traceEvent("EOS"),ii.isDebugEnabled()&&ii.debug("EOS "+t+" "+e),this.state.inPushing()&&(this.isFreshData()?(this.doEOS(t,e),this.state.inStreaming()&&this.evtRestartKeepalive()):(this.onStaleData(),this.state.inStreaming()&&this.evtRestartKeepalive()))},evtCS:function(t,e){this.traceEvent("CS"),ii.isDebugEnabled()&&ii.debug("CS "+t+" "+e),this.state.inPushing()&&(this.isFreshData()?(this.doCS(t,e),this.state.inStreaming()&&this.evtRestartKeepalive()):(this.onStaleData(),this.state.inStreaming()&&this.evtRestartKeepalive()))},evtOV:function(t,e,s){this.traceEvent("OV"),ii.isDebugEnabled()&&ii.debug("OV "+t+" "+e+" "+s),this.state.inPushing()&&(this.isFreshData()?(this.doOV(t,e,s),this.state.inStreaming()&&this.evtRestartKeepalive()):(this.onStaleData(),this.state.inStreaming()&&this.evtRestartKeepalive()))},evtCONF:function(t,e){this.traceEvent("CONF"),ii.isDebugEnabled()&&ii.debug("CONF "+t+" "+g.string(e)),this.state.inPushing()&&(this.isFreshData()?(this.doCONF(t,e),this.state.inStreaming()&&this.evtRestartKeepalive()):(this.onStaleData(),this.state.inStreaming()&&this.evtRestartKeepalive()))},evtCheckAvg:function(t){if(this.traceEvent("check.avg"),332==this.state.s_slw)switch(t._hx_index){case 0:this.state.s_slw=331,this.state.traceState();break;case 1:this.state.s_slw=333,this.state.traceState();break;case 2:this.disableStreaming(),this.cause="slow",this.state.s_slw=334,this.state.traceState(),this.evtForcePolling()}},evtSendPendingControls:function(){this.traceEvent("send.pending.controls");var t,e=this.getPendingControls();340!=(null!=(t=this.state.s_w)?t.s:null)||m.empty(e)?550!=(null!=(t=this.state.s_ws)?t.s:null)||m.empty(e)?630!=(null!=(t=this.state.s_wp)?t.s:null)||m.empty(e)||(this.sendPengingControlsWS(e),this.state.s_wp.s=630,this.state.traceState()):(this.sendPengingControlsWS(e),this.state.s_ws.s=550,this.state.traceState(),this.evtRestartHeartbeat()):(this.sendPengingControlsWS(e),this.state.s_w.s=340,this.state.traceState(),this.evtRestartHeartbeat())},evtSendPendingMessages:function(){var t;this.traceEvent("send.pending.messages"),340==(null!=(t=this.state.s_w)?t.s:null)&&m.exists(this.messageManagers,(function(t){return t.isPending()}))?(this.sendPendingMessagesWS(),this.state.s_w.s=340,this.state.traceState(),this.genAckMessagesWS(),this.evtRestartHeartbeat()):550==(null!=(t=this.state.s_ws)?t.s:null)&&m.exists(this.messageManagers,(function(t){return t.isPending()}))?(this.sendPendingMessagesWS(),this.state.s_ws.s=550,this.state.traceState(),this.genAckMessagesWS(),this.evtRestartHeartbeat()):630==(null!=(t=this.state.s_wp)?t.s:null)&&m.exists(this.messageManagers,(function(t){return t.isPending()}))&&(this.sendPendingMessagesWS(),this.state.s_wp.s=630,this.state.traceState(),this.genAckMessagesWS())},evtSelectRhb:function(){this.traceEvent("select.rhb"),320==this.state.s_rhb&&(0==this.rhb_grantedInterval?0==this.options.reverseHeartbeatInterval?(this.state.s_rhb=321,this.state.traceState()):(this.rhb_currentInterval=this.options.reverseHeartbeatInterval,this.state.s_rhb=322,this.state.traceState(),this.schedule_evtRhbTimeout(this.rhb_currentInterval)):this.options.reverseHeartbeatInterval>0&&this.options.reverseHeartbeatInterval<Xt.sure(this.rhb_grantedInterval)?(this.rhb_currentInterval=this.options.reverseHeartbeatInterval,this.state.s_rhb=323,this.state.traceState(),this.schedule_evtRhbTimeout(this.rhb_currentInterval)):(this.rhb_currentInterval=this.rhb_grantedInterval,this.state.s_rhb=323,this.state.traceState(),this.schedule_evtRhbTimeout(Xt.sure(this.rhb_currentInterval))))},evtExtSetReverseHeartbeatInterval:function(){if(this.traceEvent("setReverseHeartbeatInterval"),null!=this.state.s_rhb){var t=this.state.s_rhb;if(null!=t)switch(t){case 321:0!=this.options.reverseHeartbeatInterval&&(this.rhb_currentInterval=this.options.reverseHeartbeatInterval,this.state.s_rhb=322,this.state.traceState(),this.schedule_evtRhbTimeout(this.rhb_currentInterval));break;case 322:0==this.options.reverseHeartbeatInterval?(this.state.s_rhb=321,this.state.traceState(),this.cancel_evtRhbTimeout()):(this.rhb_currentInterval=this.options.reverseHeartbeatInterval,this.state.s_rhb=322,this.state.traceState());break;case 323:this.options.reverseHeartbeatInterval>0&&this.options.reverseHeartbeatInterval<Xt.sure(this.rhb_grantedInterval)?(this.rhb_currentInterval=this.options.reverseHeartbeatInterval,this.state.s_rhb=323,this.state.traceState()):(this.rhb_currentInterval=this.rhb_grantedInterval,this.state.s_rhb=323,this.state.traceState())}}},evtRestartHeartbeat:function(){if(this.traceEvent("restart.heartbeat"),null!=this.state.s_rhb){var t=this.state.s_rhb;if(null!=t)switch(t){case 322:this.state.s_rhb=322,this.state.traceState(),this.cancel_evtRhbTimeout(),this.schedule_evtRhbTimeout(Xt.sure(this.rhb_currentInterval));break;case 323:this.state.s_rhb=323,this.state.traceState(),this.cancel_evtRhbTimeout(),this.schedule_evtRhbTimeout(Xt.sure(this.rhb_currentInterval));break;case 324:0==this.rhb_grantedInterval?0!=this.options.reverseHeartbeatInterval?(this.rhb_currentInterval=this.options.reverseHeartbeatInterval,this.state.s_rhb=322,this.state.traceState(),this.schedule_evtRhbTimeout(this.rhb_currentInterval)):(this.state.s_rhb=321,this.state.traceState()):this.options.reverseHeartbeatInterval>0&&this.options.reverseHeartbeatInterval<Xt.sure(this.rhb_grantedInterval)?(this.rhb_currentInterval=this.options.reverseHeartbeatInterval,this.state.s_rhb=323,this.state.traceState(),this.schedule_evtRhbTimeout(this.rhb_currentInterval)):(this.rhb_currentInterval=this.rhb_grantedInterval,this.state.s_rhb=323,this.state.traceState(),this.schedule_evtRhbTimeout(Xt.sure(this.rhb_currentInterval)))}}},evtRhbTimeout:function(){this.traceEvent("rhb.timeout"),(322==this.state.s_rhb||323==this.state.s_rhb)&&(this.state.s_rhb=324,this.state.traceState(),this.cancel_evtRhbTimeout(),this.evtSendHeartbeat())},evtDisposeCtrl:function(){this.traceEvent("du:dispose.ctrl"),this.disposeCtrl()},evtStartRecovery:function(){this.traceEvent("start.recovery"),1e3==this.state.s_rec&&(this.recoverTs=_.now()/1e3,this.state.s_rec=1e3,this.state.traceState())},evtRecoveryTimeout:function(){this.traceEvent("recovery.timeout"),1e3==this.state.s_rec&&(this.sendRecovery(),this.state.s_rec=1001,this.state.traceState(),this.cancel_evtRecoveryTimeout(),this.schedule_evtTransportTimeout(this.options.retryDelay))},evtCheckRecoveryTimeout:function(t){if(this.traceEvent("check.recovery.timeout"),1002==this.state.s_rec){var e=this.options.retryDelay;if(ge.plus(this.connectTs,e)<ge.plus(this.recoverTs,this.options.sessionRecoveryTimeout)){this.cause="recovery.error";var s=ge.minus(_.now()/1e3,this.connectTs),i=e>fe.toMillis(s)?Se.minus(e,fe.toMillis(s)):Se.ZERO;this.state.s_rec=1003,this.state.traceState(),ri.isErrorEnabled()&&(i>0?ri.isErrorEnabled()&&ri.error("Retrying recovery in "+i+"ms. Cause: "+g.string(t)):ri.isErrorEnabled()&&ri.error("Retrying recovery. Cause: "+g.string(t))),this.schedule_evtRetryTimeout(i)}else this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="recovery.timeout",this.state.goto_m_from_rec(113),this.exit_rec_to_m(),this.entry_m113(F.recovery_timeout)}},evtCreate:function(){this.traceEvent("du:create"),(20==this.state.s_du||23==this.state.s_du)&&(this.state.s_du=21,this.state.traceState())},evtCheckTransport:function(){if(this.traceEvent("check.transport"),1300==this.state.s_swt)if(220==this.state.s_tr||230==this.state.s_tr||260==this.state.s_tr)this.state.s_swt=1301,this.state.traceState();else{var t=this.getBestForBinding();t==k.BFB_ws_streaming&&(210==this.state.s_tr||240==this.state.s_tr)||t==k.BFB_http_streaming&&270==this.state.s_tr&&710==this.state.s_h||t==k.BFB_ws_polling&&250==this.state.s_tr||t==k.BFB_http_polling&&270==this.state.s_tr&&720==this.state.s_h?(this.state.s_swt=1301,this.state.traceState()):(this.state.s_swt=1302,this.state.traceState(),this.evtSendControl(Xt.sure(this.switchRequest)))}},evtCheckBW:function(){this.traceEvent("check.bw"),1200==this.state.s_bw&&(this.bw_requestedMaxBandwidth!=this.options.requestedMaxBandwidth&&this.options.realMaxBandwidth!=Oe.BWUnmanaged?(this.bw_requestedMaxBandwidth=this.options.requestedMaxBandwidth,this.state.s_bw=1202,this.state.traceState(),this.evtSendControl(Xt.sure(this.constrainRequest))):(this.state.s_bw=1201,this.state.traceState()))},evtCheckCtrlRequests:function(){if(this.traceEvent("check.ctrl.requests"),1100==this.state.s_ctrl){var t=this.getPendingControls();m.empty(t)?m.exists(this.messageManagers,(function(t){return t.isPending()}))?(this.sendPendingMessagesHTTP(),this.state.s_ctrl=1102,this.state.traceState(),this.evtRestartHeartbeat(),this.schedule_evtCtrlTimeout(this.options.retryDelay)):324==this.state.s_rhb?(this.sendHeartbeatHTTP(),this.state.s_ctrl=1102,this.state.traceState(),this.evtRestartHeartbeat(),this.schedule_evtCtrlTimeout(this.options.retryDelay)):(this.state.s_ctrl=1101,this.state.traceState()):(this.sendPendingControlsHTTP(t),this.state.s_ctrl=1102,this.state.traceState(),this.evtRestartHeartbeat(),this.schedule_evtCtrlTimeout(this.options.retryDelay))}},evtCtrlDone:function(){this.traceEvent("ctrl.done"),1102==this.state.s_ctrl&&(this.closeCtrl(),this.state.s_ctrl=1100,this.state.traceState(),this.cancel_evtCtrlTimeout(),this.evtCheckCtrlRequests())},evtCtrlError:function(){if(this.traceEvent("ctrl.error"),1102==this.state.s_ctrl){this.disposeCtrl();var t=this.waitingInterval(this.options.retryDelay,this.ctrl_connectTs);this.state.s_ctrl=1103,this.state.traceState(),this.cancel_evtCtrlTimeout(),this.schedule_evtCtrlTimeout(t)}},evtCtrlTimeout:function(){if(this.traceEvent("ctrl.timeout"),null!=this.state.s_ctrl)if(1102==this.state.s_ctrl){this.disposeCtrl();var t=this.waitingInterval(this.options.retryDelay,this.ctrl_connectTs);this.state.s_ctrl=1103,this.state.traceState(),this.cancel_evtCtrlTimeout(),this.schedule_evtCtrlTimeout(t)}else 1103==this.state.s_ctrl&&(this.state.s_ctrl=1100,this.state.traceState(),this.cancel_evtCtrlTimeout(),this.evtCheckCtrlRequests())},evtSendControl:function(t){var e;this.traceEvent("send.control"),340==(null!=(e=this.state.s_w)?e.s:null)?(this.sendControlWS(t),this.state.s_w.s=340,this.state.traceState(),this.evtRestartHeartbeat()):550==(null!=(e=this.state.s_ws)?e.s:null)?(this.sendControlWS(t),this.state.s_ws.s=550,this.state.traceState(),this.evtRestartHeartbeat()):630==(null!=(e=this.state.s_wp)?e.s:null)?(this.sendControlWS(t),this.state.s_wp.s=630,this.state.traceState()):1101==this.state.s_ctrl&&(this.state.s_ctrl=1100,this.state.traceState(),this.evtCheckCtrlRequests())},evtSendHeartbeat:function(){var t;this.traceEvent("send.heartbeat"),340==(null!=(t=this.state.s_w)?t.s:null)?(this.sendHeartbeatWS(),this.state.s_w.s=340,this.state.traceState(),this.evtRestartHeartbeat()):550==(null!=(t=this.state.s_ws)?t.s:null)?(this.sendHeartbeatWS(),this.state.s_ws.s=550,this.state.traceState(),this.evtRestartHeartbeat()):1101==this.state.s_ctrl&&(this.state.s_ctrl=1100,this.state.traceState(),this.evtCheckCtrlRequests())},evtStartSession:function(){this.traceEvent("du:start.session"),ri.isInfoEnabled()&&ri.info("Starting new session: "+this.sessionId),21==this.state.s_du&&(this.state.s_du=22,this.state.traceState())},evtEndSession:function(){ri.isInfoEnabled()&&ri.info("Destroying session: "+this.sessionId)},evtRetry:function(t,e){this.traceEvent("du:retry"),ri.isErrorEnabled()&&(null!=e&&e>0?ri.isErrorEnabled()&&ri.error("Retrying connection in "+e+"ms. Cause: "+W(t)):ri.isErrorEnabled()&&ri.error("Retrying connection. Cause: "+W(t)));var s=!0;switch(this.state.s_du){case 21:this.resetSequenceMap(),this.state.s_du=23,this.state.traceState(),s=this.evtRetry_NextRegion(),this.genAbortMessages();break;case 22:this.disposeSession(),this.state.s_du=23,this.state.traceState(),s=this.evtRetry_NextRegion(),this.genAbortSubscriptions(),this.genAbortMessages()}s&&(s=this.evtRetry_NextRegion())},evtRetry_NextRegion:function(){return!1},evtTerminate:function(t){if(this.traceEvent("du:terminate"),ri.isInfoEnabled()&&2==t._hx_index&&ri.isInfoEnabled()&&ri.info("Disconnected. Cause: Requested by user"),ri.isErrorEnabled())switch(t._hx_index){case 0:ri.isErrorEnabled()&&ri.error("Disconnected. Cause: "+t.code+" - "+t.msg);break;case 1:ri.isErrorEnabled()&&ri.error("Disconnected. Cause: "+t.error)}var e=!0;switch(this.state.s_du){case 20:case 21:case 23:this.disposeClient(),this.state.s_du=20,this.state.traceState(),e=this.evtTerminate_NextRegion(),this.genAbortMessages();break;case 22:this.disposeSession(),this.disposeClient(),this.state.s_du=20,this.state.traceState(),e=this.evtTerminate_NextRegion(),this.genAbortSubscriptions(),this.genAbortMessages()}e&&(e=this.evtTerminate_NextRegion())},evtTerminate_NextRegion:function(){return this.evtTerminate_NetworkReachabilityRegion()},evtTerminate_NetworkReachabilityRegion:function(){switch(this.state.s_nr){case 1410:case 1411:case 1412:var t=this.nr_reachabilityManager;this.nr_reachabilityManager=null,this.state.s_nr=1400,this.state.traceState(),null!=t&&t.stopListening()}return!1},evtRetryTimeout:function(){switch(this.traceEvent("retry.timeout"),this.state.s_m){case 110:this.notifyStatus("CONNECTING"),this.sendCreateTTL(),this.state.s_m=140,this.state.traceState(),this.evtCreate(),this.schedule_evtTransportTimeout(6e4);break;case 111:this.notifyStatus("CONNECTING"),this.delayCounter.increase(),this.sendCreateTTL(),this.state.s_m=140,this.state.traceState(),this.cancel_evtRetryTimeout(),this.evtCreate(),this.schedule_evtTransportTimeout(6e4);break;case 112:this.delayCounter.increase(),this.state.s_m=116,this.state.traceState(),this.cancel_evtRetryTimeout(),this.evtSelectCreate();break;case 113:this.state.s_m=116,this.state.traceState(),this.cancel_evtRetryTimeout(),this.evtSelectCreate();break;case 115:this.state.s_m=116,this.state.traceState(),this.evtSelectCreate();break;case 150:1003==this.state.s_rec&&(this.sendRecovery(),this.state.s_rec=1001,this.state.traceState(),this.cancel_evtRetryTimeout(),this.schedule_evtTransportTimeout(this.options.retryDelay))}},evtExtSetForcedTransport:function(){this.traceEvent("setForcedTransport"),1301==this.state.s_swt&&(this.state.s_swt=1300,this.state.traceState(),this.evtCheckTransport())},evtExtSetRequestedMaxBandwidth:function(){this.traceEvent("setRequestedMaxBandwidth"),1201==this.state.s_bw&&(this.state.s_bw=1200,this.state.traceState(),this.evtCheckBW())},evtForceSlowing:function(){this.traceEvent("force.slowing"),1301==this.state.s_swt&&(this.state.s_swt=1300,this.state.traceState(),this.evtCheckTransport())},evtForcePolling:function(){this.traceEvent("force.polling"),1301==this.state.s_swt&&(this.state.s_swt=1300,this.state.traceState(),this.evtCheckTransport())},evtSendMessage:function(t){var e;this.traceEvent("send.message"),340==(null!=(e=this.state.s_w)?e.s:null)?(this.sendMsgWS(t),this.state.s_w.s=340,this.state.traceState(),t.evtWSSent(),this.evtRestartHeartbeat()):550==(null!=(e=this.state.s_ws)?e.s:null)?(this.sendMsgWS(t),this.state.s_ws.s=550,this.state.traceState(),t.evtWSSent(),this.evtRestartHeartbeat()):630==(null!=(e=this.state.s_wp)?e.s:null)?(this.sendMsgWS(t),this.state.s_wp.s=630,this.state.traceState(),t.evtWSSent()):1101==this.state.s_ctrl&&(this.state.s_ctrl=1100,this.state.traceState(),this.evtCheckCtrlRequests())},evtSwitchTransport:function(){this.traceEvent("switch.transport");var t=!0;1302!=this.state.s_swt&&1303!=this.state.s_swt||(this.state.s_swt=1300,this.state.traceState(),t=this.evtSwitchTransport_forwardToTransportRegion(),this.evtCheckTransport()),t&&(t=this.evtSwitchTransport_forwardToTransportRegion())},evtSwitchTransport_forwardToTransportRegion:function(){var t,e=q.TC_otherError("Selected transport "+this.options.forcedTransport+" is not available");if(200==this.state.s_tr)switch(this.getBestForBinding()._hx_index){case 0:this.notifyStatus("DISCONNECTED"),this.state.goto_m_from_session(100),this.evtEndSession(),this.evtTerminate(e);break;case 1:this.openWS_Bind(),this.state.s_tr=240,this.state.s_ws=new K(500),this.state.traceState(),this.schedule_evtTransportTimeout(this.options.retryDelay);break;case 2:this.openWS_Bind(),this.state.s_tr=250,this.state.s_wp=new G(600),this.state.traceState(),this.schedule_evtTransportTimeout(this.options.retryDelay);break;case 3:this.sendBindHTTP_Streaming(),this.state.s_tr=270,this.state.s_h=710,this.state.s_hs=new Y(800),this.state.s_ctrl=1100,this.state.traceState(),this.evtCheckCtrlRequests(),this.schedule_evtTransportTimeout(this.options.retryDelay);break;case 4:this.sendBindHTTP_Polling(),this.state.s_tr=270,this.state.s_h=720,this.state.s_hp=new z(900),this.state.s_rhb=320,this.state.s_ctrl=1100,this.state.traceState(),this.evtCheckCtrlRequests(),this.schedule_evtIdleTimeout(Se.plus(Xt.sure(this.idleTimeout),this.options.retryDelay)),this.evtSelectRhb()}else if(811==(null!=(t=this.state.s_hs)?t.p:null))switch(this.getBestForBinding()._hx_index){case 0:this.notifyStatus("DISCONNECTED"),this.state.goto_m_from_hs(100),this.exit_hs_to_m(),this.evtTerminate(e);break;case 1:this.openWS_Bind(),this.state.clear_hs(),this.state.s_h=null,this.state.s_ctrl=null,this.state.s_tr=240,this.state.s_ws=new K(500),this.state.traceState(),this.exit_hs(),this.exit_ctrl(),this.schedule_evtTransportTimeout(this.options.retryDelay);break;case 2:this.openWS_Bind(),this.state.clear_hs(),this.state.s_h=null,this.state.s_ctrl=null,this.state.s_tr=250,this.state.s_wp=new G(600),this.state.traceState(),this.exit_hs(),this.exit_ctrl(),this.schedule_evtTransportTimeout(this.options.retryDelay);break;case 3:this.sendBindHTTP_Streaming(),this.state.s_hs=new Y(800),this.state.traceState(),this.exit_hs(),this.schedule_evtTransportTimeout(this.options.retryDelay);break;case 4:this.sendBindHTTP_Polling(),this.state.clear_hs(),this.state.s_h=720,this.state.s_hp=new z(900),this.state.s_rhb=320,this.state.traceState(),this.exit_hs(),this.schedule_evtIdleTimeout(Se.plus(Xt.sure(this.idleTimeout),this.options.retryDelay)),this.evtSelectRhb()}else if(904==(null!=(t=this.state.s_hp)?t.m:null))switch(this.getBestForBinding()._hx_index){case 0:this.notifyStatus("DISCONNECTED"),this.state.goto_m_from_hp(100),this.exit_hp_to_m(),this.evtTerminate(e);break;case 1:this.openWS_Bind(),this.state.clear_hp(),this.state.s_h=null,this.state.s_ctrl=null,this.state.s_tr=240,this.state.s_ws=new K(500),this.state.traceState(),this.exit_hp(),this.exit_ctrl(),this.schedule_evtTransportTimeout(this.options.retryDelay);break;case 2:this.openWS_Bind(),this.state.clear_hp(),this.state.s_h=null,this.state.s_ctrl=null,this.state.s_tr=250,this.state.s_wp=new G(600),this.state.traceState(),this.exit_hp(),this.exit_ctrl(),this.schedule_evtTransportTimeout(this.options.retryDelay);break;case 3:this.sendBindHTTP_Streaming(),this.state.clear_hp(),this.state.s_h=710,this.state.s_hs=new Y(800),this.state.traceState(),this.exit_hp(),this.schedule_evtTransportTimeout(this.options.retryDelay);break;case 4:this.sendBindHTTP_Polling(),this.state.s_hp=new z(900),this.state.s_rhb=320,this.state.traceState(),this.exit_hp(),this.schedule_evtIdleTimeout(Se.plus(Xt.sure(this.idleTimeout),this.options.retryDelay)),this.evtSelectRhb()}return!1},onFreshData:function(){if(this.rec_serverProg!=this.rec_clientProg)throw new Qt("Assertion failure: rec_serverProg == rec_clientProg");this.rec_serverProg+=1,this.rec_clientProg+=1},onStaleData:function(){if(this.rec_serverProg>=this.rec_clientProg)throw new Qt("Assertion failure: rec_serverProg < rec_clientProg");this.rec_serverProg+=1},isFreshData:function(){return this.rec_serverProg==this.rec_clientProg},openWS:function(t,e){var s=this,i=function(t){ei.submit(Ds.a((function(){se.synchronized(s.lock,(function(){t.isDisposed()||s.evtWSOpen()}))})))},n=function(t,e){ei.submit(Ds.a((function(){se.synchronized(s.lock,(function(){if(!t.isDisposed())try{s.evtMessage(e)}catch(t){var i=w.caught(t);ri.isErrorEnabled()&&ri.error(i.get_message()+"\n"+i.details()),s.evtExtDisconnect(q.TC_standardError(61,i.get_message()))}}))})))},r=function(t,e){ei.submit(Ds.a((function(){se.synchronized(s.lock,(function(){t.isDisposed()||s.evtTransportError()}))})))};return this.wsFactory(t,e,i,n,r)},openWS_Create:function(){this.connectTs=_.now()/1e3,this.serverInstanceAddress=this.getServerAddress(),this.ws=this.openWS(We.build(this.serverInstanceAddress,"lightstreamer"),this.options.httpExtraHeaders)},openWS_Bind:function(){this.connectTs=_.now()/1e3,this.ws=this.openWS(We.build(Xt.sure(this.serverInstanceAddress),"lightstreamer"),this.getHeadersForRequestOtherThanCreate())},sendCreateWS:function(){var t=new re;this.options.keepaliveInterval>0&&t.LS_keepalive_millis(this.options.keepaliveInterval),this.rhb_grantedInterval=this.options.reverseHeartbeatInterval,this.rhb_grantedInterval>0&&t.LS_inactivity_millis(this.rhb_grantedInterval),this.bw_requestedMaxBandwidth=this.options.requestedMaxBandwidth;var e=this.bw_requestedMaxBandwidth;null!=e&&0==e._hx_index&&t.LS_requested_max_bandwidth_Float(e.bw),null!=this.details.adapterSet&&t.LS_adapter_set(this.details.adapterSet),null!=this.details.user&&t.LS_user(this.details.user),t.LS_cid(js),null!=this.sessionId&&t.LS_old_session(this.sessionId),this.options.slowingEnabled||t.LS_send_sync(!1),null!=this.cause&&(t.LS_cause(this.cause),this.cause=null),ii.isInfoEnabled()&&ii.info("Sending session create: "+g.string(t)),null!=this.details.password&&t.LS_password(this.details.password),Xt.sure(this.ws).send("wsok"),Xt.sure(this.ws).send("create_session\r\n"+t.getEncodedString())},sendBindWS_Streaming:function(){var t=new re;t.LS_session(Xt.sure(this.sessionId)),this.options.keepaliveInterval>0&&t.LS_keepalive_millis(this.options.keepaliveInterval),this.rhb_grantedInterval=this.options.reverseHeartbeatInterval,this.rhb_grantedInterval>0&&t.LS_inactivity_millis(this.rhb_grantedInterval),this.options.slowingEnabled||t.LS_send_sync(!1),null!=this.cause&&(t.LS_cause(this.cause),this.cause=null),ii.isInfoEnabled()&&ii.info("Sending session bind: "+g.string(t)),Xt.sure(this.ws).send("wsok"),Xt.sure(this.ws).send("bind_session\r\n"+t.getEncodedString())},sendBindWS_FirstPolling:function(){var t=new re;t.LS_session(Xt.sure(this.sessionId)),t.LS_polling(!0),t.LS_polling_millis(this.options.pollingInterval),this.idleTimeout=this.options.idleTimeout,t.LS_idle_millis(this.idleTimeout),null!=this.cause&&(t.LS_cause(this.cause),this.cause=null),ii.isInfoEnabled()&&ii.info("Sending session bind: "+g.string(t)),Xt.sure(this.ws).send("bind_session\r\n"+t.getEncodedString())},sendBindWS_Polling:function(){var t=new re;t.LS_polling(!0),t.LS_polling_millis(this.options.pollingInterval),this.idleTimeout=this.options.idleTimeout,t.LS_idle_millis(this.idleTimeout),null!=this.cause&&(t.LS_cause(this.cause),this.cause=null),ii.isInfoEnabled()&&ii.info("Sending session bind: "+g.string(t)),Xt.sure(this.ws).send("bind_session\r\n"+t.getEncodedString())},sendDestroyWS:function(){var t=new re;t.LS_reqId(this.generateFreshReqId()),t.LS_op("destroy"),t.LS_close_socket(!0),t.LS_cause("api"),ii.isInfoEnabled()&&ii.info("Sending session destroy: "+g.string(t)),Xt.sure(this.ws).send("control\r\n"+t.getEncodedString())},sendHttpRequest:function(t,e,s){var i=this,n=function(t,e){ei.submit(Ds.a((function(){se.synchronized(i.lock,(function(){if(!t.isDisposed())try{i.evtMessage(e)}catch(t){var s=w.caught(t);ri.isErrorEnabled()&&ri.error(s.get_message()+"\n"+s.details()),i.evtExtDisconnect(q.TC_standardError(61,s.get_message()))}}))})))},r=function(t,e){ei.submit(Ds.a((function(){se.synchronized(i.lock,(function(){t.isDisposed()||i.evtTransportError()}))})))};return this.httpFactory(t,e.getEncodedString(),s,n,r,(function(t){}))},sendCreateHTTP:function(){var t=new re;t.LS_polling(!0),t.LS_polling_millis(0),t.LS_idle_millis(0),this.bw_requestedMaxBandwidth=this.options.requestedMaxBandwidth;var e=this.bw_requestedMaxBandwidth;null!=e&&0==e._hx_index&&t.LS_requested_max_bandwidth_Float(e.bw),null!=this.details.adapterSet&&t.LS_adapter_set(this.details.adapterSet),null!=this.details.user&&t.LS_user(this.details.user),t.LS_cid(js),null!=this.sessionId&&t.LS_old_session(this.sessionId),null!=this.cause&&(t.LS_cause(this.cause),this.cause=null),ii.isInfoEnabled()&&ii.info("Sending session create: "+g.string(t)),null!=this.details.password&&t.LS_password(this.details.password),this.connectTs=_.now()/1e3,this.serverInstanceAddress=this.getServerAddress(),this.http=this.sendHttpRequest(We.build(this.serverInstanceAddress,"/lightstreamer"+Js+"/create_session.txt?LS_protocol="+Gs),t,this.options.httpExtraHeaders)},sendBindHTTP_Streaming:function(){var t=new re;t.LS_session(Xt.sure(this.sessionId)),t.LS_content_length(this.options.contentLength),this.options.keepaliveInterval>0&&t.LS_keepalive_millis(this.options.keepaliveInterval),this.rhb_grantedInterval=this.options.reverseHeartbeatInterval,this.rhb_grantedInterval>0&&t.LS_inactivity_millis(this.rhb_grantedInterval),this.options.slowingEnabled||t.LS_send_sync(!1),null!=this.cause&&(t.LS_cause(this.cause),this.cause=null),ii.isInfoEnabled()&&ii.info("Sending session bind: "+g.string(t)),this.connectTs=_.now()/1e3,this.http=this.sendHttpRequest(We.build(Xt.sure(this.serverInstanceAddress),"/lightstreamer/bind_session.txt?LS_protocol="+Gs),t,this.getHeadersForRequestOtherThanCreate())},sendBindHTTP_Polling:function(){var t=new re;t.LS_session(Xt.sure(this.sessionId)),t.LS_polling(!0),t.LS_polling_millis(this.options.pollingInterval),this.idleTimeout=this.options.idleTimeout,t.LS_idle_millis(this.idleTimeout),null!=this.cause&&(t.LS_cause(this.cause),this.cause=null),this.rhb_grantedInterval=0,ii.isInfoEnabled()&&ii.info("Sending session bind: "+g.string(t)),this.connectTs=_.now()/1e3,this.http=this.sendHttpRequest(We.build(Xt.sure(this.serverInstanceAddress),"/lightstreamer/bind_session.txt?LS_protocol="+Gs),t,this.getHeadersForRequestOtherThanCreate())},sendCreateTTL:function(){var t=new re;t.LS_ttl_millis("unlimited"),t.LS_polling(!0),t.LS_polling_millis(0),t.LS_idle_millis(0),this.bw_requestedMaxBandwidth=this.options.requestedMaxBandwidth;var e=this.bw_requestedMaxBandwidth;null!=e&&0==e._hx_index&&t.LS_requested_max_bandwidth_Float(e.bw),null!=this.details.adapterSet&&t.LS_adapter_set(this.details.adapterSet),null!=this.details.user&&t.LS_user(this.details.user),t.LS_cid(js),null!=this.sessionId&&t.LS_old_session(this.sessionId),null!=this.cause&&(t.LS_cause(this.cause),this.cause=null),ii.isInfoEnabled()&&ii.info("Sending session create: "+g.string(t)),null!=this.details.password&&t.LS_password(this.details.password),this.connectTs=_.now()/1e3,this.serverInstanceAddress=this.getServerAddress(),this.http=this.sendHttpRequest(We.build(this.serverInstanceAddress,"/lightstreamer"+Js+"/create_session.txt?LS_protocol="+Gs),t,this.options.httpExtraHeaders)},sendRecovery:function(){var t=new re;t.LS_session(Xt.sure(this.sessionId)),t.LS_recovery_from(this.rec_clientProg),t.LS_polling(!0),t.LS_polling_millis(0),t.LS_idle_millis(0),null!=this.cause&&(t.LS_cause(this.cause),this.cause=null),ii.isInfoEnabled()&&ii.info("Sending session recovery: "+g.string(t)),this.connectTs=_.now()/1e3,this.http=this.sendHttpRequest(We.build(Xt.sure(this.serverInstanceAddress),"/lightstreamer/bind_session.txt?LS_protocol="+Gs),t,this.getHeadersForRequestOtherThanCreate())},disposeWS:function(){null!=this.ws&&(this.ws.dispose(),this.ws=null)},closeWS:function(){null!=this.ws&&(this.ws.dispose(),this.ws=null)},suspendWS_Streaming:function(){ri.isWarnEnabled()&&ri.warn("Websocket suspended"),this.suspendedTransports.insert("WS-STREAMING")},disableWS:function(){ri.isWarnEnabled()&&ri.warn("Websocket disabled"),this.disabledTransports=this.disabledTransports.union(["WS-STREAMING","WS-POLLING"])},disableHTTP_Streaming:function(){ri.isWarnEnabled()&&ri.warn("HTTP streaming disabled"),this.disabledTransports=this.disabledTransports.union(["HTTP-STREAMING"])},disableStreaming:function(){ri.isWarnEnabled()&&ri.warn("Streaming disabled"),this.disabledTransports=this.disabledTransports.union(["WS-STREAMING","HTTP-STREAMING"])},enableAllTransports:function(){ri.isInfoEnabled()&&(this.disabledTransports.count()>0||this.suspendedTransports.count()>0)&&ri.isInfoEnabled()&&ri.info("Transports enabled again."),this.disabledTransports=new ae,this.suspendedTransports=new ae},disposeHTTP:function(){null!=this.http&&(this.http.dispose(),this.http=null)},closeHTTP:function(){null!=this.http&&(this.http.dispose(),this.http=null)},disposeCtrl:function(){null!=this.ctrl_http&&(this.ctrl_http.dispose(),this.ctrl_http=null)},closeCtrl:function(){null!=this.ctrl_http&&(this.ctrl_http.dispose(),this.ctrl_http=null)},notifyStatus:function(t){var e=this.m_status;this.m_status=t,e!=t&&(ri.isInfoEnabled()&&ri.info("Status: "+t),this.clientEventDispatcher.onStatusChange(t))},getBestForCreating:function(){if(0==this.getBestForBinding()._hx_index)return P.BFC_none;var t=this.options.forcedTransport,e=this.suspendedTransports.union(this.disabledTransports.toArray()),s=this.options.httpExtraHeaders,i=null==s||m.empty(s);if(null==t)return i?e.contains("WS-STREAMING")?P.BFC_http:P.BFC_ws:P.BFC_http;switch(t){case"WS":case"WS-STREAMING":return i?e.contains("WS-STREAMING")?P.BFC_http:P.BFC_ws:P.BFC_http;default:return P.BFC_http}},getBestForBinding:function(){var t=this.options.forcedTransport,e=this.disabledTransports,s=this.options.httpExtraHeaders,i=null==s||m.empty(s),n=this.options.httpExtraHeadersOnSessionCreationOnly;if(null==t)return i||n?e.contains("WS-STREAMING")?e.contains("HTTP-STREAMING")?e.contains("WS-POLLING")?k.BFB_http_polling:k.BFB_ws_polling:k.BFB_http_streaming:k.BFB_ws_streaming:e.contains("HTTP-STREAMING")?k.BFB_http_polling:k.BFB_http_streaming;switch(t){case"HTTP":return e.contains("HTTP-STREAMING")?k.BFB_http_polling:k.BFB_http_streaming;case"HTTP-POLLING":return k.BFB_http_polling;case"HTTP-STREAMING":return e.contains("HTTP-STREAMING")?k.BFB_none:k.BFB_http_streaming;case"WS":return i||n?e.contains("WS-STREAMING")?e.contains("WS-POLLING")?k.BFB_none:k.BFB_ws_polling:k.BFB_ws_streaming:k.BFB_none;case"WS-POLLING":return i||n?e.contains("WS-POLLING")?k.BFB_none:k.BFB_ws_polling:k.BFB_none;case"WS-STREAMING":return i||n?e.contains("WS-STREAMING")?k.BFB_none:k.BFB_ws_streaming:k.BFB_none}},resetCurrentRetryDelay:function(){this.delayCounter.reset(this.options.retryDelay)},notifyServerErrorIfCauseIsError:function(t){switch(t._hx_index){case 0:this.clientEventDispatcher.onServerError(t.code,t.msg);break;case 1:this.clientEventDispatcher.onServerError(61,t.error)}},notifyServerError_CONERR:function(t,e){this.clientEventDispatcher.onServerError(t,e)},notifyServerError_END:function(t,e){0<t&&t<30||t>39?this.clientEventDispatcher.onServerError(39,e):this.clientEventDispatcher.onServerError(t,e)},notifyServerError_ERROR:function(t,e){this.clientEventDispatcher.onServerError(t,e)},notifyServerError_REQERR:function(t,e){11==t?this.clientEventDispatcher.onServerError(21,e):this.clientEventDispatcher.onServerError(t,e)},doCONOK:function(t,e,s,i,n){this.sessionId=t,this.details.setSessionId(t),this.requestLimit=e,null!=s?(this.keepaliveInterval=s,this.options.setKeepaliveInterval(s)):null!=i&&(this.idleTimeout=i,this.options.setIdleTimeout(i)),"*"==n||this.options.serverInstanceAddressIgnored||(n=We.completeControlLink(n,this.getServerAddress()),this.serverInstanceAddress=n,this.details.setServerInstanceAddress(n))},doCONOK_CreateWS:function(t,e,s,i){this.doCONOK(t,e,s,null,i)},doCONOK_BindWS_Streaming:function(t,e,s,i){this.doCONOK(t,e,s,null,i)},doCONOK_BindWS_Polling:function(t,e,s,i){this.doCONOK(t,e,null,s,i)},doCONOK_CreateHTTP:function(t,e,s,i){this.doCONOK(t,e,null,null,i)},doCONOK_BindHTTP_Streaming:function(t,e,s,i){this.doCONOK(t,e,s,null,i)},doCONOK_BindHTTP_Polling:function(t,e,s,i){this.doCONOK(t,e,null,s,i)},doSERVNAME:function(t){this.details.setServerSocketName(t)},doCLIENTIP:function(t){this.details.setClientIp(t);var e=this.lastKnownClientIp;null!=e&&e!=t&&(ri.isInfoEnabled()&&ri.info("Client IP changed: "+e+" -> "+t),this.enableAllTransports()),this.lastKnownClientIp=t},doCONS:function(t){this.options.setRealMaxBandwidth(t)},doLOOP:function(t){this.options.setPollingInterval(t)},doPROG:function(t){if(t>this.rec_clientProg)throw new Qt("Assertion failure: prog <= rec_clientProg");this.rec_serverProg=t},doMSGDONE:function(t,e){this.onFreshData();var s=this.messageManagers.filter((function(s){return s.sequence==t&&s.prog==e}));if(s.length>1)throw new Qt("Assertion failure: messages.length <= 1");for(var i=s.h;null!=i;){var n=i.item;i=i.next,n.evtMSGDONE()}},doMSGFAIL:function(t,e,s,i){if(this.onFreshData(),39==s){var n=g.parseInt(i);if(null==n)throw new Qt("Assertion failure: count != null");for(var r=e-n+1,a=e+1;r<a;){if((l=this.messageManagers.filter(function(e){return function(s){return s.sequence==t&&s.prog==e[0]}}([r++]))).length>1)throw new Qt("Assertion failure: messages.length <= 1");for(var o=l.h;null!=o;){var h=o.item;o=o.next,h.evtMSGFAIL(s,i)}}}else{var l;if((l=this.messageManagers.filter((function(s){return s.sequence==t&&s.prog==e}))).length>1)throw new Qt("Assertion failure: messages.length <= 1");for(o=l.h;null!=o;)h=o.item,o=o.next,h.evtMSGFAIL(s,i)}},doU:function(t,e,s){this.onFreshData();var i=Vt.arrayRead(this.subscriptionManagers,t);null!=i?i.evtU(e,s):new vt(t,this).evtU(e,s)},doSUBOK:function(t,e,s){this.onFreshData();var i=Vt.arrayRead(this.subscriptionManagers,t);null!=i?i.evtSUBOK(e,s):new vt(t,this).evtSUBOK(e,s)},doSUBCMD:function(t,e,s,i,n){this.onFreshData();var r=Vt.arrayRead(this.subscriptionManagers,t);null!=r?r.evtSUBCMD(e,s,i,n):new vt(t,this).evtSUBCMD(e,s,i,n)},doUNSUB:function(t){this.onFreshData();var e=Vt.arrayRead(this.subscriptionManagers,t);null!=e&&e.evtUNSUB()},doEOS:function(t,e){this.onFreshData();var s=Vt.arrayRead(this.subscriptionManagers,t);null!=s?s.evtEOS(e):new vt(t,this).evtEOS(e)},doCS:function(t,e){this.onFreshData();var s=Vt.arrayRead(this.subscriptionManagers,t);null!=s?s.evtCS(e):new vt(t,this).evtCS(e)},doOV:function(t,e,s){this.onFreshData();var i=Vt.arrayRead(this.subscriptionManagers,t);null!=i?i.evtOV(e,s):new vt(t,this).evtOV(e,s)},doCONF:function(t,e){this.onFreshData();var s=Vt.arrayRead(this.subscriptionManagers,t);null!=s?s.evtCONF(e):new vt(t,this).evtCONF(e)},doREQOK:function(t){for(var e=ks(Vt)(this.subscriptionManagers);null!=e.head;){var s=e.head.item;e.head=e.head.next,s.value.evtREQOK(t)}for(var i=this.messageManagers.h;null!=i;)s=i.item,i=i.next,s.evtREQOK(t)},doREQERR:function(t,e,s){for(var i=ks(Vt)(this.subscriptionManagers);null!=i.head;){var n=i.head.item;i.head=i.head.next,n.value.evtREQERR(t,e,s)}for(var r=this.messageManagers.h;null!=r;)n=r.item,r=r.next,n.evtREQERR(t,e,s)},doSYNC:function(t){this.slw_refTime=_.now()/1e3,this.slw_avgDelayMs=-t},doSYNC_G:function(t){var e=this.diffTimeSync(t);return e>this.slw_hugeDelayMs&&e>2*this.slw_avgDelayMs?this.slw_avgDelayMs>this.slw_maxAvgDelayMs&&this.options.slowingEnabled?M.SCR_bad:M.SCR_not_good:(this.slw_avgDelayMs=this.slowAvg(e),this.slw_avgDelayMs>this.slw_maxAvgDelayMs&&this.options.slowingEnabled?M.SCR_bad:(this.slw_avgDelayMs<60&&(this.slw_avgDelayMs=0),M.SCR_good))},doSYNC_NG:function(t){var e=this.diffTimeSync(t);return e>this.slw_hugeDelayMs&&e>2*this.slw_avgDelayMs?(this.slw_avgDelayMs=this.slowAvg(e),this.slw_avgDelayMs>this.slw_maxAvgDelayMs&&this.options.slowingEnabled?M.SCR_bad:(this.slw_avgDelayMs<60&&(this.slw_avgDelayMs=0),M.SCR_good)):(this.slw_avgDelayMs=this.slowAvg(e),this.slw_avgDelayMs>this.slw_maxAvgDelayMs&&this.options.slowingEnabled?M.SCR_bad:(this.slw_avgDelayMs<60&&(this.slw_avgDelayMs=0),M.SCR_not_good))},diffTimeSync:function(t){return ge.minus(_.now()/1e3,this.slw_refTime)-t},slowAvg:function(t){return this.slw_avgDelayMs*this.slw_m+t*(1-this.slw_m)},schedule_evtTransportTimeout:function(t){this.transportTimer=this.createTimer("transport.timeout",t,Fs(this,this.evtTransportTimeout))},schedule_evtRetryTimeout:function(t){this.retryTimer=this.createTimer("retry.timeout",t,Fs(this,this.evtRetryTimeout))},schedule_evtRecoveryTimeout:function(t){this.recoveryTimer=this.createTimer("recovery.timeout",t,Fs(this,this.evtRecoveryTimeout))},schedule_evtIdleTimeout:function(t){this.idleTimer=this.createTimer("idle.timeout",t,Fs(this,this.evtIdleTimeout))},schedule_evtPollingTimeout:function(t){this.pollingTimer=this.createTimer("polling.timeout",t,Fs(this,this.evtPollingTimeout))},schedule_evtCtrlTimeout:function(t){this.ctrlTimer=this.createTimer("ctrl.timeout",t,Fs(this,this.evtCtrlTimeout))},schedule_evtKeepaliveTimeout:function(t){this.keepaliveTimer=this.createTimer("keepalive.timeout",t,Fs(this,this.evtKeepaliveTimeout))},schedule_evtStalledTimeout:function(t){this.stalledTimer=this.createTimer("stalled.timeout",t,Fs(this,this.evtStalledTimeout))},schedule_evtReconnectTimeout:function(t){this.reconnectTimer=this.createTimer("reconnect.timeout",t,Fs(this,this.evtReconnectTimeout))},schedule_evtRhbTimeout:function(t){this.rhbTimer=this.createTimer("rhb.timeout",t,Fs(this,this.evtRhbTimeout))},createTimer:function(t,e,s){var i=this;return this.timerFactory(t,e,(function(t){se.synchronized(i.lock,(function(){t.isCanceled()||s()}))}))},cancel_evtTransportTimeout:function(){null!=this.transportTimer&&(this.transportTimer.cancel(),this.transportTimer=null)},cancel_evtRetryTimeout:function(){null!=this.retryTimer&&(this.retryTimer.cancel(),this.retryTimer=null)},cancel_evtKeepaliveTimeout:function(){null!=this.keepaliveTimer&&(this.keepaliveTimer.cancel(),this.keepaliveTimer=null)},cancel_evtStalledTimeout:function(){null!=this.stalledTimer&&(this.stalledTimer.cancel(),this.stalledTimer=null)},cancel_evtReconnectTimeout:function(){null!=this.reconnectTimer&&(this.reconnectTimer.cancel(),this.reconnectTimer=null)},cancel_evtRhbTimeout:function(){null!=this.rhbTimer&&(this.rhbTimer.cancel(),this.rhbTimer=null)},cancel_evtIdleTimeout:function(){null!=this.idleTimer&&(this.idleTimer.cancel(),this.idleTimer=null)},cancel_evtPollingTimeout:function(){null!=this.pollingTimer&&(this.pollingTimer.cancel(),this.pollingTimer=null)},cancel_evtCtrlTimeout:function(){null!=this.ctrlTimer&&(this.ctrlTimer.cancel(),this.ctrlTimer=null)},cancel_evtRecoveryTimeout:function(){null!=this.recoveryTimer&&(this.recoveryTimer.cancel(),this.recoveryTimer=null)},waitingInterval:function(t,e){var s=ge.minus(_.now()/1e3,e);return s<t?t-s:0},exit_tr:function(){this.evtEndSession()},entry_m111:function(t,e){this.evtRetry(t,e),this.schedule_evtRetryTimeout(e)},entry_m112:function(t){var e=this.waitingInterval(this.delayCounter.get_currentRetryDelay(),this.connectTs);this.evtRetry(t,e),this.schedule_evtRetryTimeout(e)},entry_m113:function(t){var e=this.randomPause(this.options.firstRetryMaxDelay);this.evtRetry(t,e),this.schedule_evtRetryTimeout(e)},entry_m115:function(t){this.evtRetry(t),this.evtRetryTimeout()},entry_rec:function(t,e){ri.isErrorEnabled()&&ri.error("Recovering connection in "+t+" ms. Cause: "+W(e)),this.evtStartRecovery(),this.schedule_evtRecoveryTimeout(t)},exit_w:function(){this.cancel_evtKeepaliveTimeout(),this.cancel_evtStalledTimeout(),this.cancel_evtReconnectTimeout(),this.cancel_evtRhbTimeout()},exit_ws:function(){this.cancel_evtTransportTimeout(),this.cancel_evtKeepaliveTimeout(),this.cancel_evtStalledTimeout(),this.cancel_evtReconnectTimeout(),this.cancel_evtRhbTimeout()},exit_wp:function(){this.cancel_evtTransportTimeout(),this.cancel_evtIdleTimeout(),this.cancel_evtPollingTimeout()},exit_hs:function(){this.cancel_evtTransportTimeout(),this.cancel_evtKeepaliveTimeout(),this.cancel_evtStalledTimeout(),this.cancel_evtReconnectTimeout(),this.cancel_evtRhbTimeout()},exit_hp:function(){this.cancel_evtIdleTimeout(),this.cancel_evtPollingTimeout(),this.cancel_evtRhbTimeout()},exit_ctrl:function(){this.cancel_evtCtrlTimeout(),this.evtDisposeCtrl()},exit_rec:function(){this.cancel_evtRecoveryTimeout(),this.cancel_evtTransportTimeout(),this.cancel_evtRetryTimeout()},exit_keepalive_unit:function(){this.cancel_evtKeepaliveTimeout(),this.cancel_evtStalledTimeout(),this.cancel_evtReconnectTimeout()},exit_w_to_m:function(){this.exit_w(),this.exit_tr()},exit_ws_to_m:function(){this.exit_ws(),this.exit_tr()},exit_wp_to_m:function(){this.exit_wp(),this.exit_tr()},exit_hs_to_m:function(){this.exit_ctrl(),this.exit_hs(),this.exit_tr()},exit_hs_to_rec:function(){this.exit_ctrl(),this.exit_hs()},exit_hp_to_m:function(){this.exit_ctrl(),this.exit_hp(),this.exit_tr()},exit_hp_to_rec:function(){this.exit_ctrl(),this.exit_hp()},exit_ctrl_to_m:function(){this.exit_ctrl(),this.exit_hs(),this.exit_hp(),this.exit_tr()},exit_rec_to_m:function(){this.exit_rec(),this.exit_tr()},randomPause:function(t){return this.randomGenerator(t)},generateFreshReqId:function(){return this.m_nextReqId+=1,this.m_nextReqId},generateFreshSubId:function(){return this.m_nextSubId+=1,this.m_nextSubId},genAbortSubscriptions:function(){for(var t=ks(Vt)(this.subscriptionManagers);null!=t.head;){var e=t.head.item;t.head=t.head.next,e.value.evtExtAbort()}},genAckMessagesWS:function(){for(var t=this.messageManagers.filter((function(t){return t.isPending()})).h;null!=t;){var e=t.item;t=t.next,e.evtWSSent()}},genAbortMessages:function(){for(var t=this.messageManagers.h;null!=t;){var e=t.item;t=t.next,e.evtAbort()}},resetSequenceMap:function(){this.sequenceMap.h=Object.create(null)},isSwitching:function(){return 150==this.state.s_m&&(1302==this.state.s_swt||1303==this.state.s_swt)},encodeSwitch:function(t){var e=new re;return this.swt_lastReqId=this.generateFreshReqId(),e.LS_reqId(this.swt_lastReqId),e.LS_op("force_rebind"),t&&e.LS_close_socket(!0),null!=this.cause&&(e.LS_cause(this.cause),this.cause=null),ii.isInfoEnabled()&&ii.info("Sending transport switch: "+g.string(e)),e.getEncodedString()},encodeConstrain:function(){var t=new re;this.bw_lastReqId=this.generateFreshReqId(),t.LS_reqId(this.bw_lastReqId),t.LS_op("constrain");var e=Xt.sure(this.bw_requestedMaxBandwidth);switch(e._hx_index){case 0:t.LS_requested_max_bandwidth_Float(e.bw);break;case 1:t.LS_requested_max_bandwidth("unlimited")}return ii.isInfoEnabled()&&ii.info("Sending bandwidth constrain: "+g.string(t)),t.getEncodedString()},getPendingControls:function(){var t=[];Xt.sure(this.switchRequest).isPending()&&t.push(Xt.sure(this.switchRequest)),Xt.sure(this.constrainRequest).isPending()&&t.push(Xt.sure(this.constrainRequest));for(var e=ks(Vt)(this.subscriptionManagers);null!=e.head;){var s=e.head.item;e.head=e.head.next;var i=s.value;i.isPending()&&t.push(i)}return t},sendControlWS:function(t){Xt.sure(this.ws).send(t.encodeWS())},sendMsgWS:function(t){Xt.sure(this.ws).send(t.encodeWS())},sendPengingControlsWS:function(t){this.sendBatchWS(this.prepareBatchWS("control",t,Xt.sure(this.requestLimit)))},sendPendingMessagesWS:function(){for(var t=[],e=this.messageManagers.h;null!=e;){var s=e.item;e=e.next,s.isPending()&&t.push(s)}this.sendBatchWS(this.prepareBatchWS("msg",t,Xt.sure(this.requestLimit)))},sendBatchWS:function(t){for(var e=0;e<t.length;){var s=t[e++];Xt.sure(this.ws).send(s)}},sendHeartbeatWS:function(){ii.isInfoEnabled()&&ii.info("Heartbeat request"),Xt.sure(this.ws).send("heartbeat\r\n\r\n")},sendPendingControlsHTTP:function(t){this.sendBatchHTTP(this.prepareBatchHTTP(t,Xt.sure(this.requestLimit)),"control")},sendPendingMessagesHTTP:function(){for(var t=[],e=this.messageManagers.h;null!=e;){var s=e.item;e=e.next,s.isPending()&&t.push(s)}this.sendBatchHTTP(this.prepareBatchHTTP(t,Xt.sure(this.requestLimit)),"msg")},sendHeartbeatHTTP:function(){ii.isInfoEnabled()&&ii.info("Heartbeat request"),this.sendBatchHTTP("\r\n","heartbeat")},sendBatchHTTP:function(t,e){var s=this;this.ctrl_connectTs=_.now()/1e3;var i=We.build(Xt.sure(this.serverInstanceAddress),"/lightstreamer/"+e+".txt?LS_protocol="+Gs+"&LS_session="+this.sessionId),n=this.getHeadersForRequestOtherThanCreate(),r=function(t,e){se.synchronized(s.lock,(function(){t.isDisposed()||s.evtCtrlMessage(e)}))},a=function(t,e){se.synchronized(s.lock,(function(){t.isDisposed()||s.evtCtrlError()}))},o=function(t){se.synchronized(s.lock,(function(){t.isDisposed()||s.evtCtrlDone()}))};this.ctrl_http=this.ctrlFactory(i,t,n,r,a,o)},prepareBatchWS:function(t,e,s){if(e.length<=0)throw new Qt("Assertion failure: pendings.length > 0");for(var i=[],n=0,r=e[0].encode(!0);n<e.length;){var a=new dt;for(a.addSubRequest(t),a.addSubRequest(r),++n;n<e.length&&(r=e[n].encode(!0),a.addSubRequestOnlyIfBodyIsLessThan(r,s));)++n;i.push(a.getBody())}return i},prepareBatchHTTP:function(t,e){if(t.length<=0)throw new Qt("Assertion failure: pendings.length > 0");var s=new dt,i=0,n=t[0].encode(!1);for(s.addSubRequest(n),i=1;i<t.length&&(n=t[i].encode(!1),s.addSubRequestOnlyIfBodyIsLessThan(n,e));)++i;return s.getBody()},getHeadersForRequestOtherThanCreate:function(){return this.options.httpExtraHeadersOnSessionCreationOnly?null:this.options.httpExtraHeaders},getServerAddress:function(){var t=this.details.serverAddress;return null!=t?t:Xt.sure(this.defaultServerAddress)},relateSubManager:function(t){if(null!=Vt.arrayRead(this.subscriptionManagers,t.subId))throw new Qt("Assertion failure: subscriptionManagers[subManager.subId] == null");Vt.arrayWrite(this.subscriptionManagers,t.subId,t)},unrelateSubManager:function(t){Vt.remove(this.subscriptionManagers,t.subId)},isRelatedWithSubManager:function(t){return Vt.containsValue(this.subscriptionManagers,t)},relateMsgManager:function(t){this.messageManagers.add(t)},unrelateMsgManager:function(t){this.messageManagers.remove(t)},getAndSetNextMsgProg:function(t){var e=this.sequenceMap.h[t];return null==e&&(e=1),this.sequenceMap.h[t]=e+1,e},onPropertyChange:function(t){this.clientEventDispatcher.onPropertyChange(t)},traceEvent:function(t){ni.isTraceEnabled()&&ni.trace("event: "+t+" "+this.state.toString())},connect:function(){var t=this.details.getServerAddress();if(null==t)throw new Qt("Configure the server address before trying to connect");ai.isInfoEnabled()&&ai.info("Connection requested: details: "+g.string(this.details)+" options: "+g.string(this.options)),this.defaultServerAddress=t,this.evtExtConnect()},disconnect:function(){ai.isInfoEnabled()&&ai.info("Disconnection requested"),this.evtExtDisconnect(q.TC_api)},getStatus:function(){return this.m_status},sendMessage:function(t,e,s,i,n){if(n||!this.state.inDisconnected()&&!this.state.inRetryUnit())if(null!=e){if(!new u("^[a-zA-Z0-9_]*$","").match(e))throw new T("The given sequence name is not valid. Use only alphanumeric characters plus underscore or null");var r=new J(t,e,s,i,n,this);ai.isInfoEnabled()&&ai.info("Message sending requested: "+g.string(r)),r.evtExtSendMessage()}else r=new J(t,"UNORDERED_MESSAGES",s,i,n,this),ai.isInfoEnabled()&&ai.info("Message sending requested: "+g.string(r)),r.evtExtSendMessage();else{if(ai.isInfoEnabled()){var a=new cs;a.h.text=t,a.h.sequence=null!=e?e:"UNORDERED_MESSAGES",a.h.timeout=null==s?"null":""+s,a.h.enqueueWhileDisconnected=null==n?"null":""+n,ai.isInfoEnabled()&&ai.info("Message sending requested: "+(null==a?"null":cs.stringify(a.h)))}if(li.isWarnEnabled()&&li.warn("Message "+(null!=e?e:"UNORDERED_MESSAGES")+" "+t+" aborted"),null!=i){var o=new Q;o.addListener(i),o.onAbort(t,!1)}}},subscribeExt:function(t,e){if(null==e&&(e=!1),t.isActive())throw new Qt("Cannot subscribe to an active Subscription");if(null==t.getItems()&&null==t.getItemGroup())throw new T("Specify property 'items' or 'itemGroup'");if(null==t.getFields()&&null==t.getFieldSchema())throw new T("Specify property 'fields' or 'fieldSchema'");var s=new pt(t,this);ai.isInfoEnabled()&&ai.info((e?"Internal subscription":"Subscription")+" requested: subId: "+s.subId+" "+g.string(t)),s.evtExtSubscribe()},unsubscribe:function(t){var e=t.fetch_subManager();if(null!=e){if(!this.isRelatedWithSubManager(e))throw new T("The Subscription is not subscribed to this Client");ai.isInfoEnabled()&&ai.info("Unsubscription requested: subId: "+e.subId+" "+g.string(t)),e.evtExtUnsubscribe()}},getSubscriptions:function(){for(var t=[],e=ks(Vt)(this.subscriptionManagers);null!=e.head;){var s=e.head.item;e.head=e.head.next;var i=s.value,n=i instanceof pt?i:null;if(null!=n){var r=n.m_subscription;r.isActive()&&!r.isInternal()&&t.push(r)}}return t},__class__:N};var P=a["com.lightstreamer.client.internal._ClientMachine.BestForCreatingEnum"]={__ename__:!0,__constructs__:null,BFC_ws:{_hx_name:"BFC_ws",_hx_index:0,__enum__:"com.lightstreamer.client.internal._ClientMachine.BestForCreatingEnum",toString:r},BFC_http:{_hx_name:"BFC_http",_hx_index:1,__enum__:"com.lightstreamer.client.internal._ClientMachine.BestForCreatingEnum",toString:r},BFC_none:{_hx_name:"BFC_none",_hx_index:2,__enum__:"com.lightstreamer.client.internal._ClientMachine.BestForCreatingEnum",toString:r}};P.__constructs__=[P.BFC_ws,P.BFC_http,P.BFC_none];var k=a["com.lightstreamer.client.internal._ClientMachine.BestForBindingEnum"]={__ename__:!0,__constructs__:null,BFB_none:{_hx_name:"BFB_none",_hx_index:0,__enum__:"com.lightstreamer.client.internal._ClientMachine.BestForBindingEnum",toString:r},BFB_ws_streaming:{_hx_name:"BFB_ws_streaming",_hx_index:1,__enum__:"com.lightstreamer.client.internal._ClientMachine.BestForBindingEnum",toString:r},BFB_ws_polling:{_hx_name:"BFB_ws_polling",_hx_index:2,__enum__:"com.lightstreamer.client.internal._ClientMachine.BestForBindingEnum",toString:r},BFB_http_streaming:{_hx_name:"BFB_http_streaming",_hx_index:3,__enum__:"com.lightstreamer.client.internal._ClientMachine.BestForBindingEnum",toString:r},BFB_http_polling:{_hx_name:"BFB_http_polling",_hx_index:4,__enum__:"com.lightstreamer.client.internal._ClientMachine.BestForBindingEnum",toString:r}};k.__constructs__=[k.BFB_none,k.BFB_ws_streaming,k.BFB_ws_polling,k.BFB_http_streaming,k.BFB_http_polling];var M=a["com.lightstreamer.client.internal._ClientMachine.SyncCheckResult"]={__ename__:!0,__constructs__:null,SCR_good:{_hx_name:"SCR_good",_hx_index:0,__enum__:"com.lightstreamer.client.internal._ClientMachine.SyncCheckResult",toString:r},SCR_not_good:{_hx_name:"SCR_not_good",_hx_index:1,__enum__:"com.lightstreamer.client.internal._ClientMachine.SyncCheckResult",toString:r},SCR_bad:{_hx_name:"SCR_bad",_hx_index:2,__enum__:"com.lightstreamer.client.internal._ClientMachine.SyncCheckResult",toString:r}};M.__constructs__=[M.SCR_good,M.SCR_not_good,M.SCR_bad];var F=a["com.lightstreamer.client.internal._ClientMachine.RetryCause"]={__ename__:!0,__constructs__:null,standardError:(e=function(t,e){return{_hx_index:0,code:t,msg:e,__enum__:"com.lightstreamer.client.internal._ClientMachine.RetryCause",toString:r}},e._hx_name="standardError",e.__params__=["code","msg"],e),ws_unavailable:{_hx_name:"ws_unavailable",_hx_index:1,__enum__:"com.lightstreamer.client.internal._ClientMachine.RetryCause",toString:r},ws_error:{_hx_name:"ws_error",_hx_index:2,__enum__:"com.lightstreamer.client.internal._ClientMachine.RetryCause",toString:r},http_error:{_hx_name:"http_error",_hx_index:3,__enum__:"com.lightstreamer.client.internal._ClientMachine.RetryCause",toString:r},idle_timeout:{_hx_name:"idle_timeout",_hx_index:4,__enum__:"com.lightstreamer.client.internal._ClientMachine.RetryCause",toString:r},stalled_timeout:{_hx_name:"stalled_timeout",_hx_index:5,__enum__:"com.lightstreamer.client.internal._ClientMachine.RetryCause",toString:r},ws_timeout:{_hx_name:"ws_timeout",_hx_index:6,__enum__:"com.lightstreamer.client.internal._ClientMachine.RetryCause",toString:r},http_timeout:{_hx_name:"http_timeout",_hx_index:7,__enum__:"com.lightstreamer.client.internal._ClientMachine.RetryCause",toString:r},recovery_timeout:{_hx_name:"recovery_timeout",_hx_index:8,__enum__:"com.lightstreamer.client.internal._ClientMachine.RetryCause",toString:r},prog_mismatch:(e=function(t,e){return{_hx_index:9,expected:t,actual:e,__enum__:"com.lightstreamer.client.internal._ClientMachine.RetryCause",toString:r}},e._hx_name="prog_mismatch",e.__params__=["expected","actual"],e)};F.__constructs__=[F.standardError,F.ws_unavailable,F.ws_error,F.http_error,F.idle_timeout,F.stalled_timeout,F.ws_timeout,F.http_timeout,F.recovery_timeout,F.prog_mismatch];var q=a["com.lightstreamer.client.internal._ClientMachine.TerminationCause"]={__ename__:!0,__constructs__:null,TC_standardError:(e=function(t,e){return{_hx_index:0,code:t,msg:e,__enum__:"com.lightstreamer.client.internal._ClientMachine.TerminationCause",toString:r}},e._hx_name="TC_standardError",e.__params__=["code","msg"],e),TC_otherError:(e=function(t){return{_hx_index:1,error:t,__enum__:"com.lightstreamer.client.internal._ClientMachine.TerminationCause",toString:r}},e._hx_name="TC_otherError",e.__params__=["error"],e),TC_api:{_hx_name:"TC_api",_hx_index:2,__enum__:"com.lightstreamer.client.internal._ClientMachine.TerminationCause",toString:r}};q.__constructs__=[q.TC_standardError,q.TC_otherError,q.TC_api];var A=a["com.lightstreamer.client.internal._ClientMachine.RecoveryRetryCause"]={__ename__:!0,__constructs__:null,RRC_transport_timeout:{_hx_name:"RRC_transport_timeout",_hx_index:0,__enum__:"com.lightstreamer.client.internal._ClientMachine.RecoveryRetryCause",toString:r},RRC_transport_error:{_hx_name:"RRC_transport_error",_hx_index:1,__enum__:"com.lightstreamer.client.internal._ClientMachine.RecoveryRetryCause",toString:r}};function W(t){switch(t._hx_index){case 0:return t.code+" - "+t.msg;case 1:return"Websocket transport not available";case 2:return"Websocket error";case 3:return"HTTP error";case 4:return"idleTimeout expired";case 5:return"stalledTimeout expired";case 6:return"Websocket connect timeout expired";case 7:return"HTTP connect timeout expired";case 8:return"sessionRecoveryTimeout expired";case 9:return"Recovery counter mismatch: expected "+t.expected+" but found "+t.actual}}A.__constructs__=[A.RRC_transport_timeout,A.RRC_transport_error];var B=function(){};B.__name__="com.lightstreamer.client.internal.Encodable",B.__isInterface__=!0,B.prototype={__class__:B};var U=function(t){this.client=t};U.__name__="com.lightstreamer.client.internal.SwitchRequest",U.__interfaces__=[B],U.prototype={isPending:function(){return 150==this.client.state.s_m&&1302==this.client.state.s_swt},encode:function(t){return this.client.encodeSwitch(t)},encodeWS:function(){return"control\r\n"+this.encode(!0)},__class__:U};var H=function(t){this.client=t};H.__name__="com.lightstreamer.client.internal.ConstrainRequest",H.__interfaces__=[B],H.prototype={isPending:function(){return 1202==this.client.state.s_bw},encode:function(t){return this.client.encodeConstrain()},encodeWS:function(){return"control\r\n"+this.encode(!0)},__class__:H};var V=function(t,e,s){this.p=t,this.k=e,this.s=s};V.__name__="com.lightstreamer.client.internal.StateVar_w",V.prototype={toString:function(){return"<w_p="+this.p+" w_k="+this.k+" w_s="+this.s+">"},__class__:V};var K=function(t){this.m=t};K.__name__="com.lightstreamer.client.internal.StateVar_ws",K.prototype={toString:function(){var t="<ws_m="+this.m;return null!=this.p&&(t+=" ws_p="+this.p),null!=this.k&&(t+=" ws_k="+this.k),null!=this.s&&(t+=" ws_s="+this.s),t+=">"},__class__:K};var G=function(t){this.m=t};G.__name__="com.lightstreamer.client.internal.StateVar_wp",G.prototype={toString:function(){var t="<wp_m="+this.m;return null!=this.p&&(t+=" wp_p="+this.p),null!=this.c&&(t+=" wp_c="+this.c),null!=this.s&&(t+=" wp_s="+this.s),t+=">"},__class__:G};var Y=function(t){this.m=t};Y.__name__="com.lightstreamer.client.internal.StateVar_hs",Y.prototype={toString:function(){var t="<hs_m="+this.m;return null!=this.p&&(t+=" hs_p="+this.p),null!=this.k&&(t+=" hs_k="+this.k),t+=">"},__class__:Y};var z=function(t){this.m=t};z.__name__="com.lightstreamer.client.internal.StateVar_hp",z.prototype={toString:function(){return"<hp_m="+this.m+">"},__class__:z};var j=function(){this.s_m=100,this.s_du=20,this.s_nr=1400};j.__name__="com.lightstreamer.client.internal.State",j.prototype={goto_m_from_w:function(t){this.clear_w(),this.goto_m_from_session(t)},goto_m_from_ws:function(t){this.clear_ws(),this.goto_m_from_session(t)},goto_rec_from_w:function(){this.clear_w(),this.goto_rec()},goto_rec_from_ws:function(){this.clear_ws(),this.goto_rec()},goto_m_from_wp:function(t){this.clear_wp(),this.goto_m_from_session(t)},goto_rec_from_wp:function(){this.clear_wp(),this.goto_rec()},goto_m_from_hs:function(t){this.clear_hs(),this.s_ctrl=null,this.s_h=null,this.goto_m_from_session(t)},goto_m_from_rec:function(t){this.s_tr=null,this.goto_m_from_session(t)},goto_rec_from_hs:function(){this.clear_hs(),this.s_ctrl=null,this.s_h=null,this.goto_rec()},goto_m_from_hp:function(t){this.clear_hp(),this.s_ctrl=null,this.s_h=null,this.goto_m_from_session(t)},goto_rec_from_hp:function(){this.clear_hp(),this.s_ctrl=null,this.s_h=null,this.goto_rec()},goto_rec:function(){this.s_tr=260,this.s_rec=1e3,this.traceState()},goto_m_from_session:function(t){this.s_tr=null,this.s_swt=null,this.s_bw=null,this.s_m=t,this.traceState()},goto_m_from_ctrl:function(t){this.clear_hs(),this.clear_hp(),this.s_ctrl=null,this.s_h=null,this.goto_m_from_session(t)},goto_200_from_rec:function(){this.s_rec=null,this.s_tr=200,this.traceState()},clear_w:function(){this.s_w=null,this.s_rhb=null,this.s_slw=null},clear_ws:function(){this.s_ws=null,this.s_rhb=null,this.s_slw=null},clear_wp:function(){this.s_wp=null},clear_hs:function(){this.s_hs=null,this.s_rhb=null,this.s_slw=null},clear_hp:function(){this.s_hp=null,this.s_rhb=null},isSwitching:function(){return 150==this.s_m&&(1302==this.s_swt||1303==this.s_swt)},inPushing:function(){return!!this.inStreaming()||this.inPolling()},inStreaming:function(){var t,e;return!!(e=300==(null!=(t=this.s_w)?t.p:null)||510==(null!=(t=this.s_ws)?t.p:null))||810==(null!=(e=this.s_hs)?e.p:null)},inPolling:function(){var t;if(220!=this.s_tr&&230!=this.s_tr){var e=this.s_wp;t=611==(null!=e?e.p:null)}else t=!0;return!!(!!t||901==(null!=(t=this.s_hp)?t.m:null))||1001==this.s_rec},inRetryUnit:function(){switch(this.s_m){case 110:case 111:case 112:case 113:case 114:case 115:case 116:return!0;default:return!1}},inDisconnected:function(){return 100==this.s_m},toString:function(){var t="<m="+this.s_m;return t+=" du="+this.s_du,null!=this.s_tr&&(t+=" tr="+this.s_tr),null!=this.s_w&&(t+=" "+g.string(this.s_w)),null!=this.s_ws&&(t+=" "+g.string(this.s_ws)),null!=this.s_wp&&(t+=" "+g.string(this.s_wp)),null!=this.s_hs&&(t+=" "+g.string(this.s_hs)),null!=this.s_hp&&(t+=" "+g.string(this.s_hp)),null!=this.s_rec&&(t+=" rec="+this.s_rec),null!=this.s_h&&(t+=" h="+this.s_h),null!=this.s_ctrl&&(t+=" ctrl="+this.s_ctrl),null!=this.s_swt&&(t+=" swt="+this.s_swt),null!=this.s_bw&&(t+=" bw="+this.s_bw),null!=this.s_rhb&&(t+=" rhb="+this.s_rhb),null!=this.s_slw&&(t+=" slw="+this.s_slw),t+=" nr="+this.s_nr,t+=">"},traceState:function(){ni.isTraceEnabled()&&ni.trace("goto: "+this.toString())},__class__:j};var Q=function(){R.call(this)};Q.__name__="com.lightstreamer.client.internal.MessageEventDispatcher",Q.__super__=R,Q.prototype=c(R.prototype,{onAbort:function(t,e){this.dispatchToAll((function(s){null!=s.onAbort&&s.onAbort(t,e)}))},onDeny:function(t,e,s){this.dispatchToAll((function(i){null!=i.onDeny&&i.onDeny(t,e,s)}))},onDiscarded:function(t){this.dispatchToAll((function(e){null!=e.onDiscarded&&e.onDiscarded(t)}))},onError:function(t){this.dispatchToAll((function(e){null!=e.onError&&e.onError(t)}))},onProcessed:function(t){this.dispatchToAll((function(e){null!=e.onProcessed&&e.onProcessed(t)}))},__class__:Q});var J=function(t,e,s,i,n,r){this.eventDispatcher=new Q,this.txt=t,this.sequence=e,this.prog="UNORDERED_MESSAGES"!=e||null!=i?r.getAndSetNextMsgProg(e):-1,this.maxWait=s,this.delegate=i,null!=i&&this.eventDispatcher.addListener(i),this.enqueueWhileDisconnected=n,this.client=r,this.s_m=null!=i?10:"UNORDERED_MESSAGES"!=e?20:30,r.relateMsgManager(this)};J.__name__="com.lightstreamer.client.internal.MessageManager",J.__interfaces__=[B],J.prototype={finalize:function(){this.client.unrelateMsgManager(this)},evtExtSendMessage:function(){switch(this.traceEvent("sendMessage"),this.s_m){case 10:this.goto(11),this.client.evtSendMessage(this);break;case 20:this.goto(21),this.client.evtSendMessage(this);break;case 30:this.goto(31),this.client.evtSendMessage(this)}},evtMSGFAIL:function(t,e){switch(this.traceEvent("MSGFAIL"),this.s_m){case 10:this.finalize(),this.goto(13);break;case 11:case 12:this.doMSGFAIL(t,e),this.finalize(),this.goto(14)}},evtMSGDONE:function(){switch(this.traceEvent("MSGDONE"),this.s_m){case 10:this.finalize(),this.goto(13);break;case 11:case 12:this.doMSGDONE(),this.finalize(),this.goto(13)}},evtREQOK:function(t){switch(this.traceEvent("REQOK"),this.s_m){case 11:t==this.lastReqId&&this.goto(12);break;case 21:t==this.lastReqId&&(this.finalize(),this.goto(22));break;case 31:t==this.lastReqId&&(this.finalize(),this.goto(33))}},evtREQERR:function(t,e,s){switch(this.traceEvent("REQERR"),this.s_m){case 11:t==this.lastReqId&&(this.doREQERR(e,s),this.finalize(),this.goto(14));break;case 21:t==this.lastReqId&&(this.finalize(),this.goto(23));break;case 31:t==this.lastReqId&&(this.finalize(),this.goto(34))}},evtAbort:function(){switch(this.traceEvent("abort"),this.s_m){case 11:case 12:this.doAbort(),this.finalize(),this.goto(15);break;case 21:li.isWarnEnabled()&&li.warn("Message "+this.sequence+":"+this.prog+" aborted"),this.finalize(),this.goto(24);break;case 31:li.isWarnEnabled()&&li.warn("Message "+this.sequence+":"+this.prog+" aborted"),this.finalize(),this.goto(35)}},evtWSSent:function(){this.traceEvent("ws.sent"),31==this.s_m&&(this.finalize(),this.goto(32))},isPending:function(){return 11==this.s_m||21==this.s_m||31==this.s_m},encode:function(t){return this.encodeMsg(t)},encodeWS:function(){return"msg\r\n"+this.encode(!0)},doMSGDONE:function(){this.fireOnProcessed()},doMSGFAIL:function(t,e){38==t||39==t?this.fireOnDiscarded():t<=0?this.fireOnDeny(t,e):32!=t&&33!=t&&this.fireOnError()},doREQERR:function(t,e){32!=t&&33!=t&&this.fireOnError()},doAbort:function(){this.fireOnAbort()},encodeMsg:function(t){var e="UNORDERED_MESSAGES"!=this.sequence,s=null!=this.delegate,i=new re;return this.lastReqId=this.client.generateFreshReqId(),i.LS_reqId(this.lastReqId),i.LS_message(this.txt),e&&s?(i.LS_sequence(this.sequence),i.LS_msg_prog(this.prog),this.maxWait>=0&&i.LS_max_wait(this.maxWait)):!e&&s?i.LS_msg_prog(this.prog):e&&!s?(i.LS_outcome(!1),i.LS_sequence(this.sequence),i.LS_msg_prog(this.prog),this.maxWait>=0&&i.LS_max_wait(this.maxWait)):e||s||(i.LS_outcome(!1),t&&i.LS_ack(!1)),ii.isInfoEnabled()&&ii.info("Sending message: "+g.string(i)),i.getEncodedString()},fireOnProcessed:function(){li.isInfoEnabled()&&li.info("Message "+this.sequence+":"+this.prog+" processed"),this.eventDispatcher.onProcessed(this.txt)},fireOnDiscarded:function(){li.isWarnEnabled()&&li.warn("Message "+this.sequence+":"+this.prog+" discarded"),this.eventDispatcher.onDiscarded(this.txt)},fireOnDeny:function(t,e){li.isWarnEnabled()&&li.warn("Message "+this.sequence+":"+this.prog+" denied: "+t+" - "+e),this.eventDispatcher.onDeny(this.txt,t,e)},fireOnError:function(){li.isWarnEnabled()&&li.warn("Message "+this.sequence+":"+this.prog+" failed"),this.eventDispatcher.onError(this.txt)},fireOnAbort:function(){li.isWarnEnabled()&&li.warn("Message "+this.sequence+":"+this.prog+" aborted"),this.eventDispatcher.onAbort(this.txt,!1)},traceEvent:function(t){ni.isTraceEnabled()&&ni.trace("msg#"+t+"("+this.sequence+":"+this.prog+") in "+this.s_m)},goto:function(t){this.s_m=t,ni.isTraceEnabled()&&ni.trace("msg#goto("+this.sequence+":"+this.prog+") "+this.s_m)},toString:function(){var t=Yt._new();return Yt.set(t,"text",this.txt),Yt.set(t,"sequence",this.sequence),Yt.set(t,"prog",this.prog),Yt.set(t,"timeout",this.maxWait),Yt.set(t,"enqueueWhileDisconnected",this.enqueueWhileDisconnected),cs.stringify(t.h)},__class__:J};var X=function(t,e,s){this.items=new as,this.s_m=1,this.lock=e.lock,this.client=e,this.subscription=t,this.m_subId=s};X.__name__="com.lightstreamer.client.internal.ModeStrategy",X.prototype={finalize:function(){},evtAbort:function(){this.traceEvent("abort"),1==this.s_m?(this.doAbort(),this.goto(1)):2==this.s_m&&(this.doAbort(),this.goto(1),this.genDisposeItems())},evtOnSUB:function(t,e,s,i,n){this.traceEvent("onSUB"),1==this.s_m&&(this.doSUB(t,e),this.goto(2))},evtOnCONF:function(t){this.traceEvent("onCONF"),2==this.s_m&&(this.doCONF(t),this.goto(2))},evtOnCS:function(t){this.traceEvent("onCS"),2==this.s_m&&(this.doCS(t),this.goto(2))},evtOnEOS:function(t){this.traceEvent("onEOS"),2==this.s_m&&(this.doEOS(t),this.goto(2))},evtUpdate:function(t,e){this.traceEvent("update"),2==this.s_m&&(this.doUpdate(t,e),this.goto(2))},evtUnsubscribe:function(){this.traceEvent("unsubscribe"),1==this.s_m?(this.finalize(),this.goto(3)):2==this.s_m&&(this.finalize(),this.goto(3),this.genDisposeItems())},evtOnUNSUB:function(){this.traceEvent("onUNSUB"),2==this.s_m&&(this.finalize(),this.goto(3),this.genDisposeItems())},evtDispose:function(){this.traceEvent("dispose"),1!=this.s_m&&2!=this.s_m||(this.finalize(),this.goto(3),this.genDisposeItems())},evtSetRequestedMaxFrequency:function(t){},getValue:function(t,e){var s=this.items.h[t];return null!=s?s.getValue(e):null},getCommandValue:function(t,e,s){throw new Qt("Unsupported operation")},createItem:function(t){throw new Qt("Abstract method")},doSUB:function(t,e){var s=this.subscription.getItems(),i=this.subscription.getFields();if(null!=s&&t!=s.slice().length)throw new Qt("Assertion failure: items != null ? nItems == items.toHaxe().length : true");if(null!=i&&e!=i.slice().length)throw new Qt("Assertion failure: fields != null ? nFields == fields.toHaxe().length : true")},doUpdate:function(t,e){this.selectItem(t).evtUpdate(e)},doEOS:function(t){this.selectItem(t).evtOnEOS()},doCS:function(t){this.selectItem(t).evtOnCS()},doCONF:function(t){this.realMaxFrequency=t,this.subscription.fireOnRealMaxFrequency(t,this.m_subId)},doAbort:function(){this.realMaxFrequency=null},genDisposeItems:function(){for(var t=this.items.copy(),e=t.keys();e.hasNext();)t.get(e.next()).evtDispose(this)},selectItem:function(t){var e=this.items.h[t];return null==e&&(e=this.createItem(t),this.items.h[t]=e),e},unrelate:function(t){this.items.remove(t)},traceEvent:function(t){ni.isTraceEnabled()&&ni.trace("sub#mod#"+t+"("+this.m_subId+") in "+this.s_m)},goto:function(t){this.s_m=t,ni.isTraceEnabled()&&ni.trace("sub#mod#goto("+this.m_subId+") "+this.s_m)},__class__:X};var $=function(t,e,s){X.call(this,t,e,s)};$.__name__="com.lightstreamer.client.internal.ModeStrategyCommand",$.__super__=X,$.prototype=c(X.prototype,{evtOnSUB:function(t,e,s,i,n){this.traceEvent("onSUB"),1==this.s_m&&(this.doSUBCMD(t,e,s,i),this.goto(2))},getCommandValue:function(t,e,s){var i=this.items.h[t];return null!=i?i.getCommandValue(e,s):null},doSUBCMD:function(t,e,s,i){var n=this.subscription.getItems(),r=null!=n?n.slice():null,a=this.subscription.getFields(),o=null!=a?a.slice():null;if(null!=r&&t!=r.length)throw new Qt("Assertion failure: items != null ? nItems == items.length : true");if(null!=o&&e!=o.length)throw new Qt("Assertion failure: fields != null ? nFields == fields.length : true");if(null!=o&&s-1!=o.indexOf("command"))throw new Qt('Assertion failure: fields != null ? cmdIdx - 1 == fields.indexOf("command") : true');if(null!=o&&i-1!=o.indexOf("key"))throw new Qt('Assertion failure: fields != null ? keyIdx - 1 == fields.indexOf("key") : true')},__class__:$});var Z=function(t,e,s){$.call(this,t,e,s)};Z.__name__="com.lightstreamer.client.internal.ModeStrategyCommand1Level",Z.__super__=$,Z.prototype=c($.prototype,{createItem:function(t){return new Et(t,this.subscription,this.client,this.m_subId)},__class__:Z});var tt=function(t,e,s){$.call(this,t,e,s)};tt.__name__="com.lightstreamer.client.internal.ModeStrategyCommand2Level",tt.__super__=$,tt.prototype=c($.prototype,{evtOnSUB:function(t,e,s,i,n){this.traceEvent("onSUB"),1==this.s_m&&(this.doSUBCMD2Level(t,e,s,i,n),this.goto(2))},evtSetRequestedMaxFrequency:function(t){switch(this.traceEvent("setRequestedMaxFrequency"),this.s_m){case 1:case 2:this.doSetRequestedMaxFrequency(t),this.goto(this.s_m),this.genSetRequestedMaxFrequency()}},evtOnRealMaxFrequency2LevelAdded:function(t){this.traceEvent("onRealMaxFrequency2LevelAdded"),2==this.s_m&&(this.doAggregateFrequenciesWhenFreqIsAdded(t),this.goto(2))},evtOnRealMaxFrequency2LevelRemoved:function(){this.traceEvent("onRealMaxFrequency2LevelRemoved"),2==this.s_m&&(this.doAggregateFrequenciesWhenFreqIsRemoved(),this.goto(2))},evtOnCONF:function(t){this.traceEvent("onCONF"),2==this.s_m&&(this.doCONF2Level(t),this.doAggregateFrequenciesWhenFreqIsAdded(t),this.goto(2))},createItem:function(t){return new wt(t,this.subscription,this,this.client,this.m_subId)},doSUBCMD2Level:function(t,e,s,i,n){var r=this.subscription.getItems(),a=null!=r?r.slice():null,o=this.subscription.getFields(),h=null!=o?o.slice():null;if(null!=a&&t!=a.length)throw new Qt("Assertion failure: items != null ? nItems == items.length : true");if(null!=h&&e!=h.length)throw new Qt("Assertion failure: fields != null ? nFields == fields.length : true");if(null!=h&&s-1!=h.indexOf("command"))throw new Qt('Assertion failure: fields != null ? cmdIdx - 1 == fields.indexOf("command") : true');if(null!=h&&i-1!=h.indexOf("key"))throw new Qt('Assertion failure: fields != null ? keyIdx - 1 == fields.indexOf("key") : true');this.requestedMaxFrequency=n},doSetRequestedMaxFrequency:function(t){this.requestedMaxFrequency=t},genSetRequestedMaxFrequency:function(){for(var t=this.items,e=t.keys();e.hasNext();)Ps.__cast(t.get(e.next()),wt).evtSetRequestedMaxFrequency()},doCONF2Level:function(t){this.realMaxFrequency=t},maxFreq:function(t,e){var s;if(null==t)s=e;else switch(t._hx_index){case 0:var i=t.freq;if(null==e)s=t;else switch(e._hx_index){case 0:s=De.RFreqLimited(Math.max(i,e.freq));break;case 1:s=e}break;case 1:s=t}return s},doAggregateFrequenciesWhenFreqIsAdded:function(t){var e=this.maxFreq(this.aggregateRealMaxFrequency,t),s=this.aggregateRealMaxFrequency;this.aggregateRealMaxFrequency=e,Ae(s,e)||this.subscription.fireOnRealMaxFrequency(e,this.m_subId)},doAggregateFrequenciesWhenFreqIsRemoved:function(){for(var t=this.realMaxFrequency,e=!1,s=this.items,i=s.keys();i.hasNext();){for(var n=Ps.__cast(s.get(i.next()),wt).keys.h,r=Object.keys(n),a=r.length,o=0;o<a;)if((t=this.maxFreq(t,Ps.__cast(n[r[o++]],Ot).realMaxFrequency))==De.RFreqUnlimited){e=!0;break}if(e)break}var h=this.aggregateRealMaxFrequency;this.aggregateRealMaxFrequency=t,Ae(h,t)||this.subscription.fireOnRealMaxFrequency(t,this.m_subId)},__class__:tt});var et=function(t,e,s){X.call(this,t,e,s)};et.__name__="com.lightstreamer.client.internal.ModeStrategyDistinct",et.__super__=X,et.prototype=c(X.prototype,{createItem:function(t){return new Tt(t,this.subscription,this.client,this.m_subId)},__class__:et});var st=function(t,e,s){X.call(this,t,e,s)};st.__name__="com.lightstreamer.client.internal.ModeStrategyMerge",st.__super__=X,st.prototype=c(X.prototype,{createItem:function(t){return new Rt(t,this.subscription,this.client,this.m_subId)},__class__:st});var it=function(t,e,s){X.call(this,t,e,s)};it.__name__="com.lightstreamer.client.internal.ModeStrategyRaw",it.__super__=X,it.prototype=c(X.prototype,{createItem:function(t){return new It(t,this.subscription,this.client,this.m_subId)},__class__:it});var nt=function(t,e,s){this.subId=t,this.itemIdx=e,this.values=s};function rt(t){return Xt.sure(g.parseInt(t))}function at(t){return Xt.sure(parseFloat(t))}function ot(t){for(var e=ht(t,",")+1,s=ht(t,",",e)+1,i=ht(t,",",s)+1,n=rt(t.substring(e,s-1)),r=rt(t.substring(s,i-1)),a=new as,o=i-1,h=1;o<t.length;){var l=t.indexOf("|",o+1);-1==l&&(l=t.length);var c=t.substring(o+1,l);if(""==c)a.h[h]=ve.unchanged,++h;else if("#"==c)a.h[h]=ve.changed(null),++h;else if("$"==c)a.h[h]=ve.changed(""),++h;else if("^"==c.charAt(0))if("P"==c.charAt(1)){var u=lt(c.substring(2));try{var _=He._new(u);a.h[h]=ve.jsonPatch(_),++h}catch(t){var d=w.caught(t);throw ri.isErrorEnabled()&&ri.error("Invalid JSON patch "+u+": "+d.get_message()+"\n"+d.details()),new Qt("The JSON Patch for the field "+h+" is not well-formed")}}else if("T"==c.charAt(1)){var m=lt(c.substring(2));a.h[h]=ve.diffPatch(m),++h}else for(var f=rt(c.substring(1)),g=0;g<f;)++g,a.h[h]=ve.unchanged,++h;else{var p=ve.changed(lt(c));a.h[h]=p,++h}o=l}return new nt(n,r,a)}function ht(t,e,s){var i=t.indexOf(e,s);if(-1==i)throw new Qt("string not found");return i}function lt(t){for(var e=ut.ofString(t,_t.UTF8),s=0,i=0;s<e.length;)37==e.b[s]?(e.b[i++]=(ct(e.b[s+1])<<4)+ct(e.b[s+2]),s+=3):e.b[i++]=e.b[s++];return e.getString(0,i,_t.UTF8)}function ct(t){var e=0;return(e=t-97+10)<=9&&(e=t-65+10)<=9&&(e=t-48),e}nt.__name__="com.lightstreamer.client.internal.UpdateInfo",nt.prototype={__class__:nt};var ut=function(t){this.length=t.byteLength,this.b=new Uint8Array(t),this.b.bufferValue=t,t.hxBytes=this,t.bytes=this.b};ut.__name__="haxe.io.Bytes",ut.ofString=function(t,e){if(e==_t.RawNative){for(var s=new Uint8Array(t.length<<1),i=0,n=t.length;i<n;){var r=i++,a=t.charCodeAt(r);s[r<<1]=255&a,s[r<<1|1]=a>>8}return new ut(s.buffer)}var o=[];for(r=0;r<t.length;)55296<=(a=t.charCodeAt(r++))&&a<=56319&&(a=a-55232<<10|1023&t.charCodeAt(r++)),a<=127?o.push(a):a<=2047?(o.push(192|a>>6),o.push(128|63&a)):a<=65535?(o.push(224|a>>12),o.push(128|a>>6&63),o.push(128|63&a)):(o.push(240|a>>18),o.push(128|a>>12&63),o.push(128|a>>6&63),o.push(128|63&a));return new ut(new Uint8Array(o).buffer)},ut.prototype={getString:function(t,e,s){if(t<0||e<0||t+e>this.length)throw w.thrown(ds.OutsideBounds);null==s&&(s=_t.UTF8);var i="",n=this.b,r=t,a=t+e;switch(s._hx_index){case 0:for(;r<a;)if((c=n[r++])<128){if(0==c)break;i+=String.fromCodePoint(c)}else if(c<224){var o=(63&c)<<6|127&n[r++];i+=String.fromCodePoint(o)}else if(c<240){var h=(31&c)<<12|(127&n[r++])<<6|127&n[r++];i+=String.fromCodePoint(h)}else{var l=(15&c)<<18|(127&n[r++])<<12|(127&n[r++])<<6|127&n[r++];i+=String.fromCodePoint(l)}break;case 1:for(;r<a;){var c=n[r++]|n[r++]<<8;i+=String.fromCodePoint(c)}}return i},__class__:ut};var _t=a["haxe.io.Encoding"]={__ename__:!0,__constructs__:null,UTF8:{_hx_name:"UTF8",_hx_index:0,__enum__:"haxe.io.Encoding",toString:r},RawNative:{_hx_name:"RawNative",_hx_index:1,__enum__:"haxe.io.Encoding",toString:r}};_t.__constructs__=[_t.UTF8,_t.RawNative];var dt=function(){this.body=""};dt.__name__="com.lightstreamer.client.internal.Request",dt.isEmpty=function(t){return 0==t.length},dt.lengthOfBytes=function(t){return ut.ofString(t,_t.UTF8).length},dt.prototype={getByteSize:function(){return dt.lengthOfBytes(this.body)},getBody:function(){return this.body},addSubRequest:function(t){dt.isEmpty(this.body)?this.body=t:this.body+="\r\n"+t},addSubRequestOnlyIfBodyIsLessThan:function(t,e){return dt.isEmpty(this.body)&&dt.lengthOfBytes(t)<=e?(this.body=t,!0):dt.lengthOfBytes(this.body)+dt.EOL_LEN+dt.lengthOfBytes(t)<=e&&(this.body+="\r\n"+t,!0)},__class__:dt};var mt=function(){this.attempt=1,this._currentRetryDelay=0};mt.__name__="com.lightstreamer.client.internal.RetryDelayCounter",mt.prototype={get_currentRetryDelay:function(){return this._currentRetryDelay},increase:function(){this.attempt>10?this._currentRetryDelay<6e4&&(2*this._currentRetryDelay<6e4?this._currentRetryDelay*=2:this._currentRetryDelay=6e4):this.attempt+=1},reset:function(t){this.attempt=1,this._currentRetryDelay=t},__class__:mt};var ft=function(){};ft.__name__="com.lightstreamer.client.internal.SubscriptionManager",ft.__isInterface__=!0,ft.__interfaces__=[B],ft.prototype={__class__:ft};var gt=function(t){this.subId=t,this.s_m=1};gt.__name__="com.lightstreamer.client.internal._SubscriptionManager.State",gt.prototype={toString:function(){var t="<m="+this.s_m;return null!=this.s_s&&(t+=" s="+this.s_s),null!=this.s_c&&(t+=" c="+this.s_c),t+=">"},traceState:function(){ni.isTraceEnabled()&&ni.trace("sub#goto("+this.subId+") "+this.toString())},__class__:gt};var pt=function(t,e){var s;switch(this.lock=e.lock,this.subId=e.generateFreshSubId(),t.fetch_mode()){case"COMMAND":s=pt.is2LevelCommand(t)?new tt(t,e,this.subId):new Z(t,e,this.subId);break;case"DISTINCT":s=new et(t,e,this.subId);break;case"MERGE":s=new st(t,e,this.subId);break;case"RAW":s=new it(t,e,this.subId)}this.m_strategy=s,this.state=new gt(this.subId),this.m_client=e,this.m_subscription=t,this.m_client.relateSubManager(this),this.m_subscription.relate(this)};pt.__name__="com.lightstreamer.client.internal.SubscriptionManagerLiving",pt.__interfaces__=[ft],pt.is2LevelCommand=function(t){return"COMMAND"==t.fetch_mode()&&(null!=t.getCommandSecondLevelFields()||null!=t.getCommandSecondLevelFieldSchema())},pt.prototype={finalize:function(){this.m_strategy.evtDispose(),this.m_client.unrelateSubManager(this),this.m_subscription.unrelate(this)},evtExtSubscribe:function(){this.traceEvent("subscribe"),1==this.state.s_m&&(this.doSetActive(),this.doSubscribe(),this.state.s_m=2,this.state.traceState(),this.genSendControl())},evtExtUnsubscribe:function(){this.traceEvent("unsubscribe"),2==this.state.s_m?(this.doSetInactive(),this.finalize(),this.state.s_m=30,this.state.traceState()):3==this.state.s_m?(this.doUnsubscribe(),this.doSetInactive(),this.state.s_m=5,this.state.traceState(),this.genSendControl()):10==this.state.s_s&&(this.doUnsubscribe(),this.m_subscription.setInactive(),this.notifyOnUnsubscription(),this.state.s_m=5,this.state.s_s=null,this.state.s_c=null,this.state.traceState(),this.genSendControl())},evtExtAbort:function(){this.traceEvent("abort"),2==this.state.s_m?(this.state.s_m=2,this.state.traceState()):3==this.state.s_m?(this.doAbort(),this.doSetActive(),this.state.s_m=2,this.state.traceState()):10==this.state.s_s?(this.doAbort(),this.doSetActive(),this.notifyOnUnsubscription(),this.state.s_s=null,this.state.s_c=null,this.state.s_m=2,this.state.traceState()):5==this.state.s_m&&(this.finalize(),this.state.s_m=32,this.state.traceState())},evtREQERR:function(t,e,s){this.traceEvent("REQERR"),2==this.state.s_m&&t==this.m_lastAddReqId?(this.doSetInactive(),this.notifyOnSubscriptionError(e,s),this.finalize(),this.state.s_m=30,this.state.traceState()):5==this.state.s_m&&t==this.m_lastDeleteReqId?(this.finalize(),this.state.s_m=32,this.state.traceState()):22==this.state.s_c&&t==this.m_lastReconfReqId&&(Le.extEquals(this.m_reqMaxFrequency,this.m_subscription.fetch_requestedMaxFrequency())?(this.state.s_c=21,this.state.traceState()):(this.state.s_c=20,this.state.traceState(),this.evtCheckFrequency()))},evtREQOK:function(t){this.traceEvent("REQOK"),2==this.state.s_m&&t==this.m_lastAddReqId?(this.state.s_m=3,this.state.traceState()):5==this.state.s_m&&t==this.m_lastDeleteReqId?(this.finalize(),this.state.s_m=32,this.state.traceState()):22==this.state.s_c&&t==this.m_lastReconfReqId&&(this.doREQOKConfigure(),this.state.s_c=20,this.state.traceState(),this.evtCheckFrequency())},evtSUBOK:function(t,e){this.traceEvent("SUBOK"),(2==this.state.s_m||3==this.state.s_m)&&(this.doSUBOK(t,e),this.notifyOnSubscription(),this.state.s_m=4,this.state.s_s=10,this.state.s_c=20,this.state.traceState(),this.evtCheckFrequency())},evtSUBCMD:function(t,e,s,i){this.traceEvent("SUBCMD"),(2==this.state.s_m||3==this.state.s_m)&&(this.doSUBCMD(t,e,i,s),this.notifyOnSubscription(),this.state.s_m=4,this.state.s_s=10,this.state.s_c=20,this.state.traceState(),this.evtCheckFrequency())},evtUNSUB:function(){this.traceEvent("UNSUB"),10==this.state.s_s?(this.doUNSUB(),this.doSetInactive(),this.notifyOnUnsubscription(),this.finalize(),this.state.s_m=31,this.state.s_s=null,this.state.s_c=null,this.state.traceState()):5==this.state.s_m&&(this.finalize(),this.state.s_m=32,this.state.traceState())},evtU:function(t,e){this.traceEvent("U"),10==this.state.s_s&&(this.doU(t,e),this.state.s_s=10,this.state.traceState())},evtEOS:function(t){this.traceEvent("EOS"),10==this.state.s_s&&(this.doEOS(t),this.state.s_s=10,this.state.traceState())},evtCS:function(t){this.traceEvent("CS"),10==this.state.s_s&&(this.doCS(t),this.state.s_s=10,this.state.traceState())},evtOV:function(t,e){this.traceEvent("OV"),10==this.state.s_s&&(this.doOV(t,e),this.state.s_s=10,this.state.traceState())},evtCONF:function(t){this.traceEvent("CONF"),10==this.state.s_s&&(this.doCONF(t),this.state.s_s=10,this.state.traceState())},evtCheckFrequency:function(){this.traceEvent("check.frequency"),20==this.state.s_c&&(Le.extEquals(this.m_subscription.fetch_requestedMaxFrequency(),this.m_currentMaxFrequency)?(this.state.s_c=21,this.state.traceState()):(this.doConfigure(),this.state.s_c=22,this.state.traceState(),this.genSendControl()))},evtExtConfigure:function(){this.traceEvent("configure"),21==this.state.s_c&&(this.state.s_c=20,this.state.traceState(),this.evtCheckFrequency())},isPending:function(){return 2==this.state.s_m||5==this.state.s_m||22==this.state.s_c},encode:function(t){if(2==this.state.s_m)return this.encodeAdd(t);if(5==this.state.s_m)return this.encodeDelete(t);if(22==this.state.s_c)return this.encodeReconf(t);throw new Qt("Can't encode request")},encodeWS:function(){return"control\r\n"+this.encode(!0)},getValue:function(t,e){return this.m_strategy.getValue(t,e)},getCommandValue:function(t,e,s){return this.m_strategy.getCommandValue(t,e,s)},encodeAdd:function(t){var e=new re;this.m_lastAddReqId=this.m_client.generateFreshReqId(),e.LS_reqId(this.m_lastAddReqId),e.LS_op("add"),e.LS_subId(this.subId),e.LS_mode(this.m_subscription.fetch_mode());var s=this.m_subscription.getItemGroup(),i=this.m_subscription.getItems();null!=s?e.LS_group(s):null!=i&&e.LS_group(i.slice().join(" "));var n=this.m_subscription.getFieldSchema(),r=this.m_subscription.getFields();null!=n?e.LS_schema(n):null!=r&&e.LS_schema(r.slice().join(" "));var a=this.m_subscription.getDataAdapter();null!=a&&e.LS_data_adapter(a);var o=this.m_subscription.getSelector();null!=o&&e.LS_selector(o);var h=this.m_subscription.fetch_requestedSnapshot();if(null!=h)switch(h._hx_index){case 0:e.LS_snapshot(!0);break;case 1:e.LS_snapshot(!1);break;case 2:e.LS_snapshot_Int(h.len)}var l=this.m_currentMaxFrequency;if(null!=l)switch(l._hx_index){case 0:e.LS_requested_max_frequency_Float(l.max);break;case 1:e.LS_requested_max_frequency("unlimited");break;case 2:e.LS_requested_max_frequency("unfiltered")}var c=this.m_subscription.fetch_requestedBufferSize();if(null!=c)switch(c._hx_index){case 0:e.LS_requested_buffer_size_Int(c.size);break;case 1:e.LS_requested_buffer_size("unlimited")}return t&&e.LS_ack(!1),ii.isInfoEnabled()&&ii.info("Sending Subscription add: "+g.string(e)),e.getEncodedString()},encodeDelete:function(t){var e=new re;return this.m_lastDeleteReqId=this.m_client.generateFreshReqId(),e.LS_reqId(this.m_lastDeleteReqId),e.LS_subId(this.subId),e.LS_op("delete"),t&&e.LS_ack(!1),ii.isInfoEnabled()&&ii.info("Sending Subscription delete: "+g.string(e)),e.getEncodedString()},encodeReconf:function(t){var e=new re;this.m_lastReconfReqId=this.m_client.generateFreshReqId(),e.LS_reqId(this.m_lastReconfReqId),e.LS_subId(this.subId),e.LS_op("reconf");var s=this.m_reqMaxFrequency;if(null!=s)switch(s._hx_index){case 0:e.LS_requested_max_frequency_Float(s.max);break;case 1:e.LS_requested_max_frequency("unlimited");break;case 2:e.LS_requested_max_frequency("unfiltered")}return ii.isInfoEnabled()&&ii.info("Sending Subscription configuration: "+g.string(e)),e.getEncodedString()},doSetActive:function(){this.m_subscription.setActive()},doSetInactive:function(){this.m_subscription.setInactive()},doSubscribe:function(){this.m_currentMaxFrequency=this.m_subscription.fetch_requestedMaxFrequency()},doUnsubscribe:function(){this.m_strategy.evtUnsubscribe(),this.m_subscription.unrelate(this)},doAbort:function(){this.m_lastAddReqId=null,this.m_lastDeleteReqId=null,this.m_lastReconfReqId=null,this.m_reqMaxFrequency=null,this.m_currentMaxFrequency=this.m_subscription.fetch_requestedMaxFrequency(),this.m_strategy.evtAbort()},genSendControl:function(){this.m_client.evtSendControl(this)},notifyOnSubscription:function(){this.m_subscription.fireOnSubscription(this.subId)},notifyOnUnsubscription:function(){this.m_subscription.fireOnUnsubscription(this.subId)},notifyOnSubscriptionError:function(t,e){this.m_subscription.fireOnSubscriptionError(this.subId,t,e)},doConfigure:function(){this.m_reqMaxFrequency=this.m_subscription.fetch_requestedMaxFrequency(),this.m_strategy.evtSetRequestedMaxFrequency(this.m_reqMaxFrequency)},doREQOKConfigure:function(){this.m_currentMaxFrequency=this.m_reqMaxFrequency},doSUBOK:function(t,e){this.m_subscription.setSubscribed(this.subId,t,e),this.m_strategy.evtOnSUB(t,e,null,null,null)},doSUBCMD:function(t,e,s,i){this.m_subscription.setSubscribedCMD(this.subId,t,e,s,i),this.m_strategy.evtOnSUB(t,e,s,i,this.m_currentMaxFrequency)},doUNSUB:function(){this.m_strategy.evtOnUNSUB()},doU:function(t,e){if(t>Xt.sure(this.m_subscription.fetch_nItems()))throw new Qt("Assertion failure: itemIdx <= m_subscription.fetch_nItems().sure()");this.m_strategy.evtUpdate(t,e)},doEOS:function(t){this.m_strategy.evtOnEOS(t),this.m_subscription.fireOnEndOfSnapshot(t,this.subId)},doCS:function(t){this.m_strategy.evtOnCS(t),this.m_subscription.fireOnClearSnapshot(t,this.subId)},doOV:function(t,e){this.m_subscription.fireOnLostUpdates(t,e,this.subId)},doCONF:function(t){this.m_strategy.evtOnCONF(t)},traceEvent:function(t){ni.isTraceEnabled()&&ni.trace("sub#"+t+"("+this.subId+") in "+g.string(this.state))},__class__:pt};var vt=function(t,e){this.s_m=1,this.subId=t,this.lock=e.lock,this.m_client=e,e.relateSubManager(this)};vt.__name__="com.lightstreamer.client.internal.SubscriptionManagerZombie",vt.__interfaces__=[ft],vt.prototype={finalize:function(){this.m_client.unrelateSubManager(this)},evtExtAbort:function(){this.traceEvent("abort"),2==this.s_m&&(this.finalize(),this.goto(3))},evtREQERR:function(t,e,s){this.traceEvent("REQERR"),2==this.s_m&&t==this.m_lastDeleteReqId&&(this.finalize(),this.goto(3))},evtREQOK:function(t){this.traceEvent("REQOK"),2==this.s_m&&t==this.m_lastDeleteReqId&&(this.finalize(),this.goto(3))},evtSUBOK:function(t,e){this.traceEvent("SUBOK"),1==this.s_m&&(this.goto(2),this.genSendControl())},evtSUBCMD:function(t,e,s,i){this.traceEvent("SUBCMD"),1==this.s_m&&(this.goto(2),this.genSendControl())},evtUNSUB:function(){this.traceEvent("UNSUB"),2==this.s_m&&(this.finalize(),this.goto(3))},evtU:function(t,e){this.traceEvent("U"),1==this.s_m&&(this.goto(2),this.genSendControl())},evtEOS:function(t){this.traceEvent("EOS"),1==this.s_m&&(this.goto(2),this.genSendControl())},evtCS:function(t){this.traceEvent("CS"),1==this.s_m&&(this.goto(2),this.genSendControl())},evtOV:function(t,e){this.traceEvent("OV"),1==this.s_m&&(this.goto(2),this.genSendControl())},evtCONF:function(t){this.traceEvent("CONF"),1==this.s_m&&(this.goto(2),this.genSendControl())},isPending:function(){return 2==this.s_m},encode:function(t){if(this.isPending())return this.encodeDelete(t);throw new Qt("Can't encode unsubscription request")},encodeWS:function(){return"control\r\n"+this.encode(!0)},genSendControl:function(){this.m_client.evtSendControl(this)},encodeDelete:function(t){var e=new re;return this.m_lastDeleteReqId=this.m_client.generateFreshReqId(),e.LS_reqId(this.m_lastDeleteReqId),e.LS_subId(this.subId),e.LS_op("delete"),t&&e.LS_ack(!1),e.LS_cause("zombie"),ii.isInfoEnabled()&&ii.info("Sending Subscription delete: "+g.string(e)),e.getEncodedString()},traceEvent:function(t){ni.isTraceEnabled()&&ni.trace("zsub#"+t+"("+this.subId+") in "+this.s_m)},goto:function(t){this.s_m=t,ni.isTraceEnabled()&&ni.trace("zsub#goto("+this.subId+") "+this.s_m)},__class__:vt};var St=function(){};St.__name__="com.lightstreamer.client.internal.update.AbstractItemUpdate",St.__interfaces__=[o],St.prototype={__class__:St};var yt=function(t,e,s,i){this.m_subId=i,this.itemIdx=t,this.subscription=e,this.client=s,this.lock=s.lock};yt.__name__="com.lightstreamer.client.internal.update.ItemBase",yt.prototype={finalize:function(){},evtUpdate:function(t){this.fatalError()},evtOnEOS:function(){this.fatalError()},evtOnCS:function(){this.fatalError()},evtDispose:function(t){this.fatalError()},getValue:function(t){return null!=this.currValues?kt.toString(this.currValues.h[t]):null},getCommandValue:function(t,e){throw new Qt("Unsupported operation")},fatalError:function(){throw new Qt("Unsupported operation")},doFirstUpdate:function(t){this.doUpdate(t,!1)},doUpdate0:function(t){this.doUpdate(t,!1)},doFirstSnapshot:function(t){this.doUpdate(t,!0)},doSnapshot:function(t){this.doUpdate(t,!0)},doUpdate:function(t,e){var s=this.currValues;this.currValues=Mt(s,t);var i=Ft(s,this.currValues),n=qt(s,t),r=new Lt(this.itemIdx,this.subscription,this.currValues,i,e,n);this.subscription.fireOnItemUpdate(r,this.m_subId)},__class__:yt};var bt=function(t,e,s,i){this.keys=new cs,yt.call(this,t,e,s,i),this.s_m=e.hasSnapshot()?3:1};bt.__name__="com.lightstreamer.client.internal.update.ItemCommand",bt.__super__=yt,bt.prototype=c(yt.prototype,{finalize:function(){},unrelate:function(t){var e=this.keys;Object.prototype.hasOwnProperty.call(e.h,t)&&delete e.h[t]},evtUpdate:function(t){switch(this.traceEvent("update"),this.s_m){case 1:this.doFirstUpdate(t),this.goto(2);break;case 2:this.doUpdate0(t),this.goto(2);break;case 3:this.doFirstSnapshot(t),this.goto(4);break;case 4:this.doSnapshot(t),this.goto(4)}},evtOnEOS:function(){switch(this.traceEvent("onEOS"),this.s_m){case 3:this.goto(1);break;case 4:this.goto(2)}},evtOnCS:function(){throw new Qt("Unsupported method")},evtDispose:function(t){switch(this.traceEvent("dispose"),this.s_m){case 1:case 2:case 3:case 4:this.finalize(),this.goto(5),this.genDisposeKeys(),t.unrelate(this.itemIdx)}},getCommandValue:function(t,e){var s=this.keys.h[t];return null!=s?s.getCommandValue(e):null},createKey:function(t){throw new Qt("Abstract method")},doUpdate:function(t,e){this.currValues=Mt(this.currValues,t),this.selectKey().evtUpdate(this.currValues,e)},genDisposeKeys:function(){for(var t=cs.createCopy(this.keys.h).h,e=Object.keys(t),s=e.length,i=0;i<s;)t[e[i++]].evtDispose()},selectKey:function(){var t=this.currValues,e=this.subscription.getKeyPosition(),s=kt.toString(t.h[e]);return null==(e=this.keys.h[s])&&(e=this.createKey(s),this.keys.h[s]=e),e},goto:function(t){this.s_m=t,ni.isTraceEnabled()&&ni.trace("sub#itm#goto("+this.m_subId+":"+this.itemIdx+") in "+this.s_m)},traceEvent:function(t){ni.isTraceEnabled()&&ni.trace("sub#itm#"+t+"("+this.m_subId+":"+this.itemIdx+") in "+this.s_m)},__class__:bt});var Et=function(t,e,s,i){bt.call(this,t,e,s,i)};Et.__name__="com.lightstreamer.client.internal.update.ItemCommand1Level",Et.__super__=bt,Et.prototype=c(bt.prototype,{evtOnCS:function(){switch(this.traceEvent("onCS"),this.s_m){case 1:case 2:case 3:case 4:this.goto(this.s_m),this.genDisposeKeys()}},createKey:function(t){return new Dt(t,this)},__class__:Et});var wt=function(t,e,s,i,n){bt.call(this,t,e,i,n),this.strategy=s};wt.__name__="com.lightstreamer.client.internal.update.ItemCommand2Level",wt.__super__=bt,wt.prototype=c(bt.prototype,{evtOnCS:function(){switch(this.traceEvent("onCS"),this.s_m){case 1:case 2:case 3:case 4:this.goto(this.s_m),this.genDisposeKeys(),this.genOnRealMaxFrequency2LevelRemoved()}},evtSetRequestedMaxFrequency:function(){switch(this.traceEvent("setRequestedMaxFrequency"),this.s_m){case 1:case 2:case 3:case 4:this.goto(this.s_m),this.genSetRequestedMaxFrequency()}},createKey:function(t){return new Ot(t,this)},genSetRequestedMaxFrequency:function(){for(var t=this.keys.h,e=Object.keys(t),s=e.length,i=0;i<s;)t[e[i++]].evtSetRequestedMaxFrequency()},genOnRealMaxFrequency2LevelRemoved:function(){this.strategy.evtOnRealMaxFrequency2LevelRemoved()},__class__:wt});var Tt=function(t,e,s,i){yt.call(this,t,e,s,i),this.s_m=e.hasSnapshot()?3:1};Tt.__name__="com.lightstreamer.client.internal.update.ItemDistinct",Tt.__super__=yt,Tt.prototype=c(yt.prototype,{evtUpdate:function(t){switch(this.traceEvent("update"),this.s_m){case 1:this.doFirstUpdate(t),this.goto(2);break;case 2:this.doUpdate0(t),this.goto(2);break;case 3:this.doFirstSnapshot(t),this.goto(4);break;case 4:this.doSnapshot(t),this.goto(4)}},evtOnEOS:function(){switch(this.traceEvent("onEOS"),this.s_m){case 3:this.goto(1);break;case 4:this.goto(2)}},evtOnCS:function(){},evtDispose:function(t){switch(this.traceEvent("dispose"),this.s_m){case 1:case 2:case 3:case 4:this.finalize(),this.goto(5),t.unrelate(this.itemIdx)}},goto:function(t){this.s_m=t,ni.isTraceEnabled()&&ni.trace("sub#itm#goto("+this.m_subId+":"+this.itemIdx+") "+this.s_m)},traceEvent:function(t){ni.isTraceEnabled()&&ni.trace("sub#itm#"+t+"("+this.m_subId+":"+this.itemIdx+") in "+this.s_m)},__class__:Tt});var xt=function(){};xt.__name__="com.lightstreamer.client.internal.update.ItemKey",xt.__isInterface__=!0,xt.prototype={__class__:xt};var Rt=function(t,e,s,i){this.s_m=1,yt.call(this,t,e,s,i)};Rt.__name__="com.lightstreamer.client.internal.update.ItemMerge",Rt.__super__=yt,Rt.prototype=c(yt.prototype,{evtUpdate:function(t){switch(this.traceEvent("update"),this.s_m){case 1:this.subscription.hasSnapshot()?(this.doSnapshot(t),this.goto(2)):(this.doFirstUpdate(t),this.goto(3));break;case 2:case 3:this.doUpdate0(t),this.goto(3)}},evtDispose:function(t){switch(this.traceEvent("dispose"),this.s_m){case 1:case 2:case 3:this.finalize(),this.goto(4),t.unrelate(this.itemIdx)}},goto:function(t){this.s_m=t,ni.isTraceEnabled()&&ni.trace("sub#itm#goto("+this.m_subId+":"+this.itemIdx+") "+this.s_m)},traceEvent:function(t){ni.isTraceEnabled()&&ni.trace("sub#itm#"+t+"("+this.m_subId+":"+this.itemIdx+") in "+this.s_m)},__class__:Rt});var It=function(t,e,s,i){this.s_m=1,yt.call(this,t,e,s,i)};It.__name__="com.lightstreamer.client.internal.update.ItemRaw",It.__super__=yt,It.prototype=c(yt.prototype,{evtUpdate:function(t){switch(this.traceEvent("update"),this.s_m){case 1:this.doFirstUpdate(t),this.goto(2);break;case 2:this.doUpdate0(t),this.goto(2)}},evtDispose:function(t){switch(this.traceEvent("dispose"),this.s_m){case 1:case 2:this.finalize(),this.goto(3),t.unrelate(this.itemIdx)}},goto:function(t){this.s_m=t,ni.isTraceEnabled()&&ni.trace("sub#itm#goto("+this.m_subId+":"+this.itemIdx+") "+this.s_m)},traceEvent:function(t){ni.isTraceEnabled()&&ni.trace("sub#itm#"+t+"("+this.m_subId+":"+this.itemIdx+") in "+this.s_m)},__class__:It});var Ct=function(t,e,s,i,n,r){var a=e.getItems(),o=e.getFields(),h=e.getCommandSecondLevelFields();this.m_itemIdx=t,this.m_items=At(null!=a?a.slice():null),this.m_nFields=Xt.sure(e.fetch_nFields()),this.m_fields=At(null!=o?o.slice():null),this.m_fields2=At(null!=h?h.slice():null),this.m_newValues=s.copy(),this.m_changedFields=i.copy(),this.m_isSnapshot=n,this.m_jsonPatches=r};Ct.__name__="com.lightstreamer.client.internal.update.ItemUpdate2Level",Ct.__super__=St,Ct.prototype=c(St.prototype,{getItemName:function(){return null!=this.m_items?this.m_items.h[this.m_itemIdx]:null},getItemPos:function(){return this.m_itemIdx},isSnapshot:function(){return this.m_isSnapshot},getValue:function(t){return"number"==typeof t&&(0|t)===t?this.getValuePos(t):this.getValueName(g.string(t))},isValueChanged:function(t){return"number"==typeof t&&(0|t)===t?this.isValueChangedPos(t):this.isValueChangedName(g.string(t))},_getValueAsJSONPatchIfAvailable:function(t){if("number"==typeof t&&(0|t)===t)return this.m_jsonPatches.h[t];var e=this.getFieldIdxFromName(g.string(t));return null!=e?this.m_jsonPatches.h[e]:null},getValueAsJSONPatchIfAvailable:function(t){return this._getValueAsJSONPatchIfAvailable(t)},forEachChangedField:function(t){for(var e=this.m_changedFields.iterator();e.current<e.array.length;){var s=e.array[e.current++];try{t(this.getFieldNameOrNullFromIdx(s),s,kt.toString(this.m_newValues.h[s]))}catch(t){var i=w.caught(t);ai.isErrorEnabled()&&ai.error("An exception was thrown while executing the Function passed to the forEachChangedField method\n"+i.details())}}},forEachField:function(t){for(var e=this.m_newValues,s=e.keys();s.hasNext();){var i=s.next(),n=e.get(i);try{t(this.getFieldNameOrNullFromIdx(i),i,kt.toString(n))}catch(t){var r=w.caught(t);ai.isErrorEnabled()&&ai.error("An exception was thrown while executing the Function passed to the forEachField method\n"+r.details())}}},getValuePos:function(t){return kt.toString(this.m_newValues.h[t])},getValueName:function(t){if(null==this.m_fields&&null==this.m_fields2)throw new Qt(Xs);var e=this.getFieldIdxFromName(t);if(null==e)throw new T(Zs);return kt.toString(this.m_newValues.h[e])},isValueChangedPos:function(t){return this.m_changedFields.contains(t)},isValueChangedName:function(t){if(null==this.m_fields&&null==this.m_fields2)throw new Qt(Xs);var e=this.getFieldIdxFromName(t);if(null==e)throw new T(Zs);return this.m_changedFields.contains(e)},getFieldNameFromIdx:function(t){if(null==this.m_fields)throw new Qt("Assertion failure: m_fields != null");if(null==this.m_fields2)throw new Qt("Assertion failure: m_fields2 != null");return Xt.sure(this.getFieldNameOrNullFromIdx(t))},getFieldNameOrNullFromIdx:function(t){return t<=this.m_nFields?null!=this.m_fields?this.m_fields.h[t]:null:null!=this.m_fields2?this.m_fields2.h[t-this.m_nFields]:null},getFieldIdxFromName:function(t){var e,s,i=this.m_fields;return null!=i&&null!=(s=Wt(Xt.sure(i),t))?s:null!=(e=this.m_fields2)&&null!=(s=Wt(Xt.sure(e),t))?this.m_nFields+Xt.sure(s):null},toString:function(){var t="";t="[";for(var e=this.m_newValues,s=e.keys();s.hasNext();){var i=s.next(),n=e.get(i),r=this.getFieldNameOrNullFromIdx(i),a=null!=r?r:null==i?"null":""+i,o=g.string(n);i>1&&(t+=","),t+=null==a?"null":""+a,t+=":",t+=null==o?"null":""+o}return t+="]"},__class__:Ct});var Lt=function(t,e,s,i,n,r){var a=e.getItems(),o=e.getFields();this.m_itemIdx=t,this.m_items=At(null!=a?a.slice():null),this.m_nFields=Xt.sure(e.fetch_nFields()),this.m_fields=At(null!=o?o.slice():null),this.m_newValues=s.copy(),this.m_changedFields=i.copy(),this.m_isSnapshot=n,this.m_jsonPatches=r};Lt.__name__="com.lightstreamer.client.internal.update.ItemUpdateBase",Lt.__super__=St,Lt.prototype=c(St.prototype,{getItemName:function(){return null!=this.m_items?this.m_items.h[this.m_itemIdx]:null},getItemPos:function(){return this.m_itemIdx},isSnapshot:function(){return this.m_isSnapshot},getValue:function(t){return"number"==typeof t&&(0|t)===t?this.getValuePos(t):this.getValueName(g.string(t))},isValueChanged:function(t){return"number"==typeof t&&(0|t)===t?this.isValueChangedPos(t):this.isValueChangedName(g.string(t))},_getValueAsJSONPatchIfAvailable:function(t){if("number"==typeof t&&(0|t)===t)return this.m_jsonPatches.h[t];var e=this.getFieldIdxFromName(g.string(t));return this.m_jsonPatches.h[e]},getValueAsJSONPatchIfAvailable:function(t){return this._getValueAsJSONPatchIfAvailable(t)},forEachChangedField:function(t){for(var e=this.m_changedFields.iterator();e.current<e.array.length;){var s=e.array[e.current++];try{t(null!=this.m_fields?this.m_fields.h[s]:null,s,kt.toString(this.m_newValues.h[s]))}catch(t){var i=w.caught(t);ai.isErrorEnabled()&&ai.error("An exception was thrown while executing the Function passed to the forEachChangedField method\n"+i.details())}}},forEachField:function(t){for(var e=this.m_newValues,s=e.keys();s.hasNext();){var i=s.next(),n=e.get(i);try{t(null!=this.m_fields?this.m_fields.h[i]:null,i,kt.toString(n))}catch(t){var r=w.caught(t);ai.isErrorEnabled()&&ai.error("An exception was thrown while executing the Function passed to the forEachField method\n"+r.details())}}},getValuePos:function(t){if(!(1<=t&&t<=this.m_nFields))throw new T($s);return kt.toString(this.m_newValues.h[t])},getValueName:function(t){var e=this.getFieldIdxFromName(t);return kt.toString(this.m_newValues.h[e])},isValueChangedPos:function(t){if(!(1<=t&&t<=this.m_nFields))throw new T($s);return this.m_changedFields.contains(t)},isValueChangedName:function(t){var e=this.getFieldIdxFromName(t);return this.m_changedFields.contains(e)},getFieldNameOrNullFromIdx:function(t){return null!=this.m_fields?this.m_fields.h[t]:null},getFieldIdxFromName:function(t){if(null==this.m_fields)throw new Qt(Xs);var e=Wt(this.m_fields,t);if(null==e)throw new T(Zs);return e},toString:function(){var t="";t="[";for(var e=this.m_newValues,s=e.keys();s.hasNext();){var i=s.next(),n=e.get(i),r=this.getFieldNameOrNullFromIdx(i),a=null!=r?r:null==i?"null":""+i,o=g.string(n);i>1&&(t+=","),t+=null==a?"null":""+a,t+=":",t+=null==o?"null":""+o}return t+="]"},__class__:Lt});var Dt=function(t,e){this.s_m=1,this.keyName=t,this.item=e,this.lock=e.lock};Dt.__name__="com.lightstreamer.client.internal.update.Key1Level",Dt.__interfaces__=[xt],Dt.prototype={finalize:function(){this.currKeyValues=null,this.item.unrelate(this.keyName)},evtUpdate:function(t,e){switch(this.traceEvent("update"),this.s_m){case 1:this.isDelete(t)?(this.doLightDelete(t,e),this.finalize(),this.goto(3)):(this.doFirstUpdate(t,e),this.goto(2));break;case 2:this.isDelete(t)?(this.doDelete(t,e),this.finalize(),this.goto(3)):(this.doUpdate(t,e),this.goto(2))}},evtDispose:function(){switch(this.traceEvent("dispose"),this.s_m){case 1:case 2:this.finalize(),this.goto(3)}},evtSetRequestedMaxFrequency:function(){},getCommandValue:function(t){return null!=this.currKeyValues?kt.toString(this.currKeyValues.h[t]):null},doFirstUpdate:function(t,e){var s=Xt.sure(this.item.subscription.fetch_nFields()),i=this.item.subscription.getCommandPosition();this.currKeyValues=t,this.currKeyValues.h[i]=Pt.StringVal("ADD");var n=new ae(new d(1,s+1));this.fireOnItemUpdate(new Lt(this.item.itemIdx,this.item.subscription,this.currKeyValues,n,e,new as))},doUpdate:function(t,e){var s=this.item.subscription.getCommandPosition(),i=this.currKeyValues;this.currKeyValues=t,this.currKeyValues.h[s]=Pt.StringVal("UPDATE");var n=Ft(i,this.currKeyValues);this.fireOnItemUpdate(new Lt(this.item.itemIdx,this.item.subscription,this.currKeyValues,n,e,new as))},doLightDelete:function(t,e){this.currKeyValues=null;var s=new ae(t.keys()),i=new Lt(this.item.itemIdx,this.item.subscription,this.nullify(t),s,e,new as);this.item.unrelate(this.keyName),this.fireOnItemUpdate(i)},doDelete:function(t,e){this.currKeyValues=null;var s=new ae(t.keys()).subtracting([this.item.subscription.getKeyPosition()]),i=new Lt(this.item.itemIdx,this.item.subscription,this.nullify(t),s,e,new as);this.item.unrelate(this.keyName),this.fireOnItemUpdate(i)},nullify:function(t){for(var e=new as,s=t,i=s.keys();i.hasNext();){var n=i.next(),r=s.get(n),a=n==this.item.subscription.getCommandPosition()||n==this.item.subscription.getKeyPosition();e.h[n]=a?r:null}return e},isDelete:function(t){var e=this.item.subscription.getCommandPosition();return"DELETE"==kt.toString(t.h[e])},fireOnItemUpdate:function(t){this.item.subscription.fireOnItemUpdate(t,this.item.m_subId)},goto:function(t){this.s_m=t,this.traceEvent("goto")},traceEvent:function(t){if(ni.isTraceEnabled()){var e=this.item.m_subId,s=this.item.itemIdx;ni.isTraceEnabled()&&ni.trace("sub#key#"+t+"("+e+":"+s+":"+this.keyName+") in "+this.s_m)}},__class__:Dt};var Ot=function(t,e){this.s_m=1,this.keyName=t,this.item=e,this.lock=e.lock};Ot.__name__="com.lightstreamer.client.internal.update.Key2Level",Ot.__interfaces__=[xt],Ot.prototype={finalize:function(){this.currKeyValues=null,this.currKey2Values=null,this.item.unrelate(this.keyName)},evtUpdate:function(t,e){switch(this.traceEvent("update"),this.s_m){case 1:if(this.isDelete(t))this.doLightDelete(t,e),this.finalize(),this.goto(11),this.genOnRealMaxFrequency2LevelRemoved();else{var s=this.create2LevelSubscription();null!=s?(this.doFirstUpdate(t,e),this.subscription2Level=s,this.goto(4),this.item.strategy.client.subscribeExt(s,!0)):(this.doFirstUpdate(t,e),this.notify2LevelIllegalArgument(),this.goto(3))}break;case 3:this.isDelete(t)?(this.doDelete1LevelOnly(t,e),this.finalize(),this.goto(11),this.genOnRealMaxFrequency2LevelRemoved()):(this.doUpdate(t,e),this.goto(3));break;case 4:this.isDelete(t)?(this.doDelete(t,e),this.finalize(),this.goto(11),this.genOnRealMaxFrequency2LevelRemoved()):(this.doUpdate(t,e),this.goto(4));break;case 5:this.isDelete(t)?(this.doDeleteExt(t,e),this.finalize(),this.goto(11),this.genOnRealMaxFrequency2LevelRemoved()):(this.doUpdate1Level(t,e),this.goto(5))}},evtDispose:function(){switch(this.traceEvent("dispose"),this.s_m){case 1:case 2:case 3:this.finalize(),this.goto(10);break;case 4:case 5:this.doUnsubscribe(),this.finalize(),this.goto(12)}},evtOnSubscriptionError2Level:function(t,e){this.traceEvent("onSubscriptionError2Level"),4==this.s_m&&(this.notify2LevelSubscriptionError(t,e),this.goto(3))},evtUpdate2Level:function(t){switch(this.traceEvent("update2Level"),this.s_m){case 4:case 5:this.doUpdate2Level(t),this.goto(5)}},evtOnUnsubscription2Level:function(){switch(this.traceEvent("onUnsubscription2Level"),this.s_m){case 4:case 5:this.doUnsetRealMaxFrequency(),this.goto(this.s_m),this.genOnRealMaxFrequency2LevelRemoved()}},evtOnItemLostUpdates2Level:function(t){switch(this.traceEvent("onItemLostUpdates2Level"),this.s_m){case 4:case 5:this.goto(this.s_m),this.notify2LevelLostUpdates(t)}},evtOnRealMaxFrequency2Level:function(t){switch(this.traceEvent("onRealMaxFrequency2Level"),this.s_m){case 4:case 5:this.doSetRealMaxFrequency(t),this.goto(this.s_m),this.genOnRealMaxFrequency2LevelAdded()}},evtSetRequestedMaxFrequency:function(){switch(this.traceEvent("setRequestedMaxFrequency"),this.s_m){case 4:case 5:this.doChangeRequestedMaxFrequency(),this.goto(this.s_m)}},getCommandValue:function(t){if(null!=(e=this.currKeyValues)&&null!=e.h[t])return kt.toString(e.h[t]);var e=this.currKey2Values,s=this.item.subscription.fetch_nFields();return null!=e&&null!=s?e.h[t-s]:null},doFirstUpdate:function(t,e){var s=this.item.subscription.getCommandPosition();this.currKeyValues=t,this.currKeyValues.h[s]=Pt.StringVal("ADD");var i=Ft(null,this.currKeyValues);this.fireOnItemUpdate(new Ct(this.item.itemIdx,this.item.subscription,this.currKeyValues,i,e,new as))},doUpdate:function(t,e){var s=this.item.subscription.getCommandPosition(),i=this.currKeyValues;this.currKeyValues=t,this.currKeyValues.h[s]=Pt.StringVal("UPDATE");var n=Ft(i,this.currKeyValues);this.fireOnItemUpdate(new Ct(this.item.itemIdx,this.item.subscription,this.currKeyValues,n,e,new as))},doUpdate2Level:function(t){var e=this.item.subscription.getCommandPosition(),s=Xt.sure(this.item.subscription.fetch_nFields()),i=Xt.sure(this.currKeyValues).copy();this.currKeyValues.h[e]=Pt.StringVal("UPDATE"),this.currKey2Values=Bt(t);for(var n=Xt.sure(this.currKeyValues).copy(),r=(l=this.currKey2Values).keys();r.hasNext();){var a=r.next(),o=l.get(a);n.h[a+s]=null==o?null:Pt.StringVal(o)}var h=new ae;for(kt.toString(i.h[e])!=kt.toString(this.currKeyValues.h[e])&&h.insert(e),r=(l=Ut(t)).keys();r.hasNext();)a=r.next(),l.get(a),h.insert(a+s);var l,c=t.isSnapshot(),u=new as;for(r=(l=this.currKey2Values).keys();r.hasNext();){a=r.next(),l.get(a);var _=t.getValueAsJSONPatchIfAvailable(a);null!=_&&(u.h[a+s]=_)}this.fireOnItemUpdate(new Ct(this.item.itemIdx,this.item.subscription,n,h,c,u))},doUpdate1Level:function(t,e){var s=this.item.subscription.getCommandPosition(),i=Xt.sure(this.item.subscription.fetch_nFields()),n=Xt.sure(this.currKeyValues);this.currKeyValues=t,this.currKeyValues.h[s]=Pt.StringVal("UPDATE");for(var r=Xt.sure(this.currKeyValues).copy(),a=Xt.sure(this.currKey2Values),o=a.keys();o.hasNext();){var h=o.next(),l=a.get(h);r.h[h+i]=null==l?null:Pt.StringVal(l)}for(var c=new ae,u=1,_=i+1;u<_;){var d=u++;kt.toString(n.h[d])!=kt.toString(r.h[d])&&c.insert(d)}this.fireOnItemUpdate(new Ct(this.item.itemIdx,this.item.subscription,r,c,e,new as))},doDelete:function(t,e){var s=Xt.sure(this.item.subscription.fetch_nFields()),i=this.item.subscription.getKeyPosition(),n=this.item.subscription.getCommandPosition();this.currKeyValues=null;for(var r=new ae(new d(1,s+1)).subtracting([i]),a=new as,o=1,h=s+1;o<h;)a.h[o++]=null;a.h[i]=Pt.StringVal(this.keyName),a.h[n]=Pt.StringVal("DELETE");var l=new Ct(this.item.itemIdx,this.item.subscription,a,r,e,new as);this.item.unrelate(this.keyName);var c=Xt.sure(this.subscription2Level);c.removeListener(Xt.sure(this.listener2Level)),Xt.sure(this.listener2Level).disable(),this.subscription2Level=null,this.listener2Level=null,this.item.strategy.client.unsubscribe(c),this.fireOnItemUpdate(l)},doDeleteExt:function(t,e){var s=Xt.sure(this.item.subscription.fetch_nFields()),i=this.item.subscription.getKeyPosition(),n=this.item.subscription.getCommandPosition(),r=s+m.count(Xt.sure(this.currKey2Values));this.currKeyValues=null,this.currKey2Values=null;for(var a=new ae(new d(1,r+1)).subtracting([i]),o=new as,h=1,l=r+1;h<l;)o.h[h++]=null;o.h[i]=Pt.StringVal(this.keyName),o.h[n]=Pt.StringVal("DELETE");var c=new Ct(this.item.itemIdx,this.item.subscription,o,a,e,new as);this.item.unrelate(this.keyName);var u=Xt.sure(this.subscription2Level);u.removeListener(Xt.sure(this.listener2Level)),Xt.sure(this.listener2Level).disable(),this.subscription2Level=null,this.listener2Level=null,this.item.strategy.client.unsubscribe(u),this.fireOnItemUpdate(c)},doLightDelete:function(t,e){var s=Xt.sure(this.item.subscription.fetch_nFields()),i=this.item.subscription.getKeyPosition(),n=this.item.subscription.getCommandPosition();this.currKeyValues=null;for(var r=new ae(new d(1,s+1)),a=new as,o=1,h=s+1;o<h;)a.h[o++]=null;a.h[i]=t.h[i],a.h[n]=t.h[n],this.fireOnItemUpdate(new Ct(this.item.itemIdx,this.item.subscription,a,r,e,new as))},doDelete1LevelOnly:function(t,e){var s=Xt.sure(this.item.subscription.fetch_nFields()),i=this.item.subscription.getKeyPosition(),n=this.item.subscription.getCommandPosition();this.currKeyValues=null;for(var r=new ae(new d(1,s+1)).subtracting([i]),a=new as,o=1,h=s+1;o<h;)a.h[o++]=null;a.h[i]=t.h[i],a.h[n]=t.h[n],this.fireOnItemUpdate(new Ct(this.item.itemIdx,this.item.subscription,a,r,e,new as))},doChangeRequestedMaxFrequency:function(){Xt.sure(this.subscription2Level).setRequestedMaxFrequency(Le.toString(this.item.strategy.requestedMaxFrequency))},doSetRealMaxFrequency:function(t){this.realMaxFrequency=t},doUnsetRealMaxFrequency:function(){this.realMaxFrequency=null},genOnRealMaxFrequency2LevelAdded:function(){this.item.strategy.evtOnRealMaxFrequency2LevelAdded(this.realMaxFrequency)},genOnRealMaxFrequency2LevelRemoved:function(){this.item.strategy.evtOnRealMaxFrequency2LevelRemoved()},doUnsubscribe:function(){if(null==this.subscription2Level)throw new Qt("Assertion failure: subscription2Level != null");if(null==this.listener2Level)throw new Qt("Assertion failure: listener2Level != null");var t=this.subscription2Level;t.removeListener(this.listener2Level),this.listener2Level.disable(),this.subscription2Level=null,this.listener2Level=null,this.item.strategy.client.unsubscribe(t)},notify2LevelIllegalArgument:function(){this.listener2Level=null,this.subscription2Level=null,this.item.subscription.fireOnSubscriptionError2Level(this.keyName,14,"The received key value is not a valid name for an Item",this.item.m_subId,this.item.itemIdx)},notify2LevelSubscriptionError:function(t,e){this.listener2Level=null,this.subscription2Level=null,this.item.subscription.fireOnSubscriptionError2Level(this.keyName,t,e,this.item.m_subId,this.item.itemIdx)},notify2LevelLostUpdates:function(t){this.item.subscription.fireOnLostUpdates2Level(this.keyName,t,this.item.m_subId,this.item.itemIdx)},fireOnItemUpdate:function(t){this.item.subscription.fireOnItemUpdate(t,this.item.m_subId)},create2LevelSubscription:function(){this.listener2Level=new Nt(this);var t=this.item.subscription,e=new O("MERGE",null,null),s=[this.keyName];if(!ke.allValidNames(s))return null;e.setItems(s.slice());var i=t.getCommandSecondLevelFields();return null!=i?e.setFields(i):e.setFieldSchema(t.getCommandSecondLevelFieldSchema()),e.setDataAdapter(t.getCommandSecondLevelDataAdapter()),e.setRequestedSnapshot(Ie.toString(Re.SnpYes)),e.setRequestedMaxFrequency(Le.toString(this.item.strategy.requestedMaxFrequency)),e.addListener(Xt.sure(this.listener2Level)),e.setInternal(),e},isDelete:function(t){var e=this.item.subscription.getCommandPosition();return"DELETE"==kt.toString(t.h[e])},goto:function(t){this.s_m=t,this.traceEvent("goto")},traceEvent:function(t){if(ni.isTraceEnabled()){var e=this.item.m_subId,s=this.item.itemIdx;ni.isTraceEnabled()&&ni.trace("sub#key#"+t+"("+e+":"+s+":"+this.keyName+") in "+this.s_m)}},__class__:Ot};var Nt=function(t){this.m_disabled=!1,this.key=t};Nt.__name__="com.lightstreamer.client.internal.update._Key2Level.Sub2LevelDelegate",Nt.__interfaces__=[h],Nt.prototype={disable:function(){var t=this;se.synchronized(this.key.lock,(function(){return t.m_disabled=!0}))},synchronized:function(t){var e=this;se.synchronized(this.key.lock,(function(){e.m_disabled||t()}))},onSubscriptionError:function(t,e){var s=this;this.synchronized((function(){s.key.evtOnSubscriptionError2Level(t,e)}))},onItemUpdate:function(t){var e=this;this.synchronized((function(){e.key.evtUpdate2Level(t)}))},onItemLostUpdates:function(t,e,s){var i=this;this.synchronized((function(){i.key.evtOnItemLostUpdates2Level(s)}))},onRealMaxFrequency:function(t){var e=this;this.synchronized((function(){var s,i=e.key;if(null==t)s=null;else if(null==t){var n=parseFloat(t);s=isNaN(n)?null:De.RFreqLimited(n)}else"unlimited"==t?s=De.RFreqUnlimited:(n=parseFloat(t),s=isNaN(n)?null:De.RFreqLimited(n));i.evtOnRealMaxFrequency2Level(s)}))},onUnsubscription:function(){var t=this;this.synchronized((function(){t.key.evtOnUnsubscription2Level()}))},onClearSnapshot:function(t,e){},onCommandSecondLevelItemLostUpdates:function(t,e){},onCommandSecondLevelSubscriptionError:function(t,e,s){},onEndOfSnapshot:function(t,e){},onListenEnd:function(t){},onListenStart:function(t){},onSubscription:function(){},__class__:Nt};var Pt=a["com.lightstreamer.client.internal.update.CurrFieldVal"]={__ename__:!0,__constructs__:null,StringVal:(e=function(t){return{_hx_index:0,string:t,__enum__:"com.lightstreamer.client.internal.update.CurrFieldVal",toString:r}},e._hx_name="StringVal",e.__params__=["string"],e),JsonVal:(e=function(t){return{_hx_index:1,json:t,__enum__:"com.lightstreamer.client.internal.update.CurrFieldVal",toString:r}},e._hx_name="JsonVal",e.__params__=["json"],e)};Pt.__constructs__=[Pt.StringVal,Pt.JsonVal];var kt=function(){};function Mt(t,e){if(null!=t){for(var s=new as,i=(S=e).keys();i.hasNext();){var n=i.next();switch((y=S.get(n))._hx_index){case 0:s.h[n]=t.h[n];break;case 1:var r=y.val;s.h[n]=null==r?null:Pt.StringVal(r);break;case 2:var a=y.patch,o=t.h[n];if(null==o)throw new Qt("Cannot apply the JSON patch to the field "+n+" because the field is null");switch(o._hx_index){case 0:var h=o.string,l=null;try{l=He._new(h)}catch(t){var c=w.caught(t);throw ri.isErrorEnabled()&&ri.error(c.get_message()+"\n"+c.details()),new Qt("Cannot convert the field "+n+" to JSON")}try{var u=Pt.JsonVal(He.apply(Xt.sure(l),a));s.h[n]=u}catch(t){var _=w.caught(t);throw ri.isErrorEnabled()&&ri.error(_.get_message()+"\n"+_.details()),new Qt("Cannot apply the JSON Patch to the field "+n)}break;case 1:var d=o.json;try{var m=Pt.JsonVal(He.apply(d,a));s.h[n]=m}catch(t){var f=w.caught(t);throw ri.isErrorEnabled()&&ri.error(f.get_message()+"\n"+f.details()),new Qt("Cannot apply the JSON Patch to the field "+n)}}break;case 3:var g=y.patch,p=t.h[n];if(null==p)throw new Qt("Cannot apply the TLCP-diff to the field "+n+" because the field is null");switch(p._hx_index){case 0:var v=Pt.StringVal(new Ue(p.string,g).decode());s.h[n]=v;break;case 1:throw new Qt("Cannot apply the TLCP-diff to the field "+n+" because the field is JSON")}}}return s}var S;for(s=new as,i=(S=e).keys();i.hasNext();){var y;switch(n=i.next(),(y=S.get(n))._hx_index){case 0:throw new Qt("Cannot set the field "+n+" because the first update is UNCHANGED");case 1:r=y.val,s.h[n]=null==r?null:Pt.StringVal(r);break;case 2:throw new Qt("Cannot set the field "+n+" because the first update is a JSONPatch");case 3:throw new Qt("Cannot set the field "+n+" because the first update is a TLCP-diff")}}return s}function Ft(t,e){if(null!=t){for(var s=new ae,i=(r=e).keys();i.hasNext();){var n=i.next();r.get(n),kt.toString(t.h[n])!=kt.toString(e.h[n])&&s.insert(n)}return s}var r;for(s=new ae,i=(r=e).keys();i.hasNext();)n=i.next(),r.get(n),s.insert(n);return s}function qt(t,e){if(null!=t){for(var s=new as,i=e,n=i.keys();n.hasNext();){var r=n.next(),a=i.get(r);switch(a._hx_index){case 0:var o=t.h[r];if(null!=o&&null!=o&&1==o._hx_index){var h=He._new("[]");s.h[r]=h}break;case 2:s.h[r]=a.patch}}return s}return new as}function At(t){if(null!=t){for(var e=new as,s=0;s<t.length;){var i=t[s++];e.h[s-1+1]=i}return e}return null}function Wt(t,e){for(var s=1,i=m.count(t)+1;s<i;){var n=s++;if(t.h[n]==e)return n}return null}function Bt(t){var e=new as;return t.forEachField((function(t,s,i){e.h[s]=i})),e}function Ut(t){var e=new as;return t.forEachChangedField((function(t,s,i){e.h[s]=i})),e}kt.__name__="com.lightstreamer.client.internal.update.CurrFieldValTools",kt.toString=function(t){if(null==t)return null;switch(t._hx_index){case 0:return t.string;case 1:return He.toString(t.json)}};var Ht=function(t,e){this.key=t,this.value=e};Ht.__name__="com.lightstreamer.internal._AssocArray.AssocPair",Ht.prototype={__class__:Ht};var Vt={_new:function(){return jt._new()},arrayRead:function(t,e){var s=m.find(t,(function(t){return t.key==e}));return null==s?null:s.value},arrayWrite:function(t,e,s){return t.add(new Ht(e,s)),s},remove:function(t,e){jt.removeIf(t,(function(t){return t.key==e}))},keyValueIterator:function(t){return new ls(t.h)},containsValue:function(t,e){return m.exists(t,(function(t){return t.value==e}))}},Kt=function(){};Kt.__name__="com.lightstreamer.internal.IHttpClient",Kt.__isInterface__=!0,Kt.prototype={__class__:Kt};var Gt=function(t,e,s,i,n,r,a){this.isCanceled=!1,this.reader=new oe;var o=this;if(si.isDebugEnabled()&&si.debug("HTTP sending: "+t+" "+e+" headers("+(null==s?"null":cs.stringify(s.h))+")"),this.xhr=new XMLHttpRequest,this.xhr.open("POST",t),this.xhr.withCredentials=i,null!=s)for(var h=s.h,l=Object.keys(h),c=l.length,u=0;u<c;){var _=l[u++];this.xhr.setRequestHeader(_,h[_])}this.xhr.setRequestHeader("Content-Type","application/x-www-form-urlencoded"),this.xhr.send(e),this.xhr.onreadystatechange=function(){if(!o.isCanceled){var t=o.xhr.readyState;if(2==t){var e=o.xhr.status;0==e||e>=200&&e<300||(si.isDebugEnabled()&&si.debug("HTTP event: error(HTTP code "+e+")"),r(o,"Unexpected HTTP code: "+e),o.xhr.abort())}else if(t>2){for(var s=3==t?o.reader.extractNewData(o.xhr.responseText,!1):o.reader.extractNewData(o.xhr.responseText,!0),i=0;i<s.length;){var h=s[i];if(++i,o.isCanceled)return;""!=h&&(si.isDebugEnabled()&&si.debug("HTTP event: text("+h+")"),n(o,h))}4==t&&(si.isDebugEnabled()&&si.debug("HTTP event: complete"),a(o))}}},this.xhr.onerror=function(){o.isCanceled||(si.isDebugEnabled()&&si.debug("HTTP event: error(Network error)"),r(o,"Network error"))}};Gt.__name__="com.lightstreamer.internal.HttpClient",Gt.__interfaces__=[Kt],Gt.prototype={dispose:function(){si.isDebugEnabled()&&si.debug("HTTP disposing"),this.isCanceled=!0,this.xhr.abort()},isDisposed:function(){return this.isCanceled},__class__:Gt};var Yt={_new:function(){return new cs},set:function(t,e,s){null!=s&&(t.h[e]=null==s?"null":g.string(s))}},zt=function(t){var e=this;this.id=setTimeout((function(){e.run()}),t)};zt.__name__="com.lightstreamer.internal.JsTimer",zt.prototype={stop:function(){null!=this.id&&(clearTimeout(this.id),this.id=null)},run:function(){},__class__:zt};var jt={_new:function(){return new os},push:function(t,e){t.add(e)},exists:function(t,e){return m.exists(t,e)},find:function(t,e){return m.find(t,e)},contains:function(t,e){return m.has(t,e)},removeIf:function(t,e){for(var s=null,i=t.h;null!=i;){if(e(i.item))return null==s?t.h=i.next:s.next=i.next,t.q==i&&(t.q=s),t.length--,!0;s=i,i=i.next}return!1}},Qt=function(t,e,s){w.call(this,t,e,s),this.__skipStack++};Qt.__name__="com.lightstreamer.internal.IllegalStateException",Qt.__super__=w,Qt.prototype=c(w.prototype,{__class__:Qt});var Jt={fromHaxeMap:function(t){return Jt.fromMapToDynamicAccess(t)},toHaxeMap:function(t){return Jt.toHaxe(t)},fromMapToDynamicAccess:function(t){for(var e={},s=t.h,i=Object.keys(s),n=i.length,r=0;r<n;){var a=i[r++];e[a]=s[a]}return e},toHaxe:function(t){for(var e=new cs,s=f.fields(t),i=0;i<s.length;){var n=s[i++];e.h[n]=t[n]}return e},toDynamicAccess:function(t){return f.copy(t)}},Xt=function(){};Xt.__name__="com.lightstreamer.internal.NullTools",Xt.sure=function(t){if(null==t)throw w.thrown("null pointer in .sure() call");return t},Xt.or=function(t,e){return null==t?e:t};var $t=function(){};$t.__name__="com.lightstreamer.internal.IWsClient",$t.__isInterface__=!0,$t.prototype={__class__:$t};var Zt=function(){};Zt.__name__="com.lightstreamer.internal.ITimer",Zt.__isInterface__=!0,Zt.prototype={__class__:Zt};var te=a["com.lightstreamer.internal.ReachabilityStatus"]={__ename__:!0,__constructs__:null,RSReachable:{_hx_name:"RSReachable",_hx_index:0,__enum__:"com.lightstreamer.internal.ReachabilityStatus",toString:r},RSNotReachable:{_hx_name:"RSNotReachable",_hx_index:1,__enum__:"com.lightstreamer.internal.ReachabilityStatus",toString:r}};te.__constructs__=[te.RSReachable,te.RSNotReachable];var ee=function(){};ee.__name__="com.lightstreamer.internal.IReachability",ee.__isInterface__=!0,ee.prototype={__class__:ee};var se={_new:function(){return new Xe},synchronized:function(t,e){var s=null,i=null;t.acquire();try{i=e()}catch(t){s=w.caught(t)}if(t.release(),null!=s)throw w.thrown(s);return i}},ie=function(){};ie.__name__="com.lightstreamer.internal.ReachabilityManager",ie.__interfaces__=[ee],ie.prototype={startListening:function(t){b.get_supported()&&(window.ononline=function(){t(te.RSReachable)},window.onoffline=function(){t(te.RSNotReachable)})},stopListening:function(){b.get_supported()&&(window.ononline=null,window.onoffline=null)},__class__:ie};var ne=function(t,e){this.key=t,this.val=e};ne.__name__="com.lightstreamer.internal._RequestBuilder.KeyVal",ne.prototype={toEncodedPair:function(){var t=this.key,e=encodeURIComponent(t)+"=";return t=this.val,e+encodeURIComponent(t)},toString:function(){return this.key+"="+this.val},__class__:ne};var re=function(){this.params=[]};re.__name__="com.lightstreamer.internal.RequestBuilder",re.prototype={LS_reqId:function(t){this.addParamAny("LS_reqId",t)},LS_message:function(t){this.addParamString("LS_message",t)},LS_sequence:function(t){this.addParamString("LS_sequence",t)},LS_msg_prog:function(t){this.addParamAny("LS_msg_prog",t)},LS_max_wait:function(t){this.addParamAny("LS_max_wait",t)},LS_outcome:function(t){this.addParamBool("LS_outcome",t)},LS_ack:function(t){this.addParamBool("LS_ack",t)},LS_op:function(t){this.addParamString("LS_op",t)},LS_subId:function(t){this.addParamAny("LS_subId",t)},LS_mode:function(t){this.addParamString("LS_mode",t)},LS_group:function(t){this.addParamString("LS_group",t)},LS_schema:function(t){this.addParamString("LS_schema",t)},LS_data_adapter:function(t){this.addParamString("LS_data_adapter",t)},LS_requested_max_frequency:function(t){this.addParamString("LS_requested_max_frequency",t)},LS_requested_max_frequency_Float:function(t){this.addParamAny("LS_requested_max_frequency",t)},LS_requested_buffer_size:function(t){this.addParamString("LS_requested_buffer_size",t)},LS_requested_buffer_size_Int:function(t){this.addParamAny("LS_requested_buffer_size",t)},LS_cause:function(t){this.addParamString("LS_cause",t)},LS_keepalive_millis:function(t){this.addParamAny("LS_keepalive_millis",t)},LS_inactivity_millis:function(t){this.addParamAny("LS_inactivity_millis",t)},LS_requested_max_bandwidth:function(t){this.addParamString("LS_requested_max_bandwidth",t)},LS_requested_max_bandwidth_Float:function(t){this.addParamAny("LS_requested_max_bandwidth",t)},LS_adapter_set:function(t){this.addParamString("LS_adapter_set",t)},LS_user:function(t){this.addParamString("LS_user",t)},LS_password:function(t){this.addParamString("LS_password",t)},LS_cid:function(t){this.addParamString("LS_cid",t)},LS_old_session:function(t){this.addParamString("LS_old_session",t)},LS_session:function(t){this.addParamString("LS_session",t)},LS_send_sync:function(t){this.addParamBool("LS_send_sync",t)},LS_polling:function(t){this.addParamBool("LS_polling",t)},LS_polling_millis:function(t){this.addParamAny("LS_polling_millis",t)},LS_idle_millis:function(t){this.addParamAny("LS_idle_millis",t)},LS_content_length:function(t){this.addParamAny("LS_content_length",t)},LS_ttl_millis:function(t){this.addParamString("LS_ttl_millis",t)},LS_recovery_from:function(t){this.addParamAny("LS_recovery_from",t)},LS_close_socket:function(t){this.addParamBool("LS_close_socket",t)},LS_selector:function(t){this.addParamString("LS_selector",t)},LS_snapshot:function(t){this.addParamBool("LS_snapshot",t)},LS_snapshot_Int:function(t){this.addParamAny("LS_snapshot",t)},addParamString:function(t,e){this.params.push(new ne(t,e))},addParamAny:function(t,e){this.addParamString(t,""+(null==e?"null":g.string(e)))},addParamBool:function(t,e){this.addParamString(t,e?"true":"false")},getEncodedString:function(){for(var t=this.params,e=new Array(t.length),s=0,i=t.length;s<i;){var n=s++;e[n]=t[n].toEncodedPair()}return e.join("&")},toString:function(){return this.params.join(" ")},__class__:re};var ae=function(t){if(this.values=[],null!=t)for(;t.hasNext();)this.insert(t.next())};ae.__name__="com.lightstreamer.internal.Set",ae.prototype={count:function(){return this.values.length},insert:function(t){-1==this.values.indexOf(t)&&this.values.push(t)},contains:function(t){return-1!=this.values.indexOf(t)},remove:function(t){_.remove(this.values,t)},removeAll:function(){this.values.splice(0,this.values.length)},copy:function(){return new ae(this.iterator())},union:function(t){for(var e=new ae,s=0,i=this.values;s<i.length;)e.insert(i[s++]);for(s=0;s<t.length;)e.insert(t[s++]);return e},subtracting:function(t){for(var e=new ae,s=0,i=this.values;s<i.length;){var n=i[s];++s,-1==t.indexOf(n)&&e.insert(n)}return e},iterator:function(){return new ms(this.values)},toArray:function(){return this.values},__class__:ae};var oe=function(){this.progress=0};oe.__name__="com.lightstreamer.internal.StreamReader",oe.prototype={extractNewData:function(t,e){var s;if(e)s=t.length;else{if((s=t.lastIndexOf("\r\n"))<0)return[];s+=2}if(s<=this.progress)return[];var i=t.substring(this.progress,s);return this.progress=s,i.split("\r\n")},streamProgress:function(t){return this.extractNewData(t,!1)},streamComplete:function(t){return this.extractNewData(t,!0)},__class__:oe};var he=function(){};he.__name__="hx.concurrent.Service",he.__isInterface__=!0,he.prototype={__class__:he};var le=function(t){null==t&&(t=0),this.lock=new Xe,this._value=t};le.__name__="hx.concurrent.atomic._AtomicInt.AtomicIntImpl",le.prototype={get_value:function(){this.lock.acquire();var t=this._value;return this.lock.release(),t},set_value:function(t){return this.lock.acquire(),this._value=t,this.lock.release(),t},getAndIncrement:function(t){null==t&&(t=1),this.lock.acquire();var e=this._value;return this._value+=t,this.lock.release(),e},incrementAndGet:function(t){null==t&&(t=1),this.lock.acquire();var e=this._value+=t;return this.lock.release(),e},__class__:le};var ce=function(){this._stateLock=new Xe,this.state=bs.STOPPED,this.id=ce._ids.incrementAndGet()};ce.__name__="hx.concurrent.ServiceBase",ce.__interfaces__=[he],ce.prototype={set_state:function(t){return this.state=t},start:function(){var t=this;this._stateLock.execute((function(){switch(t.state._hx_index){case 0:case 1:break;case 2:throw w.thrown("Service ["+g.string(t)+"] is currently stopping!");case 3:t.set_state(bs.STARTING),t.onStart(),t.set_state(bs.RUNNING)}}))},onStart:function(){},stop:function(){var t=this;this._stateLock.execute((function(){t.state==bs.RUNNING&&(t.set_state(bs.STOPPING),t.onStop(),t.set_state(bs.STOPPED))}))},onStop:function(){},toString:function(){return Ps.getClass(this).__name__+"#"+this.id},__class__:ce};var ue=a["hx.concurrent.executor.Schedule"]={__ename__:!0,__constructs__:null,ONCE:(e=function(t){return{_hx_index:0,initialDelayMS:t,__enum__:"hx.concurrent.executor.Schedule",toString:r}},e._hx_name="ONCE",e.__params__=["initialDelayMS"],e),FIXED_DELAY:(e=function(t,e){return{_hx_index:1,intervalMS:t,initialDelayMS:e,__enum__:"hx.concurrent.executor.Schedule",toString:r}},e._hx_name="FIXED_DELAY",e.__params__=["intervalMS","initialDelayMS"],e),FIXED_RATE:(e=function(t,e){return{_hx_index:2,intervalMS:t,initialDelayMS:e,__enum__:"hx.concurrent.executor.Schedule",toString:r}},e._hx_name="FIXED_RATE",e.__params__=["intervalMS","initialDelayMS"],e),HOURLY:(e=function(t,e){return{_hx_index:3,minute:t,second:e,__enum__:"hx.concurrent.executor.Schedule",toString:r}},e._hx_name="HOURLY",e.__params__=["minute","second"],e),DAILY:(e=function(t,e,s){return{_hx_index:4,hour:t,minute:e,second:s,__enum__:"hx.concurrent.executor.Schedule",toString:r}},e._hx_name="DAILY",e.__params__=["hour","minute","second"],e),WEEKLY:(e=function(t,e,s,i){return{_hx_index:5,day:t,hour:e,minute:s,second:i,__enum__:"hx.concurrent.executor.Schedule",toString:r}},e._hx_name="WEEKLY",e.__params__=["day","hour","minute","second"],e)};ue.__constructs__=[ue.ONCE,ue.FIXED_DELAY,ue.FIXED_RATE,ue.HOURLY,ue.DAILY,ue.WEEKLY];var _e=function(){this.completionListeners=ws._new(),ce.call(this)};_e.__name__="hx.concurrent.executor.Executor",_e.create=function(t,e){return null==e&&(e=!0),new de(e)},_e.__super__=ce,_e.prototype=c(ce.prototype,{notifyResult:function(t){for(var e=this.completionListeners._items,s=0;s<e.length;){var i=e[s++];try{i(t)}catch(t){}}},onCompletion:function(t){this.completionListeners.add(t)},stop:function(){ce.prototype.stop.call(this)},__class__:_e});var de=function(t){null==t&&(t=!0),this._scheduledTasks=[],_e.call(this),t&&this.start()};function me(){return _e.create()}de.__name__="hx.concurrent.executor.TimerExecutor",de.__super__=_e,de.prototype=c(_e.prototype,{submit:function(t,e){var s=this,i=null==e?_e.NOW_ONCE:e;return this._stateLock.execute((function(){if(s.state!=bs.RUNNING)throw w.thrown("Cannot accept new tasks. Executor is not in state [RUNNING] but ["+g.string(s.state)+"].");for(var e=s._scheduledTasks.length;e-- >0;)s._scheduledTasks[e].isStopped&&s._scheduledTasks.splice(e,1);var n=new Ls(s,t,i);if(0==i._hx_index){var r=i.initialDelayMS;(null==r||0!=r)&&s._scheduledTasks.push(n)}else s._scheduledTasks.push(n);return n}))},onStop:function(){for(var t=0,e=this._scheduledTasks;t<e.length;)e[t++].cancel();this._scheduledTasks=[]},__class__:de});var fe={_new:function(t){return t},toMillis:function(t){return t},toLong:function(t){return t}},ge={_new:function(t){return t},now:function(){return _.now()/1e3},plus:function(t,e){return 1e3*t+e},minus:function(t,e){return 1e3*(t-e)},toFloat:function(t){return t}},pe=function(t,e,s){var i=this;this.task=ei.submit(Ds.a((function(){s(i)})),ue.ONCE(e))};pe.__name__="com.lightstreamer.internal.Timer",pe.__interfaces__=[Zt],pe.stamp=function(){return _.now()/1e3},pe.prototype={cancel:function(){this.task.cancel()},isCanceled:function(){return this.task.isStopped},__class__:pe};var ve=a["com.lightstreamer.internal.FieldValue"]={__ename__:!0,__constructs__:null,unchanged:{_hx_name:"unchanged",_hx_index:0,__enum__:"com.lightstreamer.internal.FieldValue",toString:r},changed:(e=function(t){return{_hx_index:1,val:t,__enum__:"com.lightstreamer.internal.FieldValue",toString:r}},e._hx_name="changed",e.__params__=["val"],e),jsonPatch:(e=function(t){return{_hx_index:2,patch:t,__enum__:"com.lightstreamer.internal.FieldValue",toString:r}},e._hx_name="jsonPatch",e.__params__=["patch"],e),diffPatch:(e=function(t){return{_hx_index:3,patch:t,__enum__:"com.lightstreamer.internal.FieldValue",toString:r}},e._hx_name="diffPatch",e.__params__=["patch"],e)};ve.__constructs__=[ve.unchanged,ve.changed,ve.jsonPatch,ve.diffPatch];var Se={_new:function(t){return t},fromIntGt0:function(t){if(t<=0)throw new T("value must be greater than zero");return t},fromIntGtEq0:function(t){if(t<0)throw new T("value must be greater than or equal to zero");return t},gti:function(t,e){return t>e},gt:function(t,e){return t>e},lt:function(t,e){return t<e},plus:function(t,e){return t+e},minus:function(t,e){return t-e},toInt:function(t){return t}},ye={_new:function(t){return t},fromIntGt0:function(t){if(t<=0)throw new T("value must be greater than zero");return t}},be={fromString:function(t){if(null==t)return null;switch(t){case"HTTP":return"HTTP";case"HTTP-POLLING":return"HTTP-POLLING";case"HTTP-STREAMING":return"HTTP-STREAMING";case"WS":return"WS";case"WS-POLLING":return"WS-POLLING";case"WS-STREAMING":return"WS-STREAMING";default:throw new T("The given value is not valid. Use one of: HTTP-STREAMING, HTTP-POLLING, WS-STREAMING, WS-POLLING, WS, HTTP or null")}}},Ee=a["com.lightstreamer.internal.RequestedMaxBandwidth"]={__ename__:!0,__constructs__:null,BWLimited:(e=function(t){return{_hx_index:0,bw:t,__enum__:"com.lightstreamer.internal.RequestedMaxBandwidth",toString:r}},e._hx_name="BWLimited",e.__params__=["bw"],e),BWUnlimited:{_hx_name:"BWUnlimited",_hx_index:1,__enum__:"com.lightstreamer.internal.RequestedMaxBandwidth",toString:r}};Ee.__constructs__=[Ee.BWLimited,Ee.BWUnlimited];var we=function(){};we.__name__="com.lightstreamer.internal.RequestedMaxBandwidthTools",we.fromString=function(t){var e;if("unlimited"==t.toLowerCase())return Ee.BWUnlimited;if(e=parseFloat(t),!isNaN(e)&&e>0)return Ee.BWLimited(e);throw new T('The given value is a not valid value for RequestedMaxBandwidth. Use a positive number or the string "unlimited"')},we.toString=function(t){switch(t._hx_index){case 0:var e=t.bw;return null==e?"null":""+e;case 1:return"unlimited"}};var Te=a["com.lightstreamer.internal.RequestedBufferSize"]={__ename__:!0,__constructs__:null,BSLimited:(e=function(t){return{_hx_index:0,size:t,__enum__:"com.lightstreamer.internal.RequestedBufferSize",toString:r}},e._hx_name="BSLimited",e.__params__=["size"],e),BSUnlimited:{_hx_name:"BSUnlimited",_hx_index:1,__enum__:"com.lightstreamer.internal.RequestedBufferSize",toString:r}};Te.__constructs__=[Te.BSLimited,Te.BSUnlimited];var xe=function(){};xe.__name__="com.lightstreamer.internal.RequestedBufferSizeTools",xe.fromString=function(t){if(null==t)return null;var e;if("unlimited"==t.toLowerCase())return Te.BSUnlimited;if(null!=(e=g.parseInt(t))&&e>0)return Te.BSLimited(e);throw new T("The given value is not valid for this setting; use null, 'unlimited' or a positive integer instead")},xe.toString=function(t){if(null==t)return null;switch(t._hx_index){case 0:var e=t.size;return null==e?"null":""+e;case 1:return"unlimited"}},xe.extEquals=function(t,e){return null==t?null==e:null!=e&&S.enumEq(t,e)};var Re=a["com.lightstreamer.internal.RequestedSnapshot"]={__ename__:!0,__constructs__:null,SnpYes:{_hx_name:"SnpYes",_hx_index:0,__enum__:"com.lightstreamer.internal.RequestedSnapshot",toString:r},SnpNo:{_hx_name:"SnpNo",_hx_index:1,__enum__:"com.lightstreamer.internal.RequestedSnapshot",toString:r},SnpLength:(e=function(t){return{_hx_index:2,len:t,__enum__:"com.lightstreamer.internal.RequestedSnapshot",toString:r}},e._hx_name="SnpLength",e.__params__=["len"],e)};Re.__constructs__=[Re.SnpYes,Re.SnpNo,Re.SnpLength];var Ie=function(){};Ie.__name__="com.lightstreamer.internal.RequestedSnapshotTools",Ie.fromString=function(t){if(null==t)return null;var e;switch(t.toLowerCase()){case"no":return Re.SnpNo;case"yes":return Re.SnpYes;default:if(null!=(e=g.parseInt(t))&&e>0)return Re.SnpLength(e);throw new T("The given value is not valid for this setting; use null, 'yes', 'no' or a positive number instead")}},Ie.toString=function(t){if(null==t)return null;switch(t._hx_index){case 0:return"yes";case 1:return"no";case 2:var e=t.len;return null==e?"null":""+e}};var Ce=a["com.lightstreamer.internal.RequestedMaxFrequency"]={__ename__:!0,__constructs__:null,FreqLimited:(e=function(t){return{_hx_index:0,max:t,__enum__:"com.lightstreamer.internal.RequestedMaxFrequency",toString:r}},e._hx_name="FreqLimited",e.__params__=["max"],e),FreqUnlimited:{_hx_name:"FreqUnlimited",_hx_index:1,__enum__:"com.lightstreamer.internal.RequestedMaxFrequency",toString:r},FreqUnfiltered:{_hx_name:"FreqUnfiltered",_hx_index:2,__enum__:"com.lightstreamer.internal.RequestedMaxFrequency",toString:r}};Ce.__constructs__=[Ce.FreqLimited,Ce.FreqUnlimited,Ce.FreqUnfiltered];var Le=function(){};Le.__name__="com.lightstreamer.internal.RequestedMaxFrequencyTools",Le.fromString=function(t){if(null==t)return null;var e;switch(t.toLowerCase()){case"unfiltered":return Ce.FreqUnfiltered;case"unlimited":return Ce.FreqUnlimited;default:if(e=parseFloat(t),!isNaN(e)&&e>0)return Ce.FreqLimited(e);throw new T("The given value is not valid for this setting; use null, 'unlimited', 'unfiltered' or a positive number instead")}},Le.toString=function(t){if(null==t)return null;switch(t._hx_index){case 0:var e=t.max;return null==e?"null":""+e;case 1:return"unlimited";case 2:return"unfiltered"}},Le.extEquals=function(t,e){return null==t?null==e:null!=e&&S.enumEq(t,e)};var De=a["com.lightstreamer.internal.RealMaxFrequency"]={__ename__:!0,__constructs__:null,RFreqLimited:(e=function(t){return{_hx_index:0,freq:t,__enum__:"com.lightstreamer.internal.RealMaxFrequency",toString:r}},e._hx_name="RFreqLimited",e.__params__=["freq"],e),RFreqUnlimited:{_hx_name:"RFreqUnlimited",_hx_index:1,__enum__:"com.lightstreamer.internal.RealMaxFrequency",toString:r}};De.__constructs__=[De.RFreqLimited,De.RFreqUnlimited];var Oe=a["com.lightstreamer.internal.RealMaxBandwidth"]={__ename__:!0,__constructs__:null,BWLimited:(e=function(t){return{_hx_index:0,bw:t,__enum__:"com.lightstreamer.internal.RealMaxBandwidth",toString:r}},e._hx_name="BWLimited",e.__params__=["bw"],e),BWUnlimited:{_hx_name:"BWUnlimited",_hx_index:1,__enum__:"com.lightstreamer.internal.RealMaxBandwidth",toString:r},BWUnmanaged:{_hx_name:"BWUnmanaged",_hx_index:2,__enum__:"com.lightstreamer.internal.RealMaxBandwidth",toString:r}};Oe.__constructs__=[Oe.BWLimited,Oe.BWUnlimited,Oe.BWUnmanaged];var Ne=function(){};Ne.__name__="com.lightstreamer.internal.RealMaxBandwidthTools",Ne.toString=function(t){if(null==t)return null;switch(t._hx_index){case 0:var e=t.bw;return null==e?"null":""+e;case 1:return"unlimited";case 2:return"unmanaged"}};var Pe={fromString:function(t){switch(t){case"COMMAND":return"COMMAND";case"DISTINCT":return"DISTINCT";case"MERGE":return"MERGE";case"RAW":return"RAW";default:throw new T("The given value is not a valid subscription mode. Admitted values are MERGE, DISTINCT, RAW, COMMAND")}}},ke={_new:function(t){return t},getPos:function(t,e){var s=t.indexOf(e);return-1!=s?s+1:-1},allValidNames:function(t){return!m.exists(t,(function(t){return new u("^$| |^\\d+$","").match(t)}))},fromArray:function(t){if(null==t)return null;if(0==t.length)throw new T("Item List is empty");if(ke.allValidNames(t))return t;throw new T("Item List is invalid")}},Me={_new:function(t){return t},getPos:function(t,e){var s=t.indexOf(e);return-1!=s?s+1:-1},hasKeyField:function(t){return-1!=t.indexOf("key")},hasCommandField:function(t){return-1!=t.indexOf("command")},fromArray:function(t){if(null==t)return null;if(0==t.length)throw new T("Field List is empty");if(m.exists(t,(function(t){return new u("^$| ","").match(t)})))throw new T("Field List is invalid");return t}},Fe={};function qe(t){if(null==t)return"null";switch(t._hx_index){case 0:return""+t.freq;case 1:return"unlimited"}}function Ae(t,e){return null==t?null==e:null!=e&&S.enumEq(t,e)}Fe._new=function(t){return t},Fe.fromString=function(t){if(null==t)return null;if(""==t)throw new T("The value is empty");return t};var We=function(t,e){var s=t.indexOf("://");-1!=s?(this._protocol=t.substring(0,s)+":",t=t.substring(s+3)):this._protocol="";var i=t.indexOf("/");-1!=i?(this._pathname=t.substring(i),t=t.substring(0,i)):this._pathname="/";var n=this.extractPortStart(t);-1!=n?(this._port=t.substring(n),this._hostname=t.substring(0,n-1)):(this._port="",this._hostname=t),null!=e&&this.set_pathname(e)};We.__name__="com.lightstreamer.internal.Url",We.build=function(t,e){if(null!=e){var s=v.endsWith(t,"/"),i=v.startsWith(e,"/");t+=s?i?e.substring(1):e:i?e:"/"+e}return t},We.completeControlLink=function(t,e){var s=new We(e),i=new We(t);return""==i.get_protocol()&&i.set_protocol(s.get_protocol()),""==i.get_port()&&i.set_port(s.get_port()),i.get_href()},We.prototype={get_protocol:function(){return this._protocol},set_protocol:function(t){return""==t||v.endsWith(t,":")||(t+=":"),this._protocol=t,this._protocol},get_hostname:function(){return this._hostname},set_hostname:function(t){return this._hostname=t,this._hostname},get_port:function(){return this._port},set_port:function(t){return this._port=t,this._port},get_pathname:function(){return this._pathname},set_pathname:function(t){return v.startsWith(t,"/")||(t="/"+t),this._pathname=t,this._pathname},get_href:function(){var t=this._hostname;return""!=this._protocol&&(t=this._protocol+"//"+t),""!=this._port&&(t+=":"+this._port),""!=this.get_pathname()&&(t+=this._pathname),t},toString:function(){return this.get_href()},extractPortStart:function(t){var e=t.indexOf(":");return e<=-1?-1:t.indexOf("]")>-1?(e=t.indexOf("]:"))<=-1?-1:e+2:e!=t.lastIndexOf(":")?-1:e+1},__class__:We};var Be=function(t,e,s,i){this.isCanceled=!1;var n=this;v.startsWith(t,"https://")?t=v.replace(t,"https://","wss://"):v.startsWith(t,"http://")&&(t=v.replace(t,"http://","ws://")),si.isDebugEnabled()&&si.debug("WS connecting: "+t),this.ws=new WebSocket(t,Ys),this.ws.onopen=function(){n.isCanceled||(si.isDebugEnabled()&&si.debug("WS event: open"),e(n))},this.ws.onmessage=function(t){if(!n.isCanceled)for(var e=0,i=t.data.split("\r\n");e<i.length;){var r=i[e];if(++e,n.isCanceled)return;""!=r&&(si.isDebugEnabled()&&si.debug("WS event: text("+r+")"),s(n,r))}},this.ws.onerror=function(){n.isCanceled||(si.isDebugEnabled()&&si.debug("WS event: error(Network error)"),i(n,"Network error"),n.ws.close())},this.ws.onclose=function(t){if(!n.isCanceled){var e="unexpected disconnection: "+t.code+" - "+t.reason;si.isDebugEnabled()&&si.debug("WS event: error("+e+")"),i(n,e),n.ws.close()}}};Be.__name__="com.lightstreamer.internal.WsClient",Be.__interfaces__=[$t],Be.prototype={send:function(t){si.isDebugEnabled()&&si.debug("WS sending: "+t),this.ws.send(t)},dispose:function(){si.isDebugEnabled()&&si.debug("WS disposing"),this.isCanceled=!0,this.ws.close()},isDisposed:function(){return this.isCanceled},__class__:Be};var Ue=function(t,e){this.buf=new p,this.basePos=0,this.diffPos=0,this.diff=e,this.base=t};Ue.__name__="com.lightstreamer.internal.patch.DiffDecoder",Ue.apply=function(t,e){return new Ue(t,e).decode()},Ue.prototype={decode:function(){try{for(;this.diffPos!=this.diff.length&&(this.applyCopy(),this.diffPos!=this.diff.length)&&(this.applyAdd(),this.diffPos!=this.diff.length);)this.applyDel();return this.buf.b}catch(t){throw new w("Bad TLCP-diff",w.caught(t))}},applyCopy:function(){var t=this.decodeVarint();t>0&&(this.appendToBuf(this.base,this.basePos,t),this.basePos+=t)},applyAdd:function(){var t=this.decodeVarint();t>0&&(this.appendToBuf(this.diff,this.diffPos,t),this.diffPos+=t)},applyDel:function(){var t=this.decodeVarint();t>0&&(this.basePos+=t)},decodeVarint:function(){for(var t=0;;){var e=this.charAt(this.diff,this.diffPos);if(this.diffPos+=1,e>=97&&e<123)return 26*t+(e-97);if(!(e>=65&&e<91))throw new w("The code point "+e+" is not in the range A-Z");t=26*t+(e-65)}},appendToBuf:function(t,e,s){if(!(e+s<=t.length))throw new w("Index out of range: startIndex="+e+" count="+s+" length="+t.length);this.buf.b+=null==s?_.substr(t,e,null):_.substr(t,e,s)},charAt:function(t,e){if(e<t.length)return _.cca(t.charAt(e),0);throw new w("Index out of range: pos="+e+" length="+t.length)},__class__:Ue};var He={_new:function(t){return JSON.parse(t)},apply:function(t,e){return Ve.apply_patch(t,e)},toString:function(t){return JSON.stringify(t)}},Ve=s.exports,Ke=function(){};Ke.__name__="com.lightstreamer.log.AbstractLogger",Ke.__interfaces__=[i],Ke.prototype={__class__:Ke};var Ge=l.LSConsoleLogLevel=function(){};Ge.__name__="LSConsoleLogLevel",Ge.prototype={__class__:Ge};var Ye=l.LSConsoleLoggerProvider=function(t){this.level=t};Ye.__name__="LSConsoleLoggerProvider",Ye.__interfaces__=[n],Ye.prototype={getLogger:function(t){return new ze(this.level,t)},__class__:Ye};var ze=function(t,e){this.level=t,this.category=e,this.traceEnabled=t<=Ge.TRACE,this.debugEnabled=t<=Ge.DEBUG,this.infoEnabled=t<=Ge.INFO,this.warnEnabled=t<=Ge.WARN,this.errorEnabled=t<=Ge.ERROR,this.fatalEnabled=t<=Ge.FATAL};ze.__name__="com.lightstreamer.log._ConsoleLoggerProvider.ConsoleLogger",ze.__super__=Ke,ze.prototype=c(Ke.prototype,{printLog:function(e){t.console.log(e)},format:function(t,e){return _.dateStr(new Date)+"|"+t+"|"+this.category+"|"+e},logFatal:function(e){t.console.log(e)},logError:function(e){t.console.log(e)},logWarn:function(e){t.console.log(e)},logInfo:function(e){t.console.log(e)},logDebug:function(e){t.console.log(e)},logTrace:function(e){t.console.log(e)},fatal:function(e,s){if(this.fatalEnabled){var i=this.format("FATAL",e);t.console.log(i),null!=s&&(i=w.caught(s).details(),t.console.log(i))}},error:function(e,s){if(this.errorEnabled){var i=this.format("ERROR",e);t.console.log(i),null!=s&&(i=w.caught(s).details(),t.console.log(i))}},warn:function(e,s){if(this.warnEnabled){var i=this.format("WARN ",e);t.console.log(i),null!=s&&(i=w.caught(s).details(),t.console.log(i))}},info:function(e,s){if(this.infoEnabled){var i=this.format("INFO ",e);t.console.log(i),null!=s&&(i=w.caught(s).details(),t.console.log(i))}},debug:function(e,s){if(this.debugEnabled){var i=this.format("DEBUG",e);t.console.log(i),null!=s&&(i=w.caught(s).details(),t.console.log(i))}},trace:function(e,s){if(this.traceEnabled){var i=this.format("TRACE",e);t.console.log(i),null!=s&&(i=w.caught(s).details(),t.console.log(i))}},isFatalEnabled:function(){return this.fatalEnabled},isErrorEnabled:function(){return this.errorEnabled},isWarnEnabled:function(){return this.warnEnabled},isInfoEnabled:function(){return this.infoEnabled},isDebugEnabled:function(){return this.debugEnabled},isTraceEnabled:function(){return this.traceEnabled},__class__:ze});var je=function(){};je.__name__="com.lightstreamer.log._LogManager.EmptyLogger",je.__super__=Ke,je.prototype=c(Ke.prototype,{fatal:function(t,e){},error:function(t,e){},warn:function(t,e){},info:function(t,e){},debug:function(t,e){},trace:function(t,e){},isFatalEnabled:function(){return!1},isErrorEnabled:function(){return!1},isWarnEnabled:function(){return!1},isInfoEnabled:function(){return!1},isDebugEnabled:function(){return!1},isTraceEnabled:function(){return!1},__class__:je});var Qe=function(){};Qe.__name__="hx.concurrent.lock.Acquirable",Qe.__isInterface__=!0,Qe.prototype={__class__:Qe};var Je=function(){};Je.__name__="hx.concurrent.lock.AbstractAcquirable",Je.__interfaces__=[Qe],Je.prototype={execute:function(t,e){null==e&&(e=!1);var s=null,i=null;this.acquire();try{i=t()}catch(t){s=new gs(w.caught(t))}if(this.release(),!e&&null!=s)throw w.thrown(s.toString());return i},__class__:Je};var Xe=function(){this._holderEntranceCount=0,this._holder=null};Xe.__name__="hx.concurrent.lock.RLock",Xe.__super__=Je,Xe.prototype=c(Je.prototype,{get_availablePermits:function(){return null!=this._holder?0:1},get_isAcquiredByAnyThread:function(){return null!=this._holder},get_isAcquiredByCurrentThread:function(){return this._holder==Ns.get_current()},get_isAcquiredByOtherThread:function(){return null!=this._holder&&this._holder!=Ns.get_current()},acquire:function(){this._holder=Ns.get_current(),this._holderEntranceCount++},tryAcquire:function(t){if(null==t&&(t=0),t<0)throw w.thrown("[timeoutMS] must be >= 0");return(null==this._holder||this._holder==Ns.get_current())&&(this._holder=Ns.get_current(),this._holderEntranceCount++,!0)},tryAcquireInternal:function(t){return null==this._holder||this._holder==Ns.get_current()},release:function(){if(this._holder!=Ns.get_current())throw null!=this._holder&&this._holder!=Ns.get_current()?w.thrown("Lock was aquired by another thread!"):w.thrown("Lock was not aquired by any thread!");this._holderEntranceCount--,0==this._holderEntranceCount&&(this._holder=null)},__class__:Xe});var $e=function(){};$e.__name__="com.lightstreamer.log.LogManager",$e.getLogger=function(t){return se.synchronized($e.lock,(function(){var e=$e.logInstances.h[t];if(null==e){var s=new Ze(null==$e.currentLoggerProvider?$e.emptyLogger:$e.currentLoggerProvider.getLogger(t));$e.logInstances.h[t]=s,e=s}return e}))},$e.setLoggerProvider=function(t){se.synchronized($e.lock,(function(){$e.currentLoggerProvider=t;for(var e=$e.logInstances.h,s=Object.keys(e),i=s.length,n=0;n<i;){var r=s[n++];e[r].wrappedLogger=null==$e.currentLoggerProvider?$e.emptyLogger:$e.currentLoggerProvider.getLogger(r)}}))},$e.newLogger=function(t){return null==$e.currentLoggerProvider?$e.emptyLogger:$e.currentLoggerProvider.getLogger(t)};var Ze=function(t){this.wrappedLogger=t};Ze.__name__="com.lightstreamer.log._LogManager.LoggerProxy",Ze.__super__=Ke,Ze.prototype=c(Ke.prototype,{fatal:function(t,e){this.wrappedLogger.fatal(t,e)},error:function(t,e){this.wrappedLogger.error(t,e)},warn:function(t,e){this.wrappedLogger.warn(t,e)},info:function(t,e){this.wrappedLogger.info(t,e)},debug:function(t,e){this.wrappedLogger.debug(t,e)},trace:function(t,e){this.wrappedLogger.trace(t,e)},isFatalEnabled:function(){return this.wrappedLogger.isFatalEnabled()},isErrorEnabled:function(){return this.wrappedLogger.isErrorEnabled()},isWarnEnabled:function(){return this.wrappedLogger.isWarnEnabled()},isInfoEnabled:function(){return this.wrappedLogger.isInfoEnabled()},isDebugEnabled:function(){return this.wrappedLogger.isDebugEnabled()},isTraceEnabled:function(){return this.wrappedLogger.isTraceEnabled()},__class__:Ze});var ts=a["haxe.StackItem"]={__ename__:!0,__constructs__:null,CFunction:{_hx_name:"CFunction",_hx_index:0,__enum__:"haxe.StackItem",toString:r},Module:(e=function(t){return{_hx_index:1,m:t,__enum__:"haxe.StackItem",toString:r}},e._hx_name="Module",e.__params__=["m"],e),FilePos:(e=function(t,e,s,i){return{_hx_index:2,s:t,file:e,line:s,column:i,__enum__:"haxe.StackItem",toString:r}},e._hx_name="FilePos",e.__params__=["s","file","line","column"],e),Method:(e=function(t,e){return{_hx_index:3,classname:t,method:e,__enum__:"haxe.StackItem",toString:r}},e._hx_name="Method",e.__params__=["classname","method"],e),LocalFunction:(e=function(t){return{_hx_index:4,v:t,__enum__:"haxe.StackItem",toString:r}},e._hx_name="LocalFunction",e.__params__=["v"],e)};ts.__constructs__=[ts.CFunction,ts.Module,ts.FilePos,ts.Method,ts.LocalFunction];var es={callStack:function(){return is.toHaxe(is.callStack())},exceptionStack:function(t){null==t&&(t=!1);var e=is.toHaxe(is.exceptionStack());return t?e:es.subtract(e,es.callStack())},toString:function(t){for(var e=new p,s=0,i=t;s<i.length;){var n=i[s++];e.b+="\nCalled from ",es.itemToString(e,n)}return e.b},subtract:function(t,e){for(var s=-1,i=-1;++i<t.length;){for(var n=0,r=e.length;n<r;)if(es.equalItems(t[i],e[n++])){if(s<0&&(s=i),++i>=t.length)break}else s=-1;if(s>=0)break}return s>=0?t.slice(0,s):t},equalItems:function(t,e){if(null==t)return null==e;switch(t._hx_index){case 0:return null!=e&&0==e._hx_index;case 1:return null!=e&&1==e._hx_index&&t.m==e.m;case 2:return null!=e&&2==e._hx_index&&t.file==e.file&&t.line==e.line&&t.column==e.column&&es.equalItems(t.s,e.s);case 3:return null!=e&&3==e._hx_index&&t.classname==e.classname&&t.method==e.method;case 4:return null!=e&&4==e._hx_index&&t.v==e.v}},itemToString:function(t,e){switch(e._hx_index){case 0:t.b+="a C function";break;case 1:var s=e.m;t.b=(t.b+="module ")+(null==s?"null":""+s);break;case 2:s=e.s;var i=e.file,n=e.line,r=e.column;null!=s&&(es.itemToString(t,s),t.b+=" ("),t.b=(t.b+=null==i?"null":""+i)+" line ",t.b+=null==n?"null":""+n,null!=r&&(t.b=(t.b+=" column ")+(null==r?"null":""+r)),null!=s&&(t.b+=")");break;case 3:s=e.classname,i=e.method,t.b=(t.b+=g.string(null==s?"<unknown>":s))+".",t.b+=null==i?"null":""+i;break;case 4:s=e.v,t.b=(t.b+="local function #")+(null==s?"null":""+s)}}},ss=function(){};ss.__name__="haxe.IMap",ss.__isInterface__=!0,ss.prototype={__class__:ss};var is=function(){};is.__name__="haxe.NativeStackTrace",is.saveStack=function(t){is.lastError=t},is.callStack=function(){var t=new Error(""),e=is.tryHaxeStack(t);if(void 0===e){try{throw t}catch(t){}e=t.stack}return is.normalize(e,2)},is.exceptionStack=function(){return is.normalize(is.tryHaxeStack(is.lastError))},is.toHaxe=function(t,e){if(null==e&&(e=0),null==t)return[];if("string"==typeof t){var s=t.split("\n");"Error"==s[0]&&s.shift();for(var i=[],n=0,r=s.length;n<r;){var a=n++;if(!(e>a)){var o=s[a],h=o.match(/^    at ([$A-Za-z0-9_. ]+) \(([^)]+):([0-9]+):([0-9]+)\)$/);if(null!=h){var l=h[1].split(".");"$hxClasses"==l[0]&&l.shift();var c=l.pop(),u=h[2],_=g.parseInt(h[3]),d=g.parseInt(h[4]);i.push(ts.FilePos("Anonymous function"==c?ts.LocalFunction():"Global code"==c?null:ts.Method(l.join("."),c),u,_,d))}else i.push(ts.Module(v.trim(o)))}}return i}return e>0&&Array.isArray(t)?t.slice(e):t},is.tryHaxeStack=function(t){if(null==t)return[];var e=Error.prepareStackTrace;Error.prepareStackTrace=is.prepareHxStackTrace;var s=t.stack;return Error.prepareStackTrace=e,s},is.prepareHxStackTrace=function(t,e){for(var s=[],i=0;i<e.length;){var n=e[i];++i,null!=is.wrapCallSite&&(n=is.wrapCallSite(n));var r=null,a=n.getFunctionName();if(null!=a){var o=a.lastIndexOf(".");r=o>=0?ts.Method(a.substring(0,o),a.substring(o+1)):ts.Method(null,a)}var h=n.getFileName(),l=null==h?-1:h.indexOf("file:");null!=is.wrapCallSite&&l>0&&(h=h.substring(l+6)),s.push(ts.FilePos(r,h,n.getLineNumber(),n.getColumnNumber()))}return s},is.normalize=function(t,e){if(null==e&&(e=0),Array.isArray(t)&&e>0)return t.slice(e);if("string"==typeof t){switch(t.substring(0,6)){case"Error\n":case"Error:":++e}return is.skipLines(t,e)}return t},is.skipLines=function(t,e,s){for(null==s&&(s=0);;){if(!(e>0))return t.substring(s);if((s=t.indexOf("\n",s))<0)return"";e=--e,s+=1}};var ns=function(t){var e=this;this.id=setInterval((function(){e.run()}),t)};ns.__name__="haxe.Timer",ns.delay=function(t,e){var s=new zt(e);return s.run=t,s},ns.prototype={stop:function(){null!=this.id&&(clearInterval(this.id),this.id=null)},run:function(){},__class__:ns};var rs=function(t,e,s){w.call(this,String(t),e,s),this.value=t,this.__skipStack++};rs.__name__="haxe.ValueException",rs.__super__=w,rs.prototype=c(w.prototype,{__class__:rs});var as=function(){this.h={}};as.__name__="haxe.ds.IntMap",as.__interfaces__=[ss],as.prototype={get:function(t){return this.h[t]},remove:function(t){return!!this.h.hasOwnProperty(t)&&(delete this.h[t],!0)},keys:function(){var t=[];for(var e in this.h)this.h.hasOwnProperty(e)&&t.push(+e);return new ms(t)},iterator:function(){return{ref:this.h,it:this.keys(),hasNext:function(){return this.it.hasNext()},next:function(){var t=this.it.next();return this.ref[t]}}},copy:function(){for(var t=new as,e=this.keys();e.hasNext();){var s=e.next();t.h[s]=this.h[s]}return t},__class__:as};var os=function(){this.length=0};os.__name__="haxe.ds.List",os.prototype={add:function(t){var e=new hs(t,null);null==this.h?this.h=e:this.q.next=e,this.q=e,this.length++},remove:function(t){for(var e=null,s=this.h;null!=s;){if(s.item==t)return null==e?this.h=s.next:e.next=s.next,this.q==s&&(this.q=e),this.length--,!0;e=s,s=s.next}return!1},iterator:function(){return new ls(this.h)},filter:function(t){for(var e=new os,s=this.h;null!=s;){var i=s.item;s=s.next,t(i)&&e.add(i)}return e},__class__:os};var hs=function(t,e){this.item=t,this.next=e};hs.__name__="haxe.ds._List.ListNode",hs.prototype={__class__:hs};var ls=function(t){this.head=t};ls.__name__="haxe.ds._List.ListIterator",ls.prototype={hasNext:function(){return null!=this.head},next:function(){var t=this.head.item;return this.head=this.head.next,t},__class__:ls};var cs=function(){this.h=Object.create(null)};cs.__name__="haxe.ds.StringMap",cs.__interfaces__=[ss],cs.createCopy=function(t){var e=new cs;for(var s in t)e.h[s]=t[s];return e},cs.stringify=function(t){var e="{",s=!0;for(var i in t)s?s=!1:e+=",",e+=i+" => "+g.string(t[i]);return e+"}"},cs.prototype={get:function(t){return this.h[t]},keys:function(){return new us(this.h)},iterator:function(){return new _s(this.h)},__class__:cs};var us=function(t){this.h=t,this.keys=Object.keys(t),this.length=this.keys.length,this.current=0};us.__name__="haxe.ds._StringMap.StringMapKeyIterator",us.prototype={hasNext:function(){return this.current<this.length},next:function(){return this.keys[this.current++]},__class__:us};var _s=function(t){this.h=t,this.keys=Object.keys(t),this.length=this.keys.length,this.current=0};_s.__name__="haxe.ds._StringMap.StringMapValueIterator",_s.prototype={hasNext:function(){return this.current<this.length},next:function(){return this.h[this.keys[this.current++]]},__class__:_s};var ds=a["haxe.io.Error"]={__ename__:!0,__constructs__:null,Blocked:{_hx_name:"Blocked",_hx_index:0,__enum__:"haxe.io.Error",toString:r},Overflow:{_hx_name:"Overflow",_hx_index:1,__enum__:"haxe.io.Error",toString:r},OutsideBounds:{_hx_name:"OutsideBounds",_hx_index:2,__enum__:"haxe.io.Error",toString:r},Custom:(e=function(t){return{_hx_index:3,e:t,__enum__:"haxe.io.Error",toString:r}},e._hx_name="Custom",e.__params__=["e"],e)};ds.__constructs__=[ds.Blocked,ds.Overflow,ds.OutsideBounds,ds.Custom];var ms=function(t){this.current=0,this.array=t};ms.__name__="haxe.iterators.ArrayIterator",ms.prototype={hasNext:function(){return this.current<this.array.length},next:function(){return this.array[this.current++]},__class__:ms};var fs=function(t,e,s){w.call(this,t,s),this.pos=e,this.__skipStack++};fs.__name__="haxe.macro.Error",fs.__super__=w,fs.prototype=c(w.prototype,{__class__:fs});var gs=function(t){this.cause=t,this.causeStackTrace=es.exceptionStack()};gs.__name__="hx.concurrent.ConcurrentException",gs.capture=function(t){return new gs(t)},gs.prototype={rethrow:function(){throw w.thrown(this.toString())},toString:function(){var t="";t="rethrown exception:\n",t="rethrown exception:\n  ",t+="--------------------\n",t+="  ",t+="| Exception : ",t+=g.string(this.cause),t+="\n";for(var e=0,s=es.toString(this.causeStackTrace).split("\n");e<s.length;){var i=s[e];++e,""!=i&&(t+="  ",t+=g.string(v.replace(i,"Called from","| at")),t+="\n")}return t+="  ",t+="--------------------"},__class__:gs};var ps=function(){};ps.__name__="hx.concurrent.Future",ps.__isInterface__=!0,ps.prototype={__class__:ps};var vs=a["hx.concurrent.FutureResult"]={__ename__:!0,__constructs__:null,VALUE:(e=function(t,e,s){return{_hx_index:0,result:t,time:e,future:s,__enum__:"hx.concurrent.FutureResult",toString:r}},e._hx_name="VALUE",e.__params__=["result","time","future"],e),FAILURE:(e=function(t,e,s){return{_hx_index:1,ex:t,time:e,future:s,__enum__:"hx.concurrent.FutureResult",toString:r}},e._hx_name="FAILURE",e.__params__=["ex","time","future"],e),PENDING:(e=function(t){return{_hx_index:2,future:t,__enum__:"hx.concurrent.FutureResult",toString:r}},e._hx_name="PENDING",e.__params__=["future"],e)};vs.__constructs__=[vs.VALUE,vs.FAILURE,vs.PENDING];var Ss=function(){this.sync=new Xe,this.completionListeners=[],this.result=vs.PENDING(this)};Ss.__name__="hx.concurrent.AbstractFuture",Ss.__interfaces__=[ps],Ss.prototype={isComplete:function(){return 2!=this.result._hx_index},onCompletion:function(t){var e=this;this.sync.execute((function(){return 2!=e.result._hx_index&&t(e.result),e.completionListeners.push(t)}))},__class__:Ss};var ys=function(){Ss.call(this)};ys.__name__="hx.concurrent.CompletableFuture",ys.__super__=Ss,ys.prototype=c(Ss.prototype,{complete:function(t,e){null==e&&(e=!1);var s=this;return this.sync.execute((function(){if(e||!s.isComplete()){switch((i=t)._hx_index){case 0:s.result=vs.VALUE(i.v,Date.now(),s);break;case 1:s.result=vs.FAILURE(i.v,Date.now(),s)}for(var i=0,n=s.completionListeners;i<n.length;){var r=n[i++];try{r(s.result)}catch(t){}}return!0}return!1}))},__class__:ys});var bs=a["hx.concurrent.ServiceState"]={__ename__:!0,__constructs__:null,STARTING:{_hx_name:"STARTING",_hx_index:0,__enum__:"hx.concurrent.ServiceState",toString:r},RUNNING:{_hx_name:"RUNNING",_hx_index:1,__enum__:"hx.concurrent.ServiceState",toString:r},STOPPING:{_hx_name:"STOPPING",_hx_index:2,__enum__:"hx.concurrent.ServiceState",toString:r},STOPPED:{_hx_name:"STOPPED",_hx_index:3,__enum__:"hx.concurrent.ServiceState",toString:r}};bs.__constructs__=[bs.STARTING,bs.RUNNING,bs.STOPPING,bs.STOPPED];var Es=function(){};Es.__name__="hx.concurrent.collection.Collection",Es.__isInterface__=!0,Es.prototype={__class__:Es};var ws={_new:function(t){var e=new xs;return null!=t&&e.addAll(t),e},_get:function(t,e){return t.get(e)},_set:function(t,e,s){return t._set(e,s),s}},Ts=function(){};Ts.__name__="hx.concurrent.collection.OrderedCollection",Ts.__isInterface__=!0,Ts.__interfaces__=[Es],Ts.prototype={__class__:Ts};var xs=function(){this._sync=new Xe,this._items=[]};xs.__name__="hx.concurrent.collection._CopyOnWriteArray.CopyOnWriteArrayImpl",xs.__interfaces__=[Ts],xs.prototype={_set:function(t,e){var s=this;this._sync.execute((function(){var i=s._items.slice();i[t]=e,s._items=i}))},get_first:function(){var t=this._items;return 0==t.length?null:t[0]},get_last:function(){var t=this._items;return 0==t.length?null:t[t.length-1]},get_length:function(){return this._items.length},add:function(t){var e=this;this._sync.execute((function(){var s=e._items.slice();s.push(t),e._items=s}))},addIfAbsent:function(t){var e=this;return this._sync.execute((function(){if(e._items.indexOf(t)>-1)return!1;var s=e._items.slice();return s.push(t),e._items=s,!0}))},addAll:function(t){var e=this;this._sync.execute((function(){var s=null,i=t;switch(i._hx_index){case 0:s=e._items.slice();for(var n=i.v.iterator();n.hasNext();)s.push(n.next());break;case 1:s=e._items.concat(i.v);break;case 2:s=e._items.slice();for(var r=i.v.h;null!=r;){var a=r.item;r=r.next,s.push(a)}}e._items=s}))},clear:function(){this._items=[]},insertAt:function(t,e){var s=this;this._items=this._sync.execute((function(){var i=s._items.slice();return i.splice(t,0,e),i}))},remove:function(t){var e=this;return this._sync.execute((function(){if(-1==e._items.indexOf(t))return!1;var s=e._items.slice(),i=_.remove(s,t);return e._items=s,i}))},removeAt:function(t,e){null==e&&(e=!1);var s=this;return this._sync.execute((function(){if(t<0||t>=s._items.length){if(e)throw w.thrown("Index out of range.");return null}var i=s._items.slice(),n=i.splice(t,1);return s._items=i,0==n.length?null:n[0]}))},removeFirst:function(t){null==t&&(t=!1);var e=this;return this._sync.execute((function(){if(0==e._items.length){if(t)throw w.thrown("This collection is empty.");return null}var s=e._items.slice(),i=s.shift();return e._items=s,i}))},removeLast:function(t){null==t&&(t=!1);var e=this;return this._sync.execute((function(){if(0==e._items.length){if(t)throw w.thrown("This collection is empty.");return null}var s=e._items.slice(),i=s.pop();return e._items=s,i}))},copy:function(){return ws._new(Os.b(this._items.slice()))},contains:function(t){return this._items.indexOf(t,0)>-1},isEmpty:function(){return 0==this._items.length},get:function(t,e){null==e&&(e=!1);var s=this._items;if(t<0||t>=s.length){if(e)throw w.thrown("Index out of range.");return null}return s[t]},indexOf:function(t,e){return null==e&&(e=0),this._items.indexOf(t,e)},lastIndexOf:function(t,e){var s=this._items;return s.lastIndexOf(t,null==e?s.length-1:e)},filter:function(t){for(var e=this._items,s=[],i=0;i<e.length;){var n=e[i];++i,t(n)&&s.push(n)}return ws._new(Os.b(s))},map:function(t){for(var e=this._items,s=new Array(e.length),i=0,n=e.length;i<n;){var r=i++;s[r]=t(e[r])}return ws._new(Os.b(s))},join:function(t){return this._items.join(t)},iterator:function(){return new ms(this._items)},toArray:function(){return this._items.slice()},toString:function(){return"["+this._items.toString()+"]"},__class__:xs};var Rs=function(){};Rs.__name__="hx.concurrent.executor.TaskFuture",Rs.__isInterface__=!0,Rs.__interfaces__=[ps],Rs.prototype={__class__:Rs};var Is=function(t,e,s){this.isStopped=!1,ys.call(this),this._executor=t,this._task=e,this.schedule=Cs.assertValid(s)};Is.__name__="hx.concurrent.executor.AbstractTaskFuture",Is.__interfaces__=[Rs],Is.__super__=ys,Is.prototype=c(ys.prototype,{cancel:function(){this.isStopped=!0},__class__:Is});var Cs=function(){};Cs.__name__="hx.concurrent.executor.ScheduleTools",Cs.applyDefaults=function(t){switch(t._hx_index){case 0:if(null==t.initialDelayMS)return ue.ONCE(0);break;case 1:if(null==t.initialDelayMS)return ue.FIXED_DELAY(t.intervalMS,0);break;case 2:if(null==t.initialDelayMS)return ue.FIXED_RATE(t.intervalMS,0);break;case 3:var e=t.minute,s=t.second;if(null==e||null==s)return ue.HOURLY(null==e?0:e,null==s?0:s);break;case 4:e=t.hour,s=t.minute;var i=t.second;if(null==e||null==s||null==i)return ue.DAILY(null==e?0:e,null==s?0:s,null==i?0:i);break;case 5:e=t.day,s=t.hour,i=t.minute;var n=t.second;if(null==e||null==s||null==i||null==n)return ue.WEEKLY(null==e?0:e,null==s?0:s,null==i?0:i,null==n?0:n)}return t},Cs.assertValid=function(t){switch((t=Cs.applyDefaults(t))._hx_index){case 0:if(t.initialDelayMS<0)throw w.thrown("[Schedule.ONCE.initialDelayMS] must be >= 0");break;case 1:var e=t.initialDelayMS;if(t.intervalMS<=0)throw w.thrown("[Schedule.FIXED_DELAY.intervalMS] must be > 0");if(null==e||e<0)throw w.thrown("[Schedule.FIXED_DELAY.initialDelayMS] must be >= 0");break;case 2:if(t.intervalMS<=0)throw w.thrown("[Schedule.FIXED_RATE.intervalMS] must be > 0");if(t.initialDelayMS<0)throw w.thrown("[Schedule.FIXED_RATE.initialDelayMS] must be >= 0");break;case 3:e=t.minute;var s=t.second;if(null==e||e<0)throw w.thrown("[Schedule.DAILY.minute] must be between >= 0 and <= 59");if(null==s||s<0)throw w.thrown("[Schedule.DAILY.second] must be between >= 0 and <= 59");break;case 4:e=t.hour,s=t.minute;var i=t.second;if(null==e||e<0)throw w.thrown("[Schedule.DAILY.hour] must be between >= 0 and <= 23");if(null==s||s<0)throw w.thrown("[Schedule.DAILY.minute] must be between >= 0 and <= 59");if(null==i||i<0)throw w.thrown("[Schedule.DAILY.second] must be between >= 0 and <= 59");break;case 5:if(e=t.hour,s=t.minute,i=t.second,null==e||e<0)throw w.thrown("[Schedule.WEEKLY.hour] must be between >= 0 and <= 23");if(null==s||s<0)throw w.thrown("[Schedule.WEEKLY.minute] must be between >= 0 and <= 59");if(null==i||i<0)throw w.thrown("[Schedule.WEEKLY.second] must be between >= 0 and <= 59")}return t},Cs.firstRunAt=function(t){switch((t=Cs.assertValid(t))._hx_index){case 0:case 1:case 2:return Date.now()+t.initialDelayMS;case 3:var e=Date.now(),s=new Date(e),i=60*t.minute+t.second,n=60*s.getMinutes()+s.getSeconds();return e+1e3*(i-n)+(n>i?36e5:0);case 4:return e=Date.now(),s=new Date(e),e+1e3*((r=60*t.hour*60+60*t.minute+t.second)-(a=60*s.getHours()*60+60*s.getMinutes()+s.getSeconds()))+(a>r?864e5:0);case 5:e=Date.now(),s=new Date(e);var r=60*t.hour*60+60*t.minute+t.second,a=60*s.getHours()*60+60*s.getMinutes()+s.getSeconds(),o=t.day;return o==s.getDay()?e+1e3*(r-a)+(a>r?6048e5:0):s.getDate()<o?e+1e3*(r-a)+864e5*(o-s.getDate()):e+1e3*(r-a)+864e5*(7-(o-s.getDate()))}};var Ls=function(t,e,s){Is.call(this,t,e,s);var i=Cs.firstRunAt(this.schedule)-Date.now()|0;i<0&&(i=0),ns.delay(Fs(this,this.run),i)};Ls.__name__="hx.concurrent.executor._TimerExecutor.TaskFutureImpl",Ls.__super__=Is,Ls.prototype=c(Is.prototype,{run:function(){if(!this.isStopped){if(null==this._timer){var t=null;switch((s=this.schedule)._hx_index){case 2:(t=new ns(s.intervalMS)).run=Fs(this,this.run);break;case 3:(t=new ns(36e5)).run=Fs(this,this.run);break;case 4:(t=new ns(864e5)).run=Fs(this,this.run);break;case 5:(t=new ns(6048e5)).run=Fs(this,this.run)}this._timer=t}var e;try{var s;switch((s=this._task)._hx_index){case 0:e=Ds.a(s.v());break;case 1:s.v(),e=null}}catch(s){e=Ds.b(new gs(w.caught(s)))}switch((s=this.schedule)._hx_index){case 0:this.isStopped=!0;break;case 1:this._timer=ns.delay(Fs(this,this.run),s.intervalMS)}this.complete(e,!0),this._executor.notifyResult(this.result)}},cancel:function(){var t=this._timer;null!=t&&t.stop(),Is.prototype.cancel.call(this)},__class__:Ls});var Ds=a["hx.concurrent.internal._Either2._Either2"]={__ename__:!0,__constructs__:null,a:(e=function(t){return{_hx_index:0,v:t,__enum__:"hx.concurrent.internal._Either2._Either2",toString:r}},e._hx_name="a",e.__params__=["v"],e),b:(e=function(t){return{_hx_index:1,v:t,__enum__:"hx.concurrent.internal._Either2._Either2",toString:r}},e._hx_name="b",e.__params__=["v"],e)};Ds.__constructs__=[Ds.a,Ds.b];var Os=a["hx.concurrent.internal._Either3._Either3"]={__ename__:!0,__constructs__:null,a:(e=function(t){return{_hx_index:0,v:t,__enum__:"hx.concurrent.internal._Either3._Either3",toString:r}},e._hx_name="a",e.__params__=["v"],e),b:(e=function(t){return{_hx_index:1,v:t,__enum__:"hx.concurrent.internal._Either3._Either3",toString:r}},e._hx_name="b",e.__params__=["v"],e),c:(e=function(t){return{_hx_index:2,v:t,__enum__:"hx.concurrent.internal._Either3._Either3",toString:r}},e._hx_name="c",e.__params__=["v"],e)};Os.__constructs__=[Os.a,Os.b,Os.c];var Ns=function(){};Ns.__name__="hx.concurrent.thread.Threads",Ns.get_current=function(){return"MainThread"},Ns.get_isSupported=function(){return!1};var Ps=function(){};function ks(t){return t instanceof Array?function(){return _.keyValueIter(t)}:"function"==typeof t.keyValueIterator?Fs(t,t.keyValueIterator):t.keyValueIterator}function Ms(t){return t instanceof Array?new ms(t):t.iterator()}function Fs(e,s){return null==s?null:(null==s.__id__&&(s.__id__=t.$haxeUID++),null==e.hx__closures__?e.hx__closures__={}:i=e.hx__closures__[s.__id__],null==i&&(i=s.bind(e),e.hx__closures__[s.__id__]=i),i);var i}Ps.__name__="js.Boot",Ps.getClass=function(t){if(null==t)return null;if(t instanceof Array)return Array;var e=t.__class__;if(null!=e)return e;var s=Ps.__nativeClassName(t);return null!=s?Ps.__resolveNativeClass(s):null},Ps.__string_rec=function(t,e){if(null==t)return"null";if(e.length>=5)return"<...>";var s=typeof t;switch("function"==s&&(t.__name__||t.__ename__)&&(s="object"),s){case"function":return"<function>";case"object":if(t.__enum__){var i=a[t.__enum__].__constructs__[t._hx_index],n=i._hx_name;return i.__params__?(e+="\t",n+"("+function(s){for(var n=[],r=0,a=i.__params__;r<a.length;){var o=a[r];r+=1,n.push(Ps.__string_rec(t[o],e))}return n}().join(",")+")"):n}if(t instanceof Array){var r="[";e+="\t";for(var o=0,h=t.length;o<h;){var l=o++;r+=(l>0?",":"")+Ps.__string_rec(t[l],e)}return r+="]"}var c;try{c=t.toString}catch(o){return is.lastError=o,"???"}if(null!=c&&c!=Object.toString&&"function"==typeof c){var u=t.toString();if("[object Object]"!=u)return u}r="{\n",e+="\t";var _=null!=t.hasOwnProperty,d=null;for(d in t)_&&!t.hasOwnProperty(d)||"prototype"!=d&&"__class__"!=d&&"__super__"!=d&&"__interfaces__"!=d&&"__properties__"!=d&&(2!=r.length&&(r+=", \n"),r+=e+d+" : "+Ps.__string_rec(t[d],e));return r+="\n"+(e=e.substring(1))+"}";case"string":return t;default:return String(t)}},Ps.__interfLoop=function(t,e){for(;;){if(null==t)return!1;if(t==e)return!0;var s=t.__interfaces__;if(null!=s)for(var i=0,n=s.length;i<n;){var r=s[i++];if(r==e||Ps.__interfLoop(r,e))return!0}t=t.__super__}},Ps.__instanceof=function(t,e){if(null==e)return!1;switch(e){case Array:return t instanceof Array;case Bs:return"boolean"==typeof t;case As:return null!=t;case Ws:return"number"==typeof t;case qs:return"number"==typeof t&&(0|t)===t;case String:return"string"==typeof t;default:if(null==t)return!1;if("function"==typeof e){if(Ps.__downcastCheck(t,e))return!0}else if("object"==typeof e&&Ps.__isNativeObj(e)&&t instanceof e)return!0;return e==Us&&null!=t.__name__||e==Hs&&null!=t.__ename__||null!=t.__enum__&&a[t.__enum__]==e}},Ps.__downcastCheck=function(t,e){return t instanceof e||!!e.__isInterface__&&Ps.__interfLoop(Ps.getClass(t),e)},Ps.__cast=function(t,e){if(null==t||Ps.__instanceof(t,e))return t;throw w.thrown("Cannot cast "+g.string(t)+" to "+g.string(e))},Ps.__nativeClassName=function(t){var e=Ps.__toStr.call(t).slice(8,-1);return"Object"==e||"Function"==e||"Math"==e||"JSON"==e?null:e},Ps.__isNativeObj=function(t){return null!=Ps.__nativeClassName(t)},Ps.__resolveNativeClass=function(e){return t[e]},t.$haxeUID|=0,"undefined"!=typeof performance&&"function"==typeof performance.now&&(_.now=performance.now.bind(performance)),null==String.fromCodePoint&&(String.fromCodePoint=function(t){return t<65536?String.fromCharCode(t):String.fromCharCode(55232+(t>>10))+String.fromCharCode(56320+(1023&t))}),Object.defineProperty(String.prototype,"__class__",{value:String,enumerable:!1}),String.__name__="String",Array.__name__="Array",Date.prototype.__class__=Date,Date.__name__="Date";var qs={},As={},Ws=Number,Bs=Boolean,Us={},Hs={};Ps.__toStr={}.toString;var Vs,Ks=!b.get_supported()||"http:"!=(null!=(Vs=t.location)?Vs.protocol:null)&&"https:"!=(null!=(Vs=t.location)?Vs.protocol:null)?null:E.fromString(t.location.protocol+"//"+t.location.hostname+(""!=t.location.port?":"+t.location.port:"")+"/"),Gs="TLCP-2.4.0",Ys=Gs+".lightstreamer.com",zs="9.0.0-beta.6 build 20230622",js="pcYgxn8m8 feOojyA1V661f4gpAeLD3dXoqoH6M992l87p",Qs="javascript_client",Js="";C.LIB_NAME=Qs,C.LIB_VERSION=zs,dt.EOL_LEN=dt.lengthOfBytes("\r\n");var Xs="The Subscription was initiated using a Field Schema: the field names are not available",$s="The field position is out of bounds",Zs="The field name is unknown";ce._ids=new le(0),_e.NOW_ONCE=ue.ONCE(0);var ti=me(),ei=me();Se.ZERO=0,be.WS="WS",be.WS_STREAMING="WS-STREAMING",be.WS_POLLING="WS-POLLING",be.HTTP="HTTP",be.HTTP_STREAMING="HTTP-STREAMING",be.HTTP_POLLING="HTTP-POLLING",Pe.Merge="MERGE",Pe.Distinct="DISTINCT",Pe.Command="COMMAND",Pe.Raw="RAW",Ue.VARINT_RADIX=26,Ge.TRACE=0,Ge.DEBUG=10,Ge.INFO=20,Ge.WARN=30,Ge.ERROR=40,Ge.FATAL=50,Xe.isSupported=!1,$e.lock=new Xe,$e.logInstances=new cs,$e.emptyLogger=new je;var si=$e.getLogger("lightstreamer.stream"),ii=$e.getLogger("lightstreamer.protocol"),ni=$e.getLogger("lightstreamer.internal"),ri=$e.getLogger("lightstreamer.session"),ai=$e.getLogger("lightstreamer.actions"),oi=$e.getLogger("lightstreamer.reachability"),hi=$e.getLogger("lightstreamer.subscriptions"),li=$e.getLogger("lightstreamer.messages");$e.getLogger("lightstreamer.cookies"),gs.INDENT="  ",Cs.HOUR_IN_MS=36e5,Cs.DAY_IN_MS=864e5,Cs.WEEK_IN_MS=6048e5}("undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:void 0);var c=l.LSLightstreamerClient,u=l.LSSubscription,_=l.LSConsoleLogLevel,d=l.LSConsoleLoggerProvider,m=function(t){this.delegate=t};m.prototype={setContentLength:function(t){this.delegate.setContentLength(t)},getContentLength:function(){return this.delegate.getContentLength()},setIdleTimeout:function(t){this.delegate.setIdleTimeout(t)},getIdleTimeout:function(){return this.delegate.getIdleTimeout()},setKeepaliveInterval:function(t){this.delegate.setKeepaliveInterval(t)},getKeepaliveInterval:function(){return this.delegate.getKeepaliveInterval()},setRequestedMaxBandwidth:function(t){this.delegate.setRequestedMaxBandwidth(t)},getRequestedMaxBandwidth:function(){return this.delegate.getRequestedMaxBandwidth()},getRealMaxBandwidth:function(){return this.delegate.getRealMaxBandwidth()},setPollingInterval:function(t){this.delegate.setPollingInterval(t)},getPollingInterval:function(){return this.delegate.getPollingInterval()},setReconnectTimeout:function(t){this.delegate.setReconnectTimeout(t)},getReconnectTimeout:function(){return this.delegate.getReconnectTimeout()},setStalledTimeout:function(t){this.delegate.setStalledTimeout(t)},getStalledTimeout:function(){return this.delegate.getStalledTimeout()},setRetryDelay:function(t){this.delegate.setRetryDelay(t)},getRetryDelay:function(){return this.delegate.getRetryDelay()},setFirstRetryMaxDelay:function(t){this.delegate.setFirstRetryMaxDelay(t)},getFirstRetryMaxDelay:function(){return this.delegate.getFirstRetryMaxDelay()},setSlowingEnabled:function(t){this.delegate.setSlowingEnabled(t)},isSlowingEnabled:function(){return this.delegate.isSlowingEnabled()},setForcedTransport:function(t){this.delegate.setForcedTransport(t)},getForcedTransport:function(){return this.delegate.getForcedTransport()},setServerInstanceAddressIgnored:function(t){this.delegate.setServerInstanceAddressIgnored(t)},isServerInstanceAddressIgnored:function(){return this.delegate.isServerInstanceAddressIgnored()},setCookieHandlingRequired:function(t){this.delegate.setCookieHandlingRequired(t)},isCookieHandlingRequired:function(){return this.delegate.isCookieHandlingRequired()},setReverseHeartbeatInterval:function(t){this.delegate.setReverseHeartbeatInterval(t)},getReverseHeartbeatInterval:function(){return this.delegate.getReverseHeartbeatInterval()},setHttpExtraHeaders:function(t){this.delegate.setHttpExtraHeaders(t)},getHttpExtraHeaders:function(){return this.delegate.getHttpExtraHeaders()},setHttpExtraHeadersOnSessionCreationOnly:function(t){this.delegate.setHttpExtraHeadersOnSessionCreationOnly(t)},isHttpExtraHeadersOnSessionCreationOnly:function(){return this.delegate.isHttpExtraHeadersOnSessionCreationOnly()},setSessionRecoveryTimeout:function(t){this.delegate.setSessionRecoveryTimeout(t)},getSessionRecoveryTimeout:function(){return this.delegate.getSessionRecoveryTimeout()}};var f=function(t){this.delegate=t};f.prototype={setServerAddress:function(t){this.delegate.setServerAddress(t)},getServerAddress:function(){return this.delegate.getServerAddress()},setAdapterSet:function(t){this.delegate.setAdapterSet(t)},getAdapterSet:function(){return this.delegate.getAdapterSet()},setUser:function(t){this.delegate.setUser(t)},getUser:function(){return this.delegate.getUser()},setPassword:function(t){this.delegate.setPassword(t)},getServerInstanceAddress:function(){return this.delegate.getServerInstanceAddress()},getServerSocketName:function(){return this.delegate.getServerSocketName()},getSessionId:function(){return this.delegate.getSessionId()},getClientIp:function(){return this.delegate.getClientIp()}};var g=function(t,e){this.delegate=new c(t,e),this.connectionOptions=new m(this.delegate.connectionOptions),this.connectionDetails=new f(this.delegate.connectionDetails)};g.setLoggerProvider=function(t){c.setLoggerProvider(t)},g.LIB_NAME=c.LIB_NAME,g.LIB_VERSION=c.LIB_VERSION,g.prototype={connect:function(){this.delegate.connect()},disconnect:function(){this.delegate.disconnect()},getStatus:function(){return this.delegate.getStatus()},sendMessage:function(t,e,s,i,n){this.delegate.sendMessage(t,e,s,i,n)},getSubscriptions:function(){return this.delegate.getSubscriptionWrappers()},subscribe:function(t){this.delegate.subscribe(t.delegate)},unsubscribe:function(t){this.delegate.unsubscribe(t.delegate)},addListener:function(t){this.delegate.addListener(t)},removeListener:function(t){this.delegate.removeListener(t)},getListeners:function(){return this.delegate.getListeners()}};var p=function(t,e,s){this.delegate=new u(t,e,s,this)};p.prototype={isActive:function(){return this.delegate.isActive()},isSubscribed:function(){return this.delegate.isSubscribed()},setItems:function(t){this.delegate.setItems(t)},getItems:function(){return this.delegate.getItems()},setItemGroup:function(t){this.delegate.setItemGroup(t)},getItemGroup:function(){return this.delegate.getItemGroup()},setFields:function(t){this.delegate.setFields(t)},getFields:function(){return this.delegate.getFields()},setFieldSchema:function(t){this.delegate.setFieldSchema(t)},getFieldSchema:function(){return this.delegate.getFieldSchema()},getMode:function(){return this.delegate.getMode()},setDataAdapter:function(t){this.delegate.setDataAdapter(t)},getDataAdapter:function(){return this.delegate.getDataAdapter()},setSelector:function(t){this.delegate.setSelector(t)},getSelector:function(){return this.delegate.getSelector()},setRequestedMaxFrequency:function(t){this.delegate.setRequestedMaxFrequency(t)},getRequestedMaxFrequency:function(){return this.delegate.getRequestedMaxFrequency()},setRequestedBufferSize:function(t){this.delegate.setRequestedBufferSize(t)},getRequestedBufferSize:function(){return this.delegate.getRequestedBufferSize()},setRequestedSnapshot:function(t){this.delegate.setRequestedSnapshot(t)},getRequestedSnapshot:function(){return this.delegate.getRequestedSnapshot()},setCommandSecondLevelFields:function(t){this.delegate.setCommandSecondLevelFields(t)},getCommandSecondLevelFields:function(){return this.delegate.getCommandSecondLevelFields()},setCommandSecondLevelFieldSchema:function(t){this.delegate.setCommandSecondLevelFieldSchema(t)},getCommandSecondLevelFieldSchema:function(){return this.delegate.getCommandSecondLevelFieldSchema()},setCommandSecondLevelDataAdapter:function(t){this.delegate.setCommandSecondLevelDataAdapter(t)},getCommandSecondLevelDataAdapter:function(){return this.delegate.getCommandSecondLevelDataAdapter()},getValue:function(t,e){return this.delegate.getValue(t,e)},getCommandValue:function(t,e,s){return this.delegate.getCommandValue(t,e,s)},getKeyPosition:function(){return this.delegate.getKeyPosition()},getCommandPosition:function(){return this.delegate.getCommandPosition()},addListener:function(t){this.delegate.addListener(t)},removeListener:function(t){this.delegate.removeListener(t)},getListeners:function(){return this.delegate.getListeners()}};var v=function(){};v.TRACE=_.TRACE,v.DEBUG=_.DEBUG,v.INFO=_.INFO,v.WARN=_.WARN,v.ERROR=_.ERROR,v.FATAL=_.FATAL;var S=function(t){this.delegate=new d(t)};return S.prototype.getLogger=function(t){return this.delegate.getLogger(t)},t.ClientListener=r,t.ClientMessageListener=a,t.ConsoleLogLevel=v,t.ConsoleLoggerProvider=S,t.ItemUpdate=o,t.LightstreamerClient=g,t.Logger=i,t.LoggerProvider=n,t.Subscription=p,t.SubscriptionListener=h,Object.defineProperty(t,"__esModule",{value:!0}),t}({}),s);if("function"==typeof define&&define.amd)define("lightstreamer",["module"],(function(t){var e=t.config().ns?t.config().ns+"/":"";define(e+"LightstreamerClient",(function(){return i.LightstreamerClient})),define(e+"Subscription",(function(){return i.Subscription})),define(e+"ConsoleLogLevel",(function(){return i.ConsoleLogLevel})),define(e+"ConsoleLoggerProvider",(function(){return i.ConsoleLoggerProvider})),define(e+"Logger",(function(){return i.Logger})),define(e+"LoggerProvider",(function(){return i.LoggerProvider})),define(e+"ClientListener",(function(){return i.ClientListener})),define(e+"ClientMessageListener",(function(){return i.ClientMessageListener})),define(e+"ItemUpdate",(function(){return i.ItemUpdate})),define(e+"SubscriptionListener",(function(){return i.SubscriptionListener}))})),require(["lightstreamer"]);else{var n=function(t,e){if(!t)return e;for(var s=t.split("."),i=e||window,n=0;n<s.length;n++){var r=s[n],a=i[r];a&&"object"==typeof a||(a=i[r]={}),i=a}return i}(function(){if("undefined"==typeof window||void 0===window.document)return null;for(var t=window.document.getElementsByTagName("script"),e=0,s=t.length;e<s;e++)if("data-lightstreamer-ns"in t[e].attributes)return t[e].attributes["data-lightstreamer-ns"].value;return null}(),t);n.LightstreamerClient=i.LightstreamerClient,n.Subscription=i.Subscription,n.ConsoleLogLevel=i.ConsoleLogLevel,n.ConsoleLoggerProvider=i.ConsoleLoggerProvider,n.Logger=i.Logger,n.LoggerProvider=i.LoggerProvider,n.ClientListener=i.ClientListener,n.ClientMessageListener=i.ClientMessageListener,n.ItemUpdate=i.ItemUpdate,n.SubscriptionListener=i.SubscriptionListener}}("undefined"!=typeof self?self:this);
//# sourceMappingURL=lightstreamer-core.min.js.map
