/**
 * @preserve
 * LIGHTSTREAMER - www.lightstreamer.com
 * Lightstreamer Web Client
 * Version 9.0.0-beta.6+20230622
 * Copyright (c) Lightstreamer Srl. All Rights Reserved.
 * Contains: LightstreamerClient, Subscription, ConsoleLogLevel,
 * ConsoleLoggerProvider, MpnDevice, MpnSubscription, SafariMpnBuilder,
 * FirebaseMpnBuilder, Logger, LoggerProvider, ClientListener,
 * ClientMessageListener, ItemUpdate, SubscriptionListener, MpnDeviceListener,
 * MpnSubscriptionListener
 * UMD
 */
!function(t,e){var s,i=(s=function(t){"use strict";"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self&&self;var e,s={exports:{}};
/* @preserve
	 * JSONPatch.js
	 *
	 * A Dharmafly project written by Thomas Parslow
	 * <tom@almostobsolete.net> and released with the kind permission of
	 * NetDev.
	 *
	 * Copyright 2011-2013 Thomas Parslow. All rights reserved.
	 * Permission is hereby granted,y free of charge, to any person obtaining a copy
	 * of this software and associated documentation files (the "Software"), to
	 * deal in the Software without restriction, including without limitation the
	 * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
	 * sell copies of the Software, and to permit persons to whom the Software is
	 * furnished to do so, subject to the following conditions:
	 *
	 * The above copyright notice and this permission notice shall be included in
	 * all copies or substantial portions of the Software.
	 *
	 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
	 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
	 * IN THE SOFTWARE.
	 *
	 * Implements the JSON Patch IETF RFC 6902 as specified at:
	 *
	 *   http://tools.ietf.org/html/rfc6902
	 *
	 * Also implements the JSON Pointer IETF RFC 6901 as specified at:
	 *
	 *   http://tools.ietf.org/html/rfc6901
	 *
	 */
e=s,function(t,s){s(e.exports)}(0,(function(t){var e,s,i,n;function r(t){Error.call(this,t),this.message=t}function a(t){Error.call(this,t),this.message=t}function o(t){var e,s;if(n(t))return t.slice();if(null===t)return t;if("object"==typeof t){for(s in e={},t)Object.hasOwnProperty.call(t,s)&&(e[s]=t[s]);return e}return t}function h(t,e){var s;if(t===e)return!0;if(typeof t!=typeof e)return!1;if("object"==typeof t){var i=n(t);if(i!==n(e))return!1;if(i){if(t.length!=e.length)return!1;for(var r=0;r<t.length;r++)if(!h(t[r],e[r]))return!1;return!0}for(s in t)if(Object.hasOwnProperty(t,s)&&(!Object.hasOwnProperty(e,s)||!h(t[s],e[s])))return!1;for(s in e)if(Object.hasOwnProperty(e,s)&&!Object.hasOwnProperty(t,s))return!1;return!0}return!1}function c(t){var e,s;if(!t.op)throw new r("Operation missing!");if(!i.hasOwnProperty(t.op))throw new r("Invalid operation!");if(!("path"in t))throw new r("Path missing!");for(s=i[t.op],e=0;e<s.length;e++)if(!(s[e]in t))throw new r(t.op+" must have key "+s[e])}function u(t,e){c(t);var i=t.op,n=new s(t.path),o=t.value,u=t.from?new s(t.from):null;switch(i){case"add":return function(t){return n.add(t,o,e)};case"remove":return function(t){return n.remove(t,e)};case"replace":return function(t){return n.replace(t,o,e)};case"move":if(n.subsetOf(u))throw new r("destination must not be a child of source");return function(t){var s=u.get(t),i=u.remove(t,e);return n.add(i,s,e)};case"copy":return function(t){var s=u.get(t);return n.add(t,s,e)};case"test":return function(t){if(!h(n.get(t),o))throw new a("Test operation failed. Value did not match.");return t}}}n=Array.isArray||function(t){return"[object Array]"==Object.prototype.toString.call(t)},t.apply_patch=function(t,s){return new e(s).apply(t)},t.InvalidPatch=r,r.prototype=new Error,t.PatchApplyError=a,a.prototype=new Error,t.JSONPointer=s=function(t){var e,s,i=[];if(""!==(s=t.split("/"))[0])throw new r("JSONPointer must start with a slash (or be an empty string)!");for(e=1;e<s.length;e++)i[e-1]=s[e].replace(/~1/g,"/").replace(/~0/g,"~");this.path=i,this.length=i.length},s.prototype._get_segment=function(t,e){var s=this.path[t];if(n(e))if("-"===s)s=e.length;else{if(!s.match(/^0$|^[1-9][0-9]*$/))throw new a("Expected a number to segment an array");s=parseInt(s,10)}return s},s.prototype._action=function(t,e,s){var i=this;function r(t,h){var c,u;if(s||(t=o(t)),c=i._get_segment(h,t),h==i.path.length-1)t=e(t,c);else{if(n(t)){if(t.length<=c)throw new a("Path not found in document")}else{if("object"!=typeof t)throw new a("Path not found in document");if(!Object.hasOwnProperty.call(t,c))throw new a("Path not found in document")}u=r(t[c],h+1),s||(t[c]=u)}return t}return r(t,0)},s.prototype.add=function(t,e,s){return 0===this.length?e:this._action(t,(function(t,s){if(n(t)){if(s>t.length)throw new a("Add operation must not attempt to create a sparse array!");t.splice(s,0,e)}else t[s]=e;return t}),s)},s.prototype.remove=function(t,e){if(0!==this.length)return this._action(t,(function(t,e){if(!Object.hasOwnProperty.call(t,e))throw new a("Remove operation must point to an existing value!");return n(t)?t.splice(e,1):delete t[e],t}),e)},s.prototype.replace=function(t,e,s){return 0===this.length?e:this._action(t,(function(t,s){if(!Object.hasOwnProperty.call(t,s))throw new a("Replace operation must point to an existing value!");return n(t)?t.splice(s,1,e):t[s]=e,t}),s)},s.prototype.get=function(t){var e;return 0===this.length?t:(this._action(t,(function(t,s){if(!Object.hasOwnProperty.call(t,s))throw new a("Path not found in document");return e=t[s],t}),!0),e)},s.prototype.subsetOf=function(t){if(this.length<=t.length)return!1;for(var e=0;e<t.length;e++)if(t.path[e]!==this.path[e])return!1;return!0},i={add:["value"],replace:["value"],test:["value"],remove:[],move:["from"],copy:["from"]},t.JSONPatch=e=function(t,e){this._compile(t,e)},e.prototype._compile=function(t,e){var s,i=this;if(this.compiledOps=[],"string"==typeof t&&(t=JSON.parse(t)),!n(t))throw new r("Patch must be an array of operations");for(s=0;s<t.length;s++){var a=u(t[s],e);i.compiledOps.push(a)}},t.JSONPatch.prototype.apply=function(t){var e;for(e=0;e<this.compiledOps.length;e++)t=this.compiledOps[e](t);return t}}));var i=function(){};i.prototype={fatal:function(t,e){},isFatalEnabled:function(){},error:function(t,e){},isErrorEnabled:function(){},warn:function(t,e){},isWarnEnabled:function(){},info:function(t,e){},isInfoEnabled:function(){},debug:function(t,e){},isDebugEnabled:function(){},trace:function(t,e){},isTraceEnabled:function(){}};var n=function(){};function r(){}function a(){}n.prototype={getLogger:function(t){}},r.prototype={onServerError:function(t,e){},onStatusChange:function(t){},onPropertyChange:function(t){},onListenStart:function(){},onListenEnd:function(){},onServerKeepalive:function(){}},a.prototype={onAbort:function(t,e){},onError:function(t){},onDiscarded:function(t){},onDeny:function(t,e,s){},onProcessed:function(t){}};var o=function(){};o.prototype={getItemName:function(){},getItemPos:function(){},getValue:function(t){},getValueAsJSONPatchIfAvailable:function(t){return null},isValueChanged:function(t){},isSnapshot:function(){},forEachChangedField:function(t){},forEachField:function(t){}};var h=function(){};h.prototype={onItemUpdate:function(t){},onItemLostUpdates:function(t,e,s){},onCommandSecondLevelItemLostUpdates:function(t,e){},onEndOfSnapshot:function(t,e){},onClearSnapshot:function(t,e){},onSubscription:function(){},onUnsubscription:function(){},onSubscriptionError:function(t,e){},onCommandSecondLevelSubscriptionError:function(t,e,s){},onListenStart:function(){},onListenEnd:function(){},onRealMaxFrequency:function(t){}};var c=function(){};c.prototype={onListenStart:function(){},onListenEnd:function(){},onRegistered:function(){},onSuspended:function(){},onResumed:function(){},onStatusChanged:function(t,e){},onRegistrationFailed:function(t,e){},onSubscriptionsUpdated:function(){}};var u=function(){};u.prototype={onListenStart:function(){},onListenEnd:function(){},onSubscription:function(){},onUnsubscription:function(){},onSubscriptionError:function(t,e){},onUnsubscriptionError:function(t,e){},onTriggered:function(){},onStatusChanged:function(t,e){},onPropertyChanged:function(t){},onModificationError:function(t,e,s){}};var l={};!function(t){var e,r=function(){return ni.__string_rec(this,"")},a=a||{};function c(t,e){var s=Object.create(t);for(var i in e)s[i]=e[i];return e.toString!==Object.prototype.toString&&(s.toString=e.toString),s}var u=function(t,e){this.r=new RegExp(t,e.split("u").join(""))};u.__name__="EReg",u.prototype={match:function(t){return this.r.global&&(this.r.lastIndex=0),this.r.m=this.r.exec(t),this.r.s=t,null!=this.r.m},__class__:u};var _=function(){};_.__name__="HxOverrides",_.dateStr=function(t){var e=t.getMonth()+1,s=t.getDate(),i=t.getHours(),n=t.getMinutes(),r=t.getSeconds();return t.getFullYear()+"-"+(e<10?"0"+e:""+e)+"-"+(s<10?"0"+s:""+s)+" "+(i<10?"0"+i:""+i)+":"+(n<10?"0"+n:""+n)+":"+(r<10?"0"+r:""+r)},_.cca=function(t,e){var s=t.charCodeAt(e);if(s==s)return s},_.substr=function(t,e,s){if(null==s)s=t.length;else if(s<0){if(0!=e)return"";s=t.length+s}return t.substr(e,s)},_.remove=function(t,e){var s=t.indexOf(e);return-1!=s&&(t.splice(s,1),!0)},_.now=function(){return Date.now()};var d=function(t,e){this.min=t,this.max=e};d.__name__="IntIterator",d.prototype={hasNext:function(){return this.min<this.max},next:function(){return this.min++},__class__:d};var m=function(){};m.__name__="Lambda",m.has=function(t,e){for(var s=ai(t);s.hasNext();)if(s.next()==e)return!0;return!1},m.exists=function(t,e){for(var s=ai(t);s.hasNext();)if(e(s.next()))return!0;return!1},m.count=function(t,e){var s=0;if(null==e)for(var i=ai(t);i.hasNext();)i.next(),++s;else for(var n=ai(t);n.hasNext();)e(n.next())&&++s;return s},m.empty=function(t){return!ai(t).hasNext()},m.find=function(t,e){for(var s=ai(t);s.hasNext();){var i=s.next();if(e(i))return i}return null},Math.__name__="Math";var f=function(){};f.__name__="Reflect",f.field=function(t,e){try{return t[e]}catch(t){return Cs.lastError=t,null}},f.fields=function(t){var e=[];if(null!=t){var s=Object.prototype.hasOwnProperty;for(var i in t)"__id__"!=i&&"hx__closures__"!=i&&s.call(t,i)&&e.push(i)}return e},f.deleteField=function(t,e){return!!Object.prototype.hasOwnProperty.call(t,e)&&(delete t[e],!0)},f.copy=function(t){if(null==t)return null;for(var e={},s=0,i=f.fields(t);s<i.length;){var n=i[s];++s,e[n]=f.field(t,n)}return e};var p=function(){};p.__name__="Std",p.string=function(t){return ni.__string_rec(t,"")},p.parseInt=function(t){var e=parseInt(t);return isNaN(e)?null:e},p.random=function(t){return t<=0?0:Math.floor(Math.random()*t)};var g=function(){this.b=""};g.__name__="StringBuf",g.prototype={__class__:g};var v=function(){};v.__name__="StringTools",v.startsWith=function(t,e){return t.length>=e.length&&0==t.lastIndexOf(e,0)},v.endsWith=function(t,e){var s=e.length,i=t.length;return i>=s&&t.indexOf(e,i-s)==i-s},v.isSpace=function(t,e){var s=_.cca(t,e);return s>8&&s<14||32==s},v.ltrim=function(t){for(var e=t.length,s=0;s<e&&v.isSpace(t,s);)++s;return s>0?_.substr(t,s,e-s):t},v.rtrim=function(t){for(var e=t.length,s=0;s<e&&v.isSpace(t,e-s-1);)++s;return s>0?_.substr(t,0,e-s):t},v.trim=function(t){return v.ltrim(v.rtrim(t))},v.replace=function(t,e,s){return t.split(e).join(s)};var S=function(){};S.__name__="Type",S.enumEq=function(t,e){if(t==e)return!0;try{var s=t.__enum__;if(null==s||s!=e.__enum__)return!1;if(t._hx_index!=e._hx_index)return!1;for(var i=a[s].__constructs__[t._hx_index].__params__,n=0;n<i.length;){var r=i[n];if(++n,!S.enumEq(t[r],e[r]))return!1}}catch(n){return Cs.lastError=n,!1}return!0};var b=l.LSConnectionDetails=function(t){this.serverAddress=fi,this.client=t,this.lock=t.lock};b.__name__="LSConnectionDetails",b.prototype={getServerAddress:function(){return this.serverAddress},setServerAddress:function(t){var e=y.fromString(t);Pi.isInfoEnabled()&&Pi.info("serverAddress changed: "+e);var s=this.serverAddress;this.serverAddress=e,this.client.eventDispatcher.onPropertyChange("serverAddress"),s!=e&&this.client.machine.evtServerAddressChanged()},getAdapterSet:function(){return this.adapterSet},setAdapterSet:function(t){Pi.isInfoEnabled()&&Pi.info("adapterSet changed: "+t),this.adapterSet=t,this.client.eventDispatcher.onPropertyChange("adapterSet")},getUser:function(){return this.user},setUser:function(t){Pi.isInfoEnabled()&&Pi.info("user changed: "+t),this.user=t,this.client.eventDispatcher.onPropertyChange("user")},setPassword:function(t){Pi.isInfoEnabled()&&Pi.info("password changed"),this.password=t,this.client.eventDispatcher.onPropertyChange("password")},getSessionId:function(){return this.sessionId},setSessionId:function(t){this.sessionId=t,this.client.eventDispatcher.onPropertyChange("sessionId")},getServerInstanceAddress:function(){return this.serverInstanceAddress},setServerInstanceAddress:function(t){this.serverInstanceAddress=t,this.client.eventDispatcher.onPropertyChange("serverInstanceAddress")},getServerSocketName:function(){return this.serverSocketName},setServerSocketName:function(t){this.serverSocketName=t,this.client.eventDispatcher.onPropertyChange("serverSocketName")},getClientIp:function(){return this.clientIp},setClientIp:function(t){this.clientIp=t,this.client.eventDispatcher.onPropertyChange("clientIp")},toString:function(){var t=ge._new();return ge.set(t,"serverAddress",this.serverAddress),ge.set(t,"adapterSet",this.adapterSet),ge.set(t,"user",this.user),ge.set(t,"sessionId",this.sessionId),ge.set(t,"serverInstanceAddress",this.serverInstanceAddress),ge.set(t,"serverSocketName",this.serverSocketName),ge.set(t,"clientIp",this.clientIp),ge.set(t,"libVersion",C.LIB_NAME+" "+C.LIB_VERSION),ks.stringify(t.h)},__class__:b};var E=function(){};E.__name__="js.Browser",E.get_supported=function(){return"undefined"!=typeof window&&void 0!==window.location&&"string"==typeof window.location.protocol},E.getLocalStorage=function(){try{var t=window.localStorage;if(t.getItem(""),0==t.length){var e="_hx_"+Math.random();t.setItem(e,e),t.removeItem(e)}return t}catch(t){return Cs.lastError=t,null}};var y={_new:function(t){return t},fromString:function(t){if(null==t)return null;if(v.startsWith(t,"http://")||v.startsWith(t,"https://"))return t;throw new R("address is malformed")}},w=function(t,e,s){Error.call(this,t),this.message=t,this.__previousException=e,this.__nativeException=null!=s?s:this,this.__skipStack=0;var i=Error.prepareStackTrace;if(Error.prepareStackTrace=function(t){return t.stack},s instanceof Error)this.stack=s.stack;else{var n=null;if(Error.captureStackTrace)Error.captureStackTrace(this,w),n=this;else if(void 0===(n=new Error).stack){try{throw n}catch(t){}this.__skipStack++}this.stack=n.stack}Error.prepareStackTrace=i};w.__name__="haxe.Exception",w.caught=function(t){return t instanceof w?t:t instanceof Error?new w(t.message,null,t):new Ls(t,null,t)},w.thrown=function(t){if(t instanceof w)return t.get_native();if(t instanceof Error)return t;var e=new Ls(t);return e.__skipStack++,e},w.__super__=Error,w.prototype=c(Error.prototype,{toString:function(){return this.get_message()},details:function(){if(null==this.get_previous()){var t="Exception: "+this.toString(),e=this.get_stack();return t+(null==e?"null":Is.toString(e))}for(var s="",i=this,n=null;null!=i;){if(null==n)s="Exception: "+i.get_message()+(null==(t=i.get_stack())?"null":Is.toString(t))+s;else{var r=Is.subtract(i.get_stack(),n.get_stack());s="Exception: "+i.get_message()+(null==r?"null":Is.toString(r))+"\n\nNext "+s}n=i,i=i.get_previous()}return s},__shiftStack:function(){this.__skipStack++},get_message:function(){return this.message},get_previous:function(){return this.__previousException},get_native:function(){return this.__nativeException},get_stack:function(){var t=this.__exceptionStack;if(null==t){var e=Cs.toHaxe(Cs.normalize(this.stack),this.__skipStack);return this.setProperty("__exceptionStack",e),e}return t},setProperty:function(t,e){try{Object.defineProperty(this,t,{value:e})}catch(s){this[t]=e}},__class__:w});var R=function(t,e,s){w.call(this,t,e,s),this.__skipStack++};R.__name__="com.lightstreamer.internal.IllegalArgumentException",R.__super__=w,R.prototype=c(w.prototype,{__class__:R});var T=l.LSConnectionOptions=function(t){this.cookieHandlingRequired=!1,this.slowingEnabled=!1,this.serverInstanceAddressIgnored=!1,this.httpExtraHeadersOnSessionCreationOnly=!1,this.stalledTimeout=2e3,this.sessionRecoveryTimeout=15e3,this.reverseHeartbeatInterval=0,this.retryDelay=4e3,this.reconnectTimeout=3e3,this.pollingInterval=0,this.realMaxBandwidth=null,this.requestedMaxBandwidth=Ye.BWUnlimited,this.keepaliveInterval=0,this.idleTimeout=19e3,this.httpExtraHeaders=null,this.forcedTransport=null,this.firstRetryMaxDelay=100,this.contentLength=5e7,this.client=t,this.lock=t.lock};T.__name__="LSConnectionOptions",T.prototype={getContentLength:function(){return this.contentLength},setContentLength:function(t){var e=Ge.fromIntGt0(t);Pi.isInfoEnabled()&&Pi.info("contentLength changed: "+e),this.contentLength=e,this.client.eventDispatcher.onPropertyChange("contentLength")},getFirstRetryMaxDelay:function(){return this.firstRetryMaxDelay},setFirstRetryMaxDelay:function(t){var e=Ke.fromIntGt0(t);Pi.isInfoEnabled()&&Pi.info("firstRetryMaxDelay changed: "+e),this.firstRetryMaxDelay=e,this.client.eventDispatcher.onPropertyChange("firstRetryMaxDelay")},getForcedTransport:function(){return this.forcedTransport},setForcedTransport:function(t){var e=ze.fromString(t);Pi.isInfoEnabled()&&Pi.info("forcedTransport changed: "+e),this.forcedTransport=e,this.client.eventDispatcher.onPropertyChange("forcedTransport"),this.client.machine.evtExtSetForcedTransport()},getHttpExtraHeaders:function(){return null==this.httpExtraHeaders?null:Ee.fromMapToDynamicAccess(this.httpExtraHeaders)},setHttpExtraHeaders:function(t){Pi.isInfoEnabled()&&Pi.info("httpExtraHeaders changed: "+p.string(t)),this.httpExtraHeaders=null==t?null:Ee.toHaxe(t),this.client.eventDispatcher.onPropertyChange("httpExtraHeaders")},getIdleTimeout:function(){return this.idleTimeout},setIdleTimeout:function(t){var e=Ke.fromIntGtEq0(t);Pi.isInfoEnabled()&&Pi.info("idleTimeout changed: "+e),this.idleTimeout=e,this.client.eventDispatcher.onPropertyChange("idleTimeout")},getKeepaliveInterval:function(){return this.keepaliveInterval},setKeepaliveInterval:function(t){var e=Ke.fromIntGtEq0(t);Pi.isInfoEnabled()&&Pi.info("keepaliveInterval changed: "+e),this.keepaliveInterval=e,this.client.eventDispatcher.onPropertyChange("keepaliveInterval")},getRequestedMaxBandwidth:function(){return Qe.toString(this.requestedMaxBandwidth)},setRequestedMaxBandwidth:function(t){null!=t&&(t=null==t?"null":""+t);var e=Qe.fromString(t);Pi.isInfoEnabled()&&Pi.info("requestedMaxBandwidth changed: "+Qe.toString(e)),this.requestedMaxBandwidth=e,this.client.eventDispatcher.onPropertyChange("requestedMaxBandwidth"),this.client.machine.evtExtSetRequestedMaxBandwidth()},getRealMaxBandwidth:function(){return is.toString(this.realMaxBandwidth)},setRealMaxBandwidth:function(t){this.realMaxBandwidth=t,this.client.eventDispatcher.onPropertyChange("realMaxBandwidth")},getPollingInterval:function(){return this.pollingInterval},setPollingInterval:function(t){var e=Ke.fromIntGtEq0(t);Pi.isInfoEnabled()&&Pi.info("pollingInterval changed: "+e),this.pollingInterval=e,this.client.eventDispatcher.onPropertyChange("pollingInterval")},getReconnectTimeout:function(){return this.reconnectTimeout},setReconnectTimeout:function(t){var e=Ke.fromIntGt0(t);Pi.isInfoEnabled()&&Pi.info("reconnectTimeout changed: "+e),this.reconnectTimeout=e,this.client.eventDispatcher.onPropertyChange("reconnectTimeout")},getRetryDelay:function(){return this.retryDelay},setRetryDelay:function(t){var e=Ke.fromIntGt0(t);Pi.isInfoEnabled()&&Pi.info("retryDelay changed: "+e),this.retryDelay=e,this.client.eventDispatcher.onPropertyChange("retryDelay")},getReverseHeartbeatInterval:function(){return this.reverseHeartbeatInterval},setReverseHeartbeatInterval:function(t){var e=Ke.fromIntGtEq0(t);Pi.isInfoEnabled()&&Pi.info("reverseHeartbeatInterval changed: "+e),this.reverseHeartbeatInterval=e,this.client.eventDispatcher.onPropertyChange("reverseHeartbeatInterval"),this.client.machine.evtExtSetReverseHeartbeatInterval()},getSessionRecoveryTimeout:function(){return this.sessionRecoveryTimeout},setSessionRecoveryTimeout:function(t){var e=Ke.fromIntGtEq0(t);Pi.isInfoEnabled()&&Pi.info("sessionRecoveryTimeout changed: "+e),this.sessionRecoveryTimeout=e,this.client.eventDispatcher.onPropertyChange("sessionRecoveryTimeout")},getStalledTimeout:function(){return this.stalledTimeout},setStalledTimeout:function(t){var e=Ke.fromIntGt0(t);Pi.isInfoEnabled()&&Pi.info("stalledTimeout changed: "+e),this.stalledTimeout=e,this.client.eventDispatcher.onPropertyChange("stalledTimeout")},isHttpExtraHeadersOnSessionCreationOnly:function(){return this.httpExtraHeadersOnSessionCreationOnly},setHttpExtraHeadersOnSessionCreationOnly:function(t){Pi.isInfoEnabled()&&Pi.info("httpExtraHeadersOnSessionCreationOnly changed: "+(null==t?"null":""+t)),this.httpExtraHeadersOnSessionCreationOnly=t,this.client.eventDispatcher.onPropertyChange("httpExtraHeadersOnSessionCreationOnly")},isServerInstanceAddressIgnored:function(){return this.serverInstanceAddressIgnored},setServerInstanceAddressIgnored:function(t){Pi.isInfoEnabled()&&Pi.info("serverInstanceAddressIgnored changed: "+(null==t?"null":""+t)),this.serverInstanceAddressIgnored=t,this.client.eventDispatcher.onPropertyChange("serverInstanceAddressIgnored")},setCookieHandlingRequired:function(t){Pi.isInfoEnabled()&&Pi.info("cookieHandlingRequired changed: "+(null==t?"null":""+t)),this.cookieHandlingRequired=t,this.client.eventDispatcher.onPropertyChange("cookieHandlingRequired")},isCookieHandlingRequired:function(){return this.cookieHandlingRequired},isSlowingEnabled:function(){return this.slowingEnabled},setSlowingEnabled:function(t){Pi.isInfoEnabled()&&Pi.info("slowingEnabled changed: "+(null==t?"null":""+t)),this.slowingEnabled=t,this.client.eventDispatcher.onPropertyChange("slowingEnabled")},toString:function(){var t=ge._new();return ge.set(t,"forcedTransport",this.forcedTransport),ge.set(t,"requestedMaxBandwidth",this.requestedMaxBandwidth),ge.set(t,"realMaxBandwidth",this.realMaxBandwidth),ge.set(t,"retryDelay",this.retryDelay),ge.set(t,"firstRetryMaxDelay",this.firstRetryMaxDelay),ge.set(t,"sessionRecoveryTimeout",this.sessionRecoveryTimeout),ge.set(t,"reverseHeartbeatInterval",this.reverseHeartbeatInterval),ge.set(t,"stalledTimeout",this.stalledTimeout),ge.set(t,"reconnectTimeout",this.reconnectTimeout),ge.set(t,"keepaliveInterval",this.keepaliveInterval),ge.set(t,"pollingInterval",this.pollingInterval),ge.set(t,"idleTimeout",this.idleTimeout),ge.set(t,"contentLength",this.contentLength),ge.set(t,"slowingEnabled",this.slowingEnabled),ge.set(t,"serverInstanceAddressIgnored",this.serverInstanceAddressIgnored),ge.set(t,"HTTPExtraHeadersOnSessionCreationOnly",this.httpExtraHeadersOnSessionCreationOnly),ge.set(t,"HTTPExtraHeaders",this.httpExtraHeaders),ge.set(t,"cookieHandlingRequired",this.cookieHandlingRequired),ks.stringify(t.h)},__class__:T};var I=function(){this.listeners=[]};I.__name__="com.lightstreamer.internal.EventDispatcher",I.prototype={addListener:function(t){return-1==this.listeners.indexOf(t)&&(this.listeners.push(t),!0)},removeListener:function(t){return _.remove(this.listeners,t)},getListeners:function(){return this.listeners},dispatchToAll:function(t){for(var e=0,s=this.listeners;e<s.length;)this.dispatchToOne(s[e++],t)},dispatchToOne:function(t,e){Ci.submit(ei.a((function(){try{e(t)}catch(t){var s=w.caught(t);Pi.isErrorEnabled()&&Pi.error("Uncaught exception\n"+s.details())}})))},__class__:I};var x=function(){I.call(this)};x.__name__="com.lightstreamer.client.ClientEventDispatcher",x.__super__=I,x.prototype=c(I.prototype,{removeListenerAndFireOnListenEnd:function(t,e){this.removeListener(t)&&this.dispatchToOne(t,(function(t){null!=t.onListenEnd&&t.onListenEnd(e)}))},addListenerAndFireOnListenStart:function(t,e){this.addListener(t)&&this.dispatchToOne(t,(function(t){null!=t.onListenStart&&t.onListenStart(e)}))},onServerError:function(t,e){this.dispatchToAll((function(s){null!=s.onServerError&&s.onServerError(t,e)}))},onStatusChange:function(t){this.dispatchToAll((function(e){null!=e.onStatusChange&&e.onStatusChange(t)}))},onPropertyChange:function(t){this.dispatchToAll((function(e){null!=e.onPropertyChange&&e.onPropertyChange(t)}))},onServerKeepalive:function(){this.dispatchToAll((function(t){null!=t.onServerKeepalive&&t.onServerKeepalive()}))},__class__:x});var C=l.LSLightstreamerClient=function(t,e){this.lock=new ys,this.eventDispatcher=new x,this.connectionDetails=new b(this),this.connectionOptions=new T(this),this.machine=new nt(this,oi(this,this.createWsClient),oi(this,this.createHttpClient),oi(this,this.createHttpClient),oi(this,this.createTimer),oi(this,this.randomMillis),oi(this,this.createReachabilityManager)),null!=t&&this.connectionDetails.setServerAddress(t),null!=e&&this.connectionDetails.setAdapterSet(e)};C.__name__="LSLightstreamerClient",C.setLoggerProvider=function(t){ws.setLoggerProvider(t)},C.prototype={addListener:function(t){this.eventDispatcher.addListenerAndFireOnListenStart(t,this)},removeListener:function(t){this.eventDispatcher.removeListenerAndFireOnListenEnd(t,this)},getListeners:function(){return this.eventDispatcher.getListeners().slice()},connect:function(){this.machine.connect()},disconnect:function(){this.machine.disconnect()},getStatus:function(){return this.machine.getStatus()},sendMessage:function(t,e,s,i,n){null==n&&(n=!1),null==s&&(s=-1),this.machine.sendMessage(t,e,null!=s?s:-1,i,null!=n&&n)},subscribe:function(t){this.machine.subscribeExt(t)},unsubscribe:function(t){this.machine.unsubscribe(t)},getSubscriptions:function(){return this.machine.getSubscriptions().slice()},getSubscriptionWrappers:function(){for(var t=[],e=0,s=this.machine.getSubscriptions();e<s.length;){var i=s[e];++e,null!=i.wrapper&&t.push(i.wrapper)}return t.slice()},registerForMpn:function(t){ni.__cast(this.machine,nt).registerForMpn(t)},subscribeMpn:function(t,e){ni.__cast(this.machine,nt).subscribeMpn(t,e)},unsubscribeMpn:function(t){ni.__cast(this.machine,nt).unsubscribeMpn(t)},unsubscribeMpnSubscriptions:function(t){ni.__cast(this.machine,nt).unsubscribeMpnSubscriptions(t)},getMpnSubscriptions:function(t){return ni.__cast(this.machine,nt).getMpnSubscriptions(t).slice()},getMpnSubscriptionWrappers:function(t){for(var e=[],s=0,i=ni.__cast(this.machine,nt).getMpnSubscriptions(t);s<i.length;){var n=i[s];++s,null!=n.wrapper&&e.push(n.wrapper)}return e.slice()},findMpnSubscription:function(t){return ni.__cast(this.machine,nt).findMpnSubscription(t)},findMpnSubscriptionWrapper:function(t){var e=this.findMpnSubscription(t);return null!=e?e.wrapper:null},createWsClient:function(t,e,s,i,n){return new ls(t,s,i,n)},createHttpClient:function(t,e,s,i,n,r){return new pe(t,e,s,this.connectionOptions.isCookieHandlingRequired(),i,n,r)},createReachabilityManager:function(t){return new Ce},createTimer:function(t,e,s){return new He(t,e,s)},randomMillis:function(t){return p.random(t)},__class__:C};var D=a["com.lightstreamer.client._Subscription.SubscriptionState"]={__ename__:!0,__constructs__:null,Inactive:{_hx_name:"Inactive",_hx_index:0,__enum__:"com.lightstreamer.client._Subscription.SubscriptionState",toString:r},Active:{_hx_name:"Active",_hx_index:1,__enum__:"com.lightstreamer.client._Subscription.SubscriptionState",toString:r},Subscribed:{_hx_name:"Subscribed",_hx_index:2,__enum__:"com.lightstreamer.client._Subscription.SubscriptionState",toString:r}};D.__constructs__=[D.Inactive,D.Active,D.Subscribed];var L=function(){I.call(this)};L.__name__="com.lightstreamer.client._Subscription.SubscriptionEventDispatcher",L.__super__=I,L.prototype=c(I.prototype,{onClearSnapshot:function(t,e){this.dispatchToAll((function(s){null!=s.onClearSnapshot&&s.onClearSnapshot(t,e)}))},onCommandSecondLevelItemLostUpdates:function(t,e){this.dispatchToAll((function(s){null!=s.onCommandSecondLevelItemLostUpdates&&s.onCommandSecondLevelItemLostUpdates(t,e)}))},onCommandSecondLevelSubscriptionError:function(t,e,s){this.dispatchToAll((function(i){null!=i.onCommandSecondLevelSubscriptionError&&i.onCommandSecondLevelSubscriptionError(t,e,s)}))},onEndOfSnapshot:function(t,e){this.dispatchToAll((function(s){null!=s.onEndOfSnapshot&&s.onEndOfSnapshot(t,e)}))},onItemLostUpdates:function(t,e,s){this.dispatchToAll((function(i){null!=i.onItemLostUpdates&&i.onItemLostUpdates(t,e,s)}))},onItemUpdate:function(t){this.dispatchToAll((function(e){null!=e.onItemUpdate&&e.onItemUpdate(t)}))},removeListenerAndFireOnListenEnd:function(t,e){this.removeListener(t)&&this.dispatchToOne(t,(function(t){null!=t.onListenEnd&&t.onListenEnd(e)}))},addListenerAndFireOnListenStart:function(t,e){this.addListener(t)&&this.dispatchToOne(t,(function(t){null!=t.onListenStart&&t.onListenStart(e)}))},onSubscription:function(){this.dispatchToAll((function(t){null!=t.onSubscription&&t.onSubscription()}))},onSubscriptionError:function(t,e){this.dispatchToAll((function(s){null!=s.onSubscriptionError&&s.onSubscriptionError(t,e)}))},onUnsubscription:function(){this.dispatchToAll((function(t){null!=t.onUnsubscription&&t.onUnsubscription()}))},onRealMaxFrequency:function(t){this.dispatchToAll((function(e){null!=e.onRealMaxFrequency&&e.onRealMaxFrequency(t)}))},__class__:L});var M=l.LSSubscription=function(t,e,s,i){this.lock=new ys,this.m_internal=!1,this.state=D.Inactive,this.eventDispatcher=new L,this.wrapper=i,this.mode=ns.fromString(t),this.initSnapshot(),this.initItemsAndFields("string"==typeof e?[e].slice():e,s)};M.__name__="LSSubscription",M.prototype={initSnapshot:function(){this.snapshot="RAW"==this.mode?null:Xe.SnpYes},initItemsAndFields:function(t,e){if(null!=t){if(null==e)throw new R("Please specify a valid field list");if(this.items=rs.fromArray(t.slice()),this.fields=as.fromArray(e.slice()),"COMMAND"==this.mode&&-1==this.fields.indexOf("key"))throw new R("Field 'key' is missing");if("COMMAND"==this.mode&&-1==this.fields.indexOf("command"))throw new R("Field 'command' is missing")}else if(null!=e)throw new R("Please specify a valid item or item list")},addListener:function(t){this.eventDispatcher.addListenerAndFireOnListenStart(t,this)},removeListener:function(t){this.eventDispatcher.removeListenerAndFireOnListenEnd(t,this)},getListeners:function(){return this.eventDispatcher.getListeners().slice()},isActive:function(){return this.state!=D.Inactive},isSubscribed:function(){return this.state==D.Subscribed},getDataAdapter:function(){return this.dataAdapter},setDataAdapter:function(t){this.checkActive(),this.dataAdapter=os.fromString(t)},getMode:function(){return this.mode},getItems:function(){return null==this.items?null:this.items.slice()},setItems:function(t){this.checkActive(),this.items=rs.fromArray(null==t?null:t.slice()),this.group=null},getItemGroup:function(){return this.group},setItemGroup:function(t){this.checkActive(),this.group=os.fromString(t),this.items=null},getFields:function(){return null==this.fields?null:this.fields.slice()},setFields:function(t){this.checkActive();var e=as.fromArray(null==t?null:t.slice());if("COMMAND"==this.mode&&null!=e){if(-1==e.indexOf("command"))throw new R("Field 'command' is missing");if(-1==e.indexOf("key"))throw new R("Field 'key' is missing")}this.fields=e,this.schema=null},getFieldSchema:function(){return this.schema},setFieldSchema:function(t){this.checkActive(),this.schema=os.fromString(t),this.fields=null},getRequestedBufferSize:function(){return Je.toString(this.bufferSize)},setRequestedBufferSize:function(t){null!=t&&(t=null==t?"null":""+t),this.checkActive(),this.bufferSize=Je.fromString(t)},getRequestedSnapshot:function(){return Ze.toString(this.snapshot)},setRequestedSnapshot:function(t){null!=t&&(t=null==t?"null":""+t),this.checkActive();var e=Ze.fromString(t);switch(this.mode){case"COMMAND":case"MERGE":if(null!=e&&null!=e&&2==e._hx_index)throw new R("Snapshot length is not permitted if MERGE or COMMAND was specified as mode");break;case"RAW":if(null!=e)throw new R("Snapshot is not permitted if RAW was specified as mode")}this.snapshot=e},getRequestedMaxFrequency:function(){return ts.toString(this.requestedMaxFrequency)},setRequestedMaxFrequency:function(t){var e,s=this;null!=t&&(t=null==t?"null":""+t),xe.synchronized(this.lock,(function(){var i=ts.fromString(t);switch(s.mode){case"COMMAND":case"DISTINCT":case"MERGE":break;default:throw new R("The operation in only available on MERGE, DISTINCT and COMMAND Subscripitons")}if(s.isActive()&&(null==i||i==$e.FreqUnfiltered||s.requestedMaxFrequency==$e.FreqUnfiltered))throw new R("Cannot change the frequency from/to 'unfiltered' or to null while the Subscription is active");return null!=s.subId&&Fi.isInfoEnabled()&&Fi.info("Subscription "+s.subId+" requested max frequency changed: "+t),s.requestedMaxFrequency=i,e=s.manager})),null!=e&&e.evtExtConfigure()},getSelector:function(){return this.selector},setSelector:function(t){this.checkActive(),this.selector=os.fromString(t)},getCommandPosition:function(){if(this.checkCommand(),null==this.cmdIdx)throw new be("The position of the command field is currently unknown");return this.cmdIdx},getKeyPosition:function(){if(this.checkCommand(),null==this.keyIdx)throw new be("The position of the key field is currently unknown");return this.keyIdx},getCommandSecondLevelDataAdapter:function(){return this.dataAdapter2},setCommandSecondLevelDataAdapter:function(t){this.checkActive(),this.checkCommand(),this.dataAdapter2=os.fromString(t)},getCommandSecondLevelFields:function(){return null==this.fields2?null:this.fields2.slice()},setCommandSecondLevelFields:function(t){this.checkActive(),this.checkCommand(),this.fields2=as.fromArray(null==t?null:t.slice()),this.schema2=null},getCommandSecondLevelFieldSchema:function(){return this.schema2},setCommandSecondLevelFieldSchema:function(t){this.checkActive(),this.checkCommand(),this.schema2=os.fromString(t),this.fields2=null},getValue:function(t,e){var s="number"==typeof t&&(0|t)===t,i="string"==typeof t,n="number"==typeof e&&(0|e)===e,r="string"==typeof e;if(s&&n)return this.getValuePosPos(t,e);if(s&&r)return this.getValuePosName(t,e);if(i&&n)return this.getValueNamePos(t,e);if(i&&r)return this.getValueNameName(t,e);throw new R("Invalid argument type")},getCommandValue:function(t,e,s){var i="number"==typeof t&&(0|t)===t,n="string"==typeof t,r="number"==typeof s&&(0|s)===s,a="string"==typeof s;if(i&&r)return this.getCommandValuePosPos(t,e,s);if(i&&a)return this.getCommandValuePosName(t,e,s);if(n&&r)return this.getCommandValueNamePos(t,e,s);if(n&&a)return this.getCommandValueNameName(t,e,s);throw new R("Invalid argument type")},getValuePosPos:function(t,e){var s,i=this;if(t<1||e<1)throw new R("The specified position is out of bounds");return xe.synchronized(this.lock,(function(){return s=i.manager})),null!=s?s.getValue(t,e):null},getValuePosName:function(t,e){var s=this;return this.getValuePosPos(t,xe.synchronized(this.lock,(function(){return s.getFieldPos(e)})))},getValueNamePos:function(t,e){var s=this;return this.getValuePosPos(xe.synchronized(this.lock,(function(){return s.getItemPos(t)})),e)},getValueNameName:function(t,e){var s=this;return this.getValuePosPos(xe.synchronized(this.lock,(function(){return s.getItemPos(t)})),xe.synchronized(this.lock,(function(){return s.getFieldPos(e)})))},getCommandValuePosPos:function(t,e,s){var i,n=this;if(this.checkCommand(),t<1||s<1)throw new R("The specified position is out of bounds");return xe.synchronized(this.lock,(function(){return i=n.manager})),null!=i?i.getCommandValue(t,e,s):null},getCommandValuePosName:function(t,e,s){var i=this;return this.getCommandValuePosPos(t,e,xe.synchronized(this.lock,(function(){return i.getFieldPos(s)})))},getCommandValueNamePos:function(t,e,s){var i=this;return this.getCommandValuePosPos(xe.synchronized(this.lock,(function(){return i.getItemPos(t)})),e,s)},getCommandValueNameName:function(t,e,s){var i=this;return this.getCommandValuePosPos(xe.synchronized(this.lock,(function(){return i.getItemPos(t)})),e,xe.synchronized(this.lock,(function(){return i.getFieldPos(s)})))},getItemPos:function(t){var e;if(null==this.items||-1==(e=rs.getPos(this.items,t)))throw new R("Unknown item name");return e},getFieldPos:function(t){var e;if(null==this.fields||-1==(e=as.getPos(this.fields,t)))throw new R("Unknown field name");return e},checkActive:function(){if(this.isActive())throw new be("Cannot modify an active Subscription. Please unsubscribe before applying any change")},checkCommand:function(){if("COMMAND"!=this.mode)throw new be("This method can only be used on COMMAND subscriptions")},fetch_mode:function(){return this.mode},fetch_requestedBufferSize:function(){return this.bufferSize},fetch_requestedSnapshot:function(){return this.snapshot},fetch_requestedMaxFrequency:function(){return this.requestedMaxFrequency},fetch_nItems:function(){return this.nItems},fetch_subManager:function(){return this.manager},setActive:function(){this.state=D.Active},setInactive:function(){this.state=D.Inactive,this.subId=null,this.cmdIdx=null,this.keyIdx=null,this.nItems=null,this.nFields=null},setSubscribed:function(t,e,s){this.state=D.Subscribed,this.subId=t,this.nItems=e,this.nFields=s},setSubscribedCMD:function(t,e,s,i,n){this.state=D.Subscribed,this.subId=t,this.cmdIdx=i,this.keyIdx=n,this.nItems=e,this.nFields=s},fetch_nFields:function(){return this.nFields},isInternal:function(){return this.m_internal},setInternal:function(){this.m_internal=!0},getItemName:function(t){return null!=this.items?this.items[t-1]:null},relate:function(t){this.manager=t},unrelate:function(t){this.manager==t&&(this.manager=null)},hasSnapshot:function(){return!(null==this.snapshot||this.snapshot==Xe.SnpNo)},getItemNameOrPos:function(t){return null!=this.items?this.items[t-1]:""+t},fireOnSubscription:function(t){Fi.isInfoEnabled()&&Fi.info("Subscription "+t+" added"),this.eventDispatcher.onSubscription()},fireOnUnsubscription:function(t){Fi.isInfoEnabled()&&Fi.info("Subscription "+t+" deleted"),this.eventDispatcher.onUnsubscription()},fireOnSubscriptionError:function(t,e,s){Fi.isWarnEnabled()&&Fi.warn("Subscription "+t+" failed: "+e+" - "+s),this.eventDispatcher.onSubscriptionError(e,s)},fireOnEndOfSnapshot:function(t,e){Fi.isDebugEnabled()&&Fi.debug("Subscription "+e+":"+this.getItemNameOrPos(t)+": snapshot ended"),this.eventDispatcher.onEndOfSnapshot(this.getItemName(t),t)},fireOnClearSnapshot:function(t,e){Fi.isDebugEnabled()&&Fi.debug("Subscription "+e+":"+this.getItemNameOrPos(t)+": snapshot cleared"),this.eventDispatcher.onClearSnapshot(this.getItemName(t),t)},fireOnLostUpdates:function(t,e,s){Fi.isDebugEnabled()&&Fi.debug("Subscription "+s+":"+this.getItemNameOrPos(t)+": lost "+e+" updates"),this.eventDispatcher.onItemLostUpdates(this.getItemName(t),t,e)},fireOnItemUpdate:function(t,e){Fi.isDebugEnabled()&&Fi.debug("Subscription "+e+":"+this.getItemNameOrPos(t.getItemPos())+" update: "+p.string(t)),this.eventDispatcher.onItemUpdate(t)},fireOnRealMaxFrequency:function(t,e){Fi.isDebugEnabled()&&Fi.debug("Subscription "+e+" real max frequency changed: "+p.string(t)),this.eventDispatcher.onRealMaxFrequency(hs(t))},fireOnSubscriptionError2Level:function(t,e,s,i,n){Fi.isWarnEnabled()&&Fi.warn("Subscription "+i+":"+this.getItemNameOrPos(n)+":"+t+" failed: "+e+" - "+s),this.eventDispatcher.onCommandSecondLevelSubscriptionError(e,s,t)},fireOnLostUpdates2Level:function(t,e,s,i){Fi.isDebugEnabled()&&Fi.debug("Subscription "+s+":"+this.getItemNameOrPos(i)+":"+t+": lost "+e+" updates"),this.eventDispatcher.onCommandSecondLevelItemLostUpdates(e,t)},toString:function(){var t=ge._new();return ge.set(t,"mode",this.mode),ge.set(t,"items",null!=this.items?p.string(this.items):this.group),ge.set(t,"fields",null!=this.fields?p.string(this.fields):this.schema),ge.set(t,"dataAdapter",this.dataAdapter),ge.set(t,"requestedBufferSize",this.bufferSize),ge.set(t,"requestedSnapshot",this.snapshot),ge.set(t,"requestedMaxFrequency",this.requestedMaxFrequency),ge.set(t,"selector",this.selector),ge.set(t,"secondLevelFields",null!=this.fields2?p.string(this.fields2):this.schema2),ge.set(t,"secondLevelDataAdapter",this.dataAdapter2),ks.stringify(t.h)},__class__:M};var N=function(t,e,s,i,n,r,a){this.slw_m=.5,this.slw_hugeDelayMs=2e4,this.slw_maxAvgDelayMs=7e3,this.slw_avgDelayMs=0,this.slw_refTime=0,this.rec_clientProg=0,this.rec_serverProg=0,this.subscriptionManagers=me._new(),this.messageManagers=Se._new(),this.sequenceMap=new ks,this.disabledTransports=new Me,this.suspendedTransports=new Me,this.ctrl_connectTs=0,this.recoverTs=0,this.connectTs=0,this.m_nextSubId=0,this.m_nextReqId=0,this.m_status="DISCONNECTED",this.delayCounter=new Ct,this.state=new Q,this.client=t,this.lock=t.lock,this.details=t.connectionDetails,this.options=t.connectionOptions,this.wsFactory=e,this.httpFactory=s,this.ctrlFactory=i,this.timerFactory=n,this.randomGenerator=r,this.reachabilityFactory=a,this.clientEventDispatcher=t.eventDispatcher,this.switchRequest=new W(this),this.constrainRequest=new H(this),this.delayCounter.reset(this.options.retryDelay)};N.__name__="com.lightstreamer.client.internal.ClientMachine",N.prototype={disposeSession:function(){this.disposeWS(),this.disposeHTTP(),this.disposeCtrl(),this.details.serverInstanceAddress=null,this.details.serverSocketName=null,this.details.clientIp=null,this.details.sessionId=null,this.options.realMaxBandwidth=null,this.lastKnownClientIp=null,this.resetSequenceMap(),this.rec_serverProg=0,this.rec_clientProg=0,this.bw_lastReqId=null,this.bw_requestedMaxBandwidth=null,this.swt_lastReqId=null},disposeClient:function(){this.sessionId=null,this.enableAllTransports(),this.resetCurrentRetryDelay(),this.resetSequenceMap(),this.cause=null},evtExtConnect:function(){this.traceEvent("connect");var t=!0;100==this.state.s_m&&(this.cause="api",this.resetCurrentRetryDelay(),this.state.s_m=101,this.state.traceState(),t=this.evtExtConnect_NextRegion(),this.evtSelectCreate()),t&&(t=this.evtExtConnect_NextRegion())},evtExtConnect_NextRegion:function(){return this.evtExtConnect_NetworkReachabilityRegion()},evtExtConnect_NetworkReachabilityRegion:function(){var t=this;if(1400==this.state.s_nr){var e=new us(this.getServerAddress()).get_hostname();this.nr_reachabilityManager=this.reachabilityFactory(e),this.state.s_nr=1410,this.state.traceState(),this.nr_reachabilityManager.startListening((function(s){switch(s._hx_index){case 0:t.evtNetworkReachable(e);break;case 1:t.evtNetworkNotReachable(e)}}))}return!1},evtNetworkNotReachable:function(t){ki.isInfoEnabled()&&ki.info(t+" is NOT reachable"),this.traceEvent("nr:network.not.reachable"),(1410==this.state.s_nr||1412==this.state.s_nr)&&(this.state.s_nr=1411,this.state.traceState())},evtNetworkReachable:function(t){ki.isInfoEnabled()&&ki.info(t+" is reachable"),this.traceEvent("nr:network.reachable"),1410==this.state.s_nr?(this.state.s_nr=1412,this.state.traceState()):1411==this.state.s_nr&&(this.state.s_nr=1412,this.state.traceState(),this.evtOnlineAgain())},evtOnlineAgain:function(){this.traceEvent("online.again"),112==this.state.s_m?(this.state.s_m=116,this.state.traceState(),this.cancel_evtRetryTimeout(),this.evtSelectCreate()):1003==this.state.s_rec&&(this.sendRecovery(),this.state.s_rec=1001,this.state.traceState(),this.cancel_evtRetryTimeout(),this.schedule_evtTransportTimeout(this.options.retryDelay))},evtServerAddressChanged:function(){var t=this;switch(this.traceEvent("nr:serverAddress.changed"),this.state.s_nr){case 1410:case 1411:case 1412:var e=this.nr_reachabilityManager,s=new us(this.getServerAddress()).get_hostname();this.nr_reachabilityManager=this.reachabilityFactory(s),this.state.s_nr=1410,this.state.traceState(),null!=e&&e.stopListening(),this.nr_reachabilityManager.startListening((function(e){switch(e._hx_index){case 0:t.evtNetworkReachable(s);break;case 1:t.evtNetworkNotReachable(s)}}))}},evtExtDisconnect:function(t){switch(this.traceEvent("disconnect: cause="+p.string(t)),this.state.s_m){case 110:case 111:case 112:case 113:case 114:case 115:case 116:this.notifyStatus("DISCONNECTED"),this.notifyServerErrorIfCauseIsError(t),this.state.s_m=100,this.state.traceState(),this.cancel_evtRetryTimeout(),this.evtTerminate(t);break;case 120:case 121:case 122:this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerErrorIfCauseIsError(t),this.state.s_m=100,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtTerminate(t);break;case 130:case 140:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerErrorIfCauseIsError(t),this.state.s_m=100,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtTerminate(t);break;case 150:var e=this.state.s_tr;if(null!=e)switch(e){case 210:this.sendDestroyWS(),this.closeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerErrorIfCauseIsError(t),this.state.clear_w(),this.state.goto_m_from_session(100),this.exit_w(),this.evtEndSession(),this.evtTerminate(t);break;case 220:case 230:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerErrorIfCauseIsError(t),this.state.goto_m_from_session(100),this.cancel_evtTransportTimeout(),this.evtEndSession(),this.evtTerminate(t);break;case 240:var s;if(500==(null!=(n=this.state.s_ws)?n.m:null))this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerErrorIfCauseIsError(t),this.state.goto_m_from_ws(100),this.exit_ws_to_m(),this.evtTerminate(t);else(n=!!(i=501==(null!=(s=this.state.s_ws)?s.m:null)||502==(null!=(s=this.state.s_ws)?s.m:null))||503==(null!=(i=this.state.s_ws)?i.m:null))&&(this.sendDestroyWS(),this.closeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerErrorIfCauseIsError(t),this.state.goto_m_from_ws(100),this.exit_ws_to_m(),this.evtTerminate(t));break;case 250:var i,n;(n=600==(null!=(i=this.state.s_wp)?i.m:null)||601==(null!=(i=this.state.s_wp)?i.m:null))?(this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerErrorIfCauseIsError(t),this.state.goto_m_from_wp(100),this.exit_ws_to_m(),this.evtTerminate(t)):602==(null!=(n=this.state.s_wp)?n.m:null)&&(this.sendDestroyWS(),this.closeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerErrorIfCauseIsError(t),this.state.goto_m_from_wp(100),this.exit_wp_to_m(),this.evtTerminate(t));break;case 260:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerErrorIfCauseIsError(t),this.state.goto_m_from_rec(100),this.exit_rec_to_m(),this.evtTerminate(t);break;case 270:710==this.state.s_h?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerErrorIfCauseIsError(t),this.state.goto_m_from_hs(100),this.exit_hs_to_m(),this.evtTerminate(t)):720==this.state.s_h&&(this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerErrorIfCauseIsError(t),this.state.goto_m_from_hp(100),this.exit_hp_to_m(),this.evtTerminate(t))}}},evtSelectCreate:function(){if(this.traceEvent("select.create"),101==this.state.s_m||116==this.state.s_m)switch(this.getBestForCreating()._hx_index){case 0:this.notifyStatus("CONNECTING"),this.openWS_Create(),this.state.s_m=120,this.state.traceState(),this.evtCreate(),this.schedule_evtTransportTimeout(this.delayCounter.get_currentRetryDelay());break;case 1:this.notifyStatus("CONNECTING"),this.sendCreateHTTP(),this.state.s_m=130,this.state.traceState(),this.evtCreate(),this.schedule_evtTransportTimeout(this.delayCounter.get_currentRetryDelay());break;case 2:this.notifyStatus("DISCONNECTED"),this.state.s_m=100,this.state.traceState(),this.evtTerminate(q.TC_otherError("Unable to select a transport"))}},evtWSOpen:function(){var t;this.traceEvent("ws.open"),120==this.state.s_m?(this.sendCreateWS(),this.state.s_m=121,this.state.traceState()):500==(null!=(t=this.state.s_ws)?t.m:null)?(this.sendBindWS_Streaming(),this.state.s_ws.m=501,this.state.traceState()):600==(null!=(t=this.state.s_wp)?t.m:null)&&(ye.sure(this.ws).send("wsok"),this.state.s_wp.m=601,this.state.traceState())},evtMessage:function(t){var e=!0;if(v.startsWith(t,"U,")){var s=Et(t);this.evtU(s.subId,s.itemIdx,s.values,t)}else if(v.startsWith(t,"REQOK"))"REQOK"==t?this.evtREQOK_withoutReqId():this.evtREQOK(vt(t.split(",")[1]));else if(v.startsWith(t,"PROBE"))this.evtPROBE();else if(v.startsWith(t,"LOOP"))this.evtLOOP(vt(t.split(",")[1]));else if(v.startsWith(t,"CONOK")){var i=t.split(",");this.evtCONOK(i[1],vt(i[2]),vt(i[3]),i[4])}else if(v.startsWith(t,"WSOK"))this.evtWSOK();else if(v.startsWith(t,"SERVNAME"))this.evtSERVNAME(t.split(",")[1]);else if(v.startsWith(t,"CLIENTIP"))this.evtCLIENTIP(t.split(",")[1]);else if(v.startsWith(t,"CONS")){var n=t.split(",")[1];switch(n){case"unlimited":this.evtCONS(ss.BWUnlimited);break;case"unmanaged":this.evtCONS(ss.BWUnmanaged);break;default:this.evtCONS(ss.BWLimited(St(n)))}}else if(v.startsWith(t,"MSGDONE"))"*"==(r=(i=t.split(","))[1])&&(r="UNORDERED_MESSAGES"),this.evtMSGDONE(r,vt(i[2]));else if(v.startsWith(t,"MSGFAIL")){var r;"*"==(r=(i=t.split(","))[1])&&(r="UNORDERED_MESSAGES"),this.evtMSGFAIL(r,vt(i[2]),vt(i[3]),wt(i[4]))}else if(v.startsWith(t,"REQERR"))i=t.split(","),this.evtREQERR(vt(i[1]),vt(i[2]),wt(i[3]));else if(v.startsWith(t,"PROG"))this.evtPROG(vt(t.split(",")[1]));else if(v.startsWith(t,"SUBOK"))i=t.split(","),this.evtSUBOK(vt(i[1]),vt(i[2]),vt(i[3]));else if(v.startsWith(t,"SUBCMD"))i=t.split(","),this.evtSUBCMD(vt(i[1]),vt(i[2]),vt(i[3]),vt(i[4]),vt(i[5]));else if(v.startsWith(t,"UNSUB"))this.evtUNSUB(vt(t.split(",")[1]));else if(v.startsWith(t,"CONF")){var a=vt((i=t.split(","))[1]);"unlimited"==i[2]?this.evtCONF(a,es.RFreqUnlimited):this.evtCONF(a,es.RFreqLimited(St(i[2])))}else v.startsWith(t,"EOS")?(i=t.split(","),this.evtEOS(vt(i[1]),vt(i[2]))):v.startsWith(t,"CS")?(i=t.split(","),this.evtCS(vt(i[1]),vt(i[2]))):v.startsWith(t,"OV")?(i=t.split(","),this.evtOV(vt(i[1]),vt(i[2]),vt(i[3]))):v.startsWith(t,"NOOP")?this.evtNOOP():v.startsWith(t,"CONERR")?(i=t.split(","),this.evtCONERR(vt(i[1]),wt(i[2]))):v.startsWith(t,"END")?(i=t.split(","),this.evtEND(vt(i[1]),wt(i[2]))):v.startsWith(t,"ERROR")?(i=t.split(","),this.evtERROR(vt(i[1]),wt(i[2]))):v.startsWith(t,"SYNC")?this.evtSYNC(vt(t.split(",")[1])):e=!1;return e},evtCtrlMessage:function(t){if(v.startsWith(t,"REQOK"))"REQOK"==t?this.evtREQOK_withoutReqId():this.evtREQOK(vt(t.split(",")[1]));else if(v.startsWith(t,"REQERR")){var e=t.split(",");this.evtREQERR(vt(e[1]),vt(e[2]),wt(e[3]))}else v.startsWith(t,"ERROR")&&(e=t.split(","),this.evtERROR(vt(e[1]),wt(e[2])))},evtTransportTimeout:function(){switch(this.traceEvent("transport.timeout"),this.state.s_m){case 120:case 121:this.suspendWS_Streaming(),this.disposeWS(),this.cause="ws.unavailable",this.state.s_m=115,this.state.traceState(),this.cancel_evtTransportTimeout(),this.entry_m115(F.ws_unavailable);break;case 122:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.timeout",this.state.s_m=112,this.state.traceState(),this.cancel_evtTransportTimeout(),this.entry_m112(F.ws_timeout);break;case 130:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.timeout",this.state.s_m=112,this.state.traceState(),this.cancel_evtTransportTimeout(),this.entry_m112(F.http_timeout);break;case 140:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ttl.timeout";var t=this.waitingInterval(this.delayCounter.get_currentRetryDelay(),this.connectTs);this.state.s_m=111,this.state.traceState(),this.cancel_evtTransportTimeout(),this.entry_m111(F.http_error,t);break;case 150:if(null!=(s=this.state.s_tr))switch(s){case 220:0==this.options.sessionRecoveryTimeout?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.timeout",this.state.goto_m_from_session(112),this.cancel_evtTransportTimeout(),this.evtEndSession(),this.entry_m112(F.http_timeout)):(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="http.timeout",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec(),this.cancel_evtTransportTimeout(),this.entry_rec(t,F.http_timeout));break;case 230:0==this.options.sessionRecoveryTimeout?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ttl.timeout",this.state.goto_m_from_session(112),this.cancel_evtTransportTimeout(),this.evtEndSession(),this.entry_m112(F.http_timeout)):(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="ttl.timeout",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec(),this.cancel_evtTransportTimeout(),this.entry_rec(t,F.http_error));break;case 240:if(null!=(s=null!=(e=this.state.s_ws)?e.m:null))switch(s){case 500:this.disableWS(),this.disposeWS(),this.cause="ws.unavailable",this.state.clear_ws(),this.state.s_tr=200,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtSwitchTransport();break;case 501:0==this.options.sessionRecoveryTimeout?(this.disableWS(),this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.unavailable",this.state.goto_m_from_ws(112),this.exit_ws_to_m(),this.entry_m112(F.ws_unavailable)):(this.disableWS(),this.disposeWS(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="ws.unavailable",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_ws(),this.exit_ws(),this.entry_rec(t,F.ws_unavailable));break;case 502:0==this.options.sessionRecoveryTimeout?(this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.timeout",this.state.goto_m_from_ws(112),this.exit_ws_to_m(),this.entry_m112(F.ws_timeout)):(this.disposeWS(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="ws.timeout",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_ws(),this.exit_ws(),this.entry_rec(t,F.ws_timeout))}break;case 250:if(null!=(s=null!=(e=this.state.s_wp)?e.m:null))switch(s){case 600:case 601:this.disableWS(),this.disposeWS(),this.cause="ws.unavailable",this.state.clear_wp(),this.state.s_tr=200,this.state.traceState(),this.exit_wp(),this.evtSwitchTransport()}break;case 260:1001==this.state.s_rec&&(this.disposeHTTP(),this.state.s_rec=1002,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtCheckRecoveryTimeout(A.RRC_transport_timeout));break;case 270:var e,s;if(null!=(s=this.state.s_h)&&710==s&&null!=(s=null!=(e=this.state.s_hs)?e.m:null))switch(s){case 800:this.disableHTTP_Streaming(),this.cause="http.streaming.unavailable",this.state.s_hs.m=801,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtForcePolling(),this.schedule_evtTransportTimeout(this.options.retryDelay);break;case 801:0==this.options.sessionRecoveryTimeout?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.timeout",this.state.goto_m_from_hs(112),this.exit_hs_to_m(),this.entry_m112(F.http_timeout)):(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="http.timeout",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_hs(),this.exit_hs_to_rec(),this.entry_rec(t,F.http_timeout))}}}},evtTransportError:function(){switch(this.traceEvent("transport.error"),this.state.s_m){case 120:case 121:this.suspendWS_Streaming(),this.disposeWS(),this.cause="ws.unavailable",this.state.s_m=115,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtRetry(F.ws_unavailable),this.evtRetryTimeout();break;case 122:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.error";var t=this.waitingInterval(this.delayCounter.get_currentRetryDelay(),this.connectTs);this.state.s_m=112,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtRetry(F.ws_error,t),this.schedule_evtRetryTimeout(t);break;case 130:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.error",t=this.waitingInterval(this.delayCounter.get_currentRetryDelay(),this.connectTs),this.state.s_m=112,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtRetry(F.http_error,t),this.schedule_evtRetryTimeout(t);break;case 140:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ttl.error",t=this.waitingInterval(this.delayCounter.get_currentRetryDelay(),this.connectTs),this.state.s_m=111,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtRetry(F.http_error,t),this.schedule_evtRetryTimeout(t);break;case 150:var e=this.state.s_tr;if(null!=e)switch(e){case 210:0==this.options.sessionRecoveryTimeout?(this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.error",this.state.clear_w(),this.state.goto_m_from_session(113),this.exit_w(),this.evtEndSession(),this.entry_m113(F.ws_error)):(this.disposeWS(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="ws.error",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.clear_w(),this.state.s_tr=260,this.state.s_rec=1e3,this.state.traceState(),this.exit_w(),this.entry_rec(t,F.ws_error));break;case 220:0==this.options.sessionRecoveryTimeout?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.error",t=this.waitingInterval(this.delayCounter.get_currentRetryDelay(),this.connectTs),this.state.goto_m_from_session(112),this.cancel_evtTransportTimeout(),this.evtEndSession(),this.evtRetry(F.http_error,t),this.schedule_evtRetryTimeout(t)):(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="http.error",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec(),this.cancel_evtTransportTimeout(),this.entry_rec(t,F.http_error));break;case 230:0==this.options.sessionRecoveryTimeout?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ttl.error",t=this.waitingInterval(this.delayCounter.get_currentRetryDelay(),this.connectTs),this.state.goto_m_from_session(112),this.cancel_evtTransportTimeout(),this.evtEndSession(),this.evtRetry(F.http_error,t),this.schedule_evtRetryTimeout(t)):(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="ttl.error",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec(),this.cancel_evtTransportTimeout(),this.entry_rec(t,F.http_error));break;case 240:switch(ye.sure(this.state.s_ws).m){case 500:this.disableWS(),this.disposeWS(),this.cause="ws.unavailable",this.state.clear_ws(),this.state.s_tr=200,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtSwitchTransport();break;case 501:0==this.options.sessionRecoveryTimeout?(this.disableWS(),this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.unavailable",this.state.goto_m_from_ws(112),this.exit_ws_to_m(),this.entry_m112(F.ws_unavailable)):(this.disableWS(),this.disposeWS(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="ws.unavailable",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_ws(),this.exit_ws(),this.entry_rec(t,F.ws_unavailable));break;case 502:0==this.options.sessionRecoveryTimeout?(this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.error",this.state.goto_m_from_ws(112),this.exit_ws_to_m(),this.entry_m112(F.ws_error)):(this.disposeWS(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="ws.error",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_ws(),this.cancel_evtTransportTimeout(),this.entry_rec(t,F.ws_error));break;case 503:0==this.options.sessionRecoveryTimeout?(this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.error",this.state.goto_m_from_ws(113),this.exit_ws_to_m(),this.entry_m113(F.ws_error)):(this.disposeWS(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="ws.error",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_ws(),this.exit_ws(),this.entry_rec(t,F.ws_error))}break;case 250:switch(ye.sure(this.state.s_wp).m){case 600:case 601:this.disableWS(),this.disposeWS(),this.cause="ws.unavailable",this.state.clear_wp(),this.state.s_tr=200,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtSwitchTransport();break;case 602:0==this.options.sessionRecoveryTimeout?(this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.error",this.state.goto_m_from_wp(113),this.exit_wp_to_m(),this.entry_m113(F.ws_error)):(this.disposeWS(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="ws.error",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_wp(),this.exit_wp(),this.entry_rec(t,F.ws_error))}break;case 260:1001==this.state.s_rec&&(this.disposeHTTP(),this.state.s_rec=1002,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtCheckRecoveryTimeout(A.RRC_transport_error));break;case 270:switch(ye.sure(this.state.s_h)){case 710:switch(ye.sure(this.state.s_hs).m){case 800:case 801:0==this.options.sessionRecoveryTimeout?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.error",this.state.goto_m_from_hs(112),this.exit_hs_to_m(),this.entry_m112(F.http_error)):(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="http.error",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_hs(),this.exit_hs_to_rec(),this.entry_rec(t,F.http_error));break;case 802:0==this.options.sessionRecoveryTimeout?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.error",this.state.goto_m_from_hs(113),this.exit_hs_to_m(),this.entry_m113(F.http_error)):(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="http.error",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_hs(),this.exit_hs_to_rec(),this.entry_rec(t,F.http_error))}break;case 720:switch(ye.sure(this.state.s_hp).m){case 900:case 901:case 902:case 903:case 904:0==this.options.sessionRecoveryTimeout?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.error",this.state.goto_m_from_hp(112),this.exit_hp_to_m(),this.entry_m112(F.http_error)):(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="http.error",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_hp(),this.exit_hp_to_rec(),this.entry_rec(t,F.http_error))}}}}},evtIdleTimeout:function(){if(this.traceEvent("idle.timeout"),null==(i=null!=(s=this.state.s_wp)?s.p:null))e=!1;else switch(i){case 610:case 611:case 613:e=!0;break;default:e=!1}if(e)if(0==this.options.sessionRecoveryTimeout)this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.idle.timeout",this.state.goto_m_from_wp(113),this.exit_wp_to_m(),this.entry_m113(F.idle_timeout);else{this.disposeWS(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="ws.idle.timeout";var t=this.randomGenerator(this.options.firstRetryMaxDelay);this.state.goto_rec_from_wp(),this.exit_wp(),this.entry_rec(t,F.idle_timeout)}else{var e,s,i;if(null==(i=null!=(s=this.state.s_hp)?s.m:null))e=!1;else switch(i){case 900:case 901:case 903:e=!0;break;default:e=!1}e&&(0==this.options.sessionRecoveryTimeout?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.idle.timeout",this.state.goto_m_from_hp(112),this.exit_hp_to_m(),this.entry_m112(F.idle_timeout)):(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="http.idle.timeout",t=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_hp(),this.exit_hp_to_rec(),this.entry_rec(t,F.idle_timeout)))}},evtPollingTimeout:function(){var t;this.traceEvent("polling.timeout"),612==(null!=(t=this.state.s_wp)?t.p:null)?(this.sendBindWS_Polling(),this.state.s_wp.p=613,this.state.traceState(),this.cancel_evtPollingTimeout(),this.schedule_evtIdleTimeout(Ke.plus(ye.sure(this.idleTimeout),this.options.retryDelay))):902==(null!=(t=this.state.s_hp)?t.m:null)&&(this.sendBindHTTP_Polling(),this.state.s_hp.m=903,this.state.traceState(),this.cancel_evtPollingTimeout(),this.schedule_evtIdleTimeout(Ke.plus(ye.sure(this.idleTimeout),this.options.retryDelay)))},evtKeepaliveTimeout:function(){var t;this.traceEvent("keepalive.timeout"),310==(null!=(t=this.state.s_w)?t.k:null)?(this.state.s_w.k=311,this.state.traceState(),this.cancel_evtKeepaliveTimeout(),this.schedule_evtStalledTimeout(this.options.stalledTimeout)):520==(null!=(t=this.state.s_ws)?t.k:null)?(this.state.s_ws.k=521,this.state.traceState(),this.cancel_evtKeepaliveTimeout(),this.schedule_evtStalledTimeout(this.options.stalledTimeout)):820==(null!=(t=this.state.s_hs)?t.k:null)&&(this.state.s_hs.k=821,this.state.traceState(),this.cancel_evtKeepaliveTimeout(),this.schedule_evtStalledTimeout(this.options.stalledTimeout))},evtStalledTimeout:function(){var t;this.traceEvent("stalled.timeout"),311==(null!=(t=this.state.s_w)?t.k:null)?(this.state.s_w.k=312,this.state.traceState(),this.cancel_evtStalledTimeout(),this.schedule_evtReconnectTimeout(this.options.reconnectTimeout)):521==(null!=(t=this.state.s_ws)?t.k:null)?(this.state.s_ws.k=522,this.state.traceState(),this.cancel_evtStalledTimeout(),this.schedule_evtReconnectTimeout(this.options.reconnectTimeout)):821==(null!=(t=this.state.s_hs)?t.k:null)&&(this.state.s_hs.k=822,this.state.traceState(),this.cancel_evtStalledTimeout(),this.schedule_evtReconnectTimeout(this.options.reconnectTimeout))},evtReconnectTimeout:function(){var t;if(this.traceEvent("reconnect.timeout"),312==(null!=(t=this.state.s_w)?t.k:null))if(0==this.options.sessionRecoveryTimeout)this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.stalled",this.state.goto_m_from_w(113),this.exit_w_to_m(),this.entry_m113(F.stalled_timeout);else{this.disposeWS(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="ws.stalled";var e=this.randomGenerator(this.options.firstRetryMaxDelay);this.state.goto_rec_from_w(),this.exit_w(),this.entry_rec(e,F.stalled_timeout)}else 522==(null!=(t=this.state.s_ws)?t.k:null)?0==this.options.sessionRecoveryTimeout?(this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.stalled",this.state.goto_m_from_ws(113),this.exit_ws_to_m(),this.entry_m113(F.stalled_timeout)):(this.disposeWS(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="ws.stalled",e=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_ws(),this.exit_ws(),this.entry_rec(e,F.stalled_timeout)):822==(null!=(t=this.state.s_hs)?t.k:null)&&(0==this.options.sessionRecoveryTimeout?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.stalled",this.state.goto_m_from_hs(113),this.exit_hs_to_m(),this.entry_m113(F.stalled_timeout)):(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:TRYING-RECOVERY"),this.cause="http.stalled",e=this.randomGenerator(this.options.firstRetryMaxDelay),this.state.goto_rec_from_hs(),this.exit_hs_to_rec(),this.entry_rec(e,F.stalled_timeout)))},evtRestartKeepalive:function(){var t;this.traceEvent("restart.keepalive"),null!=(null!=(t=this.state.s_w)?t.k:null)?(this.state.s_w.k=310,this.state.traceState(),this.exit_keepalive_unit(),this.schedule_evtKeepaliveTimeout(ye.sure(this.keepaliveInterval))):null!=(null!=(t=this.state.s_ws)?t.k:null)?(this.state.s_ws.k=520,this.state.traceState(),this.exit_keepalive_unit(),this.schedule_evtKeepaliveTimeout(ye.sure(this.keepaliveInterval))):null!=(null!=(t=this.state.s_hs)?t.k:null)&&(this.state.s_hs.k=820,this.state.traceState(),this.exit_keepalive_unit(),this.schedule_evtKeepaliveTimeout(ye.sure(this.keepaliveInterval)))},evtWSOK:function(){switch(this.traceEvent("WSOK"),Mi.isDebugEnabled()&&Mi.debug("WSOK"),this.state.s_m){case 121:this.state.s_m=122,this.state.traceState();break;case 150:if(null!=(e=this.state.s_tr))switch(e){case 240:null!=(e=null!=(t=this.state.s_ws)?t.m:null)&&501==e&&(this.state.s_ws.m=502,this.state.traceState());break;case 250:var t,e;null!=(e=null!=(t=this.state.s_wp)?t.m:null)&&601==e&&(this.sendBindWS_FirstPolling(),this.state.s_wp.m=602,this.state.s_wp.p=610,this.state.s_wp.c=620,this.state.s_wp.s=630,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtSendPendingControls(),this.evtSendPendingMessages(),this.schedule_evtIdleTimeout(Ke.plus(ye.sure(this.idleTimeout),this.options.retryDelay)))}}},evtCONERR:function(t,e){this.traceEvent("CONERR"),Mi.isDebugEnabled()&&Mi.debug("CONERR "+t+" "+e);var s=F.standardError(t,e),i=q.TC_standardError(t,e);if(122==this.state.s_m)switch(t){case 5:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.conerr."+t,this.state.s_m=110,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtRetry(s),this.evtRetryTimeout();break;case 4:case 6:case 20:case 40:case 41:case 48:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.conerr."+t;var n=this.waitingInterval(this.delayCounter.get_currentRetryDelay(),this.connectTs);this.state.s_m=112,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtRetry(s,n),this.schedule_evtRetryTimeout(n);break;default:this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_CONERR(t,e),this.state.s_m=100,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtTerminate(i)}else if(130==this.state.s_m)switch(t){case 5:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.conerr."+t,this.state.s_m=110,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtRetry(s),this.evtRetryTimeout();break;case 4:case 6:case 20:case 40:case 41:case 48:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.conerr."+t,n=this.waitingInterval(this.delayCounter.get_currentRetryDelay(),this.connectTs),this.state.s_m=112,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtRetry(s,n),this.schedule_evtRetryTimeout(n);break;default:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_CONERR(t,e),this.state.s_m=100,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtTerminate(i)}else if(140==this.state.s_m)switch(t){case 5:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ttl.conerr."+t,this.state.s_m=110,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtRetry(s),this.evtRetryTimeout();break;case 4:case 6:case 20:case 40:case 41:case 48:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ttl.conerr."+t,n=this.waitingInterval(this.delayCounter.get_currentRetryDelay(),this.connectTs),this.state.s_m=112,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtRetry(s,n),this.schedule_evtRetryTimeout(n);break;default:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_CONERR(t,e),this.state.s_m=100,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtTerminate(i)}else{var r,a;if(502==(null!=(r=this.state.s_ws)?r.m:null))switch(t){case 4:case 6:case 20:case 40:case 41:case 48:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.conerr."+t,this.state.goto_m_from_ws(112),this.exit_ws_to_m(),this.entry_m112(F.standardError(t,e));break;default:this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_CONERR(t,e),this.state.goto_m_from_ws(100),this.exit_ws_to_m(),this.evtTerminate(i)}else if(r=610==(null!=(a=this.state.s_wp)?a.p:null)||613==(null!=(a=this.state.s_wp)?a.p:null))switch(t){case 4:case 6:case 20:case 40:case 41:case 48:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.conerr."+t,this.state.goto_m_from_wp(112),this.exit_wp_to_m(),this.entry_m112(F.standardError(t,e));break;default:this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_CONERR(t,e),this.state.goto_m_from_wp(100),this.exit_wp_to_m(),this.evtTerminate(i)}else if(r=800==(null!=(a=this.state.s_hs)?a.m:null)||801==(null!=(a=this.state.s_hs)?a.m:null))switch(t){case 4:case 6:case 20:case 40:case 41:case 48:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.conerr."+t,this.state.goto_m_from_hs(112),this.exit_hs_to_m(),this.entry_m112(F.standardError(t,e));break;default:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_CONERR(t,e),this.state.goto_m_from_hs(100),this.exit_hs_to_m(),this.evtTerminate(i)}else if(r=900==(null!=(a=this.state.s_hp)?a.m:null)||903==(null!=(a=this.state.s_hp)?a.m:null))switch(t){case 4:case 6:case 20:case 40:case 41:case 48:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.conerr."+t,this.state.goto_m_from_hp(112),this.exit_hp_to_m(),this.entry_m112(F.standardError(t,e));break;default:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_CONERR(t,e),this.state.goto_m_from_hp(100),this.exit_hp_to_m(),this.evtTerminate(i)}else if(1001==this.state.s_rec)switch(t){case 4:case 6:case 20:case 40:case 41:case 48:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="recovery.conerr."+t,this.state.goto_m_from_rec(113),this.exit_rec_to_m(),this.entry_m113(s);break;default:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_CONERR(t,e),this.state.goto_m_from_rec(100),this.exit_rec_to_m(),this.evtTerminate(i)}}},evtEND:function(t,e){this.traceEvent("END"),Mi.isDebugEnabled()&&Mi.debug("END "+t+" "+e);var s=F.standardError(t,e),i=q.TC_standardError(t,e);if(300==(null!=(a=this.state.s_w)?a.p:null))switch(t){case 41:case 48:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.end."+t;var n=this.randomGenerator(this.options.firstRetryMaxDelay);this.state.clear_w(),this.state.goto_m_from_session(113),this.exit_w(),this.evtEndSession(),this.evtRetry(F.standardError(t,e),n),this.schedule_evtRetryTimeout(n);break;default:this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_END(t,e),this.state.clear_w(),this.state.goto_m_from_session(100),this.exit_w(),this.evtEndSession(),this.evtTerminate(i)}else if(502==(null!=(a=this.state.s_ws)?a.m:null))switch(t){case 41:case 48:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.end."+t,this.state.goto_m_from_ws(112),this.exit_ws_to_m(),this.entry_m112(F.standardError(t,e));break;default:this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_END(t,e),this.state.goto_m_from_ws(100),this.exit_ws_to_m(),this.evtTerminate(i)}else if(510==(null!=(a=this.state.s_ws)?a.p:null))switch(t){case 41:case 48:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.end."+t,this.state.goto_m_from_ws(113),this.exit_ws_to_m(),this.entry_m113(s);break;default:this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_END(t,e),this.state.goto_m_from_ws(100),this.exit_ws_to_m(),this.evtTerminate(i)}else if(a=610==(null!=(r=this.state.s_wp)?r.p:null)||613==(null!=(r=this.state.s_wp)?r.p:null))switch(t){case 41:case 48:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.end."+t,this.state.goto_m_from_wp(112),this.exit_wp_to_m(),this.entry_m112(F.standardError(t,e));break;default:this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_END(t,e),this.state.goto_m_from_wp(100),this.exit_wp_to_m(),this.evtTerminate(i)}else if(611==(null!=(a=this.state.s_wp)?a.p:null))switch(t){case 41:case 48:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.end."+t,this.state.goto_m_from_wp(113),this.exit_wp_to_m(),this.entry_m113(s);break;default:this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_END(t,e),this.state.goto_m_from_wp(100),this.exit_wp_to_m(),this.evtTerminate(i)}else if(a=800==(null!=(r=this.state.s_hs)?r.m:null)||801==(null!=(r=this.state.s_hs)?r.m:null))switch(t){case 41:case 48:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.end."+t,this.state.goto_m_from_hs(112),this.exit_hs_to_m(),this.entry_m112(F.standardError(t,e));break;default:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_END(t,e),this.state.goto_m_from_hs(100),this.exit_hs_to_m(),this.evtTerminate(i)}else if(810==(null!=(a=this.state.s_hs)?a.p:null))switch(t){case 41:case 48:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.end."+t,this.state.goto_m_from_hs(113),this.exit_hs_to_m(),this.entry_m113(s);break;default:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_END(t,e),this.state.goto_m_from_hs(100),this.exit_hs_to_m(),this.evtTerminate(i)}else{var r,a;if(a=900==(null!=(r=this.state.s_hp)?r.m:null)||903==(null!=(r=this.state.s_hp)?r.m:null))switch(t){case 41:case 48:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.end."+t,this.state.goto_m_from_hp(112),this.exit_hp_to_m(),this.entry_m112(F.standardError(t,e));break;default:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_END(t,e),this.state.goto_m_from_hp(100),this.exit_hp_to_m(),this.evtTerminate(i)}else if(901==(null!=(a=this.state.s_hp)?a.m:null))switch(t){case 41:case 48:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.end."+t,this.state.goto_m_from_hp(113),this.exit_hp_to_m(),this.entry_m113(s);break;default:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_END(t,e),this.state.goto_m_from_hp(100),this.exit_hp_to_m(),this.evtTerminate(i)}else if(1001==this.state.s_rec)switch(t){case 41:case 48:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="recovery.end."+t,this.state.goto_m_from_rec(113),this.exit_rec_to_m(),this.entry_m113(s);break;default:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_END(t,e),this.state.goto_m_from_rec(100),this.exit_rec_to_m(),this.evtTerminate(i)}}},evtERROR:function(t,e){this.traceEvent("ERROR"),Mi.isDebugEnabled()&&Mi.debug("ERROR "+t+" "+e);var s,i=q.TC_standardError(t,e);300==(null!=(s=this.state.s_w)?s.p:null)?(this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_ERROR(t,e),this.state.clear_w(),this.state.goto_m_from_session(100),this.exit_w(),this.evtEndSession(),this.evtTerminate(i)):510==(null!=(s=this.state.s_ws)?s.p:null)?(this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_ERROR(t,e),this.state.goto_m_from_ws(100),this.exit_ws_to_m(),this.evtTerminate(i)):620==(null!=(s=this.state.s_wp)?s.c:null)?(this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_ERROR(t,e),this.state.goto_m_from_wp(100),this.exit_wp_to_m(),this.evtTerminate(i)):1102==this.state.s_ctrl&&(this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_ERROR(t,e),this.state.goto_m_from_ctrl(100),this.exit_ctrl_to_m(),this.evtTerminate(i))},evtREQOK_withoutReqId:function(){this.traceEvent("REQOK"),Mi.isDebugEnabled()&&Mi.debug("REQOK"),1102==this.state.s_ctrl&&(this.state.s_ctrl=1102,this.state.traceState())},evtREQOK:function(t){this.traceEvent("REQOK"),Mi.isDebugEnabled()&&Mi.debug("REQOK "+t);var e=!0;1302==this.state.s_swt&&t==this.swt_lastReqId?(this.state.s_swt=1303,this.state.traceState(),e=this.evtREQOK_TransportRegion(t)):1202==this.state.s_bw&&t==this.bw_lastReqId?(this.state.s_bw=1200,this.state.traceState(),e=this.evtREQOK_TransportRegion(t),this.evtCheckBW()):e=this.evtREQOK_Forward(t),e&&this.evtREQOK_TransportRegion(t)},evtREQOK_Forward:function(t){return!0},evtREQOK_TransportRegion:function(t){var e;return 300==(null!=(e=this.state.s_w)?e.p:null)?(this.state.s_w.p=300,this.state.traceState(),this.doREQOK(t),this.evtRestartKeepalive()):510==(null!=(e=this.state.s_ws)?e.p:null)?(this.state.s_ws.p=510,this.state.traceState(),this.doREQOK(t),this.evtRestartKeepalive()):620==(null!=(e=this.state.s_wp)?e.c:null)?(this.state.s_wp.c=620,this.state.traceState(),this.doREQOK(t)):1102==this.state.s_ctrl&&(this.state.s_ctrl=1102,this.state.traceState(),this.doREQOK(t)),!1},evtREQERR:function(t,e,s){this.traceEvent("REQERR"),Mi.isDebugEnabled()&&Mi.debug("REQERR "+t+" "+e+" "+s);var i=!0;1302==this.state.s_swt&&t==this.swt_lastReqId?(this.state.s_swt=1301,this.state.traceState(),i=this.evtREQERR_TransportRegion(t,e,s)):1202==this.state.s_bw&&t==this.bw_lastReqId?(this.state.s_bw=1200,this.state.traceState(),i=this.evtREQERR_TransportRegion(t,e,s),this.evtCheckBW()):i=this.evtREQERR_Forward(t,e,s),i&&this.evtREQERR_TransportRegion(t,e,s)},evtREQERR_Forward:function(t,e,s){return!0},evtREQERR_TransportRegion:function(t,e,s){var i,n=F.standardError(e,s),r=q.TC_standardError(e,s);if(300==(null!=(i=this.state.s_w)?i.p:null))switch(e){case 20:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.reqerr."+e;var a=this.randomGenerator(this.options.firstRetryMaxDelay);this.state.clear_w(),this.state.goto_m_from_session(113),this.exit_w(),this.evtEndSession(),this.evtRetry(F.standardError(e,s),a),this.schedule_evtRetryTimeout(a);break;case 11:case 65:case 67:this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_REQERR(e,s),this.state.clear_w(),this.state.goto_m_from_session(100),this.exit_w(),this.evtEndSession(),this.evtTerminate(r);break;default:this.state.s_w.p=300,this.state.traceState(),this.doREQERR(t,e,s),this.evtRestartKeepalive()}else if(510==(null!=(i=this.state.s_ws)?i.p:null))switch(e){case 20:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.reqerr."+e+")",this.state.goto_m_from_ws(113),this.exit_ws_to_m(),this.entry_m113(n);break;case 11:case 65:case 67:this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_REQERR(e,s),this.state.goto_m_from_ws(100),this.exit_ws_to_m(),this.evtTerminate(r);break;default:this.state.s_ws.p=510,this.state.traceState(),this.doREQERR(t,e,s),this.evtRestartKeepalive()}else if(620==(null!=(i=this.state.s_wp)?i.c:null))switch(e){case 20:this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="ws.reqerr."+e,this.state.goto_m_from_wp(113),this.exit_wp_to_m(),this.entry_m113(n);break;case 11:case 65:case 67:this.disposeWS(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_REQERR(e,s),this.state.goto_m_from_wp(100),this.exit_wp_to_m(),this.evtTerminate(r);break;default:this.state.s_wp.c=620,this.state.traceState(),this.doREQERR(t,e,s)}else if(1102==this.state.s_ctrl)switch(e){case 20:this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="http.reqerr."+e,this.state.goto_m_from_ctrl(113),this.exit_ctrl_to_m(),this.entry_m113(n);break;case 11:case 65:case 67:this.disposeHTTP(),this.notifyStatus("DISCONNECTED"),this.notifyServerError_REQERR(e,s),this.state.goto_m_from_ctrl(100),this.exit_ctrl_to_m(),this.evtTerminate(r);break;default:this.state.s_ctrl=1102,this.state.traceState(),this.doREQERR(t,e,s)}return!1},evtPROG:function(t){this.traceEvent("PROG");var e=F.prog_mismatch(this.rec_serverProg,t);if(Mi.isDebugEnabled()&&Mi.debug("PROG "+t),300==(null!=(s=this.state.s_w)?s.p:null))t!=this.rec_serverProg?(this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="prog.mismatch."+t+"."+this.rec_serverProg,this.state.clear_w(),this.state.goto_m_from_session(113),this.exit_w(),this.evtEndSession(),this.entry_m113(e)):(this.state.s_w.p=300,this.state.traceState(),this.evtRestartKeepalive());else if(220==this.state.s_tr)t!=this.rec_serverProg?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="prog.mismatch."+t+"."+this.rec_serverProg,this.state.goto_m_from_session(113),this.cancel_evtTransportTimeout(),this.evtEndSession(),this.entry_m113(e)):(this.state.s_tr=220,this.state.traceState());else if(230==this.state.s_tr)t!=this.rec_serverProg?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="prog.mismatch."+t+"."+this.rec_serverProg,this.state.goto_m_from_session(113),this.cancel_evtTransportTimeout(),this.evtEndSession(),this.entry_m113(e)):(this.state.s_tr=230,this.state.traceState());else{var s;510==(null!=(s=this.state.s_ws)?s.p:null)?t!=this.rec_serverProg?(this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="prog.mismatch."+t+"."+this.rec_serverProg,this.state.goto_m_from_ws(113),this.exit_ws_to_m(),this.entry_m113(e)):(this.state.s_ws.p=510,this.state.traceState(),this.evtRestartKeepalive()):611==(null!=(s=this.state.s_wp)?s.p:null)?t!=this.rec_serverProg?(this.disposeWS(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="prog.mismatch."+t+"."+this.rec_serverProg,this.state.goto_m_from_wp(113),this.exit_wp_to_m(),this.entry_m113(e)):(this.state.s_wp.p=611,this.state.traceState()):810==(null!=(s=this.state.s_hs)?s.p:null)?t!=this.rec_serverProg?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="prog.mismatch."+t+"."+this.rec_serverProg,this.state.goto_m_from_hs(113),this.exit_hs_to_m(),this.entry_m113(e)):(this.state.s_hs.p=810,this.state.traceState(),this.evtRestartKeepalive()):901==(null!=(s=this.state.s_hp)?s.m:null)?t!=this.rec_serverProg?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="prog.mismatch."+t+"."+this.rec_serverProg,this.state.goto_m_from_hp(113),this.exit_hp_to_m(),this.entry_m113(e)):(this.state.s_hp.m=901,this.state.traceState()):1001==this.state.s_rec&&(t>this.rec_clientProg?(this.disposeHTTP(),this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="prog.mismatch."+t+"."+this.rec_serverProg,this.state.goto_m_from_rec(113),this.exit_rec_to_m(),this.entry_m113(e)):(this.state.s_rec=1001,this.state.traceState(),this.doPROG(t)))}},evtLOOP:function(t){if(this.traceEvent("LOOP"),Mi.isDebugEnabled()&&Mi.debug("LOOP "+t),300==(null!=(e=this.state.s_w)?e.p:null))this.closeWS(),this.cause="ws.loop",this.state.clear_w(),this.state.s_tr=200,this.state.traceState(),this.exit_w(),this.evtSwitchTransport();else if(220==this.state.s_tr)this.closeHTTP(),this.cause="http.loop",this.state.s_tr=200,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtSwitchTransport();else if(230==this.state.s_tr)this.closeHTTP(),this.cause="ttl.loop",this.state.s_tr=200,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtSwitchTransport();else{var e;510==(null!=(e=this.state.s_ws)?e.p:null)?(this.closeWS(),this.cause="ws.loop",this.state.clear_ws(),this.state.s_tr=200,this.state.traceState(),this.exit_ws(),this.evtSwitchTransport()):611==(null!=(e=this.state.s_wp)?e.p:null)?this.isSwitching()?(this.closeWS(),this.cause="ws.loop",this.state.clear_wp(),this.state.s_tr=200,this.state.traceState(),this.exit_wp(),this.evtSwitchTransport()):(this.doLOOP(t),this.state.s_wp.p=612,this.state.traceState(),this.cancel_evtIdleTimeout(),this.schedule_evtPollingTimeout(this.options.pollingInterval)):810==(null!=(e=this.state.s_hs)?e.p:null)?(this.closeHTTP(),this.cause="http.loop",this.state.s_hs.p=811,this.state.traceState(),this.evtSwitchTransport()):901==(null!=(e=this.state.s_hp)?e.m:null)?this.isSwitching()?(this.closeHTTP(),this.state.s_hp.m=904,this.state.traceState(),this.cancel_evtIdleTimeout(),this.evtSwitchTransport()):(this.doLOOP(t),this.closeHTTP(),this.state.s_hp.m=902,this.state.traceState(),this.cancel_evtIdleTimeout(),this.schedule_evtPollingTimeout(this.options.pollingInterval)):1001==this.state.s_rec&&(this.closeHTTP(),this.cause="recovery.loop",this.state.goto_200_from_rec(),this.exit_rec(),this.evtSwitchTransport())}},evtCONOK:function(t,e,s,i){if(this.traceEvent("CONOK"),Mi.isDebugEnabled()&&Mi.debug("CONOK "+t+" "+e+" "+s+" "+i),122==this.state.s_m)this.doCONOK_CreateWS(t,e,s,i),this.resetCurrentRetryDelay(),this.notifyStatus("CONNECTED:WS-STREAMING"),this.state.s_m=150,this.state.s_tr=210,this.state.s_w=new V(300,310,340),this.state.s_rhb=320,this.state.s_slw=330,this.state.s_swt=1300,this.state.s_bw=1200,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtSendPendingControls(),this.evtSendPendingMessages(),this.evtStartSession(),this.schedule_evtKeepaliveTimeout(ye.sure(this.keepaliveInterval)),this.evtSelectRhb(),this.evtCheckTransport(),this.evtCheckBW();else if(130==this.state.s_m)this.doCONOK_CreateHTTP(t,e,s,i),this.resetCurrentRetryDelay(),this.notifyStatus("CONNECTED:STREAM-SENSING"),this.state.s_m=150,this.state.s_tr=220,this.state.s_swt=1300,this.state.s_bw=1200,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtStartSession(),this.schedule_evtTransportTimeout(this.options.retryDelay),this.evtCheckTransport(),this.evtCheckBW();else if(140==this.state.s_m)this.doCONOK_CreateHTTP(t,e,s,i),this.resetCurrentRetryDelay(),this.notifyStatus("CONNECTED:STREAM-SENSING"),this.state.s_m=150,this.state.s_tr=230,this.state.s_swt=1300,this.state.s_bw=1200,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtStartSession(),this.schedule_evtTransportTimeout(this.options.retryDelay),this.evtCheckTransport(),this.evtCheckBW();else{var n;502==(null!=(n=this.state.s_ws)?n.m:null)?(this.doCONOK_BindWS_Streaming(t,e,s,i),this.notifyStatus("CONNECTED:WS-STREAMING"),this.state.s_ws.m=503,this.state.s_ws.p=510,this.state.s_ws.k=520,this.state.s_ws.s=550,this.state.s_rhb=320,this.state.s_slw=330,this.state.traceState(),this.cancel_evtTransportTimeout(),this.evtSendPendingControls(),this.evtSendPendingMessages(),this.schedule_evtKeepaliveTimeout(ye.sure(this.keepaliveInterval)),this.evtSelectRhb()):610==(null!=(n=this.state.s_wp)?n.p:null)?(this.doCONOK_BindWS_Polling(t,e,s,i),this.notifyStatus("CONNECTED:WS-POLLING"),this.state.s_wp.p=611,this.state.traceState()):613==(null!=(n=this.state.s_wp)?n.p:null)?(this.doCONOK_BindWS_Polling(t,e,s,i),this.state.s_wp.p=611,this.state.traceState()):800==(null!=(n=this.state.s_hs)?n.m:null)||801==(null!=(n=this.state.s_hs)?n.m:null)?(this.doCONOK_BindHTTP_Streaming(t,e,s,i),this.notifyStatus("CONNECTED:HTTP-STREAMING"),this.state.s_hs.m=802,this.state.s_hs.p=810,this.state.s_hs.k=820,this.state.s_rhb=320,this.state.s_slw=330,this.state.traceState(),this.cancel_evtTransportTimeout(),this.schedule_evtKeepaliveTimeout(ye.sure(this.keepaliveInterval)),this.evtSelectRhb()):900==(null!=(n=this.state.s_hp)?n.m:null)?(this.doCONOK_BindHTTP_Polling(t,e,s,i),this.notifyStatus("CONNECTED:HTTP-POLLING"),this.state.s_hp.m=901,this.state.traceState()):903==(null!=(n=this.state.s_hp)?n.m:null)&&(this.doCONOK_BindHTTP_Polling(t,e,s,i),this.state.s_hp.m=901,this.state.traceState())}},evtSERVNAME:function(t){this.traceEvent("SERVNAME"),Mi.isDebugEnabled()&&Mi.debug("SERVNAME "+t),this.state.inPushing()&&(this.doSERVNAME(t),this.state.inStreaming()&&this.evtRestartKeepalive())},evtCLIENTIP:function(t){this.traceEvent("CLIENTIP"),Mi.isDebugEnabled()&&Mi.debug("CLIENTIP "+t),this.state.inPushing()&&(this.doCLIENTIP(t),this.state.inStreaming()&&this.evtRestartKeepalive())},evtCONS:function(t){this.traceEvent("CONS"),Mi.isDebugEnabled()&&Mi.debug("CONS "+p.string(t)),this.state.inPushing()&&(this.doCONS(t),this.state.inStreaming()&&this.evtRestartKeepalive())},evtPROBE:function(){this.traceEvent("PROBE"),Mi.isDebugEnabled()&&Mi.debug("PROBE"),this.clientEventDispatcher.onServerKeepalive(),this.state.inPushing()&&this.state.inStreaming()&&this.evtRestartKeepalive()},evtNOOP:function(){this.traceEvent("NOOP"),this.state.inPushing()&&this.state.inStreaming()&&this.evtRestartKeepalive()},evtSYNC:function(t){this.traceEvent("SYNC"),Mi.isDebugEnabled()&&Mi.debug("SYNC "+t);var e,s,i=!0;(s=300==(null!=(e=this.state.s_w)?e.p:null)||510==(null!=(e=this.state.s_ws)?e.p:null),!s&&810!=(null!=(s=this.state.s_hs)?s.p:null))?(!!(s=220==this.state.s_tr||230==this.state.s_tr||611==(null!=(e=this.state.s_wp)?e.p:null))||901==(null!=(s=this.state.s_hp)?s.m:null)||1001==this.state.s_rec)&&(i=this.evtSYNC_PushingRegion(t)):(i=this.evtSYNC_PushingRegion(t),this.evtRestartKeepalive());i&&this.evtSYNC_PushingRegion(t)},evtSYNC_PushingRegion:function(t){var e=1e3*t;if(null!=this.state.s_slw){var s=this.state.s_slw;if(null!=s)switch(s){case 330:this.doSYNC(e),this.state.s_slw=331,this.state.traceState();break;case 331:var i=this.doSYNC_G(e);this.state.s_slw=332,this.state.traceState(),this.evtCheckAvg(i);break;case 333:i=this.doSYNC_NG(e),this.state.s_slw=332,this.state.traceState(),this.evtCheckAvg(i)}}return!1},evtMSGDONE:function(t,e){this.traceEvent("MSGDONE"),Mi.isDebugEnabled()&&Mi.debug("MSGDONE "+t+" "+e),this.state.inPushing()&&(this.isFreshData()?(this.doMSGDONE(t,e),this.state.inStreaming()&&this.evtRestartKeepalive()):(this.onStaleData(),this.state.inStreaming()&&this.evtRestartKeepalive()))},evtMSGFAIL:function(t,e,s,i){this.traceEvent("MSGFAIL"),Mi.isDebugEnabled()&&Mi.debug("MSGFAIL "+t+" "+e+" "+s+" "+i),this.state.inPushing()&&(this.isFreshData()?(this.doMSGFAIL(t,e,s,i),this.state.inStreaming()&&this.evtRestartKeepalive()):(this.onStaleData(),this.state.inStreaming()&&this.evtRestartKeepalive()))},evtU:function(t,e,s,i){this.traceEvent("U"),Mi.isDebugEnabled()&&Mi.debug(""+i),this.state.inPushing()&&(this.isFreshData()?(this.doU(t,e,s),this.state.inStreaming()&&this.evtRestartKeepalive()):(this.onStaleData(),this.state.inStreaming()&&this.evtRestartKeepalive()))},evtSUBOK:function(t,e,s){this.traceEvent("SUBOK"),Mi.isDebugEnabled()&&Mi.debug("SUBOK "+t+" "+e+" "+s),this.state.inPushing()&&(this.isFreshData()?(this.doSUBOK(t,e,s),this.state.inStreaming()&&this.evtRestartKeepalive()):(this.onStaleData(),this.state.inStreaming()&&this.evtRestartKeepalive()))},evtSUBCMD:function(t,e,s,i,n){this.traceEvent("SUBCMD"),Mi.isDebugEnabled()&&Mi.debug("SUBCMD "+t+" "+e+" "+s+" "+i+" "+n),this.state.inPushing()&&(this.isFreshData()?(this.doSUBCMD(t,e,s,i,n),this.state.inStreaming()&&this.evtRestartKeepalive()):(this.onStaleData(),this.state.inStreaming()&&this.evtRestartKeepalive()))},evtUNSUB:function(t){this.traceEvent("UNSUB"),Mi.isDebugEnabled()&&Mi.debug("UNSUB "+t),this.state.inPushing()&&(this.isFreshData()?(this.doUNSUB(t),this.state.inStreaming()&&this.evtRestartKeepalive()):(this.onStaleData(),this.state.inStreaming()&&this.evtRestartKeepalive()))},evtEOS:function(t,e){this.traceEvent("EOS"),Mi.isDebugEnabled()&&Mi.debug("EOS "+t+" "+e),this.state.inPushing()&&(this.isFreshData()?(this.doEOS(t,e),this.state.inStreaming()&&this.evtRestartKeepalive()):(this.onStaleData(),this.state.inStreaming()&&this.evtRestartKeepalive()))},evtCS:function(t,e){this.traceEvent("CS"),Mi.isDebugEnabled()&&Mi.debug("CS "+t+" "+e),this.state.inPushing()&&(this.isFreshData()?(this.doCS(t,e),this.state.inStreaming()&&this.evtRestartKeepalive()):(this.onStaleData(),this.state.inStreaming()&&this.evtRestartKeepalive()))},evtOV:function(t,e,s){this.traceEvent("OV"),Mi.isDebugEnabled()&&Mi.debug("OV "+t+" "+e+" "+s),this.state.inPushing()&&(this.isFreshData()?(this.doOV(t,e,s),this.state.inStreaming()&&this.evtRestartKeepalive()):(this.onStaleData(),this.state.inStreaming()&&this.evtRestartKeepalive()))},evtCONF:function(t,e){this.traceEvent("CONF"),Mi.isDebugEnabled()&&Mi.debug("CONF "+t+" "+p.string(e)),this.state.inPushing()&&(this.isFreshData()?(this.doCONF(t,e),this.state.inStreaming()&&this.evtRestartKeepalive()):(this.onStaleData(),this.state.inStreaming()&&this.evtRestartKeepalive()))},evtCheckAvg:function(t){if(this.traceEvent("check.avg"),332==this.state.s_slw)switch(t._hx_index){case 0:this.state.s_slw=331,this.state.traceState();break;case 1:this.state.s_slw=333,this.state.traceState();break;case 2:this.disableStreaming(),this.cause="slow",this.state.s_slw=334,this.state.traceState(),this.evtForcePolling()}},evtSendPendingControls:function(){this.traceEvent("send.pending.controls");var t,e=this.getPendingControls();340!=(null!=(t=this.state.s_w)?t.s:null)||m.empty(e)?550!=(null!=(t=this.state.s_ws)?t.s:null)||m.empty(e)?630!=(null!=(t=this.state.s_wp)?t.s:null)||m.empty(e)||(this.sendPengingControlsWS(e),this.state.s_wp.s=630,this.state.traceState()):(this.sendPengingControlsWS(e),this.state.s_ws.s=550,this.state.traceState(),this.evtRestartHeartbeat()):(this.sendPengingControlsWS(e),this.state.s_w.s=340,this.state.traceState(),this.evtRestartHeartbeat())},evtSendPendingMessages:function(){var t;this.traceEvent("send.pending.messages"),340==(null!=(t=this.state.s_w)?t.s:null)&&m.exists(this.messageManagers,(function(t){return t.isPending()}))?(this.sendPendingMessagesWS(),this.state.s_w.s=340,this.state.traceState(),this.genAckMessagesWS(),this.evtRestartHeartbeat()):550==(null!=(t=this.state.s_ws)?t.s:null)&&m.exists(this.messageManagers,(function(t){return t.isPending()}))?(this.sendPendingMessagesWS(),this.state.s_ws.s=550,this.state.traceState(),this.genAckMessagesWS(),this.evtRestartHeartbeat()):630==(null!=(t=this.state.s_wp)?t.s:null)&&m.exists(this.messageManagers,(function(t){return t.isPending()}))&&(this.sendPendingMessagesWS(),this.state.s_wp.s=630,this.state.traceState(),this.genAckMessagesWS())},evtSelectRhb:function(){this.traceEvent("select.rhb"),320==this.state.s_rhb&&(0==this.rhb_grantedInterval?0==this.options.reverseHeartbeatInterval?(this.state.s_rhb=321,this.state.traceState()):(this.rhb_currentInterval=this.options.reverseHeartbeatInterval,this.state.s_rhb=322,this.state.traceState(),this.schedule_evtRhbTimeout(this.rhb_currentInterval)):this.options.reverseHeartbeatInterval>0&&this.options.reverseHeartbeatInterval<ye.sure(this.rhb_grantedInterval)?(this.rhb_currentInterval=this.options.reverseHeartbeatInterval,this.state.s_rhb=323,this.state.traceState(),this.schedule_evtRhbTimeout(this.rhb_currentInterval)):(this.rhb_currentInterval=this.rhb_grantedInterval,this.state.s_rhb=323,this.state.traceState(),this.schedule_evtRhbTimeout(ye.sure(this.rhb_currentInterval))))},evtExtSetReverseHeartbeatInterval:function(){if(this.traceEvent("setReverseHeartbeatInterval"),null!=this.state.s_rhb){var t=this.state.s_rhb;if(null!=t)switch(t){case 321:0!=this.options.reverseHeartbeatInterval&&(this.rhb_currentInterval=this.options.reverseHeartbeatInterval,this.state.s_rhb=322,this.state.traceState(),this.schedule_evtRhbTimeout(this.rhb_currentInterval));break;case 322:0==this.options.reverseHeartbeatInterval?(this.state.s_rhb=321,this.state.traceState(),this.cancel_evtRhbTimeout()):(this.rhb_currentInterval=this.options.reverseHeartbeatInterval,this.state.s_rhb=322,this.state.traceState());break;case 323:this.options.reverseHeartbeatInterval>0&&this.options.reverseHeartbeatInterval<ye.sure(this.rhb_grantedInterval)?(this.rhb_currentInterval=this.options.reverseHeartbeatInterval,this.state.s_rhb=323,this.state.traceState()):(this.rhb_currentInterval=this.rhb_grantedInterval,this.state.s_rhb=323,this.state.traceState())}}},evtRestartHeartbeat:function(){if(this.traceEvent("restart.heartbeat"),null!=this.state.s_rhb){var t=this.state.s_rhb;if(null!=t)switch(t){case 322:this.state.s_rhb=322,this.state.traceState(),this.cancel_evtRhbTimeout(),this.schedule_evtRhbTimeout(ye.sure(this.rhb_currentInterval));break;case 323:this.state.s_rhb=323,this.state.traceState(),this.cancel_evtRhbTimeout(),this.schedule_evtRhbTimeout(ye.sure(this.rhb_currentInterval));break;case 324:0==this.rhb_grantedInterval?0!=this.options.reverseHeartbeatInterval?(this.rhb_currentInterval=this.options.reverseHeartbeatInterval,this.state.s_rhb=322,this.state.traceState(),this.schedule_evtRhbTimeout(this.rhb_currentInterval)):(this.state.s_rhb=321,this.state.traceState()):this.options.reverseHeartbeatInterval>0&&this.options.reverseHeartbeatInterval<ye.sure(this.rhb_grantedInterval)?(this.rhb_currentInterval=this.options.reverseHeartbeatInterval,this.state.s_rhb=323,this.state.traceState(),this.schedule_evtRhbTimeout(this.rhb_currentInterval)):(this.rhb_currentInterval=this.rhb_grantedInterval,this.state.s_rhb=323,this.state.traceState(),this.schedule_evtRhbTimeout(ye.sure(this.rhb_currentInterval)))}}},evtRhbTimeout:function(){this.traceEvent("rhb.timeout"),(322==this.state.s_rhb||323==this.state.s_rhb)&&(this.state.s_rhb=324,this.state.traceState(),this.cancel_evtRhbTimeout(),this.evtSendHeartbeat())},evtDisposeCtrl:function(){this.traceEvent("du:dispose.ctrl"),this.disposeCtrl()},evtStartRecovery:function(){this.traceEvent("start.recovery"),1e3==this.state.s_rec&&(this.recoverTs=_.now()/1e3,this.state.s_rec=1e3,this.state.traceState())},evtRecoveryTimeout:function(){this.traceEvent("recovery.timeout"),1e3==this.state.s_rec&&(this.sendRecovery(),this.state.s_rec=1001,this.state.traceState(),this.cancel_evtRecoveryTimeout(),this.schedule_evtTransportTimeout(this.options.retryDelay))},evtCheckRecoveryTimeout:function(t){if(this.traceEvent("check.recovery.timeout"),1002==this.state.s_rec){var e=this.options.retryDelay;if(We.plus(this.connectTs,e)<We.plus(this.recoverTs,this.options.sessionRecoveryTimeout)){this.cause="recovery.error";var s=We.minus(_.now()/1e3,this.connectTs),i=e>Ue.toMillis(s)?Ke.minus(e,Ue.toMillis(s)):Ke.ZERO;this.state.s_rec=1003,this.state.traceState(),Oi.isErrorEnabled()&&(i>0?Oi.isErrorEnabled()&&Oi.error("Retrying recovery in "+i+"ms. Cause: "+p.string(t)):Oi.isErrorEnabled()&&Oi.error("Retrying recovery. Cause: "+p.string(t))),this.schedule_evtRetryTimeout(i)}else this.notifyStatus("DISCONNECTED:WILL-RETRY"),this.cause="recovery.timeout",this.state.goto_m_from_rec(113),this.exit_rec_to_m(),this.entry_m113(F.recovery_timeout)}},evtCreate:function(){this.traceEvent("du:create"),(20==this.state.s_du||23==this.state.s_du)&&(this.state.s_du=21,this.state.traceState())},evtCheckTransport:function(){if(this.traceEvent("check.transport"),1300==this.state.s_swt)if(220==this.state.s_tr||230==this.state.s_tr||260==this.state.s_tr)this.state.s_swt=1301,this.state.traceState();else{var t=this.getBestForBinding();t==P.BFB_ws_streaming&&(210==this.state.s_tr||240==this.state.s_tr)||t==P.BFB_http_streaming&&270==this.state.s_tr&&710==this.state.s_h||t==P.BFB_ws_polling&&250==this.state.s_tr||t==P.BFB_http_polling&&270==this.state.s_tr&&720==this.state.s_h?(this.state.s_swt=1301,this.state.traceState()):(this.state.s_swt=1302,this.state.traceState(),this.evtSendControl(ye.sure(this.switchRequest)))}},evtCheckBW:function(){this.traceEvent("check.bw"),1200==this.state.s_bw&&(this.bw_requestedMaxBandwidth!=this.options.requestedMaxBandwidth&&this.options.realMaxBandwidth!=ss.BWUnmanaged?(this.bw_requestedMaxBandwidth=this.options.requestedMaxBandwidth,this.state.s_bw=1202,this.state.traceState(),this.evtSendControl(ye.sure(this.constrainRequest))):(this.state.s_bw=1201,this.state.traceState()))},evtCheckCtrlRequests:function(){if(this.traceEvent("check.ctrl.requests"),1100==this.state.s_ctrl){var t=this.getPendingControls();m.empty(t)?m.exists(this.messageManagers,(function(t){return t.isPending()}))?(this.sendPendingMessagesHTTP(),this.state.s_ctrl=1102,this.state.traceState(),this.evtRestartHeartbeat(),this.schedule_evtCtrlTimeout(this.options.retryDelay)):324==this.state.s_rhb?(this.sendHeartbeatHTTP(),this.state.s_ctrl=1102,this.state.traceState(),this.evtRestartHeartbeat(),this.schedule_evtCtrlTimeout(this.options.retryDelay)):(this.state.s_ctrl=1101,this.state.traceState()):(this.sendPendingControlsHTTP(t),this.state.s_ctrl=1102,this.state.traceState(),this.evtRestartHeartbeat(),this.schedule_evtCtrlTimeout(this.options.retryDelay))}},evtCtrlDone:function(){this.traceEvent("ctrl.done"),1102==this.state.s_ctrl&&(this.closeCtrl(),this.state.s_ctrl=1100,this.state.traceState(),this.cancel_evtCtrlTimeout(),this.evtCheckCtrlRequests())},evtCtrlError:function(){if(this.traceEvent("ctrl.error"),1102==this.state.s_ctrl){this.disposeCtrl();var t=this.waitingInterval(this.options.retryDelay,this.ctrl_connectTs);this.state.s_ctrl=1103,this.state.traceState(),this.cancel_evtCtrlTimeout(),this.schedule_evtCtrlTimeout(t)}},evtCtrlTimeout:function(){if(this.traceEvent("ctrl.timeout"),null!=this.state.s_ctrl)if(1102==this.state.s_ctrl){this.disposeCtrl();var t=this.waitingInterval(this.options.retryDelay,this.ctrl_connectTs);this.state.s_ctrl=1103,this.state.traceState(),this.cancel_evtCtrlTimeout(),this.schedule_evtCtrlTimeout(t)}else 1103==this.state.s_ctrl&&(this.state.s_ctrl=1100,this.state.traceState(),this.cancel_evtCtrlTimeout(),this.evtCheckCtrlRequests())},evtSendControl:function(t){var e;this.traceEvent("send.control"),340==(null!=(e=this.state.s_w)?e.s:null)?(this.sendControlWS(t),this.state.s_w.s=340,this.state.traceState(),this.evtRestartHeartbeat()):550==(null!=(e=this.state.s_ws)?e.s:null)?(this.sendControlWS(t),this.state.s_ws.s=550,this.state.traceState(),this.evtRestartHeartbeat()):630==(null!=(e=this.state.s_wp)?e.s:null)?(this.sendControlWS(t),this.state.s_wp.s=630,this.state.traceState()):1101==this.state.s_ctrl&&(this.state.s_ctrl=1100,this.state.traceState(),this.evtCheckCtrlRequests())},evtSendHeartbeat:function(){var t;this.traceEvent("send.heartbeat"),340==(null!=(t=this.state.s_w)?t.s:null)?(this.sendHeartbeatWS(),this.state.s_w.s=340,this.state.traceState(),this.evtRestartHeartbeat()):550==(null!=(t=this.state.s_ws)?t.s:null)?(this.sendHeartbeatWS(),this.state.s_ws.s=550,this.state.traceState(),this.evtRestartHeartbeat()):1101==this.state.s_ctrl&&(this.state.s_ctrl=1100,this.state.traceState(),this.evtCheckCtrlRequests())},evtStartSession:function(){this.traceEvent("du:start.session"),Oi.isInfoEnabled()&&Oi.info("Starting new session: "+this.sessionId),21==this.state.s_du&&(this.state.s_du=22,this.state.traceState())},evtEndSession:function(){Oi.isInfoEnabled()&&Oi.info("Destroying session: "+this.sessionId)},evtRetry:function(t,e){this.traceEvent("du:retry"),Oi.isErrorEnabled()&&(null!=e&&e>0?Oi.isErrorEnabled()&&Oi.error("Retrying connection in "+e+"ms. Cause: "+B(t)):Oi.isErrorEnabled()&&Oi.error("Retrying connection. Cause: "+B(t)));var s=!0;switch(this.state.s_du){case 21:this.resetSequenceMap(),this.state.s_du=23,this.state.traceState(),s=this.evtRetry_NextRegion(),this.genAbortMessages();break;case 22:this.disposeSession(),this.state.s_du=23,this.state.traceState(),s=this.evtRetry_NextRegion(),this.genAbortSubscriptions(),this.genAbortMessages()}s&&(s=this.evtRetry_NextRegion())},evtRetry_NextRegion:function(){return!1},evtTerminate:function(t){if(this.traceEvent("du:terminate"),Oi.isInfoEnabled()&&2==t._hx_index&&Oi.isInfoEnabled()&&Oi.info("Disconnected. Cause: Requested by user"),Oi.isErrorEnabled())switch(t._hx_index){case 0:Oi.isErrorEnabled()&&Oi.error("Disconnected. Cause: "+t.code+" - "+t.msg);break;case 1:Oi.isErrorEnabled()&&Oi.error("Disconnected. Cause: "+t.error)}var e=!0;switch(this.state.s_du){case 20:case 21:case 23:this.disposeClient(),this.state.s_du=20,this.state.traceState(),e=this.evtTerminate_NextRegion(),this.genAbortMessages();break;case 22:this.disposeSession(),this.disposeClient(),this.state.s_du=20,this.state.traceState(),e=this.evtTerminate_NextRegion(),this.genAbortSubscriptions(),this.genAbortMessages()}e&&(e=this.evtTerminate_NextRegion())},evtTerminate_NextRegion:function(){return this.evtTerminate_NetworkReachabilityRegion()},evtTerminate_NetworkReachabilityRegion:function(){switch(this.state.s_nr){case 1410:case 1411:case 1412:var t=this.nr_reachabilityManager;this.nr_reachabilityManager=null,this.state.s_nr=1400,this.state.traceState(),null!=t&&t.stopListening()}return!1},evtRetryTimeout:function(){switch(this.traceEvent("retry.timeout"),this.state.s_m){case 110:this.notifyStatus("CONNECTING"),this.sendCreateTTL(),this.state.s_m=140,this.state.traceState(),this.evtCreate(),this.schedule_evtTransportTimeout(6e4);break;case 111:this.notifyStatus("CONNECTING"),this.delayCounter.increase(),this.sendCreateTTL(),this.state.s_m=140,this.state.traceState(),this.cancel_evtRetryTimeout(),this.evtCreate(),this.schedule_evtTransportTimeout(6e4);break;case 112:this.delayCounter.increase(),this.state.s_m=116,this.state.traceState(),this.cancel_evtRetryTimeout(),this.evtSelectCreate();break;case 113:this.state.s_m=116,this.state.traceState(),this.cancel_evtRetryTimeout(),this.evtSelectCreate();break;case 115:this.state.s_m=116,this.state.traceState(),this.evtSelectCreate();break;case 150:1003==this.state.s_rec&&(this.sendRecovery(),this.state.s_rec=1001,this.state.traceState(),this.cancel_evtRetryTimeout(),this.schedule_evtTransportTimeout(this.options.retryDelay))}},evtExtSetForcedTransport:function(){this.traceEvent("setForcedTransport"),1301==this.state.s_swt&&(this.state.s_swt=1300,this.state.traceState(),this.evtCheckTransport())},evtExtSetRequestedMaxBandwidth:function(){this.traceEvent("setRequestedMaxBandwidth"),1201==this.state.s_bw&&(this.state.s_bw=1200,this.state.traceState(),this.evtCheckBW())},evtForceSlowing:function(){this.traceEvent("force.slowing"),1301==this.state.s_swt&&(this.state.s_swt=1300,this.state.traceState(),this.evtCheckTransport())},evtForcePolling:function(){this.traceEvent("force.polling"),1301==this.state.s_swt&&(this.state.s_swt=1300,this.state.traceState(),this.evtCheckTransport())},evtSendMessage:function(t){var e;this.traceEvent("send.message"),340==(null!=(e=this.state.s_w)?e.s:null)?(this.sendMsgWS(t),this.state.s_w.s=340,this.state.traceState(),t.evtWSSent(),this.evtRestartHeartbeat()):550==(null!=(e=this.state.s_ws)?e.s:null)?(this.sendMsgWS(t),this.state.s_ws.s=550,this.state.traceState(),t.evtWSSent(),this.evtRestartHeartbeat()):630==(null!=(e=this.state.s_wp)?e.s:null)?(this.sendMsgWS(t),this.state.s_wp.s=630,this.state.traceState(),t.evtWSSent()):1101==this.state.s_ctrl&&(this.state.s_ctrl=1100,this.state.traceState(),this.evtCheckCtrlRequests())},evtSwitchTransport:function(){this.traceEvent("switch.transport");var t=!0;1302!=this.state.s_swt&&1303!=this.state.s_swt||(this.state.s_swt=1300,this.state.traceState(),t=this.evtSwitchTransport_forwardToTransportRegion(),this.evtCheckTransport()),t&&(t=this.evtSwitchTransport_forwardToTransportRegion())},evtSwitchTransport_forwardToTransportRegion:function(){var t,e=q.TC_otherError("Selected transport "+this.options.forcedTransport+" is not available");if(200==this.state.s_tr)switch(this.getBestForBinding()._hx_index){case 0:this.notifyStatus("DISCONNECTED"),this.state.goto_m_from_session(100),this.evtEndSession(),this.evtTerminate(e);break;case 1:this.openWS_Bind(),this.state.s_tr=240,this.state.s_ws=new K(500),this.state.traceState(),this.schedule_evtTransportTimeout(this.options.retryDelay);break;case 2:this.openWS_Bind(),this.state.s_tr=250,this.state.s_wp=new G(600),this.state.traceState(),this.schedule_evtTransportTimeout(this.options.retryDelay);break;case 3:this.sendBindHTTP_Streaming(),this.state.s_tr=270,this.state.s_h=710,this.state.s_hs=new z(800),this.state.s_ctrl=1100,this.state.traceState(),this.evtCheckCtrlRequests(),this.schedule_evtTransportTimeout(this.options.retryDelay);break;case 4:this.sendBindHTTP_Polling(),this.state.s_tr=270,this.state.s_h=720,this.state.s_hp=new Y(900),this.state.s_rhb=320,this.state.s_ctrl=1100,this.state.traceState(),this.evtCheckCtrlRequests(),this.schedule_evtIdleTimeout(Ke.plus(ye.sure(this.idleTimeout),this.options.retryDelay)),this.evtSelectRhb()}else if(811==(null!=(t=this.state.s_hs)?t.p:null))switch(this.getBestForBinding()._hx_index){case 0:this.notifyStatus("DISCONNECTED"),this.state.goto_m_from_hs(100),this.exit_hs_to_m(),this.evtTerminate(e);break;case 1:this.openWS_Bind(),this.state.clear_hs(),this.state.s_h=null,this.state.s_ctrl=null,this.state.s_tr=240,this.state.s_ws=new K(500),this.state.traceState(),this.exit_hs(),this.exit_ctrl(),this.schedule_evtTransportTimeout(this.options.retryDelay);break;case 2:this.openWS_Bind(),this.state.clear_hs(),this.state.s_h=null,this.state.s_ctrl=null,this.state.s_tr=250,this.state.s_wp=new G(600),this.state.traceState(),this.exit_hs(),this.exit_ctrl(),this.schedule_evtTransportTimeout(this.options.retryDelay);break;case 3:this.sendBindHTTP_Streaming(),this.state.s_hs=new z(800),this.state.traceState(),this.exit_hs(),this.schedule_evtTransportTimeout(this.options.retryDelay);break;case 4:this.sendBindHTTP_Polling(),this.state.clear_hs(),this.state.s_h=720,this.state.s_hp=new Y(900),this.state.s_rhb=320,this.state.traceState(),this.exit_hs(),this.schedule_evtIdleTimeout(Ke.plus(ye.sure(this.idleTimeout),this.options.retryDelay)),this.evtSelectRhb()}else if(904==(null!=(t=this.state.s_hp)?t.m:null))switch(this.getBestForBinding()._hx_index){case 0:this.notifyStatus("DISCONNECTED"),this.state.goto_m_from_hp(100),this.exit_hp_to_m(),this.evtTerminate(e);break;case 1:this.openWS_Bind(),this.state.clear_hp(),this.state.s_h=null,this.state.s_ctrl=null,this.state.s_tr=240,this.state.s_ws=new K(500),this.state.traceState(),this.exit_hp(),this.exit_ctrl(),this.schedule_evtTransportTimeout(this.options.retryDelay);break;case 2:this.openWS_Bind(),this.state.clear_hp(),this.state.s_h=null,this.state.s_ctrl=null,this.state.s_tr=250,this.state.s_wp=new G(600),this.state.traceState(),this.exit_hp(),this.exit_ctrl(),this.schedule_evtTransportTimeout(this.options.retryDelay);break;case 3:this.sendBindHTTP_Streaming(),this.state.clear_hp(),this.state.s_h=710,this.state.s_hs=new z(800),this.state.traceState(),this.exit_hp(),this.schedule_evtTransportTimeout(this.options.retryDelay);break;case 4:this.sendBindHTTP_Polling(),this.state.s_hp=new Y(900),this.state.s_rhb=320,this.state.traceState(),this.exit_hp(),this.schedule_evtIdleTimeout(Ke.plus(ye.sure(this.idleTimeout),this.options.retryDelay)),this.evtSelectRhb()}return!1},onFreshData:function(){if(this.rec_serverProg!=this.rec_clientProg)throw new be("Assertion failure: rec_serverProg == rec_clientProg");this.rec_serverProg+=1,this.rec_clientProg+=1},onStaleData:function(){if(this.rec_serverProg>=this.rec_clientProg)throw new be("Assertion failure: rec_serverProg < rec_clientProg");this.rec_serverProg+=1},isFreshData:function(){return this.rec_serverProg==this.rec_clientProg},openWS:function(t,e){var s=this,i=function(t){Di.submit(ei.a((function(){xe.synchronized(s.lock,(function(){t.isDisposed()||s.evtWSOpen()}))})))},n=function(t,e){Di.submit(ei.a((function(){xe.synchronized(s.lock,(function(){if(!t.isDisposed())try{s.evtMessage(e)}catch(t){var i=w.caught(t);Oi.isErrorEnabled()&&Oi.error(i.get_message()+"\n"+i.details()),s.evtExtDisconnect(q.TC_standardError(61,i.get_message()))}}))})))},r=function(t,e){Di.submit(ei.a((function(){xe.synchronized(s.lock,(function(){t.isDisposed()||s.evtTransportError()}))})))};return this.wsFactory(t,e,i,n,r)},openWS_Create:function(){this.connectTs=_.now()/1e3,this.serverInstanceAddress=this.getServerAddress(),this.ws=this.openWS(us.build(this.serverInstanceAddress,"lightstreamer"),this.options.httpExtraHeaders)},openWS_Bind:function(){this.connectTs=_.now()/1e3,this.ws=this.openWS(us.build(ye.sure(this.serverInstanceAddress),"lightstreamer"),this.getHeadersForRequestOtherThanCreate())},sendCreateWS:function(){var t=new Le;this.options.keepaliveInterval>0&&t.LS_keepalive_millis(this.options.keepaliveInterval),this.rhb_grantedInterval=this.options.reverseHeartbeatInterval,this.rhb_grantedInterval>0&&t.LS_inactivity_millis(this.rhb_grantedInterval),this.bw_requestedMaxBandwidth=this.options.requestedMaxBandwidth;var e=this.bw_requestedMaxBandwidth;null!=e&&0==e._hx_index&&t.LS_requested_max_bandwidth_Float(e.bw),null!=this.details.adapterSet&&t.LS_adapter_set(this.details.adapterSet),null!=this.details.user&&t.LS_user(this.details.user),t.LS_cid(Si),null!=this.sessionId&&t.LS_old_session(this.sessionId),this.options.slowingEnabled||t.LS_send_sync(!1),null!=this.cause&&(t.LS_cause(this.cause),this.cause=null),Mi.isInfoEnabled()&&Mi.info("Sending session create: "+p.string(t)),null!=this.details.password&&t.LS_password(this.details.password),ye.sure(this.ws).send("wsok"),ye.sure(this.ws).send("create_session\r\n"+t.getEncodedString())},sendBindWS_Streaming:function(){var t=new Le;t.LS_session(ye.sure(this.sessionId)),this.options.keepaliveInterval>0&&t.LS_keepalive_millis(this.options.keepaliveInterval),this.rhb_grantedInterval=this.options.reverseHeartbeatInterval,this.rhb_grantedInterval>0&&t.LS_inactivity_millis(this.rhb_grantedInterval),this.options.slowingEnabled||t.LS_send_sync(!1),null!=this.cause&&(t.LS_cause(this.cause),this.cause=null),Mi.isInfoEnabled()&&Mi.info("Sending session bind: "+p.string(t)),ye.sure(this.ws).send("wsok"),ye.sure(this.ws).send("bind_session\r\n"+t.getEncodedString())},sendBindWS_FirstPolling:function(){var t=new Le;t.LS_session(ye.sure(this.sessionId)),t.LS_polling(!0),t.LS_polling_millis(this.options.pollingInterval),this.idleTimeout=this.options.idleTimeout,t.LS_idle_millis(this.idleTimeout),null!=this.cause&&(t.LS_cause(this.cause),this.cause=null),Mi.isInfoEnabled()&&Mi.info("Sending session bind: "+p.string(t)),ye.sure(this.ws).send("bind_session\r\n"+t.getEncodedString())},sendBindWS_Polling:function(){var t=new Le;t.LS_polling(!0),t.LS_polling_millis(this.options.pollingInterval),this.idleTimeout=this.options.idleTimeout,t.LS_idle_millis(this.idleTimeout),null!=this.cause&&(t.LS_cause(this.cause),this.cause=null),Mi.isInfoEnabled()&&Mi.info("Sending session bind: "+p.string(t)),ye.sure(this.ws).send("bind_session\r\n"+t.getEncodedString())},sendDestroyWS:function(){var t=new Le;t.LS_reqId(this.generateFreshReqId()),t.LS_op("destroy"),t.LS_close_socket(!0),t.LS_cause("api"),Mi.isInfoEnabled()&&Mi.info("Sending session destroy: "+p.string(t)),ye.sure(this.ws).send("control\r\n"+t.getEncodedString())},sendHttpRequest:function(t,e,s){var i=this,n=function(t,e){Di.submit(ei.a((function(){xe.synchronized(i.lock,(function(){if(!t.isDisposed())try{i.evtMessage(e)}catch(t){var s=w.caught(t);Oi.isErrorEnabled()&&Oi.error(s.get_message()+"\n"+s.details()),i.evtExtDisconnect(q.TC_standardError(61,s.get_message()))}}))})))},r=function(t,e){Di.submit(ei.a((function(){xe.synchronized(i.lock,(function(){t.isDisposed()||i.evtTransportError()}))})))};return this.httpFactory(t,e.getEncodedString(),s,n,r,(function(t){}))},sendCreateHTTP:function(){var t=new Le;t.LS_polling(!0),t.LS_polling_millis(0),t.LS_idle_millis(0),this.bw_requestedMaxBandwidth=this.options.requestedMaxBandwidth;var e=this.bw_requestedMaxBandwidth;null!=e&&0==e._hx_index&&t.LS_requested_max_bandwidth_Float(e.bw),null!=this.details.adapterSet&&t.LS_adapter_set(this.details.adapterSet),null!=this.details.user&&t.LS_user(this.details.user),t.LS_cid(Si),null!=this.sessionId&&t.LS_old_session(this.sessionId),null!=this.cause&&(t.LS_cause(this.cause),this.cause=null),Mi.isInfoEnabled()&&Mi.info("Sending session create: "+p.string(t)),null!=this.details.password&&t.LS_password(this.details.password),this.connectTs=_.now()/1e3,this.serverInstanceAddress=this.getServerAddress(),this.http=this.sendHttpRequest(us.build(this.serverInstanceAddress,"/lightstreamer"+Ei+"/create_session.txt?LS_protocol="+pi),t,this.options.httpExtraHeaders)},sendBindHTTP_Streaming:function(){var t=new Le;t.LS_session(ye.sure(this.sessionId)),t.LS_content_length(this.options.contentLength),this.options.keepaliveInterval>0&&t.LS_keepalive_millis(this.options.keepaliveInterval),this.rhb_grantedInterval=this.options.reverseHeartbeatInterval,this.rhb_grantedInterval>0&&t.LS_inactivity_millis(this.rhb_grantedInterval),this.options.slowingEnabled||t.LS_send_sync(!1),null!=this.cause&&(t.LS_cause(this.cause),this.cause=null),Mi.isInfoEnabled()&&Mi.info("Sending session bind: "+p.string(t)),this.connectTs=_.now()/1e3,this.http=this.sendHttpRequest(us.build(ye.sure(this.serverInstanceAddress),"/lightstreamer/bind_session.txt?LS_protocol="+pi),t,this.getHeadersForRequestOtherThanCreate())},sendBindHTTP_Polling:function(){var t=new Le;t.LS_session(ye.sure(this.sessionId)),t.LS_polling(!0),t.LS_polling_millis(this.options.pollingInterval),this.idleTimeout=this.options.idleTimeout,t.LS_idle_millis(this.idleTimeout),null!=this.cause&&(t.LS_cause(this.cause),this.cause=null),this.rhb_grantedInterval=0,Mi.isInfoEnabled()&&Mi.info("Sending session bind: "+p.string(t)),this.connectTs=_.now()/1e3,this.http=this.sendHttpRequest(us.build(ye.sure(this.serverInstanceAddress),"/lightstreamer/bind_session.txt?LS_protocol="+pi),t,this.getHeadersForRequestOtherThanCreate())},sendCreateTTL:function(){var t=new Le;t.LS_ttl_millis("unlimited"),t.LS_polling(!0),t.LS_polling_millis(0),t.LS_idle_millis(0),this.bw_requestedMaxBandwidth=this.options.requestedMaxBandwidth;var e=this.bw_requestedMaxBandwidth;null!=e&&0==e._hx_index&&t.LS_requested_max_bandwidth_Float(e.bw),null!=this.details.adapterSet&&t.LS_adapter_set(this.details.adapterSet),null!=this.details.user&&t.LS_user(this.details.user),t.LS_cid(Si),null!=this.sessionId&&t.LS_old_session(this.sessionId),null!=this.cause&&(t.LS_cause(this.cause),this.cause=null),Mi.isInfoEnabled()&&Mi.info("Sending session create: "+p.string(t)),null!=this.details.password&&t.LS_password(this.details.password),this.connectTs=_.now()/1e3,this.serverInstanceAddress=this.getServerAddress(),this.http=this.sendHttpRequest(us.build(this.serverInstanceAddress,"/lightstreamer"+Ei+"/create_session.txt?LS_protocol="+pi),t,this.options.httpExtraHeaders)},sendRecovery:function(){var t=new Le;t.LS_session(ye.sure(this.sessionId)),t.LS_recovery_from(this.rec_clientProg),t.LS_polling(!0),t.LS_polling_millis(0),t.LS_idle_millis(0),null!=this.cause&&(t.LS_cause(this.cause),this.cause=null),Mi.isInfoEnabled()&&Mi.info("Sending session recovery: "+p.string(t)),this.connectTs=_.now()/1e3,this.http=this.sendHttpRequest(us.build(ye.sure(this.serverInstanceAddress),"/lightstreamer/bind_session.txt?LS_protocol="+pi),t,this.getHeadersForRequestOtherThanCreate())},disposeWS:function(){null!=this.ws&&(this.ws.dispose(),this.ws=null)},closeWS:function(){null!=this.ws&&(this.ws.dispose(),this.ws=null)},suspendWS_Streaming:function(){Oi.isWarnEnabled()&&Oi.warn("Websocket suspended"),this.suspendedTransports.insert("WS-STREAMING")},disableWS:function(){Oi.isWarnEnabled()&&Oi.warn("Websocket disabled"),this.disabledTransports=this.disabledTransports.union(["WS-STREAMING","WS-POLLING"])},disableHTTP_Streaming:function(){Oi.isWarnEnabled()&&Oi.warn("HTTP streaming disabled"),this.disabledTransports=this.disabledTransports.union(["HTTP-STREAMING"])},disableStreaming:function(){Oi.isWarnEnabled()&&Oi.warn("Streaming disabled"),this.disabledTransports=this.disabledTransports.union(["WS-STREAMING","HTTP-STREAMING"])},enableAllTransports:function(){Oi.isInfoEnabled()&&(this.disabledTransports.count()>0||this.suspendedTransports.count()>0)&&Oi.isInfoEnabled()&&Oi.info("Transports enabled again."),this.disabledTransports=new Me,this.suspendedTransports=new Me},disposeHTTP:function(){null!=this.http&&(this.http.dispose(),this.http=null)},closeHTTP:function(){null!=this.http&&(this.http.dispose(),this.http=null)},disposeCtrl:function(){null!=this.ctrl_http&&(this.ctrl_http.dispose(),this.ctrl_http=null)},closeCtrl:function(){null!=this.ctrl_http&&(this.ctrl_http.dispose(),this.ctrl_http=null)},notifyStatus:function(t){var e=this.m_status;this.m_status=t,e!=t&&(Oi.isInfoEnabled()&&Oi.info("Status: "+t),this.clientEventDispatcher.onStatusChange(t))},getBestForCreating:function(){if(0==this.getBestForBinding()._hx_index)return O.BFC_none;var t=this.options.forcedTransport,e=this.suspendedTransports.union(this.disabledTransports.toArray()),s=this.options.httpExtraHeaders,i=null==s||m.empty(s);if(null==t)return i?e.contains("WS-STREAMING")?O.BFC_http:O.BFC_ws:O.BFC_http;switch(t){case"WS":case"WS-STREAMING":return i?e.contains("WS-STREAMING")?O.BFC_http:O.BFC_ws:O.BFC_http;default:return O.BFC_http}},getBestForBinding:function(){var t=this.options.forcedTransport,e=this.disabledTransports,s=this.options.httpExtraHeaders,i=null==s||m.empty(s),n=this.options.httpExtraHeadersOnSessionCreationOnly;if(null==t)return i||n?e.contains("WS-STREAMING")?e.contains("HTTP-STREAMING")?e.contains("WS-POLLING")?P.BFB_http_polling:P.BFB_ws_polling:P.BFB_http_streaming:P.BFB_ws_streaming:e.contains("HTTP-STREAMING")?P.BFB_http_polling:P.BFB_http_streaming;switch(t){case"HTTP":return e.contains("HTTP-STREAMING")?P.BFB_http_polling:P.BFB_http_streaming;case"HTTP-POLLING":return P.BFB_http_polling;case"HTTP-STREAMING":return e.contains("HTTP-STREAMING")?P.BFB_none:P.BFB_http_streaming;case"WS":return i||n?e.contains("WS-STREAMING")?e.contains("WS-POLLING")?P.BFB_none:P.BFB_ws_polling:P.BFB_ws_streaming:P.BFB_none;case"WS-POLLING":return i||n?e.contains("WS-POLLING")?P.BFB_none:P.BFB_ws_polling:P.BFB_none;case"WS-STREAMING":return i||n?e.contains("WS-STREAMING")?P.BFB_none:P.BFB_ws_streaming:P.BFB_none}},resetCurrentRetryDelay:function(){this.delayCounter.reset(this.options.retryDelay)},notifyServerErrorIfCauseIsError:function(t){switch(t._hx_index){case 0:this.clientEventDispatcher.onServerError(t.code,t.msg);break;case 1:this.clientEventDispatcher.onServerError(61,t.error)}},notifyServerError_CONERR:function(t,e){this.clientEventDispatcher.onServerError(t,e)},notifyServerError_END:function(t,e){0<t&&t<30||t>39?this.clientEventDispatcher.onServerError(39,e):this.clientEventDispatcher.onServerError(t,e)},notifyServerError_ERROR:function(t,e){this.clientEventDispatcher.onServerError(t,e)},notifyServerError_REQERR:function(t,e){11==t?this.clientEventDispatcher.onServerError(21,e):this.clientEventDispatcher.onServerError(t,e)},doCONOK:function(t,e,s,i,n){this.sessionId=t,this.details.setSessionId(t),this.requestLimit=e,null!=s?(this.keepaliveInterval=s,this.options.setKeepaliveInterval(s)):null!=i&&(this.idleTimeout=i,this.options.setIdleTimeout(i)),"*"==n||this.options.serverInstanceAddressIgnored||(n=us.completeControlLink(n,this.getServerAddress()),this.serverInstanceAddress=n,this.details.setServerInstanceAddress(n))},doCONOK_CreateWS:function(t,e,s,i){this.doCONOK(t,e,s,null,i)},doCONOK_BindWS_Streaming:function(t,e,s,i){this.doCONOK(t,e,s,null,i)},doCONOK_BindWS_Polling:function(t,e,s,i){this.doCONOK(t,e,null,s,i)},doCONOK_CreateHTTP:function(t,e,s,i){this.doCONOK(t,e,null,null,i)},doCONOK_BindHTTP_Streaming:function(t,e,s,i){this.doCONOK(t,e,s,null,i)},doCONOK_BindHTTP_Polling:function(t,e,s,i){this.doCONOK(t,e,null,s,i)},doSERVNAME:function(t){this.details.setServerSocketName(t)},doCLIENTIP:function(t){this.details.setClientIp(t);var e=this.lastKnownClientIp;null!=e&&e!=t&&(Oi.isInfoEnabled()&&Oi.info("Client IP changed: "+e+" -> "+t),this.enableAllTransports()),this.lastKnownClientIp=t},doCONS:function(t){this.options.setRealMaxBandwidth(t)},doLOOP:function(t){this.options.setPollingInterval(t)},doPROG:function(t){if(t>this.rec_clientProg)throw new be("Assertion failure: prog <= rec_clientProg");this.rec_serverProg=t},doMSGDONE:function(t,e){this.onFreshData();var s=this.messageManagers.filter((function(s){return s.sequence==t&&s.prog==e}));if(s.length>1)throw new be("Assertion failure: messages.length <= 1");for(var i=s.h;null!=i;){var n=i.item;i=i.next,n.evtMSGDONE()}},doMSGFAIL:function(t,e,s,i){if(this.onFreshData(),39==s){var n=p.parseInt(i);if(null==n)throw new be("Assertion failure: count != null");for(var r=e-n+1,a=e+1;r<a;){if((c=this.messageManagers.filter(function(e){return function(s){return s.sequence==t&&s.prog==e[0]}}([r++]))).length>1)throw new be("Assertion failure: messages.length <= 1");for(var o=c.h;null!=o;){var h=o.item;o=o.next,h.evtMSGFAIL(s,i)}}}else{var c;if((c=this.messageManagers.filter((function(s){return s.sequence==t&&s.prog==e}))).length>1)throw new be("Assertion failure: messages.length <= 1");for(o=c.h;null!=o;)h=o.item,o=o.next,h.evtMSGFAIL(s,i)}},doU:function(t,e,s){this.onFreshData();var i=me.arrayRead(this.subscriptionManagers,t);null!=i?i.evtU(e,s):new Nt(t,this).evtU(e,s)},doSUBOK:function(t,e,s){this.onFreshData();var i=me.arrayRead(this.subscriptionManagers,t);null!=i?i.evtSUBOK(e,s):new Nt(t,this).evtSUBOK(e,s)},doSUBCMD:function(t,e,s,i,n){this.onFreshData();var r=me.arrayRead(this.subscriptionManagers,t);null!=r?r.evtSUBCMD(e,s,i,n):new Nt(t,this).evtSUBCMD(e,s,i,n)},doUNSUB:function(t){this.onFreshData();var e=me.arrayRead(this.subscriptionManagers,t);null!=e&&e.evtUNSUB()},doEOS:function(t,e){this.onFreshData();var s=me.arrayRead(this.subscriptionManagers,t);null!=s?s.evtEOS(e):new Nt(t,this).evtEOS(e)},doCS:function(t,e){this.onFreshData();var s=me.arrayRead(this.subscriptionManagers,t);null!=s?s.evtCS(e):new Nt(t,this).evtCS(e)},doOV:function(t,e,s){this.onFreshData();var i=me.arrayRead(this.subscriptionManagers,t);null!=i?i.evtOV(e,s):new Nt(t,this).evtOV(e,s)},doCONF:function(t,e){this.onFreshData();var s=me.arrayRead(this.subscriptionManagers,t);null!=s?s.evtCONF(e):new Nt(t,this).evtCONF(e)},doREQOK:function(t){for(var e=ri(me)(this.subscriptionManagers);null!=e.head;){var s=e.head.item;e.head=e.head.next,s.value.evtREQOK(t)}for(var i=this.messageManagers.h;null!=i;)s=i.item,i=i.next,s.evtREQOK(t)},doREQERR:function(t,e,s){for(var i=ri(me)(this.subscriptionManagers);null!=i.head;){var n=i.head.item;i.head=i.head.next,n.value.evtREQERR(t,e,s)}for(var r=this.messageManagers.h;null!=r;)n=r.item,r=r.next,n.evtREQERR(t,e,s)},doSYNC:function(t){this.slw_refTime=_.now()/1e3,this.slw_avgDelayMs=-t},doSYNC_G:function(t){var e=this.diffTimeSync(t);return e>this.slw_hugeDelayMs&&e>2*this.slw_avgDelayMs?this.slw_avgDelayMs>this.slw_maxAvgDelayMs&&this.options.slowingEnabled?k.SCR_bad:k.SCR_not_good:(this.slw_avgDelayMs=this.slowAvg(e),this.slw_avgDelayMs>this.slw_maxAvgDelayMs&&this.options.slowingEnabled?k.SCR_bad:(this.slw_avgDelayMs<60&&(this.slw_avgDelayMs=0),k.SCR_good))},doSYNC_NG:function(t){var e=this.diffTimeSync(t);return e>this.slw_hugeDelayMs&&e>2*this.slw_avgDelayMs?(this.slw_avgDelayMs=this.slowAvg(e),this.slw_avgDelayMs>this.slw_maxAvgDelayMs&&this.options.slowingEnabled?k.SCR_bad:(this.slw_avgDelayMs<60&&(this.slw_avgDelayMs=0),k.SCR_good)):(this.slw_avgDelayMs=this.slowAvg(e),this.slw_avgDelayMs>this.slw_maxAvgDelayMs&&this.options.slowingEnabled?k.SCR_bad:(this.slw_avgDelayMs<60&&(this.slw_avgDelayMs=0),k.SCR_not_good))},diffTimeSync:function(t){return We.minus(_.now()/1e3,this.slw_refTime)-t},slowAvg:function(t){return this.slw_avgDelayMs*this.slw_m+t*(1-this.slw_m)},schedule_evtTransportTimeout:function(t){this.transportTimer=this.createTimer("transport.timeout",t,oi(this,this.evtTransportTimeout))},schedule_evtRetryTimeout:function(t){this.retryTimer=this.createTimer("retry.timeout",t,oi(this,this.evtRetryTimeout))},schedule_evtRecoveryTimeout:function(t){this.recoveryTimer=this.createTimer("recovery.timeout",t,oi(this,this.evtRecoveryTimeout))},schedule_evtIdleTimeout:function(t){this.idleTimer=this.createTimer("idle.timeout",t,oi(this,this.evtIdleTimeout))},schedule_evtPollingTimeout:function(t){this.pollingTimer=this.createTimer("polling.timeout",t,oi(this,this.evtPollingTimeout))},schedule_evtCtrlTimeout:function(t){this.ctrlTimer=this.createTimer("ctrl.timeout",t,oi(this,this.evtCtrlTimeout))},schedule_evtKeepaliveTimeout:function(t){this.keepaliveTimer=this.createTimer("keepalive.timeout",t,oi(this,this.evtKeepaliveTimeout))},schedule_evtStalledTimeout:function(t){this.stalledTimer=this.createTimer("stalled.timeout",t,oi(this,this.evtStalledTimeout))},schedule_evtReconnectTimeout:function(t){this.reconnectTimer=this.createTimer("reconnect.timeout",t,oi(this,this.evtReconnectTimeout))},schedule_evtRhbTimeout:function(t){this.rhbTimer=this.createTimer("rhb.timeout",t,oi(this,this.evtRhbTimeout))},createTimer:function(t,e,s){var i=this;return this.timerFactory(t,e,(function(t){xe.synchronized(i.lock,(function(){t.isCanceled()||s()}))}))},cancel_evtTransportTimeout:function(){null!=this.transportTimer&&(this.transportTimer.cancel(),this.transportTimer=null)},cancel_evtRetryTimeout:function(){null!=this.retryTimer&&(this.retryTimer.cancel(),this.retryTimer=null)},cancel_evtKeepaliveTimeout:function(){null!=this.keepaliveTimer&&(this.keepaliveTimer.cancel(),this.keepaliveTimer=null)},cancel_evtStalledTimeout:function(){null!=this.stalledTimer&&(this.stalledTimer.cancel(),this.stalledTimer=null)},cancel_evtReconnectTimeout:function(){null!=this.reconnectTimer&&(this.reconnectTimer.cancel(),this.reconnectTimer=null)},cancel_evtRhbTimeout:function(){null!=this.rhbTimer&&(this.rhbTimer.cancel(),this.rhbTimer=null)},cancel_evtIdleTimeout:function(){null!=this.idleTimer&&(this.idleTimer.cancel(),this.idleTimer=null)},cancel_evtPollingTimeout:function(){null!=this.pollingTimer&&(this.pollingTimer.cancel(),this.pollingTimer=null)},cancel_evtCtrlTimeout:function(){null!=this.ctrlTimer&&(this.ctrlTimer.cancel(),this.ctrlTimer=null)},cancel_evtRecoveryTimeout:function(){null!=this.recoveryTimer&&(this.recoveryTimer.cancel(),this.recoveryTimer=null)},waitingInterval:function(t,e){var s=We.minus(_.now()/1e3,e);return s<t?t-s:0},exit_tr:function(){this.evtEndSession()},entry_m111:function(t,e){this.evtRetry(t,e),this.schedule_evtRetryTimeout(e)},entry_m112:function(t){var e=this.waitingInterval(this.delayCounter.get_currentRetryDelay(),this.connectTs);this.evtRetry(t,e),this.schedule_evtRetryTimeout(e)},entry_m113:function(t){var e=this.randomPause(this.options.firstRetryMaxDelay);this.evtRetry(t,e),this.schedule_evtRetryTimeout(e)},entry_m115:function(t){this.evtRetry(t),this.evtRetryTimeout()},entry_rec:function(t,e){Oi.isErrorEnabled()&&Oi.error("Recovering connection in "+t+" ms. Cause: "+B(e)),this.evtStartRecovery(),this.schedule_evtRecoveryTimeout(t)},exit_w:function(){this.cancel_evtKeepaliveTimeout(),this.cancel_evtStalledTimeout(),this.cancel_evtReconnectTimeout(),this.cancel_evtRhbTimeout()},exit_ws:function(){this.cancel_evtTransportTimeout(),this.cancel_evtKeepaliveTimeout(),this.cancel_evtStalledTimeout(),this.cancel_evtReconnectTimeout(),this.cancel_evtRhbTimeout()},exit_wp:function(){this.cancel_evtTransportTimeout(),this.cancel_evtIdleTimeout(),this.cancel_evtPollingTimeout()},exit_hs:function(){this.cancel_evtTransportTimeout(),this.cancel_evtKeepaliveTimeout(),this.cancel_evtStalledTimeout(),this.cancel_evtReconnectTimeout(),this.cancel_evtRhbTimeout()},exit_hp:function(){this.cancel_evtIdleTimeout(),this.cancel_evtPollingTimeout(),this.cancel_evtRhbTimeout()},exit_ctrl:function(){this.cancel_evtCtrlTimeout(),this.evtDisposeCtrl()},exit_rec:function(){this.cancel_evtRecoveryTimeout(),this.cancel_evtTransportTimeout(),this.cancel_evtRetryTimeout()},exit_keepalive_unit:function(){this.cancel_evtKeepaliveTimeout(),this.cancel_evtStalledTimeout(),this.cancel_evtReconnectTimeout()},exit_w_to_m:function(){this.exit_w(),this.exit_tr()},exit_ws_to_m:function(){this.exit_ws(),this.exit_tr()},exit_wp_to_m:function(){this.exit_wp(),this.exit_tr()},exit_hs_to_m:function(){this.exit_ctrl(),this.exit_hs(),this.exit_tr()},exit_hs_to_rec:function(){this.exit_ctrl(),this.exit_hs()},exit_hp_to_m:function(){this.exit_ctrl(),this.exit_hp(),this.exit_tr()},exit_hp_to_rec:function(){this.exit_ctrl(),this.exit_hp()},exit_ctrl_to_m:function(){this.exit_ctrl(),this.exit_hs(),this.exit_hp(),this.exit_tr()},exit_rec_to_m:function(){this.exit_rec(),this.exit_tr()},randomPause:function(t){return this.randomGenerator(t)},generateFreshReqId:function(){return this.m_nextReqId+=1,this.m_nextReqId},generateFreshSubId:function(){return this.m_nextSubId+=1,this.m_nextSubId},genAbortSubscriptions:function(){for(var t=ri(me)(this.subscriptionManagers);null!=t.head;){var e=t.head.item;t.head=t.head.next,e.value.evtExtAbort()}},genAckMessagesWS:function(){for(var t=this.messageManagers.filter((function(t){return t.isPending()})).h;null!=t;){var e=t.item;t=t.next,e.evtWSSent()}},genAbortMessages:function(){for(var t=this.messageManagers.h;null!=t;){var e=t.item;t=t.next,e.evtAbort()}},resetSequenceMap:function(){this.sequenceMap.h=Object.create(null)},isSwitching:function(){return 150==this.state.s_m&&(1302==this.state.s_swt||1303==this.state.s_swt)},encodeSwitch:function(t){var e=new Le;return this.swt_lastReqId=this.generateFreshReqId(),e.LS_reqId(this.swt_lastReqId),e.LS_op("force_rebind"),t&&e.LS_close_socket(!0),null!=this.cause&&(e.LS_cause(this.cause),this.cause=null),Mi.isInfoEnabled()&&Mi.info("Sending transport switch: "+p.string(e)),e.getEncodedString()},encodeConstrain:function(){var t=new Le;this.bw_lastReqId=this.generateFreshReqId(),t.LS_reqId(this.bw_lastReqId),t.LS_op("constrain");var e=ye.sure(this.bw_requestedMaxBandwidth);switch(e._hx_index){case 0:t.LS_requested_max_bandwidth_Float(e.bw);break;case 1:t.LS_requested_max_bandwidth("unlimited")}return Mi.isInfoEnabled()&&Mi.info("Sending bandwidth constrain: "+p.string(t)),t.getEncodedString()},getPendingControls:function(){var t=[];ye.sure(this.switchRequest).isPending()&&t.push(ye.sure(this.switchRequest)),ye.sure(this.constrainRequest).isPending()&&t.push(ye.sure(this.constrainRequest));for(var e=ri(me)(this.subscriptionManagers);null!=e.head;){var s=e.head.item;e.head=e.head.next;var i=s.value;i.isPending()&&t.push(i)}return t},sendControlWS:function(t){ye.sure(this.ws).send(t.encodeWS())},sendMsgWS:function(t){ye.sure(this.ws).send(t.encodeWS())},sendPengingControlsWS:function(t){this.sendBatchWS(this.prepareBatchWS("control",t,ye.sure(this.requestLimit)))},sendPendingMessagesWS:function(){for(var t=[],e=this.messageManagers.h;null!=e;){var s=e.item;e=e.next,s.isPending()&&t.push(s)}this.sendBatchWS(this.prepareBatchWS("msg",t,ye.sure(this.requestLimit)))},sendBatchWS:function(t){for(var e=0;e<t.length;){var s=t[e++];ye.sure(this.ws).send(s)}},sendHeartbeatWS:function(){Mi.isInfoEnabled()&&Mi.info("Heartbeat request"),ye.sure(this.ws).send("heartbeat\r\n\r\n")},sendPendingControlsHTTP:function(t){this.sendBatchHTTP(this.prepareBatchHTTP(t,ye.sure(this.requestLimit)),"control")},sendPendingMessagesHTTP:function(){for(var t=[],e=this.messageManagers.h;null!=e;){var s=e.item;e=e.next,s.isPending()&&t.push(s)}this.sendBatchHTTP(this.prepareBatchHTTP(t,ye.sure(this.requestLimit)),"msg")},sendHeartbeatHTTP:function(){Mi.isInfoEnabled()&&Mi.info("Heartbeat request"),this.sendBatchHTTP("\r\n","heartbeat")},sendBatchHTTP:function(t,e){var s=this;this.ctrl_connectTs=_.now()/1e3;var i=us.build(ye.sure(this.serverInstanceAddress),"/lightstreamer/"+e+".txt?LS_protocol="+pi+"&LS_session="+this.sessionId),n=this.getHeadersForRequestOtherThanCreate(),r=function(t,e){xe.synchronized(s.lock,(function(){t.isDisposed()||s.evtCtrlMessage(e)}))},a=function(t,e){xe.synchronized(s.lock,(function(){t.isDisposed()||s.evtCtrlError()}))},o=function(t){xe.synchronized(s.lock,(function(){t.isDisposed()||s.evtCtrlDone()}))};this.ctrl_http=this.ctrlFactory(i,t,n,r,a,o)},prepareBatchWS:function(t,e,s){if(e.length<=0)throw new be("Assertion failure: pendings.length > 0");for(var i=[],n=0,r=e[0].encode(!0);n<e.length;){var a=new xt;for(a.addSubRequest(t),a.addSubRequest(r),++n;n<e.length&&(r=e[n].encode(!0),a.addSubRequestOnlyIfBodyIsLessThan(r,s));)++n;i.push(a.getBody())}return i},prepareBatchHTTP:function(t,e){if(t.length<=0)throw new be("Assertion failure: pendings.length > 0");var s=new xt,i=0,n=t[0].encode(!1);for(s.addSubRequest(n),i=1;i<t.length&&(n=t[i].encode(!1),s.addSubRequestOnlyIfBodyIsLessThan(n,e));)++i;return s.getBody()},getHeadersForRequestOtherThanCreate:function(){return this.options.httpExtraHeadersOnSessionCreationOnly?null:this.options.httpExtraHeaders},getServerAddress:function(){var t=this.details.serverAddress;return null!=t?t:ye.sure(this.defaultServerAddress)},relateSubManager:function(t){if(null!=me.arrayRead(this.subscriptionManagers,t.subId))throw new be("Assertion failure: subscriptionManagers[subManager.subId] == null");me.arrayWrite(this.subscriptionManagers,t.subId,t)},unrelateSubManager:function(t){me.remove(this.subscriptionManagers,t.subId)},isRelatedWithSubManager:function(t){return me.containsValue(this.subscriptionManagers,t)},relateMsgManager:function(t){this.messageManagers.add(t)},unrelateMsgManager:function(t){this.messageManagers.remove(t)},getAndSetNextMsgProg:function(t){var e=this.sequenceMap.h[t];return null==e&&(e=1),this.sequenceMap.h[t]=e+1,e},onPropertyChange:function(t){this.clientEventDispatcher.onPropertyChange(t)},traceEvent:function(t){Ni.isTraceEnabled()&&Ni.trace("event: "+t+" "+this.state.toString())},connect:function(){var t=this.details.getServerAddress();if(null==t)throw new be("Configure the server address before trying to connect");Pi.isInfoEnabled()&&Pi.info("Connection requested: details: "+p.string(this.details)+" options: "+p.string(this.options)),this.defaultServerAddress=t,this.evtExtConnect()},disconnect:function(){Pi.isInfoEnabled()&&Pi.info("Disconnection requested"),this.evtExtDisconnect(q.TC_api)},getStatus:function(){return this.m_status},sendMessage:function(t,e,s,i,n){if(n||!this.state.inDisconnected()&&!this.state.inRetryUnit())if(null!=e){if(!new u("^[a-zA-Z0-9_]*$","").match(e))throw new R("The given sequence name is not valid. Use only alphanumeric characters plus underscore or null");var r=new J(t,e,s,i,n,this);Pi.isInfoEnabled()&&Pi.info("Message sending requested: "+p.string(r)),r.evtExtSendMessage()}else r=new J(t,"UNORDERED_MESSAGES",s,i,n,this),Pi.isInfoEnabled()&&Pi.info("Message sending requested: "+p.string(r)),r.evtExtSendMessage();else{if(Pi.isInfoEnabled()){var a=new ks;a.h.text=t,a.h.sequence=null!=e?e:"UNORDERED_MESSAGES",a.h.timeout=null==s?"null":""+s,a.h.enqueueWhileDisconnected=null==n?"null":""+n,Pi.isInfoEnabled()&&Pi.info("Message sending requested: "+(null==a?"null":ks.stringify(a.h)))}if(qi.isWarnEnabled()&&qi.warn("Message "+(null!=e?e:"UNORDERED_MESSAGES")+" "+t+" aborted"),null!=i){var o=new j;o.addListener(i),o.onAbort(t,!1)}}},subscribeExt:function(t,e){if(null==e&&(e=!1),t.isActive())throw new be("Cannot subscribe to an active Subscription");if(null==t.getItems()&&null==t.getItemGroup())throw new R("Specify property 'items' or 'itemGroup'");if(null==t.getFields()&&null==t.getFieldSchema())throw new R("Specify property 'fields' or 'fieldSchema'");var s=new Mt(t,this);Pi.isInfoEnabled()&&Pi.info((e?"Internal subscription":"Subscription")+" requested: subId: "+s.subId+" "+p.string(t)),s.evtExtSubscribe()},unsubscribe:function(t){var e=t.fetch_subManager();if(null!=e){if(!this.isRelatedWithSubManager(e))throw new R("The Subscription is not subscribed to this Client");Pi.isInfoEnabled()&&Pi.info("Unsubscription requested: subId: "+e.subId+" "+p.string(t)),e.evtExtUnsubscribe()}},getSubscriptions:function(){for(var t=[],e=ri(me)(this.subscriptionManagers);null!=e.head;){var s=e.head.item;e.head=e.head.next;var i=s.value,n=i instanceof Mt?i:null;if(null!=n){var r=n.m_subscription;r.isActive()&&!r.isInternal()&&t.push(r)}}return t},__class__:N};var O=a["com.lightstreamer.client.internal._ClientMachine.BestForCreatingEnum"]={__ename__:!0,__constructs__:null,BFC_ws:{_hx_name:"BFC_ws",_hx_index:0,__enum__:"com.lightstreamer.client.internal._ClientMachine.BestForCreatingEnum",toString:r},BFC_http:{_hx_name:"BFC_http",_hx_index:1,__enum__:"com.lightstreamer.client.internal._ClientMachine.BestForCreatingEnum",toString:r},BFC_none:{_hx_name:"BFC_none",_hx_index:2,__enum__:"com.lightstreamer.client.internal._ClientMachine.BestForCreatingEnum",toString:r}};O.__constructs__=[O.BFC_ws,O.BFC_http,O.BFC_none];var P=a["com.lightstreamer.client.internal._ClientMachine.BestForBindingEnum"]={__ename__:!0,__constructs__:null,BFB_none:{_hx_name:"BFB_none",_hx_index:0,__enum__:"com.lightstreamer.client.internal._ClientMachine.BestForBindingEnum",toString:r},BFB_ws_streaming:{_hx_name:"BFB_ws_streaming",_hx_index:1,__enum__:"com.lightstreamer.client.internal._ClientMachine.BestForBindingEnum",toString:r},BFB_ws_polling:{_hx_name:"BFB_ws_polling",_hx_index:2,__enum__:"com.lightstreamer.client.internal._ClientMachine.BestForBindingEnum",toString:r},BFB_http_streaming:{_hx_name:"BFB_http_streaming",_hx_index:3,__enum__:"com.lightstreamer.client.internal._ClientMachine.BestForBindingEnum",toString:r},BFB_http_polling:{_hx_name:"BFB_http_polling",_hx_index:4,__enum__:"com.lightstreamer.client.internal._ClientMachine.BestForBindingEnum",toString:r}};P.__constructs__=[P.BFB_none,P.BFB_ws_streaming,P.BFB_ws_polling,P.BFB_http_streaming,P.BFB_http_polling];var k=a["com.lightstreamer.client.internal._ClientMachine.SyncCheckResult"]={__ename__:!0,__constructs__:null,SCR_good:{_hx_name:"SCR_good",_hx_index:0,__enum__:"com.lightstreamer.client.internal._ClientMachine.SyncCheckResult",toString:r},SCR_not_good:{_hx_name:"SCR_not_good",_hx_index:1,__enum__:"com.lightstreamer.client.internal._ClientMachine.SyncCheckResult",toString:r},SCR_bad:{_hx_name:"SCR_bad",_hx_index:2,__enum__:"com.lightstreamer.client.internal._ClientMachine.SyncCheckResult",toString:r}};k.__constructs__=[k.SCR_good,k.SCR_not_good,k.SCR_bad];var F=a["com.lightstreamer.client.internal._ClientMachine.RetryCause"]={__ename__:!0,__constructs__:null,standardError:(e=function(t,e){return{_hx_index:0,code:t,msg:e,__enum__:"com.lightstreamer.client.internal._ClientMachine.RetryCause",toString:r}},e._hx_name="standardError",e.__params__=["code","msg"],e),ws_unavailable:{_hx_name:"ws_unavailable",_hx_index:1,__enum__:"com.lightstreamer.client.internal._ClientMachine.RetryCause",toString:r},ws_error:{_hx_name:"ws_error",_hx_index:2,__enum__:"com.lightstreamer.client.internal._ClientMachine.RetryCause",toString:r},http_error:{_hx_name:"http_error",_hx_index:3,__enum__:"com.lightstreamer.client.internal._ClientMachine.RetryCause",toString:r},idle_timeout:{_hx_name:"idle_timeout",_hx_index:4,__enum__:"com.lightstreamer.client.internal._ClientMachine.RetryCause",toString:r},stalled_timeout:{_hx_name:"stalled_timeout",_hx_index:5,__enum__:"com.lightstreamer.client.internal._ClientMachine.RetryCause",toString:r},ws_timeout:{_hx_name:"ws_timeout",_hx_index:6,__enum__:"com.lightstreamer.client.internal._ClientMachine.RetryCause",toString:r},http_timeout:{_hx_name:"http_timeout",_hx_index:7,__enum__:"com.lightstreamer.client.internal._ClientMachine.RetryCause",toString:r},recovery_timeout:{_hx_name:"recovery_timeout",_hx_index:8,__enum__:"com.lightstreamer.client.internal._ClientMachine.RetryCause",toString:r},prog_mismatch:(e=function(t,e){return{_hx_index:9,expected:t,actual:e,__enum__:"com.lightstreamer.client.internal._ClientMachine.RetryCause",toString:r}},e._hx_name="prog_mismatch",e.__params__=["expected","actual"],e)};F.__constructs__=[F.standardError,F.ws_unavailable,F.ws_error,F.http_error,F.idle_timeout,F.stalled_timeout,F.ws_timeout,F.http_timeout,F.recovery_timeout,F.prog_mismatch];var q=a["com.lightstreamer.client.internal._ClientMachine.TerminationCause"]={__ename__:!0,__constructs__:null,TC_standardError:(e=function(t,e){return{_hx_index:0,code:t,msg:e,__enum__:"com.lightstreamer.client.internal._ClientMachine.TerminationCause",toString:r}},e._hx_name="TC_standardError",e.__params__=["code","msg"],e),TC_otherError:(e=function(t){return{_hx_index:1,error:t,__enum__:"com.lightstreamer.client.internal._ClientMachine.TerminationCause",toString:r}},e._hx_name="TC_otherError",e.__params__=["error"],e),TC_api:{_hx_name:"TC_api",_hx_index:2,__enum__:"com.lightstreamer.client.internal._ClientMachine.TerminationCause",toString:r}};q.__constructs__=[q.TC_standardError,q.TC_otherError,q.TC_api];var A=a["com.lightstreamer.client.internal._ClientMachine.RecoveryRetryCause"]={__ename__:!0,__constructs__:null,RRC_transport_timeout:{_hx_name:"RRC_transport_timeout",_hx_index:0,__enum__:"com.lightstreamer.client.internal._ClientMachine.RecoveryRetryCause",toString:r},RRC_transport_error:{_hx_name:"RRC_transport_error",_hx_index:1,__enum__:"com.lightstreamer.client.internal._ClientMachine.RecoveryRetryCause",toString:r}};function B(t){switch(t._hx_index){case 0:return t.code+" - "+t.msg;case 1:return"Websocket transport not available";case 2:return"Websocket error";case 3:return"HTTP error";case 4:return"idleTimeout expired";case 5:return"stalledTimeout expired";case 6:return"Websocket connect timeout expired";case 7:return"HTTP connect timeout expired";case 8:return"sessionRecoveryTimeout expired";case 9:return"Recovery counter mismatch: expected "+t.expected+" but found "+t.actual}}A.__constructs__=[A.RRC_transport_timeout,A.RRC_transport_error];var U=function(){};U.__name__="com.lightstreamer.client.internal.Encodable",U.__isInterface__=!0,U.prototype={__class__:U};var W=function(t){this.client=t};W.__name__="com.lightstreamer.client.internal.SwitchRequest",W.__interfaces__=[U],W.prototype={isPending:function(){return 150==this.client.state.s_m&&1302==this.client.state.s_swt},encode:function(t){return this.client.encodeSwitch(t)},encodeWS:function(){return"control\r\n"+this.encode(!0)},__class__:W};var H=function(t){this.client=t};H.__name__="com.lightstreamer.client.internal.ConstrainRequest",H.__interfaces__=[U],H.prototype={isPending:function(){return 1202==this.client.state.s_bw},encode:function(t){return this.client.encodeConstrain()},encodeWS:function(){return"control\r\n"+this.encode(!0)},__class__:H};var V=function(t,e,s){this.p=t,this.k=e,this.s=s};V.__name__="com.lightstreamer.client.internal.StateVar_w",V.prototype={toString:function(){return"<w_p="+this.p+" w_k="+this.k+" w_s="+this.s+">"},__class__:V};var K=function(t){this.m=t};K.__name__="com.lightstreamer.client.internal.StateVar_ws",K.prototype={toString:function(){var t="<ws_m="+this.m;return null!=this.p&&(t+=" ws_p="+this.p),null!=this.k&&(t+=" ws_k="+this.k),null!=this.s&&(t+=" ws_s="+this.s),t+=">"},__class__:K};var G=function(t){this.m=t};G.__name__="com.lightstreamer.client.internal.StateVar_wp",G.prototype={toString:function(){var t="<wp_m="+this.m;return null!=this.p&&(t+=" wp_p="+this.p),null!=this.c&&(t+=" wp_c="+this.c),null!=this.s&&(t+=" wp_s="+this.s),t+=">"},__class__:G};var z=function(t){this.m=t};z.__name__="com.lightstreamer.client.internal.StateVar_hs",z.prototype={toString:function(){var t="<hs_m="+this.m;return null!=this.p&&(t+=" hs_p="+this.p),null!=this.k&&(t+=" hs_k="+this.k),t+=">"},__class__:z};var Y=function(t){this.m=t};Y.__name__="com.lightstreamer.client.internal.StateVar_hp",Y.prototype={toString:function(){return"<hp_m="+this.m+">"},__class__:Y};var Q=function(){this.s_mpn=new dt,this.s_m=100,this.s_du=20,this.s_nr=1400};Q.__name__="com.lightstreamer.client.internal.State",Q.prototype={goto_m_from_w:function(t){this.clear_w(),this.goto_m_from_session(t)},goto_m_from_ws:function(t){this.clear_ws(),this.goto_m_from_session(t)},goto_rec_from_w:function(){this.clear_w(),this.goto_rec()},goto_rec_from_ws:function(){this.clear_ws(),this.goto_rec()},goto_m_from_wp:function(t){this.clear_wp(),this.goto_m_from_session(t)},goto_rec_from_wp:function(){this.clear_wp(),this.goto_rec()},goto_m_from_hs:function(t){this.clear_hs(),this.s_ctrl=null,this.s_h=null,this.goto_m_from_session(t)},goto_m_from_rec:function(t){this.s_tr=null,this.goto_m_from_session(t)},goto_rec_from_hs:function(){this.clear_hs(),this.s_ctrl=null,this.s_h=null,this.goto_rec()},goto_m_from_hp:function(t){this.clear_hp(),this.s_ctrl=null,this.s_h=null,this.goto_m_from_session(t)},goto_rec_from_hp:function(){this.clear_hp(),this.s_ctrl=null,this.s_h=null,this.goto_rec()},goto_rec:function(){this.s_tr=260,this.s_rec=1e3,this.traceState()},goto_m_from_session:function(t){this.s_tr=null,this.s_swt=null,this.s_bw=null,this.s_m=t,this.traceState()},goto_m_from_ctrl:function(t){this.clear_hs(),this.clear_hp(),this.s_ctrl=null,this.s_h=null,this.goto_m_from_session(t)},goto_200_from_rec:function(){this.s_rec=null,this.s_tr=200,this.traceState()},clear_w:function(){this.s_w=null,this.s_rhb=null,this.s_slw=null},clear_ws:function(){this.s_ws=null,this.s_rhb=null,this.s_slw=null},clear_wp:function(){this.s_wp=null},clear_hs:function(){this.s_hs=null,this.s_rhb=null,this.s_slw=null},clear_hp:function(){this.s_hp=null,this.s_rhb=null},isSwitching:function(){return 150==this.s_m&&(1302==this.s_swt||1303==this.s_swt)},inPushing:function(){return!!this.inStreaming()||this.inPolling()},inStreaming:function(){var t,e;return!!(e=300==(null!=(t=this.s_w)?t.p:null)||510==(null!=(t=this.s_ws)?t.p:null))||810==(null!=(e=this.s_hs)?e.p:null)},inPolling:function(){var t;if(220!=this.s_tr&&230!=this.s_tr){var e=this.s_wp;t=611==(null!=e?e.p:null)}else t=!0;return!!(!!t||901==(null!=(t=this.s_hp)?t.m:null))||1001==this.s_rec},inRetryUnit:function(){switch(this.s_m){case 110:case 111:case 112:case 113:case 114:case 115:case 116:return!0;default:return!1}},inDisconnected:function(){return 100==this.s_m},toString:function(){var t="<m="+this.s_m;return t+=" du="+this.s_du,null!=this.s_tr&&(t+=" tr="+this.s_tr),null!=this.s_w&&(t+=" "+p.string(this.s_w)),null!=this.s_ws&&(t+=" "+p.string(this.s_ws)),null!=this.s_wp&&(t+=" "+p.string(this.s_wp)),null!=this.s_hs&&(t+=" "+p.string(this.s_hs)),null!=this.s_hp&&(t+=" "+p.string(this.s_hp)),null!=this.s_rec&&(t+=" rec="+this.s_rec),null!=this.s_h&&(t+=" h="+this.s_h),null!=this.s_ctrl&&(t+=" ctrl="+this.s_ctrl),null!=this.s_swt&&(t+=" swt="+this.s_swt),null!=this.s_bw&&(t+=" bw="+this.s_bw),null!=this.s_rhb&&(t+=" rhb="+this.s_rhb),null!=this.s_slw&&(t+=" slw="+this.s_slw),t+=" nr="+this.s_nr,null!=this.s_mpn&&(t+=" "+p.string(this.s_mpn)),t+=">"},traceState:function(){Ni.isTraceEnabled()&&Ni.trace("goto: "+this.toString())},__class__:Q};var j=function(){I.call(this)};j.__name__="com.lightstreamer.client.internal.MessageEventDispatcher",j.__super__=I,j.prototype=c(I.prototype,{onAbort:function(t,e){this.dispatchToAll((function(s){null!=s.onAbort&&s.onAbort(t,e)}))},onDeny:function(t,e,s){this.dispatchToAll((function(i){null!=i.onDeny&&i.onDeny(t,e,s)}))},onDiscarded:function(t){this.dispatchToAll((function(e){null!=e.onDiscarded&&e.onDiscarded(t)}))},onError:function(t){this.dispatchToAll((function(e){null!=e.onError&&e.onError(t)}))},onProcessed:function(t){this.dispatchToAll((function(e){null!=e.onProcessed&&e.onProcessed(t)}))},__class__:j});var J=function(t,e,s,i,n,r){this.eventDispatcher=new j,this.txt=t,this.sequence=e,this.prog="UNORDERED_MESSAGES"!=e||null!=i?r.getAndSetNextMsgProg(e):-1,this.maxWait=s,this.delegate=i,null!=i&&this.eventDispatcher.addListener(i),this.enqueueWhileDisconnected=n,this.client=r,this.s_m=null!=i?10:"UNORDERED_MESSAGES"!=e?20:30,r.relateMsgManager(this)};J.__name__="com.lightstreamer.client.internal.MessageManager",J.__interfaces__=[U],J.prototype={finalize:function(){this.client.unrelateMsgManager(this)},evtExtSendMessage:function(){switch(this.traceEvent("sendMessage"),this.s_m){case 10:this.goto(11),this.client.evtSendMessage(this);break;case 20:this.goto(21),this.client.evtSendMessage(this);break;case 30:this.goto(31),this.client.evtSendMessage(this)}},evtMSGFAIL:function(t,e){switch(this.traceEvent("MSGFAIL"),this.s_m){case 10:this.finalize(),this.goto(13);break;case 11:case 12:this.doMSGFAIL(t,e),this.finalize(),this.goto(14)}},evtMSGDONE:function(){switch(this.traceEvent("MSGDONE"),this.s_m){case 10:this.finalize(),this.goto(13);break;case 11:case 12:this.doMSGDONE(),this.finalize(),this.goto(13)}},evtREQOK:function(t){switch(this.traceEvent("REQOK"),this.s_m){case 11:t==this.lastReqId&&this.goto(12);break;case 21:t==this.lastReqId&&(this.finalize(),this.goto(22));break;case 31:t==this.lastReqId&&(this.finalize(),this.goto(33))}},evtREQERR:function(t,e,s){switch(this.traceEvent("REQERR"),this.s_m){case 11:t==this.lastReqId&&(this.doREQERR(e,s),this.finalize(),this.goto(14));break;case 21:t==this.lastReqId&&(this.finalize(),this.goto(23));break;case 31:t==this.lastReqId&&(this.finalize(),this.goto(34))}},evtAbort:function(){switch(this.traceEvent("abort"),this.s_m){case 11:case 12:this.doAbort(),this.finalize(),this.goto(15);break;case 21:qi.isWarnEnabled()&&qi.warn("Message "+this.sequence+":"+this.prog+" aborted"),this.finalize(),this.goto(24);break;case 31:qi.isWarnEnabled()&&qi.warn("Message "+this.sequence+":"+this.prog+" aborted"),this.finalize(),this.goto(35)}},evtWSSent:function(){this.traceEvent("ws.sent"),31==this.s_m&&(this.finalize(),this.goto(32))},isPending:function(){return 11==this.s_m||21==this.s_m||31==this.s_m},encode:function(t){return this.encodeMsg(t)},encodeWS:function(){return"msg\r\n"+this.encode(!0)},doMSGDONE:function(){this.fireOnProcessed()},doMSGFAIL:function(t,e){38==t||39==t?this.fireOnDiscarded():t<=0?this.fireOnDeny(t,e):32!=t&&33!=t&&this.fireOnError()},doREQERR:function(t,e){32!=t&&33!=t&&this.fireOnError()},doAbort:function(){this.fireOnAbort()},encodeMsg:function(t){var e="UNORDERED_MESSAGES"!=this.sequence,s=null!=this.delegate,i=new Le;return this.lastReqId=this.client.generateFreshReqId(),i.LS_reqId(this.lastReqId),i.LS_message(this.txt),e&&s?(i.LS_sequence(this.sequence),i.LS_msg_prog(this.prog),this.maxWait>=0&&i.LS_max_wait(this.maxWait)):!e&&s?i.LS_msg_prog(this.prog):e&&!s?(i.LS_outcome(!1),i.LS_sequence(this.sequence),i.LS_msg_prog(this.prog),this.maxWait>=0&&i.LS_max_wait(this.maxWait)):e||s||(i.LS_outcome(!1),t&&i.LS_ack(!1)),Mi.isInfoEnabled()&&Mi.info("Sending message: "+p.string(i)),i.getEncodedString()},fireOnProcessed:function(){qi.isInfoEnabled()&&qi.info("Message "+this.sequence+":"+this.prog+" processed"),this.eventDispatcher.onProcessed(this.txt)},fireOnDiscarded:function(){qi.isWarnEnabled()&&qi.warn("Message "+this.sequence+":"+this.prog+" discarded"),this.eventDispatcher.onDiscarded(this.txt)},fireOnDeny:function(t,e){qi.isWarnEnabled()&&qi.warn("Message "+this.sequence+":"+this.prog+" denied: "+t+" - "+e),this.eventDispatcher.onDeny(this.txt,t,e)},fireOnError:function(){qi.isWarnEnabled()&&qi.warn("Message "+this.sequence+":"+this.prog+" failed"),this.eventDispatcher.onError(this.txt)},fireOnAbort:function(){qi.isWarnEnabled()&&qi.warn("Message "+this.sequence+":"+this.prog+" aborted"),this.eventDispatcher.onAbort(this.txt,!1)},traceEvent:function(t){Ni.isTraceEnabled()&&Ni.trace("msg#"+t+"("+this.sequence+":"+this.prog+") in "+this.s_m)},goto:function(t){this.s_m=t,Ni.isTraceEnabled()&&Ni.trace("msg#goto("+this.sequence+":"+this.prog+") "+this.s_m)},toString:function(){var t=ge._new();return ge.set(t,"text",this.txt),ge.set(t,"sequence",this.sequence),ge.set(t,"prog",this.prog),ge.set(t,"timeout",this.maxWait),ge.set(t,"enqueueWhileDisconnected",this.enqueueWhileDisconnected),ks.stringify(t.h)},__class__:J};var X=function(t,e,s){this.items=new Ms,this.s_m=1,this.lock=e.lock,this.client=e,this.subscription=t,this.m_subId=s};X.__name__="com.lightstreamer.client.internal.ModeStrategy",X.prototype={finalize:function(){},evtAbort:function(){this.traceEvent("abort"),1==this.s_m?(this.doAbort(),this.goto(1)):2==this.s_m&&(this.doAbort(),this.goto(1),this.genDisposeItems())},evtOnSUB:function(t,e,s,i,n){this.traceEvent("onSUB"),1==this.s_m&&(this.doSUB(t,e),this.goto(2))},evtOnCONF:function(t){this.traceEvent("onCONF"),2==this.s_m&&(this.doCONF(t),this.goto(2))},evtOnCS:function(t){this.traceEvent("onCS"),2==this.s_m&&(this.doCS(t),this.goto(2))},evtOnEOS:function(t){this.traceEvent("onEOS"),2==this.s_m&&(this.doEOS(t),this.goto(2))},evtUpdate:function(t,e){this.traceEvent("update"),2==this.s_m&&(this.doUpdate(t,e),this.goto(2))},evtUnsubscribe:function(){this.traceEvent("unsubscribe"),1==this.s_m?(this.finalize(),this.goto(3)):2==this.s_m&&(this.finalize(),this.goto(3),this.genDisposeItems())},evtOnUNSUB:function(){this.traceEvent("onUNSUB"),2==this.s_m&&(this.finalize(),this.goto(3),this.genDisposeItems())},evtDispose:function(){this.traceEvent("dispose"),1!=this.s_m&&2!=this.s_m||(this.finalize(),this.goto(3),this.genDisposeItems())},evtSetRequestedMaxFrequency:function(t){},getValue:function(t,e){var s=this.items.h[t];return null!=s?s.getValue(e):null},getCommandValue:function(t,e,s){throw new be("Unsupported operation")},createItem:function(t){throw new be("Abstract method")},doSUB:function(t,e){var s=this.subscription.getItems(),i=this.subscription.getFields();if(null!=s&&t!=s.slice().length)throw new be("Assertion failure: items != null ? nItems == items.toHaxe().length : true");if(null!=i&&e!=i.slice().length)throw new be("Assertion failure: fields != null ? nFields == fields.toHaxe().length : true")},doUpdate:function(t,e){this.selectItem(t).evtUpdate(e)},doEOS:function(t){this.selectItem(t).evtOnEOS()},doCS:function(t){this.selectItem(t).evtOnCS()},doCONF:function(t){this.realMaxFrequency=t,this.subscription.fireOnRealMaxFrequency(t,this.m_subId)},doAbort:function(){this.realMaxFrequency=null},genDisposeItems:function(){for(var t=this.items.copy(),e=t.keys();e.hasNext();)t.get(e.next()).evtDispose(this)},selectItem:function(t){var e=this.items.h[t];return null==e&&(e=this.createItem(t),this.items.h[t]=e),e},unrelate:function(t){this.items.remove(t)},traceEvent:function(t){Ni.isTraceEnabled()&&Ni.trace("sub#mod#"+t+"("+this.m_subId+") in "+this.s_m)},goto:function(t){this.s_m=t,Ni.isTraceEnabled()&&Ni.trace("sub#mod#goto("+this.m_subId+") "+this.s_m)},__class__:X};var Z=function(t,e,s){X.call(this,t,e,s)};Z.__name__="com.lightstreamer.client.internal.ModeStrategyCommand",Z.__super__=X,Z.prototype=c(X.prototype,{evtOnSUB:function(t,e,s,i,n){this.traceEvent("onSUB"),1==this.s_m&&(this.doSUBCMD(t,e,s,i),this.goto(2))},getCommandValue:function(t,e,s){var i=this.items.h[t];return null!=i?i.getCommandValue(e,s):null},doSUBCMD:function(t,e,s,i){var n=this.subscription.getItems(),r=null!=n?n.slice():null,a=this.subscription.getFields(),o=null!=a?a.slice():null;if(null!=r&&t!=r.length)throw new be("Assertion failure: items != null ? nItems == items.length : true");if(null!=o&&e!=o.length)throw new be("Assertion failure: fields != null ? nFields == fields.length : true");if(null!=o&&s-1!=o.indexOf("command"))throw new be('Assertion failure: fields != null ? cmdIdx - 1 == fields.indexOf("command") : true');if(null!=o&&i-1!=o.indexOf("key"))throw new be('Assertion failure: fields != null ? keyIdx - 1 == fields.indexOf("key") : true')},__class__:Z});var $=function(t,e,s){Z.call(this,t,e,s)};$.__name__="com.lightstreamer.client.internal.ModeStrategyCommand1Level",$.__super__=Z,$.prototype=c(Z.prototype,{createItem:function(t){return new Ft(t,this.subscription,this.client,this.m_subId)},__class__:$});var tt=function(t,e,s){Z.call(this,t,e,s)};tt.__name__="com.lightstreamer.client.internal.ModeStrategyCommand2Level",tt.__super__=Z,tt.prototype=c(Z.prototype,{evtOnSUB:function(t,e,s,i,n){this.traceEvent("onSUB"),1==this.s_m&&(this.doSUBCMD2Level(t,e,s,i,n),this.goto(2))},evtSetRequestedMaxFrequency:function(t){switch(this.traceEvent("setRequestedMaxFrequency"),this.s_m){case 1:case 2:this.doSetRequestedMaxFrequency(t),this.goto(this.s_m),this.genSetRequestedMaxFrequency()}},evtOnRealMaxFrequency2LevelAdded:function(t){this.traceEvent("onRealMaxFrequency2LevelAdded"),2==this.s_m&&(this.doAggregateFrequenciesWhenFreqIsAdded(t),this.goto(2))},evtOnRealMaxFrequency2LevelRemoved:function(){this.traceEvent("onRealMaxFrequency2LevelRemoved"),2==this.s_m&&(this.doAggregateFrequenciesWhenFreqIsRemoved(),this.goto(2))},evtOnCONF:function(t){this.traceEvent("onCONF"),2==this.s_m&&(this.doCONF2Level(t),this.doAggregateFrequenciesWhenFreqIsAdded(t),this.goto(2))},createItem:function(t){return new qt(t,this.subscription,this,this.client,this.m_subId)},doSUBCMD2Level:function(t,e,s,i,n){var r=this.subscription.getItems(),a=null!=r?r.slice():null,o=this.subscription.getFields(),h=null!=o?o.slice():null;if(null!=a&&t!=a.length)throw new be("Assertion failure: items != null ? nItems == items.length : true");if(null!=h&&e!=h.length)throw new be("Assertion failure: fields != null ? nFields == fields.length : true");if(null!=h&&s-1!=h.indexOf("command"))throw new be('Assertion failure: fields != null ? cmdIdx - 1 == fields.indexOf("command") : true');if(null!=h&&i-1!=h.indexOf("key"))throw new be('Assertion failure: fields != null ? keyIdx - 1 == fields.indexOf("key") : true');this.requestedMaxFrequency=n},doSetRequestedMaxFrequency:function(t){this.requestedMaxFrequency=t},genSetRequestedMaxFrequency:function(){for(var t=this.items,e=t.keys();e.hasNext();)ni.__cast(t.get(e.next()),qt).evtSetRequestedMaxFrequency()},doCONF2Level:function(t){this.realMaxFrequency=t},maxFreq:function(t,e){var s;if(null==t)s=e;else switch(t._hx_index){case 0:var i=t.freq;if(null==e)s=t;else switch(e._hx_index){case 0:s=es.RFreqLimited(Math.max(i,e.freq));break;case 1:s=e}break;case 1:s=t}return s},doAggregateFrequenciesWhenFreqIsAdded:function(t){var e=this.maxFreq(this.aggregateRealMaxFrequency,t),s=this.aggregateRealMaxFrequency;this.aggregateRealMaxFrequency=e,cs(s,e)||this.subscription.fireOnRealMaxFrequency(e,this.m_subId)},doAggregateFrequenciesWhenFreqIsRemoved:function(){for(var t=this.realMaxFrequency,e=!1,s=this.items,i=s.keys();i.hasNext();){for(var n=ni.__cast(s.get(i.next()),qt).keys.h,r=Object.keys(n),a=r.length,o=0;o<a;)if((t=this.maxFreq(t,ni.__cast(n[r[o++]],Gt).realMaxFrequency))==es.RFreqUnlimited){e=!0;break}if(e)break}var h=this.aggregateRealMaxFrequency;this.aggregateRealMaxFrequency=t,cs(h,t)||this.subscription.fireOnRealMaxFrequency(t,this.m_subId)},__class__:tt});var et=function(t,e,s){X.call(this,t,e,s)};et.__name__="com.lightstreamer.client.internal.ModeStrategyDistinct",et.__super__=X,et.prototype=c(X.prototype,{createItem:function(t){return new At(t,this.subscription,this.client,this.m_subId)},__class__:et});var st=function(t,e,s){X.call(this,t,e,s)};st.__name__="com.lightstreamer.client.internal.ModeStrategyMerge",st.__super__=X,st.prototype=c(X.prototype,{createItem:function(t){return new Ut(t,this.subscription,this.client,this.m_subId)},__class__:st});var it=function(t,e,s){X.call(this,t,e,s)};it.__name__="com.lightstreamer.client.internal.ModeStrategyRaw",it.__super__=X,it.prototype=c(X.prototype,{createItem:function(t){return new Wt(t,this.subscription,this.client,this.m_subId)},__class__:it});var nt=function(t,e,s,i,n,r,a){this.mpn_badge_reset_requested=!1,this.mpn_filter_pendings=[],this.mpn_snapshotSet=new Me,this.mpn_candidate_devices=[],this.mpnSubscriptionManagers=Se._new(),N.call(this,t,e,s,i,n,r,a),this.mpnRegisterRequest=new ut(this),this.mpnFilterUnsubscriptionRequest=new lt(this),this.mpnBadgeResetRequest=new _t(this)};nt.__name__="com.lightstreamer.client.internal.MpnClientMachine",nt.__super__=N,nt.prototype=c(N.prototype,{evtExtConnect_NextRegion:function(){return this.evtExtConnect_MpnRegion()},evtExtConnect_MpnRegion:function(){var t=!0;return 401==this.state.s_mpn.m&&(this.state.s_mpn.m=403,this.state.traceState(),t=this.evtExtConnect_NetworkReachabilityRegion(),this.genSendMpnRegister()),t&&(t=this.evtExtConnect_NetworkReachabilityRegion()),!1},evtREQOK_Forward:function(t){this.traceEvent("mpn:REQOK");var e=!0;return 403==this.state.s_mpn.m&&t==this.mpn_lastRegisterReqId?(this.state.s_mpn.m=404,this.state.traceState(),e=this.evtREQOK_TransportRegion(t)):406==this.state.s_mpn.m&&t==this.mpn_lastRegisterReqId?(this.state.s_mpn.m=407,this.state.traceState(),e=this.evtREQOK_TransportRegion(t)):453==this.state.s_mpn.tk&&t==this.mpn_lastRegisterReqId?(this.state.s_mpn.tk=454,this.state.traceState(),e=this.evtREQOK_TransportRegion(t)):432==this.state.s_mpn.ft&&t==this.mpn_filter_lastDeactivateReqId?(this.doREQMpnUnsubscribeFilter(),this.state.s_mpn.ft=430,this.state.traceState(),e=this.evtREQOK_TransportRegion(t),this.evtMpnCheckFilter()):442==this.state.s_mpn.bg&&t==this.mpn_badge_lastResetReqId&&(this.doREQOKMpnResetBadge(),e=this.evtREQOK_TransportRegion(t),this.state.s_mpn.bg=440,this.state.traceState(),this.evtMpnCheckReset()),e},evtREQERR_Forward:function(t,e,s){this.traceEvent("mpn:REQERR");var i=!0;return 403==this.state.s_mpn.m&&t==this.mpn_lastRegisterReqId?(this.notifyDeviceError(e,s),this.state.s_mpn.m=402,this.state.traceState(),i=this.evtREQERR_TransportRegion(t,e,s),this.evtMpnCheckNext()):406==this.state.s_mpn.m&&t==this.mpn_lastRegisterReqId?(this.notifyDeviceError(e,s),this.state.s_mpn.m=408,this.state.traceState(),i=this.evtREQERR_TransportRegion(t,e,s),this.evtMpnCheckNext()):453==this.state.s_mpn.tk&&t==this.mpn_lastRegisterReqId?(this.notifyDeviceError(e,s),this.state.s_mpn.tk=452,this.state.traceState(),i=this.evtREQERR_TransportRegion(t,e,s),this.evtMpnCheckNext()):432==this.state.s_mpn.ft&&t==this.mpn_filter_lastDeactivateReqId?(this.doREQMpnUnsubscribeFilter(),this.state.s_mpn.ft=430,this.state.traceState(),i=this.evtREQERR_TransportRegion(t,e,s),this.evtMpnCheckFilter()):442==this.state.s_mpn.bg&&t==this.mpn_badge_lastResetReqId&&(this.doREQERRMpnResetBadge(),this.notifyOnBadgeResetFailed(e,s),this.state.s_mpn.bg=440,this.state.traceState(),i=this.evtREQERR_TransportRegion(t,e,s),this.evtMpnCheckReset()),i},evtRetry_NextRegion:function(){return this.evtRetry_MpnRegion()},evtRetry_MpnRegion:function(){switch(this.state.s_mpn.m){case 403:case 404:this.state.s_mpn.m=403,this.state.traceState();break;case 405:this.doRemoveMpnSpecialListeners(),this.state.s_mpn.m=406,this.state.s_mpn.st=null,this.state.s_mpn.tk=null,this.state.s_mpn.sbs=null,this.state.s_mpn.ft=null,this.state.s_mpn.bg=null,this.state.traceState(),this.genUnsubscribeMpnSpecialItems();break;case 406:case 407:this.state.s_mpn.m=406,this.state.traceState()}return!1},evtTerminate_NextRegion:function(){return this.evtTerminate_MpnRegion()},evtTerminate_MpnRegion:function(){var t=!0;switch(this.state.s_mpn.m){case 403:case 404:case 406:case 407:this.state.s_mpn.m=401,this.state.traceState(),t=this.evtTerminate_NetworkReachabilityRegion(),this.evtResetMpnDevice();break;case 405:this.doRemoveMpnSpecialListeners(),this.state.s_mpn.m=401,this.state.s_mpn.st=null,this.state.s_mpn.tk=null,this.state.s_mpn.sbs=null,this.state.s_mpn.ft=null,this.state.s_mpn.bg=null,this.state.traceState(),t=this.evtTerminate_NetworkReachabilityRegion(),this.genUnsubscribeMpnSpecialItems(),this.evtResetMpnDevice()}return t&&(t=this.evtTerminate_NetworkReachabilityRegion()),!1},evtMessage:function(t){if(!N.prototype.evtMessage.call(this,t))if(v.startsWith(t,"MPNREG")){var e=t.split(",");this.evtMPNREG(e[1],e[2])}else v.startsWith(t,"MPNZERO")?this.evtMPNZERO(t.split(",")[1]):v.startsWith(t,"MPNOK")?(e=t.split(","),this.evtMPNOK(vt(e[1]),e[2])):v.startsWith(t,"MPNDEL")?this.evtMPNDEL(t.split(",")[1]):v.startsWith(t,"MPNCONF")&&this.evtMPNCONF(t.split(",")[1]);return!0},evtExtMpnRegister:function(){this.traceEvent("mpn.register"),400==this.state.s_mpn.m||401==this.state.s_mpn.m?(this.state.s_mpn.m=402,this.state.traceState(),this.evtMpnCheckNext()):451==this.state.s_mpn.tk&&(this.state.s_mpn.tk=452,this.state.traceState(),this.evtMpnCheckNext())},evtMpnCheckNext:function(){this.traceEvent("mpn.check.next"),402==this.state.s_mpn.m?m.empty(this.mpn_candidate_devices)?(this.state.s_mpn.m=401,this.state.traceState(),this.evtResetMpnDevice()):(this.doRegisterMpnDevice(),this.state.s_mpn.m=403,this.state.traceState(),this.genSendMpnRegister()):408==this.state.s_mpn.m?m.empty(this.mpn_candidate_devices)?(this.state.s_mpn.m=401,this.state.traceState(),this.evtResetMpnDevice()):(this.doRegisterMpnDevice(),this.state.s_mpn.m=406,this.state.traceState(),this.genSendMpnRegister()):452==this.state.s_mpn.tk&&(m.empty(this.mpn_candidate_devices)?(this.doRemoveMpnSpecialListeners(),this.state.s_mpn.m=401,this.state.s_mpn.st=null,this.state.s_mpn.tk=null,this.state.s_mpn.sbs=null,this.state.s_mpn.ft=null,this.state.s_mpn.bg=null,this.state.traceState(),this.genUnsubscribeMpnSpecialItems(),this.evtResetMpnDevice()):(this.doRegisterMpnDevice(),this.state.s_mpn.tk=453,this.state.traceState(),this.genSendMpnRegister()))},evtResetMpnDevice:function(){this.traceEvent("reset.mpn.device"),401==this.state.s_mpn.m&&(this.doResetMpnDevice(),this.notifyDeviceReset(),this.state.s_mpn.m=401,this.state.traceState())},evtMpnError:function(t,e){this.traceEvent("mpn.error"),405==this.state.s_mpn.m&&(this.doRemoveMpnSpecialListeners(),this.notifyDeviceError(t,e),this.state.s_mpn.m=401,this.state.s_mpn.st=null,this.state.s_mpn.sbs=null,this.state.s_mpn.ft=null,this.state.s_mpn.bg=null,this.state.s_mpn.tk=null,this.state.traceState(),this.genUnsubscribeMpnSpecialItems(),this.evtResetMpnDevice())},evtMPNREG:function(t,e){this.traceEvent("MPNREG"),Mi.isDebugEnabled()&&Mi.debug("MPNREG "+t+" "+e);var s=!0;if(this.state.inPushing())if(this.isFreshData()){this.doMPNREG();var i=this.state.inStreaming();s=this.evtMPNREG_MpnRegion(t,e),i&&this.evtRestartKeepalive()}else this.onStaleData(),i=this.state.inStreaming(),s=this.evtMPNREG_MpnRegion(t,e),i&&this.evtRestartKeepalive();s&&(s=this.evtMPNREG_MpnRegion(t,e))},evtMPNREG_MpnRegion:function(t,e){return 403==this.state.s_mpn.m||404==this.state.s_mpn.m?(this.doMPNREG_Register(t,e),this.notifyDeviceRegistered(0),this.state.s_mpn.m=405,this.state.s_mpn.st=410,this.state.s_mpn.sbs=420,this.state.s_mpn.ft=430,this.state.s_mpn.bg=440,this.state.s_mpn.tk=450,this.state.traceState(),this.genDeviceActive(),this.genSubscribeSpecialItems(),this.evtMpnCheckPending(),this.evtSUBS_Init(),this.evtMpnCheckFilter(),this.evtMpnCheckReset()):406==this.state.s_mpn.m||407==this.state.s_mpn.m?t==this.mpn_deviceId&&e==this.mpn_adapterName?(this.doMPNREG_Register(t,e),this.notifyDeviceRegistered(0),this.state.s_mpn.m=405,this.state.s_mpn.st=410,this.state.s_mpn.sbs=420,this.state.s_mpn.ft=430,this.state.s_mpn.bg=440,this.state.s_mpn.tk=450,this.state.traceState(),this.genDeviceActive(),this.genSubscribeSpecialItems(),this.evtMpnCheckPending(),this.evtSUBS_Init(),this.evtMpnCheckFilter(),this.evtMpnCheckReset()):(this.doMPNREG_Error(),this.notifyDeviceError_DifferentDevice(),this.state.s_mpn.m=408,this.state.traceState(),this.evtMpnCheckNext()):453!=this.state.s_mpn.tk&&454!=this.state.s_mpn.tk||(t==this.mpn_deviceId&&e==this.mpn_adapterName?(this.doMPNREG_RefreshToken(t,e),this.state.s_mpn.tk=450,this.state.traceState(),this.evtMpnCheckPending()):(this.doMPNREG_Error(),this.notifyDeviceError_DifferentDevice(),this.state.s_mpn.tk=452,this.state.traceState(),this.evtMpnCheckNext())),!1},evtMPNZERO:function(t){this.traceEvent("MPNZERO"),Mi.isDebugEnabled()&&Mi.debug("MPNZERO "+t),this.state.inPushing()&&(this.isFreshData()?(this.doMPNZERO(t),this.state.inStreaming()&&this.evtRestartKeepalive()):(this.onStaleData(),this.state.inStreaming()&&this.evtRestartKeepalive()))},evtMPNOK:function(t,e){this.traceEvent("MPNOK"),Mi.isDebugEnabled()&&Mi.debug("MPNOK "+t+" "+e),this.state.inPushing()&&(this.isFreshData()?(this.doMPNOK(t,e),this.state.inStreaming()&&this.evtRestartKeepalive()):(this.onStaleData(),this.state.inStreaming()&&this.evtRestartKeepalive()))},evtMPNDEL:function(t){this.traceEvent("MPNDEL"),Mi.isDebugEnabled()&&Mi.debug("MPNDEL "+t),this.state.inPushing()&&(this.isFreshData()?(this.doMPNDEL(t),this.state.inStreaming()&&this.evtRestartKeepalive()):(this.onStaleData(),this.state.inStreaming()&&this.evtRestartKeepalive()))},evtMPNCONF:function(t){this.traceEvent("MPNCONF"),Mi.isDebugEnabled()&&Mi.debug("MPNCONF "+t),this.state.inPushing()&&(this.isFreshData()?(this.doMPNCONF(t),this.state.inStreaming()&&this.evtRestartKeepalive()):(this.onStaleData(),this.state.inStreaming()&&this.evtRestartKeepalive()))},evtDEV_Update:function(t,e){this.traceEvent("DEV.update"),410==this.state.s_mpn.st?"ACTIVE"==t?(ye.sure(this.mpn_device).isRegistered()||this.notifyDeviceRegistered(e),this.state.s_mpn.st=410,this.state.traceState()):"SUSPENDED"==t&&(ye.sure(this.mpn_device).isSuspended()||this.notifyDeviceSuspended(e),this.state.s_mpn.st=411,this.state.traceState()):411==this.state.s_mpn.st&&"ACTIVE"==t&&(this.notifyDeviceResume(e),this.state.s_mpn.st=410,this.state.traceState())},evtMpnCheckPending:function(){this.traceEvent("mpn.check.pending"),450==this.state.s_mpn.tk&&(m.empty(this.mpn_candidate_devices)?(this.state.s_mpn.tk=451,this.state.traceState()):(this.state.s_mpn.tk=452,this.state.traceState(),this.evtMpnCheckNext()))},evtSUBS_Init:function(){this.traceEvent("SUBS.init"),420==this.state.s_mpn.sbs&&(this.doClearMpnSnapshot(),this.state.s_mpn.sbs=421,this.state.traceState())},evtSUBS_Update:function(t,e){this.traceEvent("SUBS.update");var s=e.getValue("command"),i=e.getValue("status");null!=this.state.s_mpn.sbs&&this.exists(t)?(this.state.traceState(),this.genSUBS_update(t,e)):421==this.state.s_mpn.sbs&&"DELETE"!=s&&!this.exists(t)||423==this.state.s_mpn.sbs&&"DELETE"!=s&&!this.exists(t)?null==i?(this.doAddToMpnSnapshot(t),this.state.s_mpn.sbs=423,this.state.traceState()):(this.doRemoveFromMpnSnapshot(t),this.doAddMpnSubscription(t),this.state.s_mpn.sbs=423,this.state.traceState(),this.genSUBS_update(t,e)):424!=this.state.s_mpn.sbs||"DELETE"==s||null==i||this.exists(t)||(0==this.mpn_snapshotSet.count()||1==this.mpn_snapshotSet.count()&&this.mpn_snapshotSet.contains(t)?(this.doRemoveFromMpnSnapshot(t),this.doAddMpnSubscription(t),this.state.s_mpn.sbs=424,this.state.traceState(),this.genSUBS_update(t,e),this.notifyOnSubscriptionsUpdated()):(1==this.mpn_snapshotSet.count()&&!this.mpn_snapshotSet.contains(t)||this.mpn_snapshotSet.count()>1)&&(this.doRemoveFromMpnSnapshot(t),this.doAddMpnSubscription(t),this.state.s_mpn.sbs=424,this.state.traceState(),this.genSUBS_update(t,e)))},evtSUBS_EOS:function(){this.traceEvent("SUBS.EOS"),421==this.state.s_mpn.sbs?(this.state.s_mpn.sbs=424,this.state.traceState(),this.genSUBS_EOS(),this.notifyOnSubscriptionsUpdated()):423==this.state.s_mpn.sbs&&(this.mpn_snapshotSet.count()>0?(this.state.s_mpn.sbs=424,this.state.traceState(),this.genSUBS_EOS()):(this.state.s_mpn.sbs=424,this.state.traceState(),this.genSUBS_EOS(),this.notifyOnSubscriptionsUpdated()))},evtExtMpnUnsubscribeFilter:function(){this.traceEvent("mpn.unsubscribe.filter"),431==this.state.s_mpn.ft&&(this.state.s_mpn.ft=430,this.state.traceState(),this.evtMpnCheckFilter())},evtMpnCheckFilter:function(){this.traceEvent("mpn.check.filter"),430==this.state.s_mpn.ft&&(m.empty(this.mpn_filter_pendings)?(this.state.s_mpn.ft=431,this.state.traceState()):(this.state.s_mpn.ft=432,this.state.traceState(),this.genSendMpnUnsubscribeFilter()))},evtExtMpnResetBadge:function(){this.traceEvent("mpn.reset.badge"),441==this.state.s_mpn.bg&&(this.state.s_mpn.bg=440,this.state.traceState(),this.evtMpnCheckReset())},evtMpnCheckReset:function(){this.traceEvent("mpn.check.reset"),440==this.state.s_mpn.bg&&(this.mpn_badge_reset_requested?(this.state.s_mpn.bg=442,this.state.traceState(),this.genSendMpnResetBadge()):(this.state.s_mpn.bg=441,this.state.traceState()))},doREQOK:function(t){N.prototype.doREQOK.call(this,t);for(var e=this.mpnSubscriptionManagers.h;null!=e;){var s=e.item;e=e.next,s.evtREQOK(t)}},doREQERR:function(t,e,s){N.prototype.doREQERR.call(this,t,e,s);for(var i=this.mpnSubscriptionManagers.h;null!=i;){var n=i.item;i=i.next,n.evtREQERR(t,e,s)}},genAbortSubscriptions:function(){N.prototype.genAbortSubscriptions.call(this);for(var t=this.mpnSubscriptionManagers.h;null!=t;){var e=t.item;t=t.next,e.evtAbort()}},getPendingControls:function(){var t=N.prototype.getPendingControls.call(this);this.mpnRegisterRequest.isPending()&&t.push(this.mpnRegisterRequest);for(var e=this.mpnSubscriptionManagers.filter((function(t){return t.isPending()})).h;null!=e;){var s=e.item;e=e.next,t.push(s)}return this.mpnFilterUnsubscriptionRequest.isPending()&&t.push(this.mpnFilterUnsubscriptionRequest),this.mpnBadgeResetRequest.isPending()&&t.push(this.mpnBadgeResetRequest),t},doRegisterMpnDevice:function(){if(m.empty(this.mpn_candidate_devices))throw new be("Assertion failure: !mpn_candidate_devices.empty()");this.mpn_device=this.mpn_candidate_devices.shift()},doRemoveMpnSpecialListeners:function(){this.mpn_deviceSubscription.removeListener(this.mpn_deviceListener),this.mpn_deviceListener.disable(),this.mpn_deviceListener=null,this.mpn_itemSubscription.removeListener(this.mpn_itemListener),this.mpn_itemListener.disable(),this.mpn_itemListener=null},genSendMpnRegister:function(){this.evtSendControl(this.mpnRegisterRequest)},genUnsubscribeMpnSpecialItems:function(){this.client.unsubscribe(ye.sure(this.mpn_deviceSubscription)),this.client.unsubscribe(ye.sure(this.mpn_itemSubscription))},doResetMpnDevice:function(){this.mpn_deviceId=null,this.mpn_deviceToken=null,this.mpn_adapterName=null,this.mpn_lastRegisterReqId=null,this.mpn_deviceSubscription=null,this.mpn_itemSubscription=null,this.mpn_deviceListener=null,this.mpn_itemListener=null,this.mpn_snapshotSet.removeAll(),_e(this.mpn_filter_pendings),this.mpn_filter_lastDeactivateReqId=null,this.mpn_badge_reset_requested=!1,this.mpn_badge_lastResetReqId=null},notifyDeviceReset:function(){ye.sure(this.mpn_device).onReset()},notifyDeviceError:function(t,e){ye.sure(this.mpn_device).onError(t,e)},doMPNREG:function(){this.onFreshData()},doMPNREG_Register:function(t,e){if(null==this.mpn_device)throw new be("Assertion failure: mpn_device != null");this.mpn_deviceId=t,this.mpn_deviceToken=this.mpn_device.getDeviceToken(),this.mpn_adapterName=e,this.mpn_device.setDeviceId(t,e),this.createSpecialItems(t,e)},doMPNZERO:function(t){this.onFreshData(),null!=this.mpn_deviceId&&t==this.mpn_deviceId&&ye.sure(this.mpn_device).fireOnBadgeReset()},createSpecialItems:function(t,e){this.mpn_deviceListener=new ot(this);var s=new M("MERGE",["DEV-"+t].slice(),["status","status_timestamp"].slice());s.setInternal(),s.setDataAdapter(e),s.setRequestedMaxFrequency("unfiltered"),s.addListener(this.mpn_deviceListener),this.mpn_deviceSubscription=s,this.mpn_itemListener=new ht(this);var i=new M("COMMAND",["SUBS-"+t].slice(),["key","command"].slice());i.setInternal(),i.setDataAdapter(e),i.setRequestedMaxFrequency("unfiltered"),i.setCommandSecondLevelFields(["status","status_timestamp","notification_format","trigger","group","schema","adapter","mode","requested_buffer_size","requested_max_frequency"].slice()),i.setCommandSecondLevelDataAdapter(e),i.addListener(this.mpn_itemListener),this.mpn_itemSubscription=i},genDeviceActive:function(){for(var t=this.mpnSubscriptionManagers.h;null!=t;){var e=t.item;t=t.next,e.evtDeviceActive()}},genSubscribeSpecialItems:function(){if(null==this.mpn_deviceSubscription)throw new be("Assertion failure: mpn_deviceSubscription != null");if(null==this.mpn_itemSubscription)throw new be("Assertion failure: mpn_itemSubscription != null");this.subscribeExt(this.mpn_deviceSubscription,!0),this.subscribeExt(this.mpn_itemSubscription,!0)},doMPNREG_Error:function(){},notifyDeviceError_DifferentDevice:function(){ye.sure(this.mpn_device).onError(62,"DeviceId or Adapter Name has unexpectedly been changed")},doMPNREG_RefreshToken:function(t,e){if(null==this.mpn_device)throw new be("Assertion failure: mpn_device != null");this.mpn_deviceToken=this.mpn_device.getDeviceToken(),this.mpn_device.setDeviceId(t,e)},notifyDeviceRegistered:function(t){ye.sure(this.mpn_device).onRegistered(t)},notifyDeviceSuspended:function(t){ye.sure(this.mpn_device).onSuspend(t)},notifyDeviceResume:function(t){ye.sure(this.mpn_device).onResume(t)},doClearMpnSnapshot:function(){this.mpn_snapshotSet.removeAll()},exists:function(t){return m.exists(this.mpnSubscriptionManagers,(function(e){return e.fetch_mpnSubId()==t}))},genSUBS_update:function(t,e){for(var s=this.mpnSubscriptionManagers.h;null!=s;){var i=s.item;s=s.next,t==i.fetch_mpnSubId()&&i.evtMpnUpdate(e)}},doAddToMpnSnapshot:function(t){this.mpn_snapshotSet.insert(t)},doRemoveFromMpnSnapshot:function(t){this.mpn_snapshotSet.remove(t)},doAddMpnSubscription:function(t){new pt(ft.Ctor2(t,this)).start()},notifyOnSubscriptionsUpdated:function(){ye.sure(this.mpn_device).fireOnSubscriptionsUpdated()},genSUBS_EOS:function(){for(var t=this.mpnSubscriptionManagers.h;null!=t;){var e=t.item;t=t.next,e.evtMpnEOS()}},genSendMpnUnsubscribeFilter:function(){this.evtSendControl(this.mpnFilterUnsubscriptionRequest)},genSendMpnResetBadge:function(){this.evtSendControl(this.mpnBadgeResetRequest)},doREQMpnUnsubscribeFilter:function(){this.mpn_filter_pendings.shift()},doREQOKMpnResetBadge:function(){this.mpn_badge_reset_requested=!1},doREQERRMpnResetBadge:function(){this.mpn_badge_reset_requested=!1},notifyOnBadgeResetFailed:function(t,e){ye.sure(this.mpn_device).fireOnBadgeResetFailed(t,e)},doMPNOK:function(t,e){this.onFreshData();for(var s=this.mpnSubscriptionManagers.h;null!=s;){var i=s.item;s=s.next,i.m_subId==t&&i.evtMPNOK(e)}},doMPNDEL:function(t){this.onFreshData();for(var e=this.mpnSubscriptionManagers.h;null!=e;){var s=e.item;e=e.next,s.fetch_mpnSubId()==t&&s.evtMPNDEL()}},doMPNCONF:function(t){this.onFreshData()},encodeMpnRegister:function(){if(null==this.mpn_device)throw new be("Assertion failure: mpn_device != null");var t=new Le,e=this.mpn_device.getDeviceToken(),s=this.mpn_device.getPreviousDeviceToken();return this.mpn_lastRegisterReqId=this.generateFreshReqId(),t.LS_reqId(this.mpn_lastRegisterReqId),t.LS_op("register"),t.PN_type(this.mpn_device.getPlatform()),t.PN_appId(this.mpn_device.getApplicationId()),null==s||s==e?t.PN_deviceToken(e):(t.PN_deviceToken(s),t.PN_newDeviceToken(e)),Mi.isInfoEnabled()&&Mi.info("Sending MPNDevice register: "+p.string(t)),t.getEncodedString()},encodeMpnRefreshToken:function(){if(null==this.mpn_device)throw new be("Assertion failure: mpn_device != null");var t=new Le;return this.mpn_lastRegisterReqId=this.generateFreshReqId(),t.LS_reqId(this.mpn_lastRegisterReqId),t.LS_op("register"),t.PN_type(this.mpn_device.getPlatform()),t.PN_appId(this.mpn_device.getApplicationId()),t.PN_deviceToken(ye.sure(this.mpn_deviceToken)),t.PN_newDeviceToken(this.mpn_device.getDeviceToken()),t.LS_cause("refresh.token"),Mi.isInfoEnabled()&&Mi.info("Sending MPNDevice refresh: "+p.string(t)),t.getEncodedString()},encodeMpnRestore:function(){if(null==this.mpn_device)throw new be("Assertion failure: mpn_device != null");var t=new Le;return this.mpn_lastRegisterReqId=this.generateFreshReqId(),t.LS_reqId(this.mpn_lastRegisterReqId),t.LS_op("register"),t.PN_type(this.mpn_device.getPlatform()),t.PN_appId(this.mpn_device.getApplicationId()),t.PN_deviceToken(ye.sure(this.mpn_deviceToken)),t.PN_newDeviceToken(this.mpn_device.getDeviceToken()),t.LS_cause("restore.token"),Mi.isInfoEnabled()&&Mi.info("Sending MPNDevice restore: "+p.string(t)),t.getEncodedString()},encodeDeactivateFilter:function(){var t=new Le;switch(this.mpn_filter_lastDeactivateReqId=this.generateFreshReqId(),t.LS_reqId(this.mpn_filter_lastDeactivateReqId),t.LS_op("deactivate"),t.PN_deviceId(ye.sure(this.mpn_deviceId)),this.mpn_filter_pendings[0]._hx_index){case 1:t.PN_subscriptionStatus("ACTIVE");break;case 2:t.PN_subscriptionStatus("TRIGGERED")}return Mi.isInfoEnabled()&&Mi.info("Sending multiple MPNSubscription deactivate: "+p.string(t)),t.getEncodedString()},encodeBadgeReset:function(){var t=new Le;return this.mpn_badge_lastResetReqId=this.generateFreshReqId(),t.LS_reqId(this.mpn_badge_lastResetReqId),t.LS_op("reset_badge"),t.PN_deviceId(ye.sure(this.mpn_deviceId)),Mi.isInfoEnabled()&&Mi.info("Sending MPNDevice badge reset: "+p.string(t)),t.getEncodedString()},relate:function(t){if(m.has(this.mpnSubscriptionManagers,t))throw new be("Assertion failure: !mpnSubscriptionManagers.contains(subManager)");this.mpnSubscriptionManagers.add(t)},unrelate:function(t){this.mpnSubscriptionManagers.remove(t)},fetch_mpn_deviceId:function(){return this.mpn_deviceId},fetch_mpn_device:function(){return this.mpn_device},registerForMpn:function(t){if(null==t)throw new R("Device cannot be null");this.mpn_candidate_devices.push(t),Pi.isInfoEnabled()&&Pi.info("MPN registration requested: "+p.string(t)),this.evtExtMpnRegister()},subscribeMpn:function(t,e){if(null==this.mpn_device)throw new be(wi);if(t.isActive())throw new R(yi);if(null==t.getNotificationFormat())throw new R(Ri);if(null==t.getItems()&&null==t.getItemGroup())throw new R("Specify property 'items' or 'itemGroup'");if(null==t.getFields()&&null==t.getFieldSchema())throw new R("Specify property 'fields' or 'fieldSchema'");var s=new pt(ft.Ctor1(t,e,this));Pi.isInfoEnabled()&&Pi.info("MPN Subscription requested: subId: "+s.m_subId+" "+p.string(t)+" coalescing: "+(null==e?"null":""+e)),s.evtExtMpnSubscribe()},unsubscribeMpn:function(t){if(null==this.mpn_device)throw new be(wi);var e=t.fetch_subManager();if(null!=e){if(!m.has(this.mpnSubscriptionManagers,e))throw new be("The MPNSubscription is not subscribed to this Client");Pi.isInfoEnabled()&&Pi.info("MPN Unsubscription requested: pnSubId: "+t.getSubscriptionId()+" "+p.string(t)),e.evtExtMpnUnsubscribe()}},unsubscribeMpnSubscriptions:function(t){if(null==this.mpn_device)throw new be(wi);var e=ct(t);this.mpn_filter_pendings.push(e),Pi.isInfoEnabled()&&Pi.info("Multiple MPN Unsubscriptions requested: "+p.string(e)),this.evtExtMpnUnsubscribeFilter()},getMpnSubscriptions:function(t){if(null==this.mpn_device)throw new be(wi);var e;switch(ct(t)._hx_index){case 0:e=this.mpnSubscriptionManagers.map((function(t){return t.m_subscription})).filter((function(t){return t.fetch_status()==re.Subscribed||t.fetch_status()==re.Triggered}));break;case 1:e=this.mpnSubscriptionManagers.map((function(t){return t.m_subscription})).filter((function(t){return t.fetch_status()==re.Subscribed}));break;case 2:e=this.mpnSubscriptionManagers.map((function(t){return t.m_subscription})).filter((function(t){return t.fetch_status()==re.Triggered}))}for(var s=Object.create(null),i=e.h;null!=i;){var n=i.item;i=i.next;var r=n.getSubscriptionId();if(null!=r){var a=s[r];null==a?s[r]=[n]:a.push(n)}}for(var o=[],h=Object.keys(s),c=h.length,u=0;u<c;){for(var l=s[h[u++]],_=!1,d=0;d<l.length;){var m=l[d];if(++d,!m.fetch_madeByServer()){o.push(m),_=!0;break}}_||null==l[0]||o.push(l[0])}return o},findMpnSubscription:function(t){if(null==t)throw new R("Subscription id must be not null");if(null==this.mpn_device)throw new be(wi);for(var e=this.mpnSubscriptionManagers.h;null!=e;){var s=e.item;if(e=e.next,s.m_subscription.getSubscriptionId()==t)return s.m_subscription}return null},__class__:nt});var rt=a["com.lightstreamer.client.internal._MpnClientMachine.MPNSubscriptionStatus"]={__ename__:!0,__constructs__:null,ALL:{_hx_name:"ALL",_hx_index:0,__enum__:"com.lightstreamer.client.internal._MpnClientMachine.MPNSubscriptionStatus",toString:r},SUBSCRIBED:{_hx_name:"SUBSCRIBED",_hx_index:1,__enum__:"com.lightstreamer.client.internal._MpnClientMachine.MPNSubscriptionStatus",toString:r},TRIGGERED:{_hx_name:"TRIGGERED",_hx_index:2,__enum__:"com.lightstreamer.client.internal._MpnClientMachine.MPNSubscriptionStatus",toString:r}};rt.__constructs__=[rt.ALL,rt.SUBSCRIBED,rt.TRIGGERED];var at=function(t){this.m_disabled=!1,this.client=t};at.__name__="com.lightstreamer.client.internal._MpnClientMachine.SubscriptionDelegateBase",at.__interfaces__=[h],at.prototype={disable:function(){var t=this;xe.synchronized(this.client.lock,(function(){return t.m_disabled=!0}))},synchronized:function(t){var e=this;xe.synchronized(this.client.lock,(function(){e.m_disabled||t()}))},onClearSnapshot:function(t,e){},onCommandSecondLevelItemLostUpdates:function(t,e){},onCommandSecondLevelSubscriptionError:function(t,e,s){},onEndOfSnapshot:function(t,e){},onItemLostUpdates:function(t,e,s){},onItemUpdate:function(t){},onListenEnd:function(t){},onListenStart:function(t){},onSubscription:function(){},onSubscriptionError:function(t,e){},onUnsubscription:function(){},onRealMaxFrequency:function(t){},__class__:at};var ot=function(t){at.call(this,t)};ot.__name__="com.lightstreamer.client.internal._MpnClientMachine.MpnDeviceDelegate",ot.__super__=at,ot.prototype=c(at.prototype,{onItemUpdate:function(t){var e=this;this.synchronized((function(){var s=t.getValue("status"),i=t.getValue("status_timestamp");null!=s&&e.client.evtDEV_Update(s,bt(null!=i?i:"0"))}))},onSubscriptionError:function(t,e){var s=this;this.synchronized((function(){s.client.evtMpnError(62,"MPN device activation can't be completed (62/1)")}))},onUnsubscription:function(){var t=this;this.synchronized((function(){t.client.evtMpnError(62,"MPN device activation can't be completed (62/2)")}))},__class__:ot});var ht=function(t){at.call(this,t)};function ct(t){if(null==t)return rt.ALL;switch(t){case"ALL":return rt.ALL;case"SUBSCRIBED":return rt.SUBSCRIBED;case"TRIGGERED":return rt.TRIGGERED;default:throw new R("The given value is not valid for this setting. Use null, ALL, TRIGGERED or SUBSCRIBED instead")}}ht.__name__="com.lightstreamer.client.internal._MpnClientMachine.MpnItemDelegate",ht.__super__=at,ht.prototype=c(at.prototype,{onItemUpdate:function(t){var e=this;this.synchronized((function(){var s=t.getValue("key");null!=s&&e.client.evtSUBS_Update(s.substring(4),t)}))},onEndOfSnapshot:function(t,e){var s=this;this.synchronized((function(){s.client.evtSUBS_EOS()}))},onSubscriptionError:function(t,e){var s=this;this.synchronized((function(){s.client.evtMpnError(62,"MPN device activation can't be completed (62/3)")}))},onUnsubscription:function(){var t=this;this.synchronized((function(){t.client.evtMpnError(62,"MPN device activation can't be completed (62/4)")}))},onCommandSecondLevelSubscriptionError:function(t,e,s){this.synchronized((function(){Ai.isWarnEnabled()&&Ai.warn("MPN device can't complete the subscription of "+s)}))},__class__:ht});var ut=function(t){this.client=t};ut.__name__="com.lightstreamer.client.internal.MpnRegisterRequest",ut.__interfaces__=[U],ut.prototype={isPending:function(){return 403==this.client.state.s_mpn.m||406==this.client.state.s_mpn.m||453==this.client.state.s_mpn.tk},encode:function(t){if(403==this.client.state.s_mpn.m)return this.client.encodeMpnRegister();if(406==this.client.state.s_mpn.m)return this.client.encodeMpnRestore();if(453==this.client.state.s_mpn.tk)return this.client.encodeMpnRefreshToken();throw new be("Can't encode register request")},encodeWS:function(){return"control\r\n"+this.encode(!0)},__class__:ut};var lt=function(t){this.client=t};lt.__name__="com.lightstreamer.client.internal.MpnFilterUnsubscriptionRequest",lt.__interfaces__=[U],lt.prototype={isPending:function(){return 432==this.client.state.s_mpn.ft},encode:function(t){if(this.isPending())return this.client.encodeDeactivateFilter();throw new be("Can't encode unsubscription request")},encodeWS:function(){return"control\r\n"+this.encode(!0)},__class__:lt};var _t=function(t){this.client=t};_t.__name__="com.lightstreamer.client.internal.MpnBadgeResetRequest",_t.__interfaces__=[U],_t.prototype={isPending:function(){return 442==this.client.state.s_mpn.bg},encode:function(t){if(this.isPending())return this.client.encodeBadgeReset();throw new be("Can't encode badge reset request")},encodeWS:function(){return"control\r\n"+this.encode(!0)},__class__:_t};var dt=function(){this.m=400};dt.__name__="com.lightstreamer.client.internal.StateVar_mpn",dt.prototype={toString:function(){var t="<mpn_m="+this.m;return null!=this.st&&(t+=" mpn_st="+this.st),null!=this.tk&&(t+=" mpn_tk="+this.tk),null!=this.sbs&&(t+=" mpn_sbs="+this.sbs),null!=this.ft&&(t+=" mpn_ft="+this.ft),null!=this.bg&&(t+=" mpn_bg="+this.bg),t+=">"},__class__:dt};var mt=function(t,e){this.s_tu=30,this.s_fu=20,this.s_uu=10,this.s_m=t,this.manager=e};mt.__name__="com.lightstreamer.client.internal._MpnSubscriptionManager.State",mt.prototype={toString:function(){var t="<m="+this.s_m;return t+=" uu="+this.s_uu,t+=" fu="+this.s_fu,t+=" tu="+this.s_tu,null!=this.s_st&&(t+=" st="+this.s_st),null!=this.s_ab&&(t+=" ab="+this.s_ab),null!=this.s_ct&&(t+=" ct="+this.s_ct),t+=">"},traceState:function(){Ni.isTraceEnabled()&&Ni.trace("mpn#sub#goto("+this.manager.m_subId+":"+this.manager.fetch_mpnSubId()+") "+this.toString())},__class__:mt};var ft=a["com.lightstreamer.client.internal._MpnSubscriptionManager.CtorArgs"]={__ename__:!0,__constructs__:null,Ctor1:(e=function(t,e,s){return{_hx_index:0,sub:t,coalescing:e,client:s,__enum__:"com.lightstreamer.client.internal._MpnSubscriptionManager.CtorArgs",toString:r}},e._hx_name="Ctor1",e.__params__=["sub","coalescing","client"],e),Ctor2:(e=function(t,e){return{_hx_index:1,mpnSubId:t,client:e,__enum__:"com.lightstreamer.client.internal._MpnSubscriptionManager.CtorArgs",toString:r}},e._hx_name="Ctor2",e.__params__=["mpnSubId","client"],e)};ft.__constructs__=[ft.Ctor1,ft.Ctor2];var pt=function(t){var e=null,s=null,i=null,n=null;switch(t._hx_index){case 0:e=t.sub,s=t.coalescing,i=t.client;break;case 1:n=t.mpnSubId,i=t.client}null==n?(this.lock=i.lock,this.m_subId=i.generateFreshSubId(),this.m_coalescing=s,this.m_initFormat=e.getNotificationFormat(),this.m_initTrigger=e.getTriggerExpression(),this.m_subscription=e,this.m_client=i,this.state=new mt(40,this),this.m_subscription.relate(this),this.m_client.relate(this)):(this.lock=i.lock,this.m_subId=null,this.m_coalescing=!1,this.m_initFormat=null,this.m_initTrigger=null,this.m_subscription=new oe("MERGE",null,null),this.m_subscription.reInit(n),this.m_client=i,this.state=new mt(45,this),this.m_subscription.relate(this),this.m_client.relate(this))};pt.__name__="com.lightstreamer.client.internal.MpnSubscriptionManager",pt.__interfaces__=[U],pt.prototype={finalize:function(){this.m_subscription.reset(),this.m_client.unrelate(this),this.m_subscription.unrelate(this)},fetch_mpnSubId:function(){return this.m_subscription.fetch_mpnSubId()},start:function(){},evtExtMpnUnsubscribe:function(){this.traceEvent("unsubscribe");var t=!0;41==this.state.s_m?(this.notifyStatus(re.Unknown),this.notifyOnSubscriptionDiscarded(),this.finalize(),this.state.s_m=50,this.state.traceState(),t=this.evtExtMpnUnsubscribe_UnsubRegion()):71==this.state.s_ct&&(this.state.s_ct=70,this.state.traceState(),t=this.evtExtMpnUnsubscribe_UnsubRegion(),this.evtCheck()),t&&this.evtExtMpnUnsubscribe_UnsubRegion()},evtExtMpnUnsubscribe_UnsubRegion:function(){return this.traceEvent("unsubscribe"),(10==this.state.s_uu||12==this.state.s_uu)&&(this.state.s_uu=11,this.state.traceState()),!1},evtAbort:function(){this.traceEvent("abort"),41==this.state.s_m?(this.notifyStatus(re.Unknown),this.notifyOnSubscriptionDiscarded(),this.finalize(),this.state.s_m=50,this.state.traceState()):42==this.state.s_m||43==this.state.s_m?(this.notifyStatus(re.Unknown),this.notifyOnSubscriptionAbort(),this.finalize(),this.state.s_m=50,this.state.traceState()):44==this.state.s_m&&(this.state.s_m=44,this.state.traceState(),this.evtAbort_AbortRegion())},evtAbort_AbortRegion:function(){this.traceEvent("abort");var t=!0;80==this.state.s_ab&&(this.state.s_ab=81,this.state.traceState(),t=this.evtAbort_ControlRegion()),t&&(t=this.evtAbort_ControlRegion())},evtAbort_ControlRegion:function(){return this.traceEvent("abort"),70!=this.state.s_ct&&71!=this.state.s_ct&&72!=this.state.s_ct&&73!=this.state.s_ct&&74!=this.state.s_ct||(this.state.s_ct=76,this.state.traceState(),this.evtAbortFormat(),this.evtAbortTrigger(),this.evtAbortUnsubscribe()),!1},evtRestoreSession:function(){this.traceEvent("restore.session"),76==this.state.s_ct&&(this.state.s_ct=70,this.state.traceState(),this.evtCheck())},evtREQOK:function(t){this.traceEvent("REQOK");var e=!0;22==this.state.s_fu&&t==this.m_lastConfigureReqId?(this.state.s_fu=20,this.state.traceState(),e=this.evtREQOK_TriggerRegion(t)):23==this.state.s_fu&&t==this.m_lastConfigureReqId&&(this.state.s_fu=21,this.state.traceState(),e=this.evtREQOK_TriggerRegion(t)),e&&this.evtREQOK_TriggerRegion(t)},evtREQOK_TriggerRegion:function(t){this.traceEvent("REQOK");var e=!0;return 32==this.state.s_tu&&t==this.m_lastConfigureReqId?(this.state.s_tu=30,this.state.traceState(),e=this.evtREQOK_MainRegion(t)):33==this.state.s_tu&&t==this.m_lastConfigureReqId&&(this.state.s_tu=31,this.state.traceState(),e=this.evtREQOK_MainRegion(t)),e&&this.evtREQOK_MainRegion(t),!1},evtREQOK_MainRegion:function(t){return this.traceEvent("REQOK"),42==this.state.s_m&&t==this.m_lastActivateReqId?(this.state.s_m=43,this.state.traceState()):44==this.state.s_m&&(this.state.s_m=44,this.state.traceState(),this.evtREQOK_ControlRegion(t)),!1},evtREQOK_ControlRegion:function(t){this.traceEvent("REQOK"),72==this.state.s_ct&&t==this.m_lastDeactivateReqId?(this.notifyStatus(re.Unknown),this.notifyOnUnsubscription(),this.notifyOnSubscriptionsUpdated(),this.finalize(),this.state.s_m=52,this.state.s_st=null,this.state.s_ct=null,this.state.s_ab=null,this.state.traceState()):73!=this.state.s_ct&&74!=this.state.s_ct||t!=this.m_lastConfigureReqId||(this.state.s_ct=70,this.state.traceState(),this.evtCheck())},evtREQERR:function(t,e,s){this.traceEvent("REQERR");var i=!0;11==this.state.s_uu&&t==this.m_lastDeactivateReqId&&(this.notifyOnUnsubscriptionError(e,s),this.state.s_uu=12,this.state.traceState(),i=this.evtREQERR_FormatRegion(t,e,s)),i&&(i=this.evtREQERR_FormatRegion(t,e,s))},evtREQERR_FormatRegion:function(t,e,s){this.traceEvent("REQERR");var i=!0;return 22==this.state.s_fu&&t==this.m_lastConfigureReqId?(this.notifyOnModificationError_Format(e,s),this.state.s_fu=20,this.state.traceState(),i=this.evtREQERR_TriggerRegion(t,e,s)):23==this.state.s_fu&&t==this.m_lastConfigureReqId&&(this.state.s_fu=21,this.state.traceState(),i=this.evtREQERR_TriggerRegion(t,e,s)),i&&this.evtREQERR_TriggerRegion(t,e,s),!1},evtREQERR_TriggerRegion:function(t,e,s){this.traceEvent("REQERR");var i=!0;return 32==this.state.s_tu&&t==this.m_lastConfigureReqId?(this.notifyOnModificationError_Trigger(e,s),this.state.s_tu=30,this.state.traceState(),i=this.evtREQERR_MainRegion(t,e,s)):33==this.state.s_tu&&t==this.m_lastConfigureReqId&&(this.state.s_tu=31,this.state.traceState(),i=this.evtREQERR_MainRegion(t,e,s)),i&&this.evtREQERR_MainRegion(t,e,s),!1},evtREQERR_MainRegion:function(t,e,s){return this.traceEvent("REQERR"),42==this.state.s_m&&t==this.m_lastActivateReqId?(this.notifyStatus(re.Unknown),this.notifyOnSubscriptionError(e,s),this.finalize(),this.state.s_m=50,this.state.traceState()):44==this.state.s_m&&(this.state.s_m=44,this.state.traceState(),this.evtREQERR_ControlRegion(t,e,s)),!1},evtREQERR_ControlRegion:function(t,e,s){this.traceEvent("REQERR"),72==this.state.s_ct&&t==this.m_lastDeactivateReqId?(this.state.s_ct=70,this.state.traceState(),this.evtCheck()):73!=this.state.s_ct&&74!=this.state.s_ct||t!=this.m_lastConfigureReqId||(this.state.s_ct=70,this.state.traceState(),this.evtCheck())},evtAbortUnsubscribe:function(){this.traceEvent("abort.unsubscribe"),11==this.state.s_uu&&(this.notifyOnUnsubscriptionAbort(),this.state.s_uu=12,this.state.traceState())},evtExtMpnSetFormat:function(){this.traceEvent("setFormat");var t=!0;20==this.state.s_fu?(this.state.s_fu=21,this.state.traceState(),t=this.evtExtMpnSetFormat_ControlRegion()):22==this.state.s_fu&&(this.state.s_fu=23,this.state.traceState(),t=this.evtExtMpnSetFormat_ControlRegion()),t&&this.evtExtMpnSetFormat_ControlRegion()},evtExtMpnSetFormat_ControlRegion:function(){return this.traceEvent("setFormat"),71==this.state.s_ct&&(this.state.s_ct=70,this.state.traceState(),this.evtCheck()),!1},evtExtMpnSetTrigger:function(){this.traceEvent("setTrigger");var t=!0;30==this.state.s_tu?(this.state.s_tu=31,this.state.traceState(),t=this.evtExtMpnSetTrigger_ControlRegion()):32==this.state.s_tu&&(this.state.s_tu=33,this.state.traceState(),t=this.evtExtMpnSetTrigger_ControlRegion()),t&&this.evtExtMpnSetTrigger_ControlRegion()},evtExtMpnSetTrigger_ControlRegion:function(){return this.traceEvent("setTrigger"),71==this.state.s_ct&&(this.state.s_ct=70,this.state.traceState(),this.evtCheck()),!1},evtChangeFormat:function(){this.traceEvent("change.format"),21==this.state.s_fu&&(this.doSetCurrentFormat(),this.state.s_fu=22,this.state.traceState())},evtChangeTrigger:function(){this.traceEvent("change.trigger"),31==this.state.s_tu&&(this.doSetCurrentTrigger(),this.state.s_tu=32,this.state.traceState())},evtAbortFormat:function(){switch(this.traceEvent("abort.format"),this.state.s_fu){case 21:case 22:case 23:this.notifyOnModificationAbort_Format(),this.state.s_fu=20,this.state.traceState()}},evtAbortTrigger:function(){switch(this.traceEvent("abort.trigger"),this.state.s_tu){case 31:case 32:case 33:this.notifyOnModificationAbort_Trigger(),this.state.s_tu=30,this.state.traceState()}},evtCheck:function(){this.traceEvent("check"),70==this.state.s_ct&&(11==this.state.s_uu?(this.state.s_ct=72,this.state.traceState(),this.genSendUnsubscribe()):21==this.state.s_fu?(this.state.s_ct=74,this.state.traceState(),this.evtChangeFormat(),this.genSendConfigure()):31==this.state.s_tu?(this.state.s_ct=73,this.state.traceState(),this.evtChangeTrigger(),this.genSendConfigure()):(this.state.s_ct=71,this.state.traceState()))},evtExtMpnSubscribe:function(){this.traceEvent("subscribe"),40==this.state.s_m&&(405==this.m_client.state.s_mpn.m?(this.notifyStatus(re.Active),this.state.s_m=42,this.state.traceState(),this.genSendSubscribe()):(this.notifyStatus(re.Active),this.state.s_m=41,this.state.traceState()))},evtDeviceActive:function(){this.traceEvent("device.active"),41==this.state.s_m&&(this.state.s_m=42,this.state.traceState(),this.genSendSubscribe())},evtMPNOK:function(t){this.traceEvent("MPNOK"),(42==this.state.s_m||43==this.state.s_m)&&(this.doMPNOK(t),this.notifyStatus(re.Subscribed),this.notifyOnSubscription(),this.notifyOnSubscriptionsUpdated(),this.state.s_m=44,this.state.s_st=60,this.state.s_ct=70,this.state.s_ab=80,this.state.traceState(),this.evtCheck())},evtMPNDEL:function(){this.traceEvent("MPNDEL"),72==this.state.s_ct&&(this.notifyStatus(re.Unknown),this.notifyOnUnsubscription(),this.notifyOnSubscriptionsUpdated(),this.finalize(),this.state.s_m=52,this.state.s_st=null,this.state.s_ct=null,this.state.s_ab=null,this.state.traceState())},evtMpnUpdate:function(t){this.traceEvent("update");var e=t.getValue("status_timestamp"),s=t.getValue("status");s=null!=s?s.toUpperCase():null;var i=t.getValue("command");i=null!=i?i.toUpperCase():null,44==this.state.s_m&&"DELETE"==i?(this.notifyStatus(re.Unknown),this.notifyOnUnsubscription(),this.notifyOnSubscriptionsUpdated(),this.finalize(),this.state.s_m=52,this.state.s_st=null,this.state.s_ct=null,this.state.s_ab=null,this.state.traceState()):45==this.state.s_m?"ACTIVE"==s?(this.notifyStatus(re.Subscribed,e),this.notifyOnSubscription(),this.notifyUpdate(t),this.state.s_m=44,this.state.s_st=60,this.state.s_ct=70,this.state.s_ab=80,this.state.traceState(),this.evtCheck()):"TRIGGERED"==s&&(this.notifyStatus(re.Triggered,e),this.notifyOnSubscription(),this.notifyOnTriggered(),this.notifyUpdate(t),this.state.s_m=44,this.state.s_st=61,this.state.s_ct=70,this.state.s_ab=80,this.state.traceState(),this.evtCheck()):44==this.state.s_m&&(this.state.s_m=44,this.state.traceState(),this.evtMpnUpdate_AbortRegion(t))},evtMpnUpdate_AbortRegion:function(t){this.traceEvent("update");var e=!0;81==this.state.s_ab&&(this.state.s_ab=80,this.state.traceState(),e=this.evtMpnUpdate_StatusRegion(t),this.evtRestoreSession()),e&&(e=this.evtMpnUpdate_StatusRegion(t))},evtMpnUpdate_StatusRegion:function(t){this.traceEvent("update");var e=t.getValue("status_timestamp"),s=t.getValue("status");return s=null!=s?s.toUpperCase():null,60==this.state.s_st?"ACTIVE"==s?(this.notifyUpdate(t),this.state.s_st=60,this.state.traceState()):"TRIGGERED"==s&&(this.notifyStatus(re.Triggered,e),this.notifyOnTriggered(),this.notifyUpdate(t),this.state.s_st=61,this.state.traceState()):61==this.state.s_st&&("ACTIVE"==s?(this.notifyStatus(re.Subscribed,e),this.notifyUpdate(t),this.state.s_st=60,this.state.traceState()):"TRIGGERED"==s&&(this.notifyUpdate(t),this.state.s_st=61,this.state.traceState())),!1},evtMpnEOS:function(){this.traceEvent("EOS"),81==this.state.s_ab&&(this.notifyStatus(re.Unknown),this.notifyOnUnsubscription(),this.notifyOnSubscriptionsUpdated(),this.finalize(),this.state.s_m=51,this.state.s_st=null,this.state.s_ct=null,this.state.s_ab=null,this.state.traceState())},isPending:function(){return 42==this.state.s_m||72==this.state.s_ct||73==this.state.s_ct||74==this.state.s_ct},encode:function(t){if(42==this.state.s_m)return this.encodeActivate();if(72==this.state.s_ct)return this.encodeDeactivate();if(73==this.state.s_ct||74==this.state.s_ct)return this.encodeConfigure();throw new be("Can't encode request")},encodeWS:function(){return"control\r\n"+this.encode(!0)},encodeActivate:function(){var t=new Le;this.m_lastActivateReqId=this.m_client.generateFreshReqId(),t.LS_reqId(this.m_lastActivateReqId),t.LS_op("activate"),t.LS_subId(ye.sure(this.m_subId)),t.LS_mode(ye.sure(this.m_subscription.fetch_mode()));var e=this.m_subscription.getItemGroup(),s=this.m_subscription.getItems();null!=e?t.LS_group(e):null!=s&&t.LS_group(s.slice().join(" "));var i=this.m_subscription.getFieldSchema(),n=this.m_subscription.getFields();null!=i?t.LS_schema(i):null!=n&&t.LS_schema(n.slice().join(" "));var r=this.m_subscription.getDataAdapter();null!=r&&t.LS_data_adapter(r);var a=this.m_subscription.fetch_requestedMaxFrequency();if(null!=a)switch(a._hx_index){case 0:t.LS_requested_max_frequency_Float(a.max);break;case 1:t.LS_requested_max_frequency("unlimited")}var o=this.m_subscription.fetch_requestedBufferSize();if(null!=o)switch(o._hx_index){case 0:t.LS_requested_buffer_size_Int(o.size);break;case 1:t.LS_requested_buffer_size("unlimited")}t.PN_deviceId(ye.sure(this.m_client.fetch_mpn_deviceId())),t.PN_notificationFormat(ye.sure(this.m_initFormat));var h=this.m_initTrigger;return null!=h&&t.PN_trigger(h),this.m_coalescing&&t.PN_coalescing(!0),Mi.isInfoEnabled()&&Mi.info("Sending MPNSubscription activate: "+p.string(t)),t.getEncodedString()},encodeDeactivate:function(){var t=new Le;return this.m_lastDeactivateReqId=this.m_client.generateFreshReqId(),t.LS_reqId(this.m_lastDeactivateReqId),t.LS_op("deactivate"),t.PN_deviceId(ye.sure(this.m_client.fetch_mpn_deviceId())),t.PN_subscriptionId(ye.sure(this.m_subscription.getSubscriptionId())),Mi.isInfoEnabled()&&Mi.info("Sending MPNSubscription deactivate: "+p.string(t)),t.getEncodedString()},encodeConfigure:function(){var t=new Le;this.m_lastConfigureReqId=this.m_client.generateFreshReqId(),t.LS_reqId(this.m_lastConfigureReqId),t.LS_op("pn_reconf"),t.LS_mode(ye.sure(this.m_subscription.fetch_mode()));var e=this.m_subscription.getItemGroup(),s=this.m_subscription.getItems();null!=e?t.LS_group(e):null!=s&&t.LS_group(s.slice().join(" "));var i=this.m_subscription.getFieldSchema(),n=this.m_subscription.getFields();null!=i?t.LS_schema(i):null!=n&&t.LS_schema(n.slice().join(" "));var r=this.m_subscription.getDataAdapter();if(null!=r&&t.LS_data_adapter(r),t.PN_deviceId(ye.sure(this.m_client.fetch_mpn_deviceId())),t.PN_subscriptionId(ye.sure(this.m_subscription.getSubscriptionId())),74==this.state.s_ct&&t.PN_notificationFormat(ye.sure(this.m_currentFormat)),73==this.state.s_ct){var a=this.m_currentTrigger;t.PN_trigger(null!=a?a:"")}return Mi.isInfoEnabled()&&Mi.info("Sending MPNSubscription configuration: "+p.string(t)),t.getEncodedString()},genSendSubscribe:function(){this.m_client.evtSendControl(this)},genSendConfigure:function(){this.m_client.evtSendControl(this)},genSendUnsubscribe:function(){this.m_client.evtSendControl(this)},notifyStatus:function(t,e){this.m_subscription.changeStatus(t,e)},notifyOnSubscriptionError:function(t,e){this.m_subscription.fireOnSubscriptionError(t,e)},notifyOnSubscriptionAbort:function(){this.m_subscription.fireOnSubscriptionError(54,"The request was aborted because the operation could not be completed")},notifyOnSubscriptionDiscarded:function(){this.m_subscription.fireOnSubscriptionError(55,"The request was discarded because the operation could not be completed")},notifyOnUnsubscriptionError:function(t,e){this.m_subscription.fireOnUnsubscriptionError(t,e)},notifyOnUnsubscriptionAbort:function(){this.m_subscription.fireOnUnsubscriptionError(54,"The request was aborted because the operation could not be completed")},doMPNOK:function(t){this.m_subscription.setSubscriptionId(t)},notifyOnSubscription:function(){this.m_subscription.fireOnSubscription()},notifyOnUnsubscription:function(){this.m_subscription.fireOnUnsubscription()},notifyOnTriggered:function(){this.m_subscription.fireOnTriggered()},notifyOnSubscriptionsUpdated:function(){ye.sure(this.m_client.fetch_mpn_device()).fireOnSubscriptionsUpdated()},notifyUpdate:function(t){this.m_subscription.changeStatusTs(t.getValue("status_timestamp")),this.m_subscription.changeMode(t.getValue("mode")),this.m_subscription.changeAdapter(t.getValue("adapter")),this.m_subscription.changeGroup(t.getValue("group")),this.m_subscription.changeSchema(t.getValue("schema")),this.m_subscription.changeFormat(t.getValue("notification_format")),this.m_subscription.changeTrigger(t.getValue("trigger")),this.m_subscription.changeBufferSize(t.getValue("requested_buffer_size")),this.m_subscription.changeMaxFrequency(t.getValue("requested_max_frequency"))},doSetCurrentFormat:function(){this.m_currentFormat=this.m_subscription.fetch_requestedFormat()},doSetCurrentTrigger:function(){this.m_currentTrigger=this.m_subscription.fetch_requestedTrigger()},notifyOnModificationError_Format:function(t,e){this.m_subscription.fireOnModificationError(t,e,"notification_format")},notifyOnModificationAbort_Format:function(){this.m_subscription.fireOnModificationError(54,"The request was aborted because the operation could not be completed","notification_format")},notifyOnModificationError_Trigger:function(t,e){this.m_subscription.fireOnModificationError(t,e,"trigger")},notifyOnModificationAbort_Trigger:function(){this.m_subscription.fireOnModificationError(54,"The request was aborted because the operation could not be completed","trigger")},traceEvent:function(t){Ni.isTraceEnabled()&&Ni.trace("mpn#sub#"+t+"("+this.m_subId+":"+this.fetch_mpnSubId()+") in "+p.string(this.state))},__class__:pt};var gt=function(t,e,s){this.subId=t,this.itemIdx=e,this.values=s};function vt(t){return ye.sure(p.parseInt(t))}function St(t){return ye.sure(parseFloat(t))}function bt(t){return vt(t)}function Et(t){for(var e=yt(t,",")+1,s=yt(t,",",e)+1,i=yt(t,",",s)+1,n=vt(t.substring(e,s-1)),r=vt(t.substring(s,i-1)),a=new Ms,o=i-1,h=1;o<t.length;){var c=t.indexOf("|",o+1);-1==c&&(c=t.length);var u=t.substring(o+1,c);if(""==u)a.h[h]=Ve.unchanged,++h;else if("#"==u)a.h[h]=Ve.changed(null),++h;else if("$"==u)a.h[h]=Ve.changed(""),++h;else if("^"==u.charAt(0))if("P"==u.charAt(1)){var l=wt(u.substring(2));try{var _=ds._new(l);a.h[h]=Ve.jsonPatch(_),++h}catch(t){var d=w.caught(t);throw Oi.isErrorEnabled()&&Oi.error("Invalid JSON patch "+l+": "+d.get_message()+"\n"+d.details()),new be("The JSON Patch for the field "+h+" is not well-formed")}}else if("T"==u.charAt(1)){var m=wt(u.substring(2));a.h[h]=Ve.diffPatch(m),++h}else for(var f=vt(u.substring(1)),p=0;p<f;)++p,a.h[h]=Ve.unchanged,++h;else{var g=Ve.changed(wt(u));a.h[h]=g,++h}o=c}return new gt(n,r,a)}function yt(t,e,s){var i=t.indexOf(e,s);if(-1==i)throw new be("string not found");return i}function wt(t){for(var e=Tt.ofString(t,It.UTF8),s=0,i=0;s<e.length;)37==e.b[s]?(e.b[i++]=(Rt(e.b[s+1])<<4)+Rt(e.b[s+2]),s+=3):e.b[i++]=e.b[s++];return e.getString(0,i,It.UTF8)}function Rt(t){var e=0;return(e=t-97+10)<=9&&(e=t-65+10)<=9&&(e=t-48),e}gt.__name__="com.lightstreamer.client.internal.UpdateInfo",gt.prototype={__class__:gt};var Tt=function(t){this.length=t.byteLength,this.b=new Uint8Array(t),this.b.bufferValue=t,t.hxBytes=this,t.bytes=this.b};Tt.__name__="haxe.io.Bytes",Tt.ofString=function(t,e){if(e==It.RawNative){for(var s=new Uint8Array(t.length<<1),i=0,n=t.length;i<n;){var r=i++,a=t.charCodeAt(r);s[r<<1]=255&a,s[r<<1|1]=a>>8}return new Tt(s.buffer)}var o=[];for(r=0;r<t.length;)55296<=(a=t.charCodeAt(r++))&&a<=56319&&(a=a-55232<<10|1023&t.charCodeAt(r++)),a<=127?o.push(a):a<=2047?(o.push(192|a>>6),o.push(128|63&a)):a<=65535?(o.push(224|a>>12),o.push(128|a>>6&63),o.push(128|63&a)):(o.push(240|a>>18),o.push(128|a>>12&63),o.push(128|a>>6&63),o.push(128|63&a));return new Tt(new Uint8Array(o).buffer)},Tt.prototype={getString:function(t,e,s){if(t<0||e<0||t+e>this.length)throw w.thrown(As.OutsideBounds);null==s&&(s=It.UTF8);var i="",n=this.b,r=t,a=t+e;switch(s._hx_index){case 0:for(;r<a;)if((u=n[r++])<128){if(0==u)break;i+=String.fromCodePoint(u)}else if(u<224){var o=(63&u)<<6|127&n[r++];i+=String.fromCodePoint(o)}else if(u<240){var h=(31&u)<<12|(127&n[r++])<<6|127&n[r++];i+=String.fromCodePoint(h)}else{var c=(15&u)<<18|(127&n[r++])<<12|(127&n[r++])<<6|127&n[r++];i+=String.fromCodePoint(c)}break;case 1:for(;r<a;){var u=n[r++]|n[r++]<<8;i+=String.fromCodePoint(u)}}return i},__class__:Tt};var It=a["haxe.io.Encoding"]={__ename__:!0,__constructs__:null,UTF8:{_hx_name:"UTF8",_hx_index:0,__enum__:"haxe.io.Encoding",toString:r},RawNative:{_hx_name:"RawNative",_hx_index:1,__enum__:"haxe.io.Encoding",toString:r}};It.__constructs__=[It.UTF8,It.RawNative];var xt=function(){this.body=""};xt.__name__="com.lightstreamer.client.internal.Request",xt.isEmpty=function(t){return 0==t.length},xt.lengthOfBytes=function(t){return Tt.ofString(t,It.UTF8).length},xt.prototype={getByteSize:function(){return xt.lengthOfBytes(this.body)},getBody:function(){return this.body},addSubRequest:function(t){xt.isEmpty(this.body)?this.body=t:this.body+="\r\n"+t},addSubRequestOnlyIfBodyIsLessThan:function(t,e){return xt.isEmpty(this.body)&&xt.lengthOfBytes(t)<=e?(this.body=t,!0):xt.lengthOfBytes(this.body)+xt.EOL_LEN+xt.lengthOfBytes(t)<=e&&(this.body+="\r\n"+t,!0)},__class__:xt};var Ct=function(){this.attempt=1,this._currentRetryDelay=0};Ct.__name__="com.lightstreamer.client.internal.RetryDelayCounter",Ct.prototype={get_currentRetryDelay:function(){return this._currentRetryDelay},increase:function(){this.attempt>10?this._currentRetryDelay<6e4&&(2*this._currentRetryDelay<6e4?this._currentRetryDelay*=2:this._currentRetryDelay=6e4):this.attempt+=1},reset:function(t){this.attempt=1,this._currentRetryDelay=t},__class__:Ct};var Dt=function(){};Dt.__name__="com.lightstreamer.client.internal.SubscriptionManager",Dt.__isInterface__=!0,Dt.__interfaces__=[U],Dt.prototype={__class__:Dt};var Lt=function(t){this.subId=t,this.s_m=1};Lt.__name__="com.lightstreamer.client.internal._SubscriptionManager.State",Lt.prototype={toString:function(){var t="<m="+this.s_m;return null!=this.s_s&&(t+=" s="+this.s_s),null!=this.s_c&&(t+=" c="+this.s_c),t+=">"},traceState:function(){Ni.isTraceEnabled()&&Ni.trace("sub#goto("+this.subId+") "+this.toString())},__class__:Lt};var Mt=function(t,e){var s;switch(this.lock=e.lock,this.subId=e.generateFreshSubId(),t.fetch_mode()){case"COMMAND":s=Mt.is2LevelCommand(t)?new tt(t,e,this.subId):new $(t,e,this.subId);break;case"DISTINCT":s=new et(t,e,this.subId);break;case"MERGE":s=new st(t,e,this.subId);break;case"RAW":s=new it(t,e,this.subId)}this.m_strategy=s,this.state=new Lt(this.subId),this.m_client=e,this.m_subscription=t,this.m_client.relateSubManager(this),this.m_subscription.relate(this)};Mt.__name__="com.lightstreamer.client.internal.SubscriptionManagerLiving",Mt.__interfaces__=[Dt],Mt.is2LevelCommand=function(t){return"COMMAND"==t.fetch_mode()&&(null!=t.getCommandSecondLevelFields()||null!=t.getCommandSecondLevelFieldSchema())},Mt.prototype={finalize:function(){this.m_strategy.evtDispose(),this.m_client.unrelateSubManager(this),this.m_subscription.unrelate(this)},evtExtSubscribe:function(){this.traceEvent("subscribe"),1==this.state.s_m&&(this.doSetActive(),this.doSubscribe(),this.state.s_m=2,this.state.traceState(),this.genSendControl())},evtExtUnsubscribe:function(){this.traceEvent("unsubscribe"),2==this.state.s_m?(this.doSetInactive(),this.finalize(),this.state.s_m=30,this.state.traceState()):3==this.state.s_m?(this.doUnsubscribe(),this.doSetInactive(),this.state.s_m=5,this.state.traceState(),this.genSendControl()):10==this.state.s_s&&(this.doUnsubscribe(),this.m_subscription.setInactive(),this.notifyOnUnsubscription(),this.state.s_m=5,this.state.s_s=null,this.state.s_c=null,this.state.traceState(),this.genSendControl())},evtExtAbort:function(){this.traceEvent("abort"),2==this.state.s_m?(this.state.s_m=2,this.state.traceState()):3==this.state.s_m?(this.doAbort(),this.doSetActive(),this.state.s_m=2,this.state.traceState()):10==this.state.s_s?(this.doAbort(),this.doSetActive(),this.notifyOnUnsubscription(),this.state.s_s=null,this.state.s_c=null,this.state.s_m=2,this.state.traceState()):5==this.state.s_m&&(this.finalize(),this.state.s_m=32,this.state.traceState())},evtREQERR:function(t,e,s){this.traceEvent("REQERR"),2==this.state.s_m&&t==this.m_lastAddReqId?(this.doSetInactive(),this.notifyOnSubscriptionError(e,s),this.finalize(),this.state.s_m=30,this.state.traceState()):5==this.state.s_m&&t==this.m_lastDeleteReqId?(this.finalize(),this.state.s_m=32,this.state.traceState()):22==this.state.s_c&&t==this.m_lastReconfReqId&&(ts.extEquals(this.m_reqMaxFrequency,this.m_subscription.fetch_requestedMaxFrequency())?(this.state.s_c=21,this.state.traceState()):(this.state.s_c=20,this.state.traceState(),this.evtCheckFrequency()))},evtREQOK:function(t){this.traceEvent("REQOK"),2==this.state.s_m&&t==this.m_lastAddReqId?(this.state.s_m=3,this.state.traceState()):5==this.state.s_m&&t==this.m_lastDeleteReqId?(this.finalize(),this.state.s_m=32,this.state.traceState()):22==this.state.s_c&&t==this.m_lastReconfReqId&&(this.doREQOKConfigure(),this.state.s_c=20,this.state.traceState(),this.evtCheckFrequency())},evtSUBOK:function(t,e){this.traceEvent("SUBOK"),(2==this.state.s_m||3==this.state.s_m)&&(this.doSUBOK(t,e),this.notifyOnSubscription(),this.state.s_m=4,this.state.s_s=10,this.state.s_c=20,this.state.traceState(),this.evtCheckFrequency())},evtSUBCMD:function(t,e,s,i){this.traceEvent("SUBCMD"),(2==this.state.s_m||3==this.state.s_m)&&(this.doSUBCMD(t,e,i,s),this.notifyOnSubscription(),this.state.s_m=4,this.state.s_s=10,this.state.s_c=20,this.state.traceState(),this.evtCheckFrequency())},evtUNSUB:function(){this.traceEvent("UNSUB"),10==this.state.s_s?(this.doUNSUB(),this.doSetInactive(),this.notifyOnUnsubscription(),this.finalize(),this.state.s_m=31,this.state.s_s=null,this.state.s_c=null,this.state.traceState()):5==this.state.s_m&&(this.finalize(),this.state.s_m=32,this.state.traceState())},evtU:function(t,e){this.traceEvent("U"),10==this.state.s_s&&(this.doU(t,e),this.state.s_s=10,this.state.traceState())},evtEOS:function(t){this.traceEvent("EOS"),10==this.state.s_s&&(this.doEOS(t),this.state.s_s=10,this.state.traceState())},evtCS:function(t){this.traceEvent("CS"),10==this.state.s_s&&(this.doCS(t),this.state.s_s=10,this.state.traceState())},evtOV:function(t,e){this.traceEvent("OV"),10==this.state.s_s&&(this.doOV(t,e),this.state.s_s=10,this.state.traceState())},evtCONF:function(t){this.traceEvent("CONF"),10==this.state.s_s&&(this.doCONF(t),this.state.s_s=10,this.state.traceState())},evtCheckFrequency:function(){this.traceEvent("check.frequency"),20==this.state.s_c&&(ts.extEquals(this.m_subscription.fetch_requestedMaxFrequency(),this.m_currentMaxFrequency)?(this.state.s_c=21,this.state.traceState()):(this.doConfigure(),this.state.s_c=22,this.state.traceState(),this.genSendControl()))},evtExtConfigure:function(){this.traceEvent("configure"),21==this.state.s_c&&(this.state.s_c=20,this.state.traceState(),this.evtCheckFrequency())},isPending:function(){return 2==this.state.s_m||5==this.state.s_m||22==this.state.s_c},encode:function(t){if(2==this.state.s_m)return this.encodeAdd(t);if(5==this.state.s_m)return this.encodeDelete(t);if(22==this.state.s_c)return this.encodeReconf(t);throw new be("Can't encode request")},encodeWS:function(){return"control\r\n"+this.encode(!0)},getValue:function(t,e){return this.m_strategy.getValue(t,e)},getCommandValue:function(t,e,s){return this.m_strategy.getCommandValue(t,e,s)},encodeAdd:function(t){var e=new Le;this.m_lastAddReqId=this.m_client.generateFreshReqId(),e.LS_reqId(this.m_lastAddReqId),e.LS_op("add"),e.LS_subId(this.subId),e.LS_mode(this.m_subscription.fetch_mode());var s=this.m_subscription.getItemGroup(),i=this.m_subscription.getItems();null!=s?e.LS_group(s):null!=i&&e.LS_group(i.slice().join(" "));var n=this.m_subscription.getFieldSchema(),r=this.m_subscription.getFields();null!=n?e.LS_schema(n):null!=r&&e.LS_schema(r.slice().join(" "));var a=this.m_subscription.getDataAdapter();null!=a&&e.LS_data_adapter(a);var o=this.m_subscription.getSelector();null!=o&&e.LS_selector(o);var h=this.m_subscription.fetch_requestedSnapshot();if(null!=h)switch(h._hx_index){case 0:e.LS_snapshot(!0);break;case 1:e.LS_snapshot(!1);break;case 2:e.LS_snapshot_Int(h.len)}var c=this.m_currentMaxFrequency;if(null!=c)switch(c._hx_index){case 0:e.LS_requested_max_frequency_Float(c.max);break;case 1:e.LS_requested_max_frequency("unlimited");break;case 2:e.LS_requested_max_frequency("unfiltered")}var u=this.m_subscription.fetch_requestedBufferSize();if(null!=u)switch(u._hx_index){case 0:e.LS_requested_buffer_size_Int(u.size);break;case 1:e.LS_requested_buffer_size("unlimited")}return t&&e.LS_ack(!1),Mi.isInfoEnabled()&&Mi.info("Sending Subscription add: "+p.string(e)),e.getEncodedString()},encodeDelete:function(t){var e=new Le;return this.m_lastDeleteReqId=this.m_client.generateFreshReqId(),e.LS_reqId(this.m_lastDeleteReqId),e.LS_subId(this.subId),e.LS_op("delete"),t&&e.LS_ack(!1),Mi.isInfoEnabled()&&Mi.info("Sending Subscription delete: "+p.string(e)),e.getEncodedString()},encodeReconf:function(t){var e=new Le;this.m_lastReconfReqId=this.m_client.generateFreshReqId(),e.LS_reqId(this.m_lastReconfReqId),e.LS_subId(this.subId),e.LS_op("reconf");var s=this.m_reqMaxFrequency;if(null!=s)switch(s._hx_index){case 0:e.LS_requested_max_frequency_Float(s.max);break;case 1:e.LS_requested_max_frequency("unlimited");break;case 2:e.LS_requested_max_frequency("unfiltered")}return Mi.isInfoEnabled()&&Mi.info("Sending Subscription configuration: "+p.string(e)),e.getEncodedString()},doSetActive:function(){this.m_subscription.setActive()},doSetInactive:function(){this.m_subscription.setInactive()},doSubscribe:function(){this.m_currentMaxFrequency=this.m_subscription.fetch_requestedMaxFrequency()},doUnsubscribe:function(){this.m_strategy.evtUnsubscribe(),this.m_subscription.unrelate(this)},doAbort:function(){this.m_lastAddReqId=null,this.m_lastDeleteReqId=null,this.m_lastReconfReqId=null,this.m_reqMaxFrequency=null,this.m_currentMaxFrequency=this.m_subscription.fetch_requestedMaxFrequency(),this.m_strategy.evtAbort()},genSendControl:function(){this.m_client.evtSendControl(this)},notifyOnSubscription:function(){this.m_subscription.fireOnSubscription(this.subId)},notifyOnUnsubscription:function(){this.m_subscription.fireOnUnsubscription(this.subId)},notifyOnSubscriptionError:function(t,e){this.m_subscription.fireOnSubscriptionError(this.subId,t,e)},doConfigure:function(){this.m_reqMaxFrequency=this.m_subscription.fetch_requestedMaxFrequency(),this.m_strategy.evtSetRequestedMaxFrequency(this.m_reqMaxFrequency)},doREQOKConfigure:function(){this.m_currentMaxFrequency=this.m_reqMaxFrequency},doSUBOK:function(t,e){this.m_subscription.setSubscribed(this.subId,t,e),this.m_strategy.evtOnSUB(t,e,null,null,null)},doSUBCMD:function(t,e,s,i){this.m_subscription.setSubscribedCMD(this.subId,t,e,s,i),this.m_strategy.evtOnSUB(t,e,s,i,this.m_currentMaxFrequency)},doUNSUB:function(){this.m_strategy.evtOnUNSUB()},doU:function(t,e){if(t>ye.sure(this.m_subscription.fetch_nItems()))throw new be("Assertion failure: itemIdx <= m_subscription.fetch_nItems().sure()");this.m_strategy.evtUpdate(t,e)},doEOS:function(t){this.m_strategy.evtOnEOS(t),this.m_subscription.fireOnEndOfSnapshot(t,this.subId)},doCS:function(t){this.m_strategy.evtOnCS(t),this.m_subscription.fireOnClearSnapshot(t,this.subId)},doOV:function(t,e){this.m_subscription.fireOnLostUpdates(t,e,this.subId)},doCONF:function(t){this.m_strategy.evtOnCONF(t)},traceEvent:function(t){Ni.isTraceEnabled()&&Ni.trace("sub#"+t+"("+this.subId+") in "+p.string(this.state))},__class__:Mt};var Nt=function(t,e){this.s_m=1,this.subId=t,this.lock=e.lock,this.m_client=e,e.relateSubManager(this)};Nt.__name__="com.lightstreamer.client.internal.SubscriptionManagerZombie",Nt.__interfaces__=[Dt],Nt.prototype={finalize:function(){this.m_client.unrelateSubManager(this)},evtExtAbort:function(){this.traceEvent("abort"),2==this.s_m&&(this.finalize(),this.goto(3))},evtREQERR:function(t,e,s){this.traceEvent("REQERR"),2==this.s_m&&t==this.m_lastDeleteReqId&&(this.finalize(),this.goto(3))},evtREQOK:function(t){this.traceEvent("REQOK"),2==this.s_m&&t==this.m_lastDeleteReqId&&(this.finalize(),this.goto(3))},evtSUBOK:function(t,e){this.traceEvent("SUBOK"),1==this.s_m&&(this.goto(2),this.genSendControl())},evtSUBCMD:function(t,e,s,i){this.traceEvent("SUBCMD"),1==this.s_m&&(this.goto(2),this.genSendControl())},evtUNSUB:function(){this.traceEvent("UNSUB"),2==this.s_m&&(this.finalize(),this.goto(3))},evtU:function(t,e){this.traceEvent("U"),1==this.s_m&&(this.goto(2),this.genSendControl())},evtEOS:function(t){this.traceEvent("EOS"),1==this.s_m&&(this.goto(2),this.genSendControl())},evtCS:function(t){this.traceEvent("CS"),1==this.s_m&&(this.goto(2),this.genSendControl())},evtOV:function(t,e){this.traceEvent("OV"),1==this.s_m&&(this.goto(2),this.genSendControl())},evtCONF:function(t){this.traceEvent("CONF"),1==this.s_m&&(this.goto(2),this.genSendControl())},isPending:function(){return 2==this.s_m},encode:function(t){if(this.isPending())return this.encodeDelete(t);throw new be("Can't encode unsubscription request")},encodeWS:function(){return"control\r\n"+this.encode(!0)},genSendControl:function(){this.m_client.evtSendControl(this)},encodeDelete:function(t){var e=new Le;return this.m_lastDeleteReqId=this.m_client.generateFreshReqId(),e.LS_reqId(this.m_lastDeleteReqId),e.LS_subId(this.subId),e.LS_op("delete"),t&&e.LS_ack(!1),e.LS_cause("zombie"),Mi.isInfoEnabled()&&Mi.info("Sending Subscription delete: "+p.string(e)),e.getEncodedString()},traceEvent:function(t){Ni.isTraceEnabled()&&Ni.trace("zsub#"+t+"("+this.subId+") in "+this.s_m)},goto:function(t){this.s_m=t,Ni.isTraceEnabled()&&Ni.trace("zsub#goto("+this.subId+") "+this.s_m)},__class__:Nt};var Ot=function(){};Ot.__name__="com.lightstreamer.client.internal.update.AbstractItemUpdate",Ot.__interfaces__=[o],Ot.prototype={__class__:Ot};var Pt=function(t,e,s,i){this.m_subId=i,this.itemIdx=t,this.subscription=e,this.client=s,this.lock=s.lock};Pt.__name__="com.lightstreamer.client.internal.update.ItemBase",Pt.prototype={finalize:function(){},evtUpdate:function(t){this.fatalError()},evtOnEOS:function(){this.fatalError()},evtOnCS:function(){this.fatalError()},evtDispose:function(t){this.fatalError()},getValue:function(t){return null!=this.currValues?Qt.toString(this.currValues.h[t]):null},getCommandValue:function(t,e){throw new be("Unsupported operation")},fatalError:function(){throw new be("Unsupported operation")},doFirstUpdate:function(t){this.doUpdate(t,!1)},doUpdate0:function(t){this.doUpdate(t,!1)},doFirstSnapshot:function(t){this.doUpdate(t,!0)},doSnapshot:function(t){this.doUpdate(t,!0)},doUpdate:function(t,e){var s=this.currValues;this.currValues=jt(s,t);var i=Jt(s,this.currValues),n=Xt(s,t),r=new Vt(this.itemIdx,this.subscription,this.currValues,i,e,n);this.subscription.fireOnItemUpdate(r,this.m_subId)},__class__:Pt};var kt=function(t,e,s,i){this.keys=new ks,Pt.call(this,t,e,s,i),this.s_m=e.hasSnapshot()?3:1};kt.__name__="com.lightstreamer.client.internal.update.ItemCommand",kt.__super__=Pt,kt.prototype=c(Pt.prototype,{finalize:function(){},unrelate:function(t){var e=this.keys;Object.prototype.hasOwnProperty.call(e.h,t)&&delete e.h[t]},evtUpdate:function(t){switch(this.traceEvent("update"),this.s_m){case 1:this.doFirstUpdate(t),this.goto(2);break;case 2:this.doUpdate0(t),this.goto(2);break;case 3:this.doFirstSnapshot(t),this.goto(4);break;case 4:this.doSnapshot(t),this.goto(4)}},evtOnEOS:function(){switch(this.traceEvent("onEOS"),this.s_m){case 3:this.goto(1);break;case 4:this.goto(2)}},evtOnCS:function(){throw new be("Unsupported method")},evtDispose:function(t){switch(this.traceEvent("dispose"),this.s_m){case 1:case 2:case 3:case 4:this.finalize(),this.goto(5),this.genDisposeKeys(),t.unrelate(this.itemIdx)}},getCommandValue:function(t,e){var s=this.keys.h[t];return null!=s?s.getCommandValue(e):null},createKey:function(t){throw new be("Abstract method")},doUpdate:function(t,e){this.currValues=jt(this.currValues,t),this.selectKey().evtUpdate(this.currValues,e)},genDisposeKeys:function(){for(var t=ks.createCopy(this.keys.h).h,e=Object.keys(t),s=e.length,i=0;i<s;)t[e[i++]].evtDispose()},selectKey:function(){var t=this.currValues,e=this.subscription.getKeyPosition(),s=Qt.toString(t.h[e]);return null==(e=this.keys.h[s])&&(e=this.createKey(s),this.keys.h[s]=e),e},goto:function(t){this.s_m=t,Ni.isTraceEnabled()&&Ni.trace("sub#itm#goto("+this.m_subId+":"+this.itemIdx+") in "+this.s_m)},traceEvent:function(t){Ni.isTraceEnabled()&&Ni.trace("sub#itm#"+t+"("+this.m_subId+":"+this.itemIdx+") in "+this.s_m)},__class__:kt});var Ft=function(t,e,s,i){kt.call(this,t,e,s,i)};Ft.__name__="com.lightstreamer.client.internal.update.ItemCommand1Level",Ft.__super__=kt,Ft.prototype=c(kt.prototype,{evtOnCS:function(){switch(this.traceEvent("onCS"),this.s_m){case 1:case 2:case 3:case 4:this.goto(this.s_m),this.genDisposeKeys()}},createKey:function(t){return new Kt(t,this)},__class__:Ft});var qt=function(t,e,s,i,n){kt.call(this,t,e,i,n),this.strategy=s};qt.__name__="com.lightstreamer.client.internal.update.ItemCommand2Level",qt.__super__=kt,qt.prototype=c(kt.prototype,{evtOnCS:function(){switch(this.traceEvent("onCS"),this.s_m){case 1:case 2:case 3:case 4:this.goto(this.s_m),this.genDisposeKeys(),this.genOnRealMaxFrequency2LevelRemoved()}},evtSetRequestedMaxFrequency:function(){switch(this.traceEvent("setRequestedMaxFrequency"),this.s_m){case 1:case 2:case 3:case 4:this.goto(this.s_m),this.genSetRequestedMaxFrequency()}},createKey:function(t){return new Gt(t,this)},genSetRequestedMaxFrequency:function(){for(var t=this.keys.h,e=Object.keys(t),s=e.length,i=0;i<s;)t[e[i++]].evtSetRequestedMaxFrequency()},genOnRealMaxFrequency2LevelRemoved:function(){this.strategy.evtOnRealMaxFrequency2LevelRemoved()},__class__:qt});var At=function(t,e,s,i){Pt.call(this,t,e,s,i),this.s_m=e.hasSnapshot()?3:1};At.__name__="com.lightstreamer.client.internal.update.ItemDistinct",At.__super__=Pt,At.prototype=c(Pt.prototype,{evtUpdate:function(t){switch(this.traceEvent("update"),this.s_m){case 1:this.doFirstUpdate(t),this.goto(2);break;case 2:this.doUpdate0(t),this.goto(2);break;case 3:this.doFirstSnapshot(t),this.goto(4);break;case 4:this.doSnapshot(t),this.goto(4)}},evtOnEOS:function(){switch(this.traceEvent("onEOS"),this.s_m){case 3:this.goto(1);break;case 4:this.goto(2)}},evtOnCS:function(){},evtDispose:function(t){switch(this.traceEvent("dispose"),this.s_m){case 1:case 2:case 3:case 4:this.finalize(),this.goto(5),t.unrelate(this.itemIdx)}},goto:function(t){this.s_m=t,Ni.isTraceEnabled()&&Ni.trace("sub#itm#goto("+this.m_subId+":"+this.itemIdx+") "+this.s_m)},traceEvent:function(t){Ni.isTraceEnabled()&&Ni.trace("sub#itm#"+t+"("+this.m_subId+":"+this.itemIdx+") in "+this.s_m)},__class__:At});var Bt=function(){};Bt.__name__="com.lightstreamer.client.internal.update.ItemKey",Bt.__isInterface__=!0,Bt.prototype={__class__:Bt};var Ut=function(t,e,s,i){this.s_m=1,Pt.call(this,t,e,s,i)};Ut.__name__="com.lightstreamer.client.internal.update.ItemMerge",Ut.__super__=Pt,Ut.prototype=c(Pt.prototype,{evtUpdate:function(t){switch(this.traceEvent("update"),this.s_m){case 1:this.subscription.hasSnapshot()?(this.doSnapshot(t),this.goto(2)):(this.doFirstUpdate(t),this.goto(3));break;case 2:case 3:this.doUpdate0(t),this.goto(3)}},evtDispose:function(t){switch(this.traceEvent("dispose"),this.s_m){case 1:case 2:case 3:this.finalize(),this.goto(4),t.unrelate(this.itemIdx)}},goto:function(t){this.s_m=t,Ni.isTraceEnabled()&&Ni.trace("sub#itm#goto("+this.m_subId+":"+this.itemIdx+") "+this.s_m)},traceEvent:function(t){Ni.isTraceEnabled()&&Ni.trace("sub#itm#"+t+"("+this.m_subId+":"+this.itemIdx+") in "+this.s_m)},__class__:Ut});var Wt=function(t,e,s,i){this.s_m=1,Pt.call(this,t,e,s,i)};Wt.__name__="com.lightstreamer.client.internal.update.ItemRaw",Wt.__super__=Pt,Wt.prototype=c(Pt.prototype,{evtUpdate:function(t){switch(this.traceEvent("update"),this.s_m){case 1:this.doFirstUpdate(t),this.goto(2);break;case 2:this.doUpdate0(t),this.goto(2)}},evtDispose:function(t){switch(this.traceEvent("dispose"),this.s_m){case 1:case 2:this.finalize(),this.goto(3),t.unrelate(this.itemIdx)}},goto:function(t){this.s_m=t,Ni.isTraceEnabled()&&Ni.trace("sub#itm#goto("+this.m_subId+":"+this.itemIdx+") "+this.s_m)},traceEvent:function(t){Ni.isTraceEnabled()&&Ni.trace("sub#itm#"+t+"("+this.m_subId+":"+this.itemIdx+") in "+this.s_m)},__class__:Wt});var Ht=function(t,e,s,i,n,r){var a=e.getItems(),o=e.getFields(),h=e.getCommandSecondLevelFields();this.m_itemIdx=t,this.m_items=Zt(null!=a?a.slice():null),this.m_nFields=ye.sure(e.fetch_nFields()),this.m_fields=Zt(null!=o?o.slice():null),this.m_fields2=Zt(null!=h?h.slice():null),this.m_newValues=s.copy(),this.m_changedFields=i.copy(),this.m_isSnapshot=n,this.m_jsonPatches=r};Ht.__name__="com.lightstreamer.client.internal.update.ItemUpdate2Level",Ht.__super__=Ot,Ht.prototype=c(Ot.prototype,{getItemName:function(){return null!=this.m_items?this.m_items.h[this.m_itemIdx]:null},getItemPos:function(){return this.m_itemIdx},isSnapshot:function(){return this.m_isSnapshot},getValue:function(t){return"number"==typeof t&&(0|t)===t?this.getValuePos(t):this.getValueName(p.string(t))},isValueChanged:function(t){return"number"==typeof t&&(0|t)===t?this.isValueChangedPos(t):this.isValueChangedName(p.string(t))},_getValueAsJSONPatchIfAvailable:function(t){if("number"==typeof t&&(0|t)===t)return this.m_jsonPatches.h[t];var e=this.getFieldIdxFromName(p.string(t));return null!=e?this.m_jsonPatches.h[e]:null},getValueAsJSONPatchIfAvailable:function(t){return this._getValueAsJSONPatchIfAvailable(t)},forEachChangedField:function(t){for(var e=this.m_changedFields.iterator();e.current<e.array.length;){var s=e.array[e.current++];try{t(this.getFieldNameOrNullFromIdx(s),s,Qt.toString(this.m_newValues.h[s]))}catch(t){var i=w.caught(t);Pi.isErrorEnabled()&&Pi.error("An exception was thrown while executing the Function passed to the forEachChangedField method\n"+i.details())}}},forEachField:function(t){for(var e=this.m_newValues,s=e.keys();s.hasNext();){var i=s.next(),n=e.get(i);try{t(this.getFieldNameOrNullFromIdx(i),i,Qt.toString(n))}catch(t){var r=w.caught(t);Pi.isErrorEnabled()&&Pi.error("An exception was thrown while executing the Function passed to the forEachField method\n"+r.details())}}},getValuePos:function(t){return Qt.toString(this.m_newValues.h[t])},getValueName:function(t){if(null==this.m_fields&&null==this.m_fields2)throw new be(Ti);var e=this.getFieldIdxFromName(t);if(null==e)throw new R(xi);return Qt.toString(this.m_newValues.h[e])},isValueChangedPos:function(t){return this.m_changedFields.contains(t)},isValueChangedName:function(t){if(null==this.m_fields&&null==this.m_fields2)throw new be(Ti);var e=this.getFieldIdxFromName(t);if(null==e)throw new R(xi);return this.m_changedFields.contains(e)},getFieldNameFromIdx:function(t){if(null==this.m_fields)throw new be("Assertion failure: m_fields != null");if(null==this.m_fields2)throw new be("Assertion failure: m_fields2 != null");return ye.sure(this.getFieldNameOrNullFromIdx(t))},getFieldNameOrNullFromIdx:function(t){return t<=this.m_nFields?null!=this.m_fields?this.m_fields.h[t]:null:null!=this.m_fields2?this.m_fields2.h[t-this.m_nFields]:null},getFieldIdxFromName:function(t){var e,s,i=this.m_fields;return null!=i&&null!=(s=$t(ye.sure(i),t))?s:null!=(e=this.m_fields2)&&null!=(s=$t(ye.sure(e),t))?this.m_nFields+ye.sure(s):null},toString:function(){var t="";t="[";for(var e=this.m_newValues,s=e.keys();s.hasNext();){var i=s.next(),n=e.get(i),r=this.getFieldNameOrNullFromIdx(i),a=null!=r?r:null==i?"null":""+i,o=p.string(n);i>1&&(t+=","),t+=null==a?"null":""+a,t+=":",t+=null==o?"null":""+o}return t+="]"},__class__:Ht});var Vt=function(t,e,s,i,n,r){var a=e.getItems(),o=e.getFields();this.m_itemIdx=t,this.m_items=Zt(null!=a?a.slice():null),this.m_nFields=ye.sure(e.fetch_nFields()),this.m_fields=Zt(null!=o?o.slice():null),this.m_newValues=s.copy(),this.m_changedFields=i.copy(),this.m_isSnapshot=n,this.m_jsonPatches=r};Vt.__name__="com.lightstreamer.client.internal.update.ItemUpdateBase",Vt.__super__=Ot,Vt.prototype=c(Ot.prototype,{getItemName:function(){return null!=this.m_items?this.m_items.h[this.m_itemIdx]:null},getItemPos:function(){return this.m_itemIdx},isSnapshot:function(){return this.m_isSnapshot},getValue:function(t){return"number"==typeof t&&(0|t)===t?this.getValuePos(t):this.getValueName(p.string(t))},isValueChanged:function(t){return"number"==typeof t&&(0|t)===t?this.isValueChangedPos(t):this.isValueChangedName(p.string(t))},_getValueAsJSONPatchIfAvailable:function(t){if("number"==typeof t&&(0|t)===t)return this.m_jsonPatches.h[t];var e=this.getFieldIdxFromName(p.string(t));return this.m_jsonPatches.h[e]},getValueAsJSONPatchIfAvailable:function(t){return this._getValueAsJSONPatchIfAvailable(t)},forEachChangedField:function(t){for(var e=this.m_changedFields.iterator();e.current<e.array.length;){var s=e.array[e.current++];try{t(null!=this.m_fields?this.m_fields.h[s]:null,s,Qt.toString(this.m_newValues.h[s]))}catch(t){var i=w.caught(t);Pi.isErrorEnabled()&&Pi.error("An exception was thrown while executing the Function passed to the forEachChangedField method\n"+i.details())}}},forEachField:function(t){for(var e=this.m_newValues,s=e.keys();s.hasNext();){var i=s.next(),n=e.get(i);try{t(null!=this.m_fields?this.m_fields.h[i]:null,i,Qt.toString(n))}catch(t){var r=w.caught(t);Pi.isErrorEnabled()&&Pi.error("An exception was thrown while executing the Function passed to the forEachField method\n"+r.details())}}},getValuePos:function(t){if(!(1<=t&&t<=this.m_nFields))throw new R(Ii);return Qt.toString(this.m_newValues.h[t])},getValueName:function(t){var e=this.getFieldIdxFromName(t);return Qt.toString(this.m_newValues.h[e])},isValueChangedPos:function(t){if(!(1<=t&&t<=this.m_nFields))throw new R(Ii);return this.m_changedFields.contains(t)},isValueChangedName:function(t){var e=this.getFieldIdxFromName(t);return this.m_changedFields.contains(e)},getFieldNameOrNullFromIdx:function(t){return null!=this.m_fields?this.m_fields.h[t]:null},getFieldIdxFromName:function(t){if(null==this.m_fields)throw new be(Ti);var e=$t(this.m_fields,t);if(null==e)throw new R(xi);return e},toString:function(){var t="";t="[";for(var e=this.m_newValues,s=e.keys();s.hasNext();){var i=s.next(),n=e.get(i),r=this.getFieldNameOrNullFromIdx(i),a=null!=r?r:null==i?"null":""+i,o=p.string(n);i>1&&(t+=","),t+=null==a?"null":""+a,t+=":",t+=null==o?"null":""+o}return t+="]"},__class__:Vt});var Kt=function(t,e){this.s_m=1,this.keyName=t,this.item=e,this.lock=e.lock};Kt.__name__="com.lightstreamer.client.internal.update.Key1Level",Kt.__interfaces__=[Bt],Kt.prototype={finalize:function(){this.currKeyValues=null,this.item.unrelate(this.keyName)},evtUpdate:function(t,e){switch(this.traceEvent("update"),this.s_m){case 1:this.isDelete(t)?(this.doLightDelete(t,e),this.finalize(),this.goto(3)):(this.doFirstUpdate(t,e),this.goto(2));break;case 2:this.isDelete(t)?(this.doDelete(t,e),this.finalize(),this.goto(3)):(this.doUpdate(t,e),this.goto(2))}},evtDispose:function(){switch(this.traceEvent("dispose"),this.s_m){case 1:case 2:this.finalize(),this.goto(3)}},evtSetRequestedMaxFrequency:function(){},getCommandValue:function(t){return null!=this.currKeyValues?Qt.toString(this.currKeyValues.h[t]):null},doFirstUpdate:function(t,e){var s=ye.sure(this.item.subscription.fetch_nFields()),i=this.item.subscription.getCommandPosition();this.currKeyValues=t,this.currKeyValues.h[i]=Yt.StringVal("ADD");var n=new Me(new d(1,s+1));this.fireOnItemUpdate(new Vt(this.item.itemIdx,this.item.subscription,this.currKeyValues,n,e,new Ms))},doUpdate:function(t,e){var s=this.item.subscription.getCommandPosition(),i=this.currKeyValues;this.currKeyValues=t,this.currKeyValues.h[s]=Yt.StringVal("UPDATE");var n=Jt(i,this.currKeyValues);this.fireOnItemUpdate(new Vt(this.item.itemIdx,this.item.subscription,this.currKeyValues,n,e,new Ms))},doLightDelete:function(t,e){this.currKeyValues=null;var s=new Me(t.keys()),i=new Vt(this.item.itemIdx,this.item.subscription,this.nullify(t),s,e,new Ms);this.item.unrelate(this.keyName),this.fireOnItemUpdate(i)},doDelete:function(t,e){this.currKeyValues=null;var s=new Me(t.keys()).subtracting([this.item.subscription.getKeyPosition()]),i=new Vt(this.item.itemIdx,this.item.subscription,this.nullify(t),s,e,new Ms);this.item.unrelate(this.keyName),this.fireOnItemUpdate(i)},nullify:function(t){for(var e=new Ms,s=t,i=s.keys();i.hasNext();){var n=i.next(),r=s.get(n),a=n==this.item.subscription.getCommandPosition()||n==this.item.subscription.getKeyPosition();e.h[n]=a?r:null}return e},isDelete:function(t){var e=this.item.subscription.getCommandPosition();return"DELETE"==Qt.toString(t.h[e])},fireOnItemUpdate:function(t){this.item.subscription.fireOnItemUpdate(t,this.item.m_subId)},goto:function(t){this.s_m=t,this.traceEvent("goto")},traceEvent:function(t){if(Ni.isTraceEnabled()){var e=this.item.m_subId,s=this.item.itemIdx;Ni.isTraceEnabled()&&Ni.trace("sub#key#"+t+"("+e+":"+s+":"+this.keyName+") in "+this.s_m)}},__class__:Kt};var Gt=function(t,e){this.s_m=1,this.keyName=t,this.item=e,this.lock=e.lock};Gt.__name__="com.lightstreamer.client.internal.update.Key2Level",Gt.__interfaces__=[Bt],Gt.prototype={finalize:function(){this.currKeyValues=null,this.currKey2Values=null,this.item.unrelate(this.keyName)},evtUpdate:function(t,e){switch(this.traceEvent("update"),this.s_m){case 1:if(this.isDelete(t))this.doLightDelete(t,e),this.finalize(),this.goto(11),this.genOnRealMaxFrequency2LevelRemoved();else{var s=this.create2LevelSubscription();null!=s?(this.doFirstUpdate(t,e),this.subscription2Level=s,this.goto(4),this.item.strategy.client.subscribeExt(s,!0)):(this.doFirstUpdate(t,e),this.notify2LevelIllegalArgument(),this.goto(3))}break;case 3:this.isDelete(t)?(this.doDelete1LevelOnly(t,e),this.finalize(),this.goto(11),this.genOnRealMaxFrequency2LevelRemoved()):(this.doUpdate(t,e),this.goto(3));break;case 4:this.isDelete(t)?(this.doDelete(t,e),this.finalize(),this.goto(11),this.genOnRealMaxFrequency2LevelRemoved()):(this.doUpdate(t,e),this.goto(4));break;case 5:this.isDelete(t)?(this.doDeleteExt(t,e),this.finalize(),this.goto(11),this.genOnRealMaxFrequency2LevelRemoved()):(this.doUpdate1Level(t,e),this.goto(5))}},evtDispose:function(){switch(this.traceEvent("dispose"),this.s_m){case 1:case 2:case 3:this.finalize(),this.goto(10);break;case 4:case 5:this.doUnsubscribe(),this.finalize(),this.goto(12)}},evtOnSubscriptionError2Level:function(t,e){this.traceEvent("onSubscriptionError2Level"),4==this.s_m&&(this.notify2LevelSubscriptionError(t,e),this.goto(3))},evtUpdate2Level:function(t){switch(this.traceEvent("update2Level"),this.s_m){case 4:case 5:this.doUpdate2Level(t),this.goto(5)}},evtOnUnsubscription2Level:function(){switch(this.traceEvent("onUnsubscription2Level"),this.s_m){case 4:case 5:this.doUnsetRealMaxFrequency(),this.goto(this.s_m),this.genOnRealMaxFrequency2LevelRemoved()}},evtOnItemLostUpdates2Level:function(t){switch(this.traceEvent("onItemLostUpdates2Level"),this.s_m){case 4:case 5:this.goto(this.s_m),this.notify2LevelLostUpdates(t)}},evtOnRealMaxFrequency2Level:function(t){switch(this.traceEvent("onRealMaxFrequency2Level"),this.s_m){case 4:case 5:this.doSetRealMaxFrequency(t),this.goto(this.s_m),this.genOnRealMaxFrequency2LevelAdded()}},evtSetRequestedMaxFrequency:function(){switch(this.traceEvent("setRequestedMaxFrequency"),this.s_m){case 4:case 5:this.doChangeRequestedMaxFrequency(),this.goto(this.s_m)}},getCommandValue:function(t){if(null!=(e=this.currKeyValues)&&null!=e.h[t])return Qt.toString(e.h[t]);var e=this.currKey2Values,s=this.item.subscription.fetch_nFields();return null!=e&&null!=s?e.h[t-s]:null},doFirstUpdate:function(t,e){var s=this.item.subscription.getCommandPosition();this.currKeyValues=t,this.currKeyValues.h[s]=Yt.StringVal("ADD");var i=Jt(null,this.currKeyValues);this.fireOnItemUpdate(new Ht(this.item.itemIdx,this.item.subscription,this.currKeyValues,i,e,new Ms))},doUpdate:function(t,e){var s=this.item.subscription.getCommandPosition(),i=this.currKeyValues;this.currKeyValues=t,this.currKeyValues.h[s]=Yt.StringVal("UPDATE");var n=Jt(i,this.currKeyValues);this.fireOnItemUpdate(new Ht(this.item.itemIdx,this.item.subscription,this.currKeyValues,n,e,new Ms))},doUpdate2Level:function(t){var e=this.item.subscription.getCommandPosition(),s=ye.sure(this.item.subscription.fetch_nFields()),i=ye.sure(this.currKeyValues).copy();this.currKeyValues.h[e]=Yt.StringVal("UPDATE"),this.currKey2Values=te(t);for(var n=ye.sure(this.currKeyValues).copy(),r=(c=this.currKey2Values).keys();r.hasNext();){var a=r.next(),o=c.get(a);n.h[a+s]=null==o?null:Yt.StringVal(o)}var h=new Me;for(Qt.toString(i.h[e])!=Qt.toString(this.currKeyValues.h[e])&&h.insert(e),r=(c=ee(t)).keys();r.hasNext();)a=r.next(),c.get(a),h.insert(a+s);var c,u=t.isSnapshot(),l=new Ms;for(r=(c=this.currKey2Values).keys();r.hasNext();){a=r.next(),c.get(a);var _=t.getValueAsJSONPatchIfAvailable(a);null!=_&&(l.h[a+s]=_)}this.fireOnItemUpdate(new Ht(this.item.itemIdx,this.item.subscription,n,h,u,l))},doUpdate1Level:function(t,e){var s=this.item.subscription.getCommandPosition(),i=ye.sure(this.item.subscription.fetch_nFields()),n=ye.sure(this.currKeyValues);this.currKeyValues=t,this.currKeyValues.h[s]=Yt.StringVal("UPDATE");for(var r=ye.sure(this.currKeyValues).copy(),a=ye.sure(this.currKey2Values),o=a.keys();o.hasNext();){var h=o.next(),c=a.get(h);r.h[h+i]=null==c?null:Yt.StringVal(c)}for(var u=new Me,l=1,_=i+1;l<_;){var d=l++;Qt.toString(n.h[d])!=Qt.toString(r.h[d])&&u.insert(d)}this.fireOnItemUpdate(new Ht(this.item.itemIdx,this.item.subscription,r,u,e,new Ms))},doDelete:function(t,e){var s=ye.sure(this.item.subscription.fetch_nFields()),i=this.item.subscription.getKeyPosition(),n=this.item.subscription.getCommandPosition();this.currKeyValues=null;for(var r=new Me(new d(1,s+1)).subtracting([i]),a=new Ms,o=1,h=s+1;o<h;)a.h[o++]=null;a.h[i]=Yt.StringVal(this.keyName),a.h[n]=Yt.StringVal("DELETE");var c=new Ht(this.item.itemIdx,this.item.subscription,a,r,e,new Ms);this.item.unrelate(this.keyName);var u=ye.sure(this.subscription2Level);u.removeListener(ye.sure(this.listener2Level)),ye.sure(this.listener2Level).disable(),this.subscription2Level=null,this.listener2Level=null,this.item.strategy.client.unsubscribe(u),this.fireOnItemUpdate(c)},doDeleteExt:function(t,e){var s=ye.sure(this.item.subscription.fetch_nFields()),i=this.item.subscription.getKeyPosition(),n=this.item.subscription.getCommandPosition(),r=s+m.count(ye.sure(this.currKey2Values));this.currKeyValues=null,this.currKey2Values=null;for(var a=new Me(new d(1,r+1)).subtracting([i]),o=new Ms,h=1,c=r+1;h<c;)o.h[h++]=null;o.h[i]=Yt.StringVal(this.keyName),o.h[n]=Yt.StringVal("DELETE");var u=new Ht(this.item.itemIdx,this.item.subscription,o,a,e,new Ms);this.item.unrelate(this.keyName);var l=ye.sure(this.subscription2Level);l.removeListener(ye.sure(this.listener2Level)),ye.sure(this.listener2Level).disable(),this.subscription2Level=null,this.listener2Level=null,this.item.strategy.client.unsubscribe(l),this.fireOnItemUpdate(u)},doLightDelete:function(t,e){var s=ye.sure(this.item.subscription.fetch_nFields()),i=this.item.subscription.getKeyPosition(),n=this.item.subscription.getCommandPosition();this.currKeyValues=null;for(var r=new Me(new d(1,s+1)),a=new Ms,o=1,h=s+1;o<h;)a.h[o++]=null;a.h[i]=t.h[i],a.h[n]=t.h[n],this.fireOnItemUpdate(new Ht(this.item.itemIdx,this.item.subscription,a,r,e,new Ms))},doDelete1LevelOnly:function(t,e){var s=ye.sure(this.item.subscription.fetch_nFields()),i=this.item.subscription.getKeyPosition(),n=this.item.subscription.getCommandPosition();this.currKeyValues=null;for(var r=new Me(new d(1,s+1)).subtracting([i]),a=new Ms,o=1,h=s+1;o<h;)a.h[o++]=null;a.h[i]=t.h[i],a.h[n]=t.h[n],this.fireOnItemUpdate(new Ht(this.item.itemIdx,this.item.subscription,a,r,e,new Ms))},doChangeRequestedMaxFrequency:function(){ye.sure(this.subscription2Level).setRequestedMaxFrequency(ts.toString(this.item.strategy.requestedMaxFrequency))},doSetRealMaxFrequency:function(t){this.realMaxFrequency=t},doUnsetRealMaxFrequency:function(){this.realMaxFrequency=null},genOnRealMaxFrequency2LevelAdded:function(){this.item.strategy.evtOnRealMaxFrequency2LevelAdded(this.realMaxFrequency)},genOnRealMaxFrequency2LevelRemoved:function(){this.item.strategy.evtOnRealMaxFrequency2LevelRemoved()},doUnsubscribe:function(){if(null==this.subscription2Level)throw new be("Assertion failure: subscription2Level != null");if(null==this.listener2Level)throw new be("Assertion failure: listener2Level != null");var t=this.subscription2Level;t.removeListener(this.listener2Level),this.listener2Level.disable(),this.subscription2Level=null,this.listener2Level=null,this.item.strategy.client.unsubscribe(t)},notify2LevelIllegalArgument:function(){this.listener2Level=null,this.subscription2Level=null,this.item.subscription.fireOnSubscriptionError2Level(this.keyName,14,"The received key value is not a valid name for an Item",this.item.m_subId,this.item.itemIdx)},notify2LevelSubscriptionError:function(t,e){this.listener2Level=null,this.subscription2Level=null,this.item.subscription.fireOnSubscriptionError2Level(this.keyName,t,e,this.item.m_subId,this.item.itemIdx)},notify2LevelLostUpdates:function(t){this.item.subscription.fireOnLostUpdates2Level(this.keyName,t,this.item.m_subId,this.item.itemIdx)},fireOnItemUpdate:function(t){this.item.subscription.fireOnItemUpdate(t,this.item.m_subId)},create2LevelSubscription:function(){this.listener2Level=new zt(this);var t=this.item.subscription,e=new M("MERGE",null,null),s=[this.keyName];if(!rs.allValidNames(s))return null;e.setItems(s.slice());var i=t.getCommandSecondLevelFields();return null!=i?e.setFields(i):e.setFieldSchema(t.getCommandSecondLevelFieldSchema()),e.setDataAdapter(t.getCommandSecondLevelDataAdapter()),e.setRequestedSnapshot(Ze.toString(Xe.SnpYes)),e.setRequestedMaxFrequency(ts.toString(this.item.strategy.requestedMaxFrequency)),e.addListener(ye.sure(this.listener2Level)),e.setInternal(),e},isDelete:function(t){var e=this.item.subscription.getCommandPosition();return"DELETE"==Qt.toString(t.h[e])},goto:function(t){this.s_m=t,this.traceEvent("goto")},traceEvent:function(t){if(Ni.isTraceEnabled()){var e=this.item.m_subId,s=this.item.itemIdx;Ni.isTraceEnabled()&&Ni.trace("sub#key#"+t+"("+e+":"+s+":"+this.keyName+") in "+this.s_m)}},__class__:Gt};var zt=function(t){this.m_disabled=!1,this.key=t};zt.__name__="com.lightstreamer.client.internal.update._Key2Level.Sub2LevelDelegate",zt.__interfaces__=[h],zt.prototype={disable:function(){var t=this;xe.synchronized(this.key.lock,(function(){return t.m_disabled=!0}))},synchronized:function(t){var e=this;xe.synchronized(this.key.lock,(function(){e.m_disabled||t()}))},onSubscriptionError:function(t,e){var s=this;this.synchronized((function(){s.key.evtOnSubscriptionError2Level(t,e)}))},onItemUpdate:function(t){var e=this;this.synchronized((function(){e.key.evtUpdate2Level(t)}))},onItemLostUpdates:function(t,e,s){var i=this;this.synchronized((function(){i.key.evtOnItemLostUpdates2Level(s)}))},onRealMaxFrequency:function(t){var e=this;this.synchronized((function(){var s,i=e.key;if(null==t)s=null;else if(null==t){var n=parseFloat(t);s=isNaN(n)?null:es.RFreqLimited(n)}else"unlimited"==t?s=es.RFreqUnlimited:(n=parseFloat(t),s=isNaN(n)?null:es.RFreqLimited(n));i.evtOnRealMaxFrequency2Level(s)}))},onUnsubscription:function(){var t=this;this.synchronized((function(){t.key.evtOnUnsubscription2Level()}))},onClearSnapshot:function(t,e){},onCommandSecondLevelItemLostUpdates:function(t,e){},onCommandSecondLevelSubscriptionError:function(t,e,s){},onEndOfSnapshot:function(t,e){},onListenEnd:function(t){},onListenStart:function(t){},onSubscription:function(){},__class__:zt};var Yt=a["com.lightstreamer.client.internal.update.CurrFieldVal"]={__ename__:!0,__constructs__:null,StringVal:(e=function(t){return{_hx_index:0,string:t,__enum__:"com.lightstreamer.client.internal.update.CurrFieldVal",toString:r}},e._hx_name="StringVal",e.__params__=["string"],e),JsonVal:(e=function(t){return{_hx_index:1,json:t,__enum__:"com.lightstreamer.client.internal.update.CurrFieldVal",toString:r}},e._hx_name="JsonVal",e.__params__=["json"],e)};Yt.__constructs__=[Yt.StringVal,Yt.JsonVal];var Qt=function(){};function jt(t,e){if(null!=t){for(var s=new Ms,i=(S=e).keys();i.hasNext();){var n=i.next();switch((b=S.get(n))._hx_index){case 0:s.h[n]=t.h[n];break;case 1:var r=b.val;s.h[n]=null==r?null:Yt.StringVal(r);break;case 2:var a=b.patch,o=t.h[n];if(null==o)throw new be("Cannot apply the JSON patch to the field "+n+" because the field is null");switch(o._hx_index){case 0:var h=o.string,c=null;try{c=ds._new(h)}catch(t){var u=w.caught(t);throw Oi.isErrorEnabled()&&Oi.error(u.get_message()+"\n"+u.details()),new be("Cannot convert the field "+n+" to JSON")}try{var l=Yt.JsonVal(ds.apply(ye.sure(c),a));s.h[n]=l}catch(t){var _=w.caught(t);throw Oi.isErrorEnabled()&&Oi.error(_.get_message()+"\n"+_.details()),new be("Cannot apply the JSON Patch to the field "+n)}break;case 1:var d=o.json;try{var m=Yt.JsonVal(ds.apply(d,a));s.h[n]=m}catch(t){var f=w.caught(t);throw Oi.isErrorEnabled()&&Oi.error(f.get_message()+"\n"+f.details()),new be("Cannot apply the JSON Patch to the field "+n)}}break;case 3:var p=b.patch,g=t.h[n];if(null==g)throw new be("Cannot apply the TLCP-diff to the field "+n+" because the field is null");switch(g._hx_index){case 0:var v=Yt.StringVal(new _s(g.string,p).decode());s.h[n]=v;break;case 1:throw new be("Cannot apply the TLCP-diff to the field "+n+" because the field is JSON")}}}return s}var S;for(s=new Ms,i=(S=e).keys();i.hasNext();){var b;switch(n=i.next(),(b=S.get(n))._hx_index){case 0:throw new be("Cannot set the field "+n+" because the first update is UNCHANGED");case 1:r=b.val,s.h[n]=null==r?null:Yt.StringVal(r);break;case 2:throw new be("Cannot set the field "+n+" because the first update is a JSONPatch");case 3:throw new be("Cannot set the field "+n+" because the first update is a TLCP-diff")}}return s}function Jt(t,e){if(null!=t){for(var s=new Me,i=(r=e).keys();i.hasNext();){var n=i.next();r.get(n),Qt.toString(t.h[n])!=Qt.toString(e.h[n])&&s.insert(n)}return s}var r;for(s=new Me,i=(r=e).keys();i.hasNext();)n=i.next(),r.get(n),s.insert(n);return s}function Xt(t,e){if(null!=t){for(var s=new Ms,i=e,n=i.keys();n.hasNext();){var r=n.next(),a=i.get(r);switch(a._hx_index){case 0:var o=t.h[r];if(null!=o&&null!=o&&1==o._hx_index){var h=ds._new("[]");s.h[r]=h}break;case 2:s.h[r]=a.patch}}return s}return new Ms}function Zt(t){if(null!=t){for(var e=new Ms,s=0;s<t.length;){var i=t[s++];e.h[s-1+1]=i}return e}return null}function $t(t,e){for(var s=1,i=m.count(t)+1;s<i;){var n=s++;if(t.h[n]==e)return n}return null}function te(t){var e=new Ms;return t.forEachField((function(t,s,i){e.h[s]=i})),e}function ee(t){var e=new Ms;return t.forEachChangedField((function(t,s,i){e.h[s]=i})),e}Qt.__name__="com.lightstreamer.client.internal.update.CurrFieldValTools",Qt.toString=function(t){if(null==t)return null;switch(t._hx_index){case 0:return t.string;case 1:return ds.toString(t.json)}};var se=l.LSFirebaseMpnBuilder=function(t){var e=null==t?null:JSON.parse(t);null==e&&(e={webpush:{notification:{}}}),null==e.webpush&&(e.webpush={notification:{}}),null==e.webpush.notification&&(e.webpush.notification={}),this.obj=e};se.__name__="LSFirebaseMpnBuilder",se.prototype={build:function(){return this.removeNullFields(this.obj.webpush),this.removeNullFields(this.obj.webpush.notification),JSON.stringify(this.obj)},removeNullFields:function(t){for(var e=0,s=f.fields(t);e<s.length;){var i=s[e];++e,null==f.field(t,i)&&f.deleteField(t,i)}},getHeaders:function(){var t=this.obj.webpush.headers;return null==t?null:f.copy(t)},setHeaders:function(t){var e=null==t?null:Ee.toDynamicAccess(t);return this.obj.webpush.headers=e,this},getTitle:function(){return this.obj.webpush.notification.title},setTitle:function(t){return this.obj.webpush.notification.title=t,this},getBody:function(){return this.obj.webpush.notification.body},setBody:function(t){return this.obj.webpush.notification.body=t,this},getIcon:function(){return this.obj.webpush.notification.icon},setIcon:function(t){return this.obj.webpush.notification.icon=t,this},getData:function(){var t=this.obj.webpush.data;return null==t?null:f.copy(t)},setData:function(t){var e=null==t?null:Ee.toDynamicAccess(t);return this.obj.webpush.data=e,this},__class__:se};var ie=function(){I.call(this)};ie.__name__="com.lightstreamer.client.mpn._MpnDevice.MpnDeviceEventDispatcher",ie.__super__=I,ie.prototype=c(I.prototype,{addListenerAndFireOnListenStart:function(t){this.addListener(t)&&this.dispatchToOne(t,(function(t){null!=t.onListenStart&&t.onListenStart()}))},removeListenerAndFireOnListenEnd:function(t){this.removeListener(t)&&this.dispatchToOne(t,(function(t){null!=t.onListenEnd&&t.onListenEnd()}))},onRegistered:function(){this.dispatchToAll((function(t){null!=t.onRegistered&&t.onRegistered()}))},onSuspended:function(){this.dispatchToAll((function(t){null!=t.onSuspended&&t.onSuspended()}))},onResumed:function(){this.dispatchToAll((function(t){null!=t.onResumed&&t.onResumed()}))},onStatusChanged:function(t,e){this.dispatchToAll((function(s){null!=s.onStatusChanged&&s.onStatusChanged(t,e)}))},onRegistrationFailed:function(t,e){this.dispatchToAll((function(s){null!=s.onRegistrationFailed&&s.onRegistrationFailed(t,e)}))},onSubscriptionsUpdated:function(){this.dispatchToAll((function(t){null!=t.onSubscriptionsUpdated&&t.onSubscriptionsUpdated()}))},__class__:ie});var ne=l.LSMpnDevice=function(t,e,s){if(this.lock=new ys,this.statusTs=0,this.status="UNKNOWN",this.eventDispatcher=new ie,null==t)throw new R("Please specify a valid device token");if(null==e)throw new R("Please specify a valid application ID");var i;switch(this.deviceToken=t,this.applicationId=e,s){case"Apple":i="Apple";break;case"Google":i="Google";break;default:throw new R("Please specify a valid platform: Google or Apple")}this.platform=i;var n=E.getLocalStorage();if(null!=n){var r=n.getItem("com.lightstreamer.mpn.device_token");null!=r?Ai.isDebugEnabled()&&Ai.debug("Previous registration ID found ("+r+")"):Ai.isDebugEnabled()&&Ai.debug("No previous registration ID found"),Ai.isDebugEnabled()&&Ai.debug("Registration ID obtained ("+t+"), storing..."),n.setItem("com.lightstreamer.mpn.device_token",t),Ai.isDebugEnabled()&&Ai.debug("Registration ID stored"),this.prevDeviceToken=r}else Ai.isErrorEnabled()&&Ai.error("Local storage not available"),this.prevDeviceToken=null};ne.__name__="LSMpnDevice",ne.prototype={addListener:function(t){this.eventDispatcher.addListenerAndFireOnListenStart(t)},removeListener:function(t){this.eventDispatcher.removeListenerAndFireOnListenEnd(t)},getListeners:function(){return this.eventDispatcher.getListeners().slice()},isRegistered:function(){return"REGISTERED"==this.status},isSuspended:function(){return"SUSPENDED"==this.status},getStatus:function(){return this.status},getStatusTimestamp:function(){return this.statusTs},getPlatform:function(){return this.platform},getApplicationId:function(){return this.applicationId},getDeviceToken:function(){return this.deviceToken},getPreviousDeviceToken:function(){return this.prevDeviceToken},getDeviceId:function(){return this.deviceId},setDeviceId:function(t,e){var s=this;xe.synchronized(this.lock,(function(){return s.deviceId=t,s.adapterName=e}))},onRegistered:function(t){var e=this;xe.synchronized(this.lock,(function(){Ai.isInfoEnabled()&&Ai.info("MPN device registered: "+e.deviceId+")"),e.status="REGISTERED",e.statusTs=t,e.eventDispatcher.onStatusChanged("REGISTERED",t),e.eventDispatcher.onRegistered()}))},onSuspend:function(t){var e=this;xe.synchronized(this.lock,(function(){Ai.isInfoEnabled()&&Ai.info("MPN device suspended: "+e.deviceId),e.status="SUSPENDED",e.statusTs=t,e.eventDispatcher.onStatusChanged("SUSPENDED",t),e.eventDispatcher.onSuspended()}))},onResume:function(t){var e=this;xe.synchronized(this.lock,(function(){Ai.isInfoEnabled()&&Ai.info("MPN device resumed: "+e.deviceId),e.status="REGISTERED",e.statusTs=t,e.eventDispatcher.onStatusChanged("REGISTERED",t),e.eventDispatcher.onResumed()}))},onError:function(t,e){var s=this;xe.synchronized(this.lock,(function(){Ai.isWarnEnabled()&&Ai.warn("MPN device error: "+t+" - "+e+" "+s.deviceId),s.status="UNKNOWN",s.statusTs=0,s.deviceId=null,s.adapterName=null,s.eventDispatcher.onRegistrationFailed(t,e),s.eventDispatcher.onStatusChanged("UNKNOWN",0)}))},onReset:function(){var t=this;xe.synchronized(this.lock,(function(){Ai.isInfoEnabled()&&Ai.info("MPN device NOT registered");var e=t.status;t.status="UNKNOWN",t.statusTs=0,t.deviceId=null,t.adapterName=null,"UNKNOWN"!=e&&t.eventDispatcher.onStatusChanged("UNKNOWN",0)}))},fireOnSubscriptionsUpdated:function(){var t=this;xe.synchronized(this.lock,(function(){Ai.isInfoEnabled()&&Ai.info("MPN subscriptions have been updated: "+t.deviceId),t.eventDispatcher.onSubscriptionsUpdated()}))},fireOnBadgeResetFailed:function(t,e){var s=this;xe.synchronized(this.lock,(function(){Ai.isWarnEnabled()&&Ai.warn("MPN badge reset failed: "+t+" - "+e+" "+s.deviceId)}))},fireOnBadgeReset:function(){var t=this;xe.synchronized(this.lock,(function(){Ai.isInfoEnabled()&&Ai.info("MPN badge successfully reset: "+t.deviceId)}))},toString:function(){var t=ge._new();return ge.set(t,"platform",this.platform),ge.set(t,"applicationId",this.applicationId),ge.set(t,"deviceToken",this.deviceToken),ge.set(t,"prevDeviceToken",this.prevDeviceToken),ks.stringify(t.h)},__class__:ne};var re=a["com.lightstreamer.client.mpn.MpnSubscriptionStatus"]={__ename__:!0,__constructs__:null,Unknown:{_hx_name:"Unknown",_hx_index:0,__enum__:"com.lightstreamer.client.mpn.MpnSubscriptionStatus",toString:r},Active:{_hx_name:"Active",_hx_index:1,__enum__:"com.lightstreamer.client.mpn.MpnSubscriptionStatus",toString:r},Subscribed:{_hx_name:"Subscribed",_hx_index:2,__enum__:"com.lightstreamer.client.mpn.MpnSubscriptionStatus",toString:r},Triggered:{_hx_name:"Triggered",_hx_index:3,__enum__:"com.lightstreamer.client.mpn.MpnSubscriptionStatus",toString:r}};re.__constructs__=[re.Unknown,re.Active,re.Subscribed,re.Triggered];var ae=function(){I.call(this)};ae.__name__="com.lightstreamer.client.mpn._MpnSubscription.MpnSubscriptionEventDispatcher",ae.__super__=I,ae.prototype=c(I.prototype,{addListenerAndFireOnListenStart:function(t){this.addListener(t)&&this.dispatchToOne(t,(function(t){null!=t.onListenStart&&t.onListenStart()}))},removeListenerAndFireOnListenEnd:function(t){this.removeListener(t)&&this.dispatchToOne(t,(function(t){null!=t.onListenEnd&&t.onListenEnd()}))},onSubscription:function(){this.dispatchToAll((function(t){null!=t.onSubscription&&t.onSubscription()}))},onUnsubscription:function(){this.dispatchToAll((function(t){null!=t.onUnsubscription&&t.onUnsubscription()}))},onSubscriptionError:function(t,e){this.dispatchToAll((function(s){null!=s.onSubscriptionError&&s.onSubscriptionError(t,e)}))},onUnsubscriptionError:function(t,e){this.dispatchToAll((function(s){null!=s.onUnsubscriptionError&&s.onUnsubscriptionError(t,e)}))},onTriggered:function(){this.dispatchToAll((function(t){null!=t.onTriggered&&t.onTriggered()}))},onStatusChanged:function(t,e){this.dispatchToAll((function(s){null!=s.onStatusChanged&&s.onStatusChanged(t,e)}))},onPropertyChanged:function(t){this.dispatchToAll((function(e){null!=e.onPropertyChanged&&e.onPropertyChanged(t)}))},onModificationError:function(t,e,s){this.dispatchToAll((function(i){null!=i.onModificationError&&i.onModificationError(t,e,s)}))},__class__:ae});var oe=l.LSMpnSubscription=function(t,e,s,i){if(this.lock=new ys,this.m_status=re.Unknown,this.m_statusTs=0,this.eventDispatcher=new ae,this.wrapper=i,"string"==typeof t)this.mode=ce.fromString(t),this.madeByServer=!1,this.initItemsAndFields("string"==typeof e?[e].slice():e,s);else if(t instanceof M){var n=t;this.mode=ce.fromString(n.getMode()),this.madeByServer=!1,this.initFromSubscription(n)}else{if(!(t instanceof oe))throw this.mode="MERGE",this.madeByServer=!1,new R("Wrong arguments for MpnSubscription constructor");var r=t;this.mode=r.mode,this.madeByServer=!1,this.initFromMpnSubscription(r)}};oe.__name__="LSMpnSubscription",oe.prototype={reInit:function(t){this.m_mpnSubId=t,this.madeByServer=!0},initFromSubscription:function(t){var e=t.getItems(),s=t.getFields();this.items=null!=e?rs.fromArray(e.slice()):null,this.group=os.fromString(t.getItemGroup()),this.fields=null!=s?as.fromArray(s.slice()):null,this.schema=os.fromString(t.getFieldSchema()),this.dataAdapter=os.fromString(t.getDataAdapter()),this.bufferSize=Je.fromString(t.getRequestedBufferSize()),this.requestedMaxFrequency=le.fromString(t.getRequestedMaxFrequency())},initFromMpnSubscription:function(t){this.items=t.items,this.group=t.group,this.fields=t.fields,this.schema=t.schema,this.dataAdapter=t.dataAdapter,this.bufferSize=t.bufferSize,this.requestedMaxFrequency=t.requestedMaxFrequency,this.requestedFormat=t.requestedFormat,this.requestedTrigger=t.requestedTrigger},initItemsAndFields:function(t,e){if(null!=t){if(null==e)throw new R("Please specify a valid field list");this.items=rs.fromArray(t.slice()),this.fields=as.fromArray(e.slice())}else if(null!=e)throw new R("Please specify a valid item or item list")},addListener:function(t){this.eventDispatcher.addListenerAndFireOnListenStart(t)},removeListener:function(t){this.eventDispatcher.removeListenerAndFireOnListenEnd(t)},getListeners:function(){return this.eventDispatcher.getListeners().slice()},getMode:function(){return this.mode},getTriggerExpression:function(){return this.requestedTrigger},setTriggerExpression:function(t){var e,s=this;xe.synchronized(this.lock,(function(){return s.requestedTrigger=null==t?null:t,e=s.m_manager})),null!=e&&e.evtExtMpnSetTrigger()},getActualTriggerExpression:function(){return this.realTrigger},getNotificationFormat:function(){return this.requestedFormat},setNotificationFormat:function(t){var e,s=this;xe.synchronized(this.lock,(function(){return s.requestedFormat=null==t?null:t,e=s.m_manager})),null!=e&&e.evtExtMpnSetFormat()},getActualNotificationFormat:function(){return this.realFormat},getDataAdapter:function(){return this.dataAdapter},setDataAdapter:function(t){this.checkActive(),this.dataAdapter=os.fromString(t)},getFields:function(){return null==this.fields?null:this.fields.slice()},setFields:function(t){this.checkActive(),this.fields=as.fromArray(null==t?null:t.slice()),this.schema=null},getFieldSchema:function(){return this.schema},setFieldSchema:function(t){this.checkActive(),this.schema=os.fromString(t),this.fields=null},getItems:function(){return null==this.items?null:this.items.slice()},setItems:function(t){this.checkActive(),this.items=rs.fromArray(null==t?null:t.slice()),this.group=null},getItemGroup:function(){return this.group},setItemGroup:function(t){this.checkActive(),this.group=os.fromString(t),this.items=null},getRequestedBufferSize:function(){return Je.toString(this.bufferSize)},setRequestedBufferSize:function(t){null!=t&&(t=null==t?"null":""+t),this.checkActive(),this.bufferSize=Je.fromString(t)},getRequestedMaxFrequency:function(){return le.toString(this.requestedMaxFrequency)},setRequestedMaxFrequency:function(t){null!=t&&(t=null==t?"null":""+t),this.checkActive(),this.requestedMaxFrequency=le.fromString(t)},isActive:function(){return this.m_status!=re.Unknown},isSubscribed:function(){return this.m_status==re.Subscribed},isTriggered:function(){return this.m_status==re.Triggered},getStatus:function(){switch(this.m_status._hx_index){case 0:return"UNKNOWN";case 1:return"ACTIVE";case 2:return"SUBSCRIBED";case 3:return"TRIGGERED"}},getStatusTimestamp:function(){return this.m_statusTs},getSubscriptionId:function(){return this.m_mpnSubId},checkActive:function(){if(this.isActive())throw new be("Cannot modify an active MpnSubscription. Please unsubscribe before applying any change")},setSubscriptionId:function(t){this.m_mpnSubId=t},changeStatus:function(t,e){var s=null==e?this.m_statusTs:bt(e);t!=this.m_status&&(this.m_status=t,this.eventDispatcher.onStatusChanged(this.getStatus(),s))},changeStatusTs:function(t){if(null!=t){var e=bt(t);e!=this.m_statusTs&&(this.m_statusTs=e,this.fireOnPropertyChange("status_timestamp"))}},changeMode:function(t){if(null!=t){var e=ce.fromString(t);this.mode!=e&&(this.mode=e,this.fireOnPropertyChange("mode"))}},changeGroup:function(t){null!=t&&this.group!=t&&(this.group=t,this.items=null,this.fireOnPropertyChange("group"))},changeSchema:function(t){null!=t&&this.schema!=t&&(this.schema=t,this.fields=null,this.fireOnPropertyChange("schema"))},changeAdapter:function(t){this.dataAdapter!=t&&(this.dataAdapter=null!=t?t:null,this.fireOnPropertyChange("adapter"))},changeFormat:function(t){null!=t&&t!=this.realFormat&&(this.realFormat=t,this.fireOnPropertyChange("notification_format"))},changeTrigger:function(t){t!=this.realTrigger&&(this.realTrigger=null!=t?t:null,this.fireOnPropertyChange("trigger"))},changeBufferSize:function(t){var e=Je.fromString(t);Je.extEquals(this.bufferSize,e)||(this.bufferSize=e,this.fireOnPropertyChange("requested_buffer_size"))},changeMaxFrequency:function(t){var e=le.fromString(t);le.extEquals(e,this.requestedMaxFrequency)||(this.requestedMaxFrequency=e,this.fireOnPropertyChange("requested_max_frequency"))},reset:function(){this.realFormat=null,this.realTrigger=null,this.m_statusTs=0,this.m_mpnSubId=null},fireOnSubscription:function(){Bi.isInfoEnabled()&&Bi.info((this.madeByServer?"Server ":"")+"MPNSubscription subscribed: pnSubId: "+this.m_mpnSubId),this.eventDispatcher.onSubscription()},fireOnUnsubscription:function(){Bi.isInfoEnabled()&&Bi.info((this.madeByServer?"Server ":"")+"MPNSubscription unsubscribed: pnSubId: "+this.m_mpnSubId),this.eventDispatcher.onUnsubscription()},fireOnTriggered:function(){Bi.isInfoEnabled()&&Bi.info((this.madeByServer?"Server ":"")+"MPNSubscription triggered: pnSubId: "+this.m_mpnSubId),this.eventDispatcher.onTriggered()},fireOnSubscriptionError:function(t,e){Bi.isWarnEnabled()&&Bi.warn((this.madeByServer?"Server ":"")+"MPNSubscription error: "+t+" - "+e+" pnSubId: "+this.m_mpnSubId),this.eventDispatcher.onSubscriptionError(t,e)},fireOnUnsubscriptionError:function(t,e){Bi.isWarnEnabled()&&Bi.warn((this.madeByServer?"Server ":"")+"MPNSubscription unsubscription error: "+t+" - "+e+" pnSubId: "+this.m_mpnSubId),this.eventDispatcher.onUnsubscriptionError(t,e)},fireOnModificationError:function(t,e,s){Bi.isWarnEnabled()&&Bi.warn((this.madeByServer?"Server ":"")+"MPNSubscription "+s+" modification error: "+t+" - "+e+" pnSubId: "+this.m_mpnSubId),this.eventDispatcher.onModificationError(t,e,s)},fireOnPropertyChange:function(t){if(Bi.isInfoEnabled()){var e;switch(t){case"adapter":e="newValue: "+this.dataAdapter;break;case"group":e="newValue: "+this.group;break;case"mode":e="newValue: "+this.mode;break;case"notification_format":e="newValue: "+this.realFormat;break;case"requested_buffer_size":e="newValue: "+Je.toString(this.bufferSize);break;case"requested_max_frequency":e="newValue: "+le.toString(this.requestedMaxFrequency);break;case"schema":e="newValue: "+this.schema;break;case"status_timestamp":default:e="";break;case"trigger":e="newValue: "+this.realTrigger}"status_timestamp"!=t&&Bi.isInfoEnabled()&&Bi.info((this.madeByServer?"Server ":"")+"MPNSubscription "+t+" changed: "+e+" pnSubId: "+(null!=this.m_mpnSubId?this.m_mpnSubId:"n.a."))}this.eventDispatcher.onPropertyChanged(t)},fetch_subManager:function(){return this.m_manager},fetch_status:function(){return this.m_status},fetch_madeByServer:function(){return this.madeByServer},fetch_mpnSubId:function(){return this.m_mpnSubId},fetch_requestedBufferSize:function(){return this.bufferSize},fetch_mode:function(){return this.mode},fetch_requestedMaxFrequency:function(){return this.requestedMaxFrequency},fetch_requestedFormat:function(){return this.requestedFormat},fetch_requestedTrigger:function(){return this.requestedTrigger},relate:function(t){this.m_manager=t},unrelate:function(t){t==this.m_manager&&(this.m_manager=null)},toString:function(){var t=ge._new();return ge.set(t,"mode",this.mode),ge.set(t,"items",null!=this.items?p.string(this.items):this.group),ge.set(t,"fields",null!=this.fields?p.string(this.fields):this.schema),ge.set(t,"dataAdapter",this.dataAdapter),ge.set(t,"requestedBufferSize",this.bufferSize),ge.set(t,"requestedMaxFrequency",this.requestedMaxFrequency),ge.set(t,"trigger",this.requestedTrigger),ge.set(t,"notificationFormat",this.requestedFormat),ks.stringify(t.h)},__class__:oe};var he=l.LSSafariMpnBuilder=function(t){var e=null==t?null:JSON.parse(t);null==e&&(e={aps:{alert:{}}}),null==e.aps&&(e.aps={alert:{}}),null==e.aps.alert&&(e.aps.alert={}),this.obj=e};he.__name__="LSSafariMpnBuilder",he.prototype={build:function(){return this.removeNullFields(this.obj.aps),this.removeNullFields(this.obj.aps.alert),JSON.stringify(this.obj)},removeNullFields:function(t){for(var e=0,s=f.fields(t);e<s.length;){var i=s[e];++e,null==f.field(t,i)&&f.deleteField(t,i)}},getTitle:function(){return this.obj.aps.alert.title},setTitle:function(t){return this.obj.aps.alert.title=t,this},getBody:function(){return this.obj.aps.alert.body},setBody:function(t){return this.obj.aps.alert.body=t,this},getAction:function(){return this.obj.aps.alert.action},setAction:function(t){return this.obj.aps.alert.action=t,this},getUrlArguments:function(){var t=f.field(this.obj.aps,"url-args");return null==t?null:t.slice()},setUrlArguments:function(t){return this.obj.aps["url-args"]=null==t?null:t.slice(),this},__class__:he};var ce={fromString:function(t){switch(t){case"DISTINCT":return"DISTINCT";case"MERGE":return"MERGE";default:throw new R("The given value is not a valid subscription mode. Admitted values are MERGE, DISTINCT")}}},ue=a["com.lightstreamer.client.mpn.MpnRequestedMaxFrequency"]={__ename__:!0,__constructs__:null,FreqLimited:(e=function(t){return{_hx_index:0,max:t,__enum__:"com.lightstreamer.client.mpn.MpnRequestedMaxFrequency",toString:r}},e._hx_name="FreqLimited",e.__params__=["max"],e),FreqUnlimited:{_hx_name:"FreqUnlimited",_hx_index:1,__enum__:"com.lightstreamer.client.mpn.MpnRequestedMaxFrequency",toString:r}};ue.__constructs__=[ue.FreqLimited,ue.FreqUnlimited];var le=function(){};function _e(t){t.splice(0,t.length)}le.__name__="com.lightstreamer.client.mpn.MpnRequestedMaxFrequencyTools",le.fromString=function(t){if(null==t)return null;var e;if("unlimited"==t.toLowerCase())return ue.FreqUnlimited;if(e=parseFloat(t),!isNaN(e)&&e>0)return ue.FreqLimited(e);throw new R("The given value is not valid for this setting; use null, 'unlimited' or a positive number instead")},le.toString=function(t){if(null==t)return null;switch(t._hx_index){case 0:var e=t.max;return null==e?"null":""+e;case 1:return"unlimited"}},le.extEquals=function(t,e){return null==t?null==e:null!=e&&S.enumEq(t,e)};var de=function(t,e){this.key=t,this.value=e};de.__name__="com.lightstreamer.internal._AssocArray.AssocPair",de.prototype={__class__:de};var me={_new:function(){return Se._new()},arrayRead:function(t,e){var s=m.find(t,(function(t){return t.key==e}));return null==s?null:s.value},arrayWrite:function(t,e,s){return t.add(new de(e,s)),s},remove:function(t,e){Se.removeIf(t,(function(t){return t.key==e}))},keyValueIterator:function(t){return new Ps(t.h)},containsValue:function(t,e){return m.exists(t,(function(t){return t.value==e}))}},fe=function(){};fe.__name__="com.lightstreamer.internal.IHttpClient",fe.__isInterface__=!0,fe.prototype={__class__:fe};var pe=function(t,e,s,i,n,r,a){this.isCanceled=!1,this.reader=new Ne;var o=this;if(Li.isDebugEnabled()&&Li.debug("HTTP sending: "+t+" "+e+" headers("+(null==s?"null":ks.stringify(s.h))+")"),this.xhr=new XMLHttpRequest,this.xhr.open("POST",t),this.xhr.withCredentials=i,null!=s)for(var h=s.h,c=Object.keys(h),u=c.length,l=0;l<u;){var _=c[l++];this.xhr.setRequestHeader(_,h[_])}this.xhr.setRequestHeader("Content-Type","application/x-www-form-urlencoded"),this.xhr.send(e),this.xhr.onreadystatechange=function(){if(!o.isCanceled){var t=o.xhr.readyState;if(2==t){var e=o.xhr.status;0==e||e>=200&&e<300||(Li.isDebugEnabled()&&Li.debug("HTTP event: error(HTTP code "+e+")"),r(o,"Unexpected HTTP code: "+e),o.xhr.abort())}else if(t>2){for(var s=3==t?o.reader.extractNewData(o.xhr.responseText,!1):o.reader.extractNewData(o.xhr.responseText,!0),i=0;i<s.length;){var h=s[i];if(++i,o.isCanceled)return;""!=h&&(Li.isDebugEnabled()&&Li.debug("HTTP event: text("+h+")"),n(o,h))}4==t&&(Li.isDebugEnabled()&&Li.debug("HTTP event: complete"),a(o))}}},this.xhr.onerror=function(){o.isCanceled||(Li.isDebugEnabled()&&Li.debug("HTTP event: error(Network error)"),r(o,"Network error"))}};pe.__name__="com.lightstreamer.internal.HttpClient",pe.__interfaces__=[fe],pe.prototype={dispose:function(){Li.isDebugEnabled()&&Li.debug("HTTP disposing"),this.isCanceled=!0,this.xhr.abort()},isDisposed:function(){return this.isCanceled},__class__:pe};var ge={_new:function(){return new ks},set:function(t,e,s){null!=s&&(t.h[e]=null==s?"null":p.string(s))}},ve=function(t){var e=this;this.id=setTimeout((function(){e.run()}),t)};ve.__name__="com.lightstreamer.internal.JsTimer",ve.prototype={stop:function(){null!=this.id&&(clearTimeout(this.id),this.id=null)},run:function(){},__class__:ve};var Se={_new:function(){return new Ns},push:function(t,e){t.add(e)},exists:function(t,e){return m.exists(t,e)},find:function(t,e){return m.find(t,e)},contains:function(t,e){return m.has(t,e)},removeIf:function(t,e){for(var s=null,i=t.h;null!=i;){if(e(i.item))return null==s?t.h=i.next:s.next=i.next,t.q==i&&(t.q=s),t.length--,!0;s=i,i=i.next}return!1}},be=function(t,e,s){w.call(this,t,e,s),this.__skipStack++};be.__name__="com.lightstreamer.internal.IllegalStateException",be.__super__=w,be.prototype=c(w.prototype,{__class__:be});var Ee={fromHaxeMap:function(t){return Ee.fromMapToDynamicAccess(t)},toHaxeMap:function(t){return Ee.toHaxe(t)},fromMapToDynamicAccess:function(t){for(var e={},s=t.h,i=Object.keys(s),n=i.length,r=0;r<n;){var a=i[r++];e[a]=s[a]}return e},toHaxe:function(t){for(var e=new ks,s=f.fields(t),i=0;i<s.length;){var n=s[i++];e.h[n]=t[n]}return e},toDynamicAccess:function(t){return f.copy(t)}},ye=function(){};ye.__name__="com.lightstreamer.internal.NullTools",ye.sure=function(t){if(null==t)throw w.thrown("null pointer in .sure() call");return t},ye.or=function(t,e){return null==t?e:t};var we=function(){};we.__name__="com.lightstreamer.internal.IWsClient",we.__isInterface__=!0,we.prototype={__class__:we};var Re=function(){};Re.__name__="com.lightstreamer.internal.ITimer",Re.__isInterface__=!0,Re.prototype={__class__:Re};var Te=a["com.lightstreamer.internal.ReachabilityStatus"]={__ename__:!0,__constructs__:null,RSReachable:{_hx_name:"RSReachable",_hx_index:0,__enum__:"com.lightstreamer.internal.ReachabilityStatus",toString:r},RSNotReachable:{_hx_name:"RSNotReachable",_hx_index:1,__enum__:"com.lightstreamer.internal.ReachabilityStatus",toString:r}};Te.__constructs__=[Te.RSReachable,Te.RSNotReachable];var Ie=function(){};Ie.__name__="com.lightstreamer.internal.IReachability",Ie.__isInterface__=!0,Ie.prototype={__class__:Ie};var xe={_new:function(){return new ys},synchronized:function(t,e){var s=null,i=null;t.acquire();try{i=e()}catch(t){s=w.caught(t)}if(t.release(),null!=s)throw w.thrown(s);return i}},Ce=function(){};Ce.__name__="com.lightstreamer.internal.ReachabilityManager",Ce.__interfaces__=[Ie],Ce.prototype={startListening:function(t){E.get_supported()&&(window.ononline=function(){t(Te.RSReachable)},window.onoffline=function(){t(Te.RSNotReachable)})},stopListening:function(){E.get_supported()&&(window.ononline=null,window.onoffline=null)},__class__:Ce};var De=function(t,e){this.key=t,this.val=e};De.__name__="com.lightstreamer.internal._RequestBuilder.KeyVal",De.prototype={toEncodedPair:function(){var t=this.key,e=encodeURIComponent(t)+"=";return t=this.val,e+encodeURIComponent(t)},toString:function(){return this.key+"="+this.val},__class__:De};var Le=function(){this.params=[]};Le.__name__="com.lightstreamer.internal.RequestBuilder",Le.prototype={LS_reqId:function(t){this.addParamAny("LS_reqId",t)},LS_message:function(t){this.addParamString("LS_message",t)},LS_sequence:function(t){this.addParamString("LS_sequence",t)},LS_msg_prog:function(t){this.addParamAny("LS_msg_prog",t)},LS_max_wait:function(t){this.addParamAny("LS_max_wait",t)},LS_outcome:function(t){this.addParamBool("LS_outcome",t)},LS_ack:function(t){this.addParamBool("LS_ack",t)},LS_op:function(t){this.addParamString("LS_op",t)},LS_subId:function(t){this.addParamAny("LS_subId",t)},LS_mode:function(t){this.addParamString("LS_mode",t)},LS_group:function(t){this.addParamString("LS_group",t)},LS_schema:function(t){this.addParamString("LS_schema",t)},LS_data_adapter:function(t){this.addParamString("LS_data_adapter",t)},LS_requested_max_frequency:function(t){this.addParamString("LS_requested_max_frequency",t)},LS_requested_max_frequency_Float:function(t){this.addParamAny("LS_requested_max_frequency",t)},LS_requested_buffer_size:function(t){this.addParamString("LS_requested_buffer_size",t)},LS_requested_buffer_size_Int:function(t){this.addParamAny("LS_requested_buffer_size",t)},LS_cause:function(t){this.addParamString("LS_cause",t)},LS_keepalive_millis:function(t){this.addParamAny("LS_keepalive_millis",t)},LS_inactivity_millis:function(t){this.addParamAny("LS_inactivity_millis",t)},LS_requested_max_bandwidth:function(t){this.addParamString("LS_requested_max_bandwidth",t)},LS_requested_max_bandwidth_Float:function(t){this.addParamAny("LS_requested_max_bandwidth",t)},LS_adapter_set:function(t){this.addParamString("LS_adapter_set",t)},LS_user:function(t){this.addParamString("LS_user",t)},LS_password:function(t){this.addParamString("LS_password",t)},LS_cid:function(t){this.addParamString("LS_cid",t)},LS_old_session:function(t){this.addParamString("LS_old_session",t)},LS_session:function(t){this.addParamString("LS_session",t)},LS_send_sync:function(t){this.addParamBool("LS_send_sync",t)},LS_polling:function(t){this.addParamBool("LS_polling",t)},LS_polling_millis:function(t){this.addParamAny("LS_polling_millis",t)},LS_idle_millis:function(t){this.addParamAny("LS_idle_millis",t)},LS_content_length:function(t){this.addParamAny("LS_content_length",t)},LS_ttl_millis:function(t){this.addParamString("LS_ttl_millis",t)},LS_recovery_from:function(t){this.addParamAny("LS_recovery_from",t)},LS_close_socket:function(t){this.addParamBool("LS_close_socket",t)},LS_selector:function(t){this.addParamString("LS_selector",t)},LS_snapshot:function(t){this.addParamBool("LS_snapshot",t)},LS_snapshot_Int:function(t){this.addParamAny("LS_snapshot",t)},addParamString:function(t,e){this.params.push(new De(t,e))},addParamAny:function(t,e){this.addParamString(t,""+(null==e?"null":p.string(e)))},addParamBool:function(t,e){this.addParamString(t,e?"true":"false")},getEncodedString:function(){for(var t=this.params,e=new Array(t.length),s=0,i=t.length;s<i;){var n=s++;e[n]=t[n].toEncodedPair()}return e.join("&")},toString:function(){return this.params.join(" ")},PN_deviceId:function(t){this.addParamString("PN_deviceId",t)},PN_notificationFormat:function(t){this.addParamString("PN_notificationFormat",t)},PN_trigger:function(t){this.addParamString("PN_trigger",t)},PN_coalescing:function(t){this.addParamBool("PN_coalescing",t)},PN_subscriptionId:function(t){this.addParamString("PN_subscriptionId",t)},PN_type:function(t){this.addParamString("PN_type",t)},PN_appId:function(t){this.addParamString("PN_appId",t)},PN_deviceToken:function(t){this.addParamString("PN_deviceToken",t)},PN_newDeviceToken:function(t){this.addParamString("PN_newDeviceToken",t)},PN_subscriptionStatus:function(t){this.addParamString("PN_subscriptionStatus",t)},__class__:Le};var Me=function(t){if(this.values=[],null!=t)for(;t.hasNext();)this.insert(t.next())};Me.__name__="com.lightstreamer.internal.Set",Me.prototype={count:function(){return this.values.length},insert:function(t){-1==this.values.indexOf(t)&&this.values.push(t)},contains:function(t){return-1!=this.values.indexOf(t)},remove:function(t){_.remove(this.values,t)},removeAll:function(){this.values.splice(0,this.values.length)},copy:function(){return new Me(this.iterator())},union:function(t){for(var e=new Me,s=0,i=this.values;s<i.length;)e.insert(i[s++]);for(s=0;s<t.length;)e.insert(t[s++]);return e},subtracting:function(t){for(var e=new Me,s=0,i=this.values;s<i.length;){var n=i[s];++s,-1==t.indexOf(n)&&e.insert(n)}return e},iterator:function(){return new Bs(this.values)},toArray:function(){return this.values},__class__:Me};var Ne=function(){this.progress=0};Ne.__name__="com.lightstreamer.internal.StreamReader",Ne.prototype={extractNewData:function(t,e){var s;if(e)s=t.length;else{if((s=t.lastIndexOf("\r\n"))<0)return[];s+=2}if(s<=this.progress)return[];var i=t.substring(this.progress,s);return this.progress=s,i.split("\r\n")},streamProgress:function(t){return this.extractNewData(t,!1)},streamComplete:function(t){return this.extractNewData(t,!0)},__class__:Ne};var Oe=function(){};Oe.__name__="hx.concurrent.Service",Oe.__isInterface__=!0,Oe.prototype={__class__:Oe};var Pe=function(t){null==t&&(t=0),this.lock=new ys,this._value=t};Pe.__name__="hx.concurrent.atomic._AtomicInt.AtomicIntImpl",Pe.prototype={get_value:function(){this.lock.acquire();var t=this._value;return this.lock.release(),t},set_value:function(t){return this.lock.acquire(),this._value=t,this.lock.release(),t},getAndIncrement:function(t){null==t&&(t=1),this.lock.acquire();var e=this._value;return this._value+=t,this.lock.release(),e},incrementAndGet:function(t){null==t&&(t=1),this.lock.acquire();var e=this._value+=t;return this.lock.release(),e},__class__:Pe};var ke=function(){this._stateLock=new ys,this.state=zs.STOPPED,this.id=ke._ids.incrementAndGet()};ke.__name__="hx.concurrent.ServiceBase",ke.__interfaces__=[Oe],ke.prototype={set_state:function(t){return this.state=t},start:function(){var t=this;this._stateLock.execute((function(){switch(t.state._hx_index){case 0:case 1:break;case 2:throw w.thrown("Service ["+p.string(t)+"] is currently stopping!");case 3:t.set_state(zs.STARTING),t.onStart(),t.set_state(zs.RUNNING)}}))},onStart:function(){},stop:function(){var t=this;this._stateLock.execute((function(){t.state==zs.RUNNING&&(t.set_state(zs.STOPPING),t.onStop(),t.set_state(zs.STOPPED))}))},onStop:function(){},toString:function(){return ni.getClass(this).__name__+"#"+this.id},__class__:ke};var Fe=a["hx.concurrent.executor.Schedule"]={__ename__:!0,__constructs__:null,ONCE:(e=function(t){return{_hx_index:0,initialDelayMS:t,__enum__:"hx.concurrent.executor.Schedule",toString:r}},e._hx_name="ONCE",e.__params__=["initialDelayMS"],e),FIXED_DELAY:(e=function(t,e){return{_hx_index:1,intervalMS:t,initialDelayMS:e,__enum__:"hx.concurrent.executor.Schedule",toString:r}},e._hx_name="FIXED_DELAY",e.__params__=["intervalMS","initialDelayMS"],e),FIXED_RATE:(e=function(t,e){return{_hx_index:2,intervalMS:t,initialDelayMS:e,__enum__:"hx.concurrent.executor.Schedule",toString:r}},e._hx_name="FIXED_RATE",e.__params__=["intervalMS","initialDelayMS"],e),HOURLY:(e=function(t,e){return{_hx_index:3,minute:t,second:e,__enum__:"hx.concurrent.executor.Schedule",toString:r}},e._hx_name="HOURLY",e.__params__=["minute","second"],e),DAILY:(e=function(t,e,s){return{_hx_index:4,hour:t,minute:e,second:s,__enum__:"hx.concurrent.executor.Schedule",toString:r}},e._hx_name="DAILY",e.__params__=["hour","minute","second"],e),WEEKLY:(e=function(t,e,s,i){return{_hx_index:5,day:t,hour:e,minute:s,second:i,__enum__:"hx.concurrent.executor.Schedule",toString:r}},e._hx_name="WEEKLY",e.__params__=["day","hour","minute","second"],e)};Fe.__constructs__=[Fe.ONCE,Fe.FIXED_DELAY,Fe.FIXED_RATE,Fe.HOURLY,Fe.DAILY,Fe.WEEKLY];var qe=function(){this.completionListeners=Qs._new(),ke.call(this)};qe.__name__="hx.concurrent.executor.Executor",qe.create=function(t,e){return null==e&&(e=!0),new Ae(e)},qe.__super__=ke,qe.prototype=c(ke.prototype,{notifyResult:function(t){for(var e=this.completionListeners._items,s=0;s<e.length;){var i=e[s++];try{i(t)}catch(t){}}},onCompletion:function(t){this.completionListeners.add(t)},stop:function(){ke.prototype.stop.call(this)},__class__:qe});var Ae=function(t){null==t&&(t=!0),this._scheduledTasks=[],qe.call(this),t&&this.start()};function Be(){return qe.create()}Ae.__name__="hx.concurrent.executor.TimerExecutor",Ae.__super__=qe,Ae.prototype=c(qe.prototype,{submit:function(t,e){var s=this,i=null==e?qe.NOW_ONCE:e;return this._stateLock.execute((function(){if(s.state!=zs.RUNNING)throw w.thrown("Cannot accept new tasks. Executor is not in state [RUNNING] but ["+p.string(s.state)+"].");for(var e=s._scheduledTasks.length;e-- >0;)s._scheduledTasks[e].isStopped&&s._scheduledTasks.splice(e,1);var n=new ti(s,t,i);if(0==i._hx_index){var r=i.initialDelayMS;(null==r||0!=r)&&s._scheduledTasks.push(n)}else s._scheduledTasks.push(n);return n}))},onStop:function(){for(var t=0,e=this._scheduledTasks;t<e.length;)e[t++].cancel();this._scheduledTasks=[]},__class__:Ae});var Ue={_new:function(t){return t},toMillis:function(t){return t},toLong:function(t){return t}},We={_new:function(t){return t},now:function(){return _.now()/1e3},plus:function(t,e){return 1e3*t+e},minus:function(t,e){return 1e3*(t-e)},toFloat:function(t){return t}},He=function(t,e,s){var i=this;this.task=Di.submit(ei.a((function(){s(i)})),Fe.ONCE(e))};He.__name__="com.lightstreamer.internal.Timer",He.__interfaces__=[Re],He.stamp=function(){return _.now()/1e3},He.prototype={cancel:function(){this.task.cancel()},isCanceled:function(){return this.task.isStopped},__class__:He};var Ve=a["com.lightstreamer.internal.FieldValue"]={__ename__:!0,__constructs__:null,unchanged:{_hx_name:"unchanged",_hx_index:0,__enum__:"com.lightstreamer.internal.FieldValue",toString:r},changed:(e=function(t){return{_hx_index:1,val:t,__enum__:"com.lightstreamer.internal.FieldValue",toString:r}},e._hx_name="changed",e.__params__=["val"],e),jsonPatch:(e=function(t){return{_hx_index:2,patch:t,__enum__:"com.lightstreamer.internal.FieldValue",toString:r}},e._hx_name="jsonPatch",e.__params__=["patch"],e),diffPatch:(e=function(t){return{_hx_index:3,patch:t,__enum__:"com.lightstreamer.internal.FieldValue",toString:r}},e._hx_name="diffPatch",e.__params__=["patch"],e)};Ve.__constructs__=[Ve.unchanged,Ve.changed,Ve.jsonPatch,Ve.diffPatch];var Ke={_new:function(t){return t},fromIntGt0:function(t){if(t<=0)throw new R("value must be greater than zero");return t},fromIntGtEq0:function(t){if(t<0)throw new R("value must be greater than or equal to zero");return t},gti:function(t,e){return t>e},gt:function(t,e){return t>e},lt:function(t,e){return t<e},plus:function(t,e){return t+e},minus:function(t,e){return t-e},toInt:function(t){return t}},Ge={_new:function(t){return t},fromIntGt0:function(t){if(t<=0)throw new R("value must be greater than zero");return t}},ze={fromString:function(t){if(null==t)return null;switch(t){case"HTTP":return"HTTP";case"HTTP-POLLING":return"HTTP-POLLING";case"HTTP-STREAMING":return"HTTP-STREAMING";case"WS":return"WS";case"WS-POLLING":return"WS-POLLING";case"WS-STREAMING":return"WS-STREAMING";default:throw new R("The given value is not valid. Use one of: HTTP-STREAMING, HTTP-POLLING, WS-STREAMING, WS-POLLING, WS, HTTP or null")}}},Ye=a["com.lightstreamer.internal.RequestedMaxBandwidth"]={__ename__:!0,__constructs__:null,BWLimited:(e=function(t){return{_hx_index:0,bw:t,__enum__:"com.lightstreamer.internal.RequestedMaxBandwidth",toString:r}},e._hx_name="BWLimited",e.__params__=["bw"],e),BWUnlimited:{_hx_name:"BWUnlimited",_hx_index:1,__enum__:"com.lightstreamer.internal.RequestedMaxBandwidth",toString:r}};Ye.__constructs__=[Ye.BWLimited,Ye.BWUnlimited];var Qe=function(){};Qe.__name__="com.lightstreamer.internal.RequestedMaxBandwidthTools",Qe.fromString=function(t){var e;if("unlimited"==t.toLowerCase())return Ye.BWUnlimited;if(e=parseFloat(t),!isNaN(e)&&e>0)return Ye.BWLimited(e);throw new R('The given value is a not valid value for RequestedMaxBandwidth. Use a positive number or the string "unlimited"')},Qe.toString=function(t){switch(t._hx_index){case 0:var e=t.bw;return null==e?"null":""+e;case 1:return"unlimited"}};var je=a["com.lightstreamer.internal.RequestedBufferSize"]={__ename__:!0,__constructs__:null,BSLimited:(e=function(t){return{_hx_index:0,size:t,__enum__:"com.lightstreamer.internal.RequestedBufferSize",toString:r}},e._hx_name="BSLimited",e.__params__=["size"],e),BSUnlimited:{_hx_name:"BSUnlimited",_hx_index:1,__enum__:"com.lightstreamer.internal.RequestedBufferSize",toString:r}};je.__constructs__=[je.BSLimited,je.BSUnlimited];var Je=function(){};Je.__name__="com.lightstreamer.internal.RequestedBufferSizeTools",Je.fromString=function(t){if(null==t)return null;var e;if("unlimited"==t.toLowerCase())return je.BSUnlimited;if(null!=(e=p.parseInt(t))&&e>0)return je.BSLimited(e);throw new R("The given value is not valid for this setting; use null, 'unlimited' or a positive integer instead")},Je.toString=function(t){if(null==t)return null;switch(t._hx_index){case 0:var e=t.size;return null==e?"null":""+e;case 1:return"unlimited"}},Je.extEquals=function(t,e){return null==t?null==e:null!=e&&S.enumEq(t,e)};var Xe=a["com.lightstreamer.internal.RequestedSnapshot"]={__ename__:!0,__constructs__:null,SnpYes:{_hx_name:"SnpYes",_hx_index:0,__enum__:"com.lightstreamer.internal.RequestedSnapshot",toString:r},SnpNo:{_hx_name:"SnpNo",_hx_index:1,__enum__:"com.lightstreamer.internal.RequestedSnapshot",toString:r},SnpLength:(e=function(t){return{_hx_index:2,len:t,__enum__:"com.lightstreamer.internal.RequestedSnapshot",toString:r}},e._hx_name="SnpLength",e.__params__=["len"],e)};Xe.__constructs__=[Xe.SnpYes,Xe.SnpNo,Xe.SnpLength];var Ze=function(){};Ze.__name__="com.lightstreamer.internal.RequestedSnapshotTools",Ze.fromString=function(t){if(null==t)return null;var e;switch(t.toLowerCase()){case"no":return Xe.SnpNo;case"yes":return Xe.SnpYes;default:if(null!=(e=p.parseInt(t))&&e>0)return Xe.SnpLength(e);throw new R("The given value is not valid for this setting; use null, 'yes', 'no' or a positive number instead")}},Ze.toString=function(t){if(null==t)return null;switch(t._hx_index){case 0:return"yes";case 1:return"no";case 2:var e=t.len;return null==e?"null":""+e}};var $e=a["com.lightstreamer.internal.RequestedMaxFrequency"]={__ename__:!0,__constructs__:null,FreqLimited:(e=function(t){return{_hx_index:0,max:t,__enum__:"com.lightstreamer.internal.RequestedMaxFrequency",toString:r}},e._hx_name="FreqLimited",e.__params__=["max"],e),FreqUnlimited:{_hx_name:"FreqUnlimited",_hx_index:1,__enum__:"com.lightstreamer.internal.RequestedMaxFrequency",toString:r},FreqUnfiltered:{_hx_name:"FreqUnfiltered",_hx_index:2,__enum__:"com.lightstreamer.internal.RequestedMaxFrequency",toString:r}};$e.__constructs__=[$e.FreqLimited,$e.FreqUnlimited,$e.FreqUnfiltered];var ts=function(){};ts.__name__="com.lightstreamer.internal.RequestedMaxFrequencyTools",ts.fromString=function(t){if(null==t)return null;var e;switch(t.toLowerCase()){case"unfiltered":return $e.FreqUnfiltered;case"unlimited":return $e.FreqUnlimited;default:if(e=parseFloat(t),!isNaN(e)&&e>0)return $e.FreqLimited(e);throw new R("The given value is not valid for this setting; use null, 'unlimited', 'unfiltered' or a positive number instead")}},ts.toString=function(t){if(null==t)return null;switch(t._hx_index){case 0:var e=t.max;return null==e?"null":""+e;case 1:return"unlimited";case 2:return"unfiltered"}},ts.extEquals=function(t,e){return null==t?null==e:null!=e&&S.enumEq(t,e)};var es=a["com.lightstreamer.internal.RealMaxFrequency"]={__ename__:!0,__constructs__:null,RFreqLimited:(e=function(t){return{_hx_index:0,freq:t,__enum__:"com.lightstreamer.internal.RealMaxFrequency",toString:r}},e._hx_name="RFreqLimited",e.__params__=["freq"],e),RFreqUnlimited:{_hx_name:"RFreqUnlimited",_hx_index:1,__enum__:"com.lightstreamer.internal.RealMaxFrequency",toString:r}};es.__constructs__=[es.RFreqLimited,es.RFreqUnlimited];var ss=a["com.lightstreamer.internal.RealMaxBandwidth"]={__ename__:!0,__constructs__:null,BWLimited:(e=function(t){return{_hx_index:0,bw:t,__enum__:"com.lightstreamer.internal.RealMaxBandwidth",toString:r}},e._hx_name="BWLimited",e.__params__=["bw"],e),BWUnlimited:{_hx_name:"BWUnlimited",_hx_index:1,__enum__:"com.lightstreamer.internal.RealMaxBandwidth",toString:r},BWUnmanaged:{_hx_name:"BWUnmanaged",_hx_index:2,__enum__:"com.lightstreamer.internal.RealMaxBandwidth",toString:r}};ss.__constructs__=[ss.BWLimited,ss.BWUnlimited,ss.BWUnmanaged];var is=function(){};is.__name__="com.lightstreamer.internal.RealMaxBandwidthTools",is.toString=function(t){if(null==t)return null;switch(t._hx_index){case 0:var e=t.bw;return null==e?"null":""+e;case 1:return"unlimited";case 2:return"unmanaged"}};var ns={fromString:function(t){switch(t){case"COMMAND":return"COMMAND";case"DISTINCT":return"DISTINCT";case"MERGE":return"MERGE";case"RAW":return"RAW";default:throw new R("The given value is not a valid subscription mode. Admitted values are MERGE, DISTINCT, RAW, COMMAND")}}},rs={_new:function(t){return t},getPos:function(t,e){var s=t.indexOf(e);return-1!=s?s+1:-1},allValidNames:function(t){return!m.exists(t,(function(t){return new u("^$| |^\\d+$","").match(t)}))},fromArray:function(t){if(null==t)return null;if(0==t.length)throw new R("Item List is empty");if(rs.allValidNames(t))return t;throw new R("Item List is invalid")}},as={_new:function(t){return t},getPos:function(t,e){var s=t.indexOf(e);return-1!=s?s+1:-1},hasKeyField:function(t){return-1!=t.indexOf("key")},hasCommandField:function(t){return-1!=t.indexOf("command")},fromArray:function(t){if(null==t)return null;if(0==t.length)throw new R("Field List is empty");if(m.exists(t,(function(t){return new u("^$| ","").match(t)})))throw new R("Field List is invalid");return t}},os={};function hs(t){if(null==t)return"null";switch(t._hx_index){case 0:return""+t.freq;case 1:return"unlimited"}}function cs(t,e){return null==t?null==e:null!=e&&S.enumEq(t,e)}os._new=function(t){return t},os.fromString=function(t){if(null==t)return null;if(""==t)throw new R("The value is empty");return t};var us=function(t,e){var s=t.indexOf("://");-1!=s?(this._protocol=t.substring(0,s)+":",t=t.substring(s+3)):this._protocol="";var i=t.indexOf("/");-1!=i?(this._pathname=t.substring(i),t=t.substring(0,i)):this._pathname="/";var n=this.extractPortStart(t);-1!=n?(this._port=t.substring(n),this._hostname=t.substring(0,n-1)):(this._port="",this._hostname=t),null!=e&&this.set_pathname(e)};us.__name__="com.lightstreamer.internal.Url",us.build=function(t,e){if(null!=e){var s=v.endsWith(t,"/"),i=v.startsWith(e,"/");t+=s?i?e.substring(1):e:i?e:"/"+e}return t},us.completeControlLink=function(t,e){var s=new us(e),i=new us(t);return""==i.get_protocol()&&i.set_protocol(s.get_protocol()),""==i.get_port()&&i.set_port(s.get_port()),i.get_href()},us.prototype={get_protocol:function(){return this._protocol},set_protocol:function(t){return""==t||v.endsWith(t,":")||(t+=":"),this._protocol=t,this._protocol},get_hostname:function(){return this._hostname},set_hostname:function(t){return this._hostname=t,this._hostname},get_port:function(){return this._port},set_port:function(t){return this._port=t,this._port},get_pathname:function(){return this._pathname},set_pathname:function(t){return v.startsWith(t,"/")||(t="/"+t),this._pathname=t,this._pathname},get_href:function(){var t=this._hostname;return""!=this._protocol&&(t=this._protocol+"//"+t),""!=this._port&&(t+=":"+this._port),""!=this.get_pathname()&&(t+=this._pathname),t},toString:function(){return this.get_href()},extractPortStart:function(t){var e=t.indexOf(":");return e<=-1?-1:t.indexOf("]")>-1?(e=t.indexOf("]:"))<=-1?-1:e+2:e!=t.lastIndexOf(":")?-1:e+1},__class__:us};var ls=function(t,e,s,i){this.isCanceled=!1;var n=this;v.startsWith(t,"https://")?t=v.replace(t,"https://","wss://"):v.startsWith(t,"http://")&&(t=v.replace(t,"http://","ws://")),Li.isDebugEnabled()&&Li.debug("WS connecting: "+t),this.ws=new WebSocket(t,gi),this.ws.onopen=function(){n.isCanceled||(Li.isDebugEnabled()&&Li.debug("WS event: open"),e(n))},this.ws.onmessage=function(t){if(!n.isCanceled)for(var e=0,i=t.data.split("\r\n");e<i.length;){var r=i[e];if(++e,n.isCanceled)return;""!=r&&(Li.isDebugEnabled()&&Li.debug("WS event: text("+r+")"),s(n,r))}},this.ws.onerror=function(){n.isCanceled||(Li.isDebugEnabled()&&Li.debug("WS event: error(Network error)"),i(n,"Network error"),n.ws.close())},this.ws.onclose=function(t){if(!n.isCanceled){var e="unexpected disconnection: "+t.code+" - "+t.reason;Li.isDebugEnabled()&&Li.debug("WS event: error("+e+")"),i(n,e),n.ws.close()}}};ls.__name__="com.lightstreamer.internal.WsClient",ls.__interfaces__=[we],ls.prototype={send:function(t){Li.isDebugEnabled()&&Li.debug("WS sending: "+t),this.ws.send(t)},dispose:function(){Li.isDebugEnabled()&&Li.debug("WS disposing"),this.isCanceled=!0,this.ws.close()},isDisposed:function(){return this.isCanceled},__class__:ls};var _s=function(t,e){this.buf=new g,this.basePos=0,this.diffPos=0,this.diff=e,this.base=t};_s.__name__="com.lightstreamer.internal.patch.DiffDecoder",_s.apply=function(t,e){return new _s(t,e).decode()},_s.prototype={decode:function(){try{for(;this.diffPos!=this.diff.length&&(this.applyCopy(),this.diffPos!=this.diff.length)&&(this.applyAdd(),this.diffPos!=this.diff.length);)this.applyDel();return this.buf.b}catch(t){throw new w("Bad TLCP-diff",w.caught(t))}},applyCopy:function(){var t=this.decodeVarint();t>0&&(this.appendToBuf(this.base,this.basePos,t),this.basePos+=t)},applyAdd:function(){var t=this.decodeVarint();t>0&&(this.appendToBuf(this.diff,this.diffPos,t),this.diffPos+=t)},applyDel:function(){var t=this.decodeVarint();t>0&&(this.basePos+=t)},decodeVarint:function(){for(var t=0;;){var e=this.charAt(this.diff,this.diffPos);if(this.diffPos+=1,e>=97&&e<123)return 26*t+(e-97);if(!(e>=65&&e<91))throw new w("The code point "+e+" is not in the range A-Z");t=26*t+(e-65)}},appendToBuf:function(t,e,s){if(!(e+s<=t.length))throw new w("Index out of range: startIndex="+e+" count="+s+" length="+t.length);this.buf.b+=null==s?_.substr(t,e,null):_.substr(t,e,s)},charAt:function(t,e){if(e<t.length)return _.cca(t.charAt(e),0);throw new w("Index out of range: pos="+e+" length="+t.length)},__class__:_s};var ds={_new:function(t){return JSON.parse(t)},apply:function(t,e){return ms.apply_patch(t,e)},toString:function(t){return JSON.stringify(t)}},ms=s.exports,fs=function(){};fs.__name__="com.lightstreamer.log.AbstractLogger",fs.__interfaces__=[i],fs.prototype={__class__:fs};var ps=l.LSConsoleLogLevel=function(){};ps.__name__="LSConsoleLogLevel",ps.prototype={__class__:ps};var gs=l.LSConsoleLoggerProvider=function(t){this.level=t};gs.__name__="LSConsoleLoggerProvider",gs.__interfaces__=[n],gs.prototype={getLogger:function(t){return new vs(this.level,t)},__class__:gs};var vs=function(t,e){this.level=t,this.category=e,this.traceEnabled=t<=ps.TRACE,this.debugEnabled=t<=ps.DEBUG,this.infoEnabled=t<=ps.INFO,this.warnEnabled=t<=ps.WARN,this.errorEnabled=t<=ps.ERROR,this.fatalEnabled=t<=ps.FATAL};vs.__name__="com.lightstreamer.log._ConsoleLoggerProvider.ConsoleLogger",vs.__super__=fs,vs.prototype=c(fs.prototype,{printLog:function(e){t.console.log(e)},format:function(t,e){return _.dateStr(new Date)+"|"+t+"|"+this.category+"|"+e},logFatal:function(e){t.console.log(e)},logError:function(e){t.console.log(e)},logWarn:function(e){t.console.log(e)},logInfo:function(e){t.console.log(e)},logDebug:function(e){t.console.log(e)},logTrace:function(e){t.console.log(e)},fatal:function(e,s){if(this.fatalEnabled){var i=this.format("FATAL",e);t.console.log(i),null!=s&&(i=w.caught(s).details(),t.console.log(i))}},error:function(e,s){if(this.errorEnabled){var i=this.format("ERROR",e);t.console.log(i),null!=s&&(i=w.caught(s).details(),t.console.log(i))}},warn:function(e,s){if(this.warnEnabled){var i=this.format("WARN ",e);t.console.log(i),null!=s&&(i=w.caught(s).details(),t.console.log(i))}},info:function(e,s){if(this.infoEnabled){var i=this.format("INFO ",e);t.console.log(i),null!=s&&(i=w.caught(s).details(),t.console.log(i))}},debug:function(e,s){if(this.debugEnabled){var i=this.format("DEBUG",e);t.console.log(i),null!=s&&(i=w.caught(s).details(),t.console.log(i))}},trace:function(e,s){if(this.traceEnabled){var i=this.format("TRACE",e);t.console.log(i),null!=s&&(i=w.caught(s).details(),t.console.log(i))}},isFatalEnabled:function(){return this.fatalEnabled},isErrorEnabled:function(){return this.errorEnabled},isWarnEnabled:function(){return this.warnEnabled},isInfoEnabled:function(){return this.infoEnabled},isDebugEnabled:function(){return this.debugEnabled},isTraceEnabled:function(){return this.traceEnabled},__class__:vs});var Ss=function(){};Ss.__name__="com.lightstreamer.log._LogManager.EmptyLogger",Ss.__super__=fs,Ss.prototype=c(fs.prototype,{fatal:function(t,e){},error:function(t,e){},warn:function(t,e){},info:function(t,e){},debug:function(t,e){},trace:function(t,e){},isFatalEnabled:function(){return!1},isErrorEnabled:function(){return!1},isWarnEnabled:function(){return!1},isInfoEnabled:function(){return!1},isDebugEnabled:function(){return!1},isTraceEnabled:function(){return!1},__class__:Ss});var bs=function(){};bs.__name__="hx.concurrent.lock.Acquirable",bs.__isInterface__=!0,bs.prototype={__class__:bs};var Es=function(){};Es.__name__="hx.concurrent.lock.AbstractAcquirable",Es.__interfaces__=[bs],Es.prototype={execute:function(t,e){null==e&&(e=!1);var s=null,i=null;this.acquire();try{i=t()}catch(t){s=new Ws(w.caught(t))}if(this.release(),!e&&null!=s)throw w.thrown(s.toString());return i},__class__:Es};var ys=function(){this._holderEntranceCount=0,this._holder=null};ys.__name__="hx.concurrent.lock.RLock",ys.__super__=Es,ys.prototype=c(Es.prototype,{get_availablePermits:function(){return null!=this._holder?0:1},get_isAcquiredByAnyThread:function(){return null!=this._holder},get_isAcquiredByCurrentThread:function(){return this._holder==ii.get_current()},get_isAcquiredByOtherThread:function(){return null!=this._holder&&this._holder!=ii.get_current()},acquire:function(){this._holder=ii.get_current(),this._holderEntranceCount++},tryAcquire:function(t){if(null==t&&(t=0),t<0)throw w.thrown("[timeoutMS] must be >= 0");return(null==this._holder||this._holder==ii.get_current())&&(this._holder=ii.get_current(),this._holderEntranceCount++,!0)},tryAcquireInternal:function(t){return null==this._holder||this._holder==ii.get_current()},release:function(){if(this._holder!=ii.get_current())throw null!=this._holder&&this._holder!=ii.get_current()?w.thrown("Lock was aquired by another thread!"):w.thrown("Lock was not aquired by any thread!");this._holderEntranceCount--,0==this._holderEntranceCount&&(this._holder=null)},__class__:ys});var ws=function(){};ws.__name__="com.lightstreamer.log.LogManager",ws.getLogger=function(t){return xe.synchronized(ws.lock,(function(){var e=ws.logInstances.h[t];if(null==e){var s=new Rs(null==ws.currentLoggerProvider?ws.emptyLogger:ws.currentLoggerProvider.getLogger(t));ws.logInstances.h[t]=s,e=s}return e}))},ws.setLoggerProvider=function(t){xe.synchronized(ws.lock,(function(){ws.currentLoggerProvider=t;for(var e=ws.logInstances.h,s=Object.keys(e),i=s.length,n=0;n<i;){var r=s[n++];e[r].wrappedLogger=null==ws.currentLoggerProvider?ws.emptyLogger:ws.currentLoggerProvider.getLogger(r)}}))},ws.newLogger=function(t){return null==ws.currentLoggerProvider?ws.emptyLogger:ws.currentLoggerProvider.getLogger(t)};var Rs=function(t){this.wrappedLogger=t};Rs.__name__="com.lightstreamer.log._LogManager.LoggerProxy",Rs.__super__=fs,Rs.prototype=c(fs.prototype,{fatal:function(t,e){this.wrappedLogger.fatal(t,e)},error:function(t,e){this.wrappedLogger.error(t,e)},warn:function(t,e){this.wrappedLogger.warn(t,e)},info:function(t,e){this.wrappedLogger.info(t,e)},debug:function(t,e){this.wrappedLogger.debug(t,e)},trace:function(t,e){this.wrappedLogger.trace(t,e)},isFatalEnabled:function(){return this.wrappedLogger.isFatalEnabled()},isErrorEnabled:function(){return this.wrappedLogger.isErrorEnabled()},isWarnEnabled:function(){return this.wrappedLogger.isWarnEnabled()},isInfoEnabled:function(){return this.wrappedLogger.isInfoEnabled()},isDebugEnabled:function(){return this.wrappedLogger.isDebugEnabled()},isTraceEnabled:function(){return this.wrappedLogger.isTraceEnabled()},__class__:Rs});var Ts=a["haxe.StackItem"]={__ename__:!0,__constructs__:null,CFunction:{_hx_name:"CFunction",_hx_index:0,__enum__:"haxe.StackItem",toString:r},Module:(e=function(t){return{_hx_index:1,m:t,__enum__:"haxe.StackItem",toString:r}},e._hx_name="Module",e.__params__=["m"],e),FilePos:(e=function(t,e,s,i){return{_hx_index:2,s:t,file:e,line:s,column:i,__enum__:"haxe.StackItem",toString:r}},e._hx_name="FilePos",e.__params__=["s","file","line","column"],e),Method:(e=function(t,e){return{_hx_index:3,classname:t,method:e,__enum__:"haxe.StackItem",toString:r}},e._hx_name="Method",e.__params__=["classname","method"],e),LocalFunction:(e=function(t){return{_hx_index:4,v:t,__enum__:"haxe.StackItem",toString:r}},e._hx_name="LocalFunction",e.__params__=["v"],e)};Ts.__constructs__=[Ts.CFunction,Ts.Module,Ts.FilePos,Ts.Method,Ts.LocalFunction];var Is={callStack:function(){return Cs.toHaxe(Cs.callStack())},exceptionStack:function(t){null==t&&(t=!1);var e=Cs.toHaxe(Cs.exceptionStack());return t?e:Is.subtract(e,Is.callStack())},toString:function(t){for(var e=new g,s=0,i=t;s<i.length;){var n=i[s++];e.b+="\nCalled from ",Is.itemToString(e,n)}return e.b},subtract:function(t,e){for(var s=-1,i=-1;++i<t.length;){for(var n=0,r=e.length;n<r;)if(Is.equalItems(t[i],e[n++])){if(s<0&&(s=i),++i>=t.length)break}else s=-1;if(s>=0)break}return s>=0?t.slice(0,s):t},equalItems:function(t,e){if(null==t)return null==e;switch(t._hx_index){case 0:return null!=e&&0==e._hx_index;case 1:return null!=e&&1==e._hx_index&&t.m==e.m;case 2:return null!=e&&2==e._hx_index&&t.file==e.file&&t.line==e.line&&t.column==e.column&&Is.equalItems(t.s,e.s);case 3:return null!=e&&3==e._hx_index&&t.classname==e.classname&&t.method==e.method;case 4:return null!=e&&4==e._hx_index&&t.v==e.v}},itemToString:function(t,e){switch(e._hx_index){case 0:t.b+="a C function";break;case 1:var s=e.m;t.b=(t.b+="module ")+(null==s?"null":""+s);break;case 2:s=e.s;var i=e.file,n=e.line,r=e.column;null!=s&&(Is.itemToString(t,s),t.b+=" ("),t.b=(t.b+=null==i?"null":""+i)+" line ",t.b+=null==n?"null":""+n,null!=r&&(t.b=(t.b+=" column ")+(null==r?"null":""+r)),null!=s&&(t.b+=")");break;case 3:s=e.classname,i=e.method,t.b=(t.b+=p.string(null==s?"<unknown>":s))+".",t.b+=null==i?"null":""+i;break;case 4:s=e.v,t.b=(t.b+="local function #")+(null==s?"null":""+s)}}},xs=function(){};xs.__name__="haxe.IMap",xs.__isInterface__=!0,xs.prototype={__class__:xs};var Cs=function(){};Cs.__name__="haxe.NativeStackTrace",Cs.saveStack=function(t){Cs.lastError=t},Cs.callStack=function(){var t=new Error(""),e=Cs.tryHaxeStack(t);if(void 0===e){try{throw t}catch(t){}e=t.stack}return Cs.normalize(e,2)},Cs.exceptionStack=function(){return Cs.normalize(Cs.tryHaxeStack(Cs.lastError))},Cs.toHaxe=function(t,e){if(null==e&&(e=0),null==t)return[];if("string"==typeof t){var s=t.split("\n");"Error"==s[0]&&s.shift();for(var i=[],n=0,r=s.length;n<r;){var a=n++;if(!(e>a)){var o=s[a],h=o.match(/^    at ([$A-Za-z0-9_. ]+) \(([^)]+):([0-9]+):([0-9]+)\)$/);if(null!=h){var c=h[1].split(".");"$hxClasses"==c[0]&&c.shift();var u=c.pop(),l=h[2],_=p.parseInt(h[3]),d=p.parseInt(h[4]);i.push(Ts.FilePos("Anonymous function"==u?Ts.LocalFunction():"Global code"==u?null:Ts.Method(c.join("."),u),l,_,d))}else i.push(Ts.Module(v.trim(o)))}}return i}return e>0&&Array.isArray(t)?t.slice(e):t},Cs.tryHaxeStack=function(t){if(null==t)return[];var e=Error.prepareStackTrace;Error.prepareStackTrace=Cs.prepareHxStackTrace;var s=t.stack;return Error.prepareStackTrace=e,s},Cs.prepareHxStackTrace=function(t,e){for(var s=[],i=0;i<e.length;){var n=e[i];++i,null!=Cs.wrapCallSite&&(n=Cs.wrapCallSite(n));var r=null,a=n.getFunctionName();if(null!=a){var o=a.lastIndexOf(".");r=o>=0?Ts.Method(a.substring(0,o),a.substring(o+1)):Ts.Method(null,a)}var h=n.getFileName(),c=null==h?-1:h.indexOf("file:");null!=Cs.wrapCallSite&&c>0&&(h=h.substring(c+6)),s.push(Ts.FilePos(r,h,n.getLineNumber(),n.getColumnNumber()))}return s},Cs.normalize=function(t,e){if(null==e&&(e=0),Array.isArray(t)&&e>0)return t.slice(e);if("string"==typeof t){switch(t.substring(0,6)){case"Error\n":case"Error:":++e}return Cs.skipLines(t,e)}return t},Cs.skipLines=function(t,e,s){for(null==s&&(s=0);;){if(!(e>0))return t.substring(s);if((s=t.indexOf("\n",s))<0)return"";e=--e,s+=1}};var Ds=function(t){var e=this;this.id=setInterval((function(){e.run()}),t)};Ds.__name__="haxe.Timer",Ds.delay=function(t,e){var s=new ve(e);return s.run=t,s},Ds.prototype={stop:function(){null!=this.id&&(clearInterval(this.id),this.id=null)},run:function(){},__class__:Ds};var Ls=function(t,e,s){w.call(this,String(t),e,s),this.value=t,this.__skipStack++};Ls.__name__="haxe.ValueException",Ls.__super__=w,Ls.prototype=c(w.prototype,{__class__:Ls});var Ms=function(){this.h={}};Ms.__name__="haxe.ds.IntMap",Ms.__interfaces__=[xs],Ms.prototype={get:function(t){return this.h[t]},remove:function(t){return!!this.h.hasOwnProperty(t)&&(delete this.h[t],!0)},keys:function(){var t=[];for(var e in this.h)this.h.hasOwnProperty(e)&&t.push(+e);return new Bs(t)},iterator:function(){return{ref:this.h,it:this.keys(),hasNext:function(){return this.it.hasNext()},next:function(){var t=this.it.next();return this.ref[t]}}},copy:function(){for(var t=new Ms,e=this.keys();e.hasNext();){var s=e.next();t.h[s]=this.h[s]}return t},__class__:Ms};var Ns=function(){this.length=0};Ns.__name__="haxe.ds.List",Ns.prototype={add:function(t){var e=new Os(t,null);null==this.h?this.h=e:this.q.next=e,this.q=e,this.length++},remove:function(t){for(var e=null,s=this.h;null!=s;){if(s.item==t)return null==e?this.h=s.next:e.next=s.next,this.q==s&&(this.q=e),this.length--,!0;e=s,s=s.next}return!1},iterator:function(){return new Ps(this.h)},filter:function(t){for(var e=new Ns,s=this.h;null!=s;){var i=s.item;s=s.next,t(i)&&e.add(i)}return e},map:function(t){for(var e=new Ns,s=this.h;null!=s;){var i=s.item;s=s.next,e.add(t(i))}return e},__class__:Ns};var Os=function(t,e){this.item=t,this.next=e};Os.__name__="haxe.ds._List.ListNode",Os.prototype={__class__:Os};var Ps=function(t){this.head=t};Ps.__name__="haxe.ds._List.ListIterator",Ps.prototype={hasNext:function(){return null!=this.head},next:function(){var t=this.head.item;return this.head=this.head.next,t},__class__:Ps};var ks=function(){this.h=Object.create(null)};ks.__name__="haxe.ds.StringMap",ks.__interfaces__=[xs],ks.createCopy=function(t){var e=new ks;for(var s in t)e.h[s]=t[s];return e},ks.stringify=function(t){var e="{",s=!0;for(var i in t)s?s=!1:e+=",",e+=i+" => "+p.string(t[i]);return e+"}"},ks.prototype={get:function(t){return this.h[t]},keys:function(){return new Fs(this.h)},iterator:function(){return new qs(this.h)},__class__:ks};var Fs=function(t){this.h=t,this.keys=Object.keys(t),this.length=this.keys.length,this.current=0};Fs.__name__="haxe.ds._StringMap.StringMapKeyIterator",Fs.prototype={hasNext:function(){return this.current<this.length},next:function(){return this.keys[this.current++]},__class__:Fs};var qs=function(t){this.h=t,this.keys=Object.keys(t),this.length=this.keys.length,this.current=0};qs.__name__="haxe.ds._StringMap.StringMapValueIterator",qs.prototype={hasNext:function(){return this.current<this.length},next:function(){return this.h[this.keys[this.current++]]},__class__:qs};var As=a["haxe.io.Error"]={__ename__:!0,__constructs__:null,Blocked:{_hx_name:"Blocked",_hx_index:0,__enum__:"haxe.io.Error",toString:r},Overflow:{_hx_name:"Overflow",_hx_index:1,__enum__:"haxe.io.Error",toString:r},OutsideBounds:{_hx_name:"OutsideBounds",_hx_index:2,__enum__:"haxe.io.Error",toString:r},Custom:(e=function(t){return{_hx_index:3,e:t,__enum__:"haxe.io.Error",toString:r}},e._hx_name="Custom",e.__params__=["e"],e)};As.__constructs__=[As.Blocked,As.Overflow,As.OutsideBounds,As.Custom];var Bs=function(t){this.current=0,this.array=t};Bs.__name__="haxe.iterators.ArrayIterator",Bs.prototype={hasNext:function(){return this.current<this.array.length},next:function(){return this.array[this.current++]},__class__:Bs};var Us=function(t,e,s){w.call(this,t,s),this.pos=e,this.__skipStack++};Us.__name__="haxe.macro.Error",Us.__super__=w,Us.prototype=c(w.prototype,{__class__:Us});var Ws=function(t){this.cause=t,this.causeStackTrace=Is.exceptionStack()};Ws.__name__="hx.concurrent.ConcurrentException",Ws.capture=function(t){return new Ws(t)},Ws.prototype={rethrow:function(){throw w.thrown(this.toString())},toString:function(){var t="";t="rethrown exception:\n",t="rethrown exception:\n  ",t+="--------------------\n",t+="  ",t+="| Exception : ",t+=p.string(this.cause),t+="\n";for(var e=0,s=Is.toString(this.causeStackTrace).split("\n");e<s.length;){var i=s[e];++e,""!=i&&(t+="  ",t+=p.string(v.replace(i,"Called from","| at")),t+="\n")}return t+="  ",t+="--------------------"},__class__:Ws};var Hs=function(){};Hs.__name__="hx.concurrent.Future",Hs.__isInterface__=!0,Hs.prototype={__class__:Hs};var Vs=a["hx.concurrent.FutureResult"]={__ename__:!0,__constructs__:null,VALUE:(e=function(t,e,s){return{_hx_index:0,result:t,time:e,future:s,__enum__:"hx.concurrent.FutureResult",toString:r}},e._hx_name="VALUE",e.__params__=["result","time","future"],e),FAILURE:(e=function(t,e,s){return{_hx_index:1,ex:t,time:e,future:s,__enum__:"hx.concurrent.FutureResult",toString:r}},e._hx_name="FAILURE",e.__params__=["ex","time","future"],e),PENDING:(e=function(t){return{_hx_index:2,future:t,__enum__:"hx.concurrent.FutureResult",toString:r}},e._hx_name="PENDING",e.__params__=["future"],e)};Vs.__constructs__=[Vs.VALUE,Vs.FAILURE,Vs.PENDING];var Ks=function(){this.sync=new ys,this.completionListeners=[],this.result=Vs.PENDING(this)};Ks.__name__="hx.concurrent.AbstractFuture",Ks.__interfaces__=[Hs],Ks.prototype={isComplete:function(){return 2!=this.result._hx_index},onCompletion:function(t){var e=this;this.sync.execute((function(){return 2!=e.result._hx_index&&t(e.result),e.completionListeners.push(t)}))},__class__:Ks};var Gs=function(){Ks.call(this)};Gs.__name__="hx.concurrent.CompletableFuture",Gs.__super__=Ks,Gs.prototype=c(Ks.prototype,{complete:function(t,e){null==e&&(e=!1);var s=this;return this.sync.execute((function(){if(e||!s.isComplete()){switch((i=t)._hx_index){case 0:s.result=Vs.VALUE(i.v,Date.now(),s);break;case 1:s.result=Vs.FAILURE(i.v,Date.now(),s)}for(var i=0,n=s.completionListeners;i<n.length;){var r=n[i++];try{r(s.result)}catch(t){}}return!0}return!1}))},__class__:Gs});var zs=a["hx.concurrent.ServiceState"]={__ename__:!0,__constructs__:null,STARTING:{_hx_name:"STARTING",_hx_index:0,__enum__:"hx.concurrent.ServiceState",toString:r},RUNNING:{_hx_name:"RUNNING",_hx_index:1,__enum__:"hx.concurrent.ServiceState",toString:r},STOPPING:{_hx_name:"STOPPING",_hx_index:2,__enum__:"hx.concurrent.ServiceState",toString:r},STOPPED:{_hx_name:"STOPPED",_hx_index:3,__enum__:"hx.concurrent.ServiceState",toString:r}};zs.__constructs__=[zs.STARTING,zs.RUNNING,zs.STOPPING,zs.STOPPED];var Ys=function(){};Ys.__name__="hx.concurrent.collection.Collection",Ys.__isInterface__=!0,Ys.prototype={__class__:Ys};var Qs={_new:function(t){var e=new Js;return null!=t&&e.addAll(t),e},_get:function(t,e){return t.get(e)},_set:function(t,e,s){return t._set(e,s),s}},js=function(){};js.__name__="hx.concurrent.collection.OrderedCollection",js.__isInterface__=!0,js.__interfaces__=[Ys],js.prototype={__class__:js};var Js=function(){this._sync=new ys,this._items=[]};Js.__name__="hx.concurrent.collection._CopyOnWriteArray.CopyOnWriteArrayImpl",Js.__interfaces__=[js],Js.prototype={_set:function(t,e){var s=this;this._sync.execute((function(){var i=s._items.slice();i[t]=e,s._items=i}))},get_first:function(){var t=this._items;return 0==t.length?null:t[0]},get_last:function(){var t=this._items;return 0==t.length?null:t[t.length-1]},get_length:function(){return this._items.length},add:function(t){var e=this;this._sync.execute((function(){var s=e._items.slice();s.push(t),e._items=s}))},addIfAbsent:function(t){var e=this;return this._sync.execute((function(){if(e._items.indexOf(t)>-1)return!1;var s=e._items.slice();return s.push(t),e._items=s,!0}))},addAll:function(t){var e=this;this._sync.execute((function(){var s=null,i=t;switch(i._hx_index){case 0:s=e._items.slice();for(var n=i.v.iterator();n.hasNext();)s.push(n.next());break;case 1:s=e._items.concat(i.v);break;case 2:s=e._items.slice();for(var r=i.v.h;null!=r;){var a=r.item;r=r.next,s.push(a)}}e._items=s}))},clear:function(){this._items=[]},insertAt:function(t,e){var s=this;this._items=this._sync.execute((function(){var i=s._items.slice();return i.splice(t,0,e),i}))},remove:function(t){var e=this;return this._sync.execute((function(){if(-1==e._items.indexOf(t))return!1;var s=e._items.slice(),i=_.remove(s,t);return e._items=s,i}))},removeAt:function(t,e){null==e&&(e=!1);var s=this;return this._sync.execute((function(){if(t<0||t>=s._items.length){if(e)throw w.thrown("Index out of range.");return null}var i=s._items.slice(),n=i.splice(t,1);return s._items=i,0==n.length?null:n[0]}))},removeFirst:function(t){null==t&&(t=!1);var e=this;return this._sync.execute((function(){if(0==e._items.length){if(t)throw w.thrown("This collection is empty.");return null}var s=e._items.slice(),i=s.shift();return e._items=s,i}))},removeLast:function(t){null==t&&(t=!1);var e=this;return this._sync.execute((function(){if(0==e._items.length){if(t)throw w.thrown("This collection is empty.");return null}var s=e._items.slice(),i=s.pop();return e._items=s,i}))},copy:function(){return Qs._new(si.b(this._items.slice()))},contains:function(t){return this._items.indexOf(t,0)>-1},isEmpty:function(){return 0==this._items.length},get:function(t,e){null==e&&(e=!1);var s=this._items;if(t<0||t>=s.length){if(e)throw w.thrown("Index out of range.");return null}return s[t]},indexOf:function(t,e){return null==e&&(e=0),this._items.indexOf(t,e)},lastIndexOf:function(t,e){var s=this._items;return s.lastIndexOf(t,null==e?s.length-1:e)},filter:function(t){for(var e=this._items,s=[],i=0;i<e.length;){var n=e[i];++i,t(n)&&s.push(n)}return Qs._new(si.b(s))},map:function(t){for(var e=this._items,s=new Array(e.length),i=0,n=e.length;i<n;){var r=i++;s[r]=t(e[r])}return Qs._new(si.b(s))},join:function(t){return this._items.join(t)},iterator:function(){return new Bs(this._items)},toArray:function(){return this._items.slice()},toString:function(){return"["+this._items.toString()+"]"},__class__:Js};var Xs=function(){};Xs.__name__="hx.concurrent.executor.TaskFuture",Xs.__isInterface__=!0,Xs.__interfaces__=[Hs],Xs.prototype={__class__:Xs};var Zs=function(t,e,s){this.isStopped=!1,Gs.call(this),this._executor=t,this._task=e,this.schedule=$s.assertValid(s)};Zs.__name__="hx.concurrent.executor.AbstractTaskFuture",Zs.__interfaces__=[Xs],Zs.__super__=Gs,Zs.prototype=c(Gs.prototype,{cancel:function(){this.isStopped=!0},__class__:Zs});var $s=function(){};$s.__name__="hx.concurrent.executor.ScheduleTools",$s.applyDefaults=function(t){switch(t._hx_index){case 0:if(null==t.initialDelayMS)return Fe.ONCE(0);break;case 1:if(null==t.initialDelayMS)return Fe.FIXED_DELAY(t.intervalMS,0);break;case 2:if(null==t.initialDelayMS)return Fe.FIXED_RATE(t.intervalMS,0);break;case 3:var e=t.minute,s=t.second;if(null==e||null==s)return Fe.HOURLY(null==e?0:e,null==s?0:s);break;case 4:e=t.hour,s=t.minute;var i=t.second;if(null==e||null==s||null==i)return Fe.DAILY(null==e?0:e,null==s?0:s,null==i?0:i);break;case 5:e=t.day,s=t.hour,i=t.minute;var n=t.second;if(null==e||null==s||null==i||null==n)return Fe.WEEKLY(null==e?0:e,null==s?0:s,null==i?0:i,null==n?0:n)}return t},$s.assertValid=function(t){switch((t=$s.applyDefaults(t))._hx_index){case 0:if(t.initialDelayMS<0)throw w.thrown("[Schedule.ONCE.initialDelayMS] must be >= 0");break;case 1:var e=t.initialDelayMS;if(t.intervalMS<=0)throw w.thrown("[Schedule.FIXED_DELAY.intervalMS] must be > 0");if(null==e||e<0)throw w.thrown("[Schedule.FIXED_DELAY.initialDelayMS] must be >= 0");break;case 2:if(t.intervalMS<=0)throw w.thrown("[Schedule.FIXED_RATE.intervalMS] must be > 0");if(t.initialDelayMS<0)throw w.thrown("[Schedule.FIXED_RATE.initialDelayMS] must be >= 0");break;case 3:e=t.minute;var s=t.second;if(null==e||e<0)throw w.thrown("[Schedule.DAILY.minute] must be between >= 0 and <= 59");if(null==s||s<0)throw w.thrown("[Schedule.DAILY.second] must be between >= 0 and <= 59");break;case 4:e=t.hour,s=t.minute;var i=t.second;if(null==e||e<0)throw w.thrown("[Schedule.DAILY.hour] must be between >= 0 and <= 23");if(null==s||s<0)throw w.thrown("[Schedule.DAILY.minute] must be between >= 0 and <= 59");if(null==i||i<0)throw w.thrown("[Schedule.DAILY.second] must be between >= 0 and <= 59");break;case 5:if(e=t.hour,s=t.minute,i=t.second,null==e||e<0)throw w.thrown("[Schedule.WEEKLY.hour] must be between >= 0 and <= 23");if(null==s||s<0)throw w.thrown("[Schedule.WEEKLY.minute] must be between >= 0 and <= 59");if(null==i||i<0)throw w.thrown("[Schedule.WEEKLY.second] must be between >= 0 and <= 59")}return t},$s.firstRunAt=function(t){switch((t=$s.assertValid(t))._hx_index){case 0:case 1:case 2:return Date.now()+t.initialDelayMS;case 3:var e=Date.now(),s=new Date(e),i=60*t.minute+t.second,n=60*s.getMinutes()+s.getSeconds();return e+1e3*(i-n)+(n>i?36e5:0);case 4:return e=Date.now(),s=new Date(e),e+1e3*((r=60*t.hour*60+60*t.minute+t.second)-(a=60*s.getHours()*60+60*s.getMinutes()+s.getSeconds()))+(a>r?864e5:0);case 5:e=Date.now(),s=new Date(e);var r=60*t.hour*60+60*t.minute+t.second,a=60*s.getHours()*60+60*s.getMinutes()+s.getSeconds(),o=t.day;return o==s.getDay()?e+1e3*(r-a)+(a>r?6048e5:0):s.getDate()<o?e+1e3*(r-a)+864e5*(o-s.getDate()):e+1e3*(r-a)+864e5*(7-(o-s.getDate()))}};var ti=function(t,e,s){Zs.call(this,t,e,s);var i=$s.firstRunAt(this.schedule)-Date.now()|0;i<0&&(i=0),Ds.delay(oi(this,this.run),i)};ti.__name__="hx.concurrent.executor._TimerExecutor.TaskFutureImpl",ti.__super__=Zs,ti.prototype=c(Zs.prototype,{run:function(){if(!this.isStopped){if(null==this._timer){var t=null;switch((s=this.schedule)._hx_index){case 2:(t=new Ds(s.intervalMS)).run=oi(this,this.run);break;case 3:(t=new Ds(36e5)).run=oi(this,this.run);break;case 4:(t=new Ds(864e5)).run=oi(this,this.run);break;case 5:(t=new Ds(6048e5)).run=oi(this,this.run)}this._timer=t}var e;try{var s;switch((s=this._task)._hx_index){case 0:e=ei.a(s.v());break;case 1:s.v(),e=null}}catch(s){e=ei.b(new Ws(w.caught(s)))}switch((s=this.schedule)._hx_index){case 0:this.isStopped=!0;break;case 1:this._timer=Ds.delay(oi(this,this.run),s.intervalMS)}this.complete(e,!0),this._executor.notifyResult(this.result)}},cancel:function(){var t=this._timer;null!=t&&t.stop(),Zs.prototype.cancel.call(this)},__class__:ti});var ei=a["hx.concurrent.internal._Either2._Either2"]={__ename__:!0,__constructs__:null,a:(e=function(t){return{_hx_index:0,v:t,__enum__:"hx.concurrent.internal._Either2._Either2",toString:r}},e._hx_name="a",e.__params__=["v"],e),b:(e=function(t){return{_hx_index:1,v:t,__enum__:"hx.concurrent.internal._Either2._Either2",toString:r}},e._hx_name="b",e.__params__=["v"],e)};ei.__constructs__=[ei.a,ei.b];var si=a["hx.concurrent.internal._Either3._Either3"]={__ename__:!0,__constructs__:null,a:(e=function(t){return{_hx_index:0,v:t,__enum__:"hx.concurrent.internal._Either3._Either3",toString:r}},e._hx_name="a",e.__params__=["v"],e),b:(e=function(t){return{_hx_index:1,v:t,__enum__:"hx.concurrent.internal._Either3._Either3",toString:r}},e._hx_name="b",e.__params__=["v"],e),c:(e=function(t){return{_hx_index:2,v:t,__enum__:"hx.concurrent.internal._Either3._Either3",toString:r}},e._hx_name="c",e.__params__=["v"],e)};si.__constructs__=[si.a,si.b,si.c];var ii=function(){};ii.__name__="hx.concurrent.thread.Threads",ii.get_current=function(){return"MainThread"},ii.get_isSupported=function(){return!1};var ni=function(){};function ri(t){return t instanceof Array?function(){return _.keyValueIter(t)}:"function"==typeof t.keyValueIterator?oi(t,t.keyValueIterator):t.keyValueIterator}function ai(t){return t instanceof Array?new Bs(t):t.iterator()}function oi(e,s){return null==s?null:(null==s.__id__&&(s.__id__=t.$haxeUID++),null==e.hx__closures__?e.hx__closures__={}:i=e.hx__closures__[s.__id__],null==i&&(i=s.bind(e),e.hx__closures__[s.__id__]=i),i);var i}ni.__name__="js.Boot",ni.getClass=function(t){if(null==t)return null;if(t instanceof Array)return Array;var e=t.__class__;if(null!=e)return e;var s=ni.__nativeClassName(t);return null!=s?ni.__resolveNativeClass(s):null},ni.__string_rec=function(t,e){if(null==t)return"null";if(e.length>=5)return"<...>";var s=typeof t;switch("function"==s&&(t.__name__||t.__ename__)&&(s="object"),s){case"function":return"<function>";case"object":if(t.__enum__){var i=a[t.__enum__].__constructs__[t._hx_index],n=i._hx_name;return i.__params__?(e+="\t",n+"("+function(s){for(var n=[],r=0,a=i.__params__;r<a.length;){var o=a[r];r+=1,n.push(ni.__string_rec(t[o],e))}return n}().join(",")+")"):n}if(t instanceof Array){var r="[";e+="\t";for(var o=0,h=t.length;o<h;){var c=o++;r+=(c>0?",":"")+ni.__string_rec(t[c],e)}return r+="]"}var u;try{u=t.toString}catch(o){return Cs.lastError=o,"???"}if(null!=u&&u!=Object.toString&&"function"==typeof u){var l=t.toString();if("[object Object]"!=l)return l}r="{\n",e+="\t";var _=null!=t.hasOwnProperty,d=null;for(d in t)_&&!t.hasOwnProperty(d)||"prototype"!=d&&"__class__"!=d&&"__super__"!=d&&"__interfaces__"!=d&&"__properties__"!=d&&(2!=r.length&&(r+=", \n"),r+=e+d+" : "+ni.__string_rec(t[d],e));return r+="\n"+(e=e.substring(1))+"}";case"string":return t;default:return String(t)}},ni.__interfLoop=function(t,e){for(;;){if(null==t)return!1;if(t==e)return!0;var s=t.__interfaces__;if(null!=s)for(var i=0,n=s.length;i<n;){var r=s[i++];if(r==e||ni.__interfLoop(r,e))return!0}t=t.__super__}},ni.__instanceof=function(t,e){if(null==e)return!1;switch(e){case Array:return t instanceof Array;case li:return"boolean"==typeof t;case ci:return null!=t;case ui:return"number"==typeof t;case hi:return"number"==typeof t&&(0|t)===t;case String:return"string"==typeof t;default:if(null==t)return!1;if("function"==typeof e){if(ni.__downcastCheck(t,e))return!0}else if("object"==typeof e&&ni.__isNativeObj(e)&&t instanceof e)return!0;return e==_i&&null!=t.__name__||e==di&&null!=t.__ename__||null!=t.__enum__&&a[t.__enum__]==e}},ni.__downcastCheck=function(t,e){return t instanceof e||!!e.__isInterface__&&ni.__interfLoop(ni.getClass(t),e)},ni.__cast=function(t,e){if(null==t||ni.__instanceof(t,e))return t;throw w.thrown("Cannot cast "+p.string(t)+" to "+p.string(e))},ni.__nativeClassName=function(t){var e=ni.__toStr.call(t).slice(8,-1);return"Object"==e||"Function"==e||"Math"==e||"JSON"==e?null:e},ni.__isNativeObj=function(t){return null!=ni.__nativeClassName(t)},ni.__resolveNativeClass=function(e){return t[e]},t.$haxeUID|=0,"undefined"!=typeof performance&&"function"==typeof performance.now&&(_.now=performance.now.bind(performance)),null==String.fromCodePoint&&(String.fromCodePoint=function(t){return t<65536?String.fromCharCode(t):String.fromCharCode(55232+(t>>10))+String.fromCharCode(56320+(1023&t))}),Object.defineProperty(String.prototype,"__class__",{value:String,enumerable:!1}),String.__name__="String",Array.__name__="Array",Date.prototype.__class__=Date,Date.__name__="Date";var hi={},ci={},ui=Number,li=Boolean,_i={},di={};ni.__toStr={}.toString;var mi,fi=!E.get_supported()||"http:"!=(null!=(mi=t.location)?mi.protocol:null)&&"https:"!=(null!=(mi=t.location)?mi.protocol:null)?null:y.fromString(t.location.protocol+"//"+t.location.hostname+(""!=t.location.port?":"+t.location.port:"")+"/"),pi="TLCP-2.4.0",gi=pi+".lightstreamer.com",vi="9.0.0-beta.6 build 20230622",Si="pcYgxn8m8 feOojyA1V661f4gpAeLD3dXoqoH6M992l87p",bi="javascript_client",Ei="";C.LIB_NAME=bi,C.LIB_VERSION=vi;var yi="Cannot subscribe to an active MPNSubscription",wi="No MPNDevice Registered",Ri="Specify property 'notificationFormat'";xt.EOL_LEN=xt.lengthOfBytes("\r\n");var Ti="The Subscription was initiated using a Field Schema: the field names are not available",Ii="The field position is out of bounds",xi="The field name is unknown";ce.Merge="MERGE",ce.Distinct="DISTINCT",ke._ids=new Pe(0),qe.NOW_ONCE=Fe.ONCE(0);var Ci=Be(),Di=Be();Ke.ZERO=0,ze.WS="WS",ze.WS_STREAMING="WS-STREAMING",ze.WS_POLLING="WS-POLLING",ze.HTTP="HTTP",ze.HTTP_STREAMING="HTTP-STREAMING",ze.HTTP_POLLING="HTTP-POLLING",ns.Merge="MERGE",ns.Distinct="DISTINCT",ns.Command="COMMAND",ns.Raw="RAW",_s.VARINT_RADIX=26,ps.TRACE=0,ps.DEBUG=10,ps.INFO=20,ps.WARN=30,ps.ERROR=40,ps.FATAL=50,ys.isSupported=!1,ws.lock=new ys,ws.logInstances=new ks,ws.emptyLogger=new Ss;var Li=ws.getLogger("lightstreamer.stream"),Mi=ws.getLogger("lightstreamer.protocol"),Ni=ws.getLogger("lightstreamer.internal"),Oi=ws.getLogger("lightstreamer.session"),Pi=ws.getLogger("lightstreamer.actions"),ki=ws.getLogger("lightstreamer.reachability"),Fi=ws.getLogger("lightstreamer.subscriptions"),qi=ws.getLogger("lightstreamer.messages");ws.getLogger("lightstreamer.cookies");var Ai=ws.getLogger("lightstreamer.mpn.device"),Bi=ws.getLogger("lightstreamer.mpn.subscriptions");Ws.INDENT="  ",$s.HOUR_IN_MS=36e5,$s.DAY_IN_MS=864e5,$s.WEEK_IN_MS=6048e5}("undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:void 0);var _=l.LSLightstreamerClient,d=l.LSSubscription,m=l.LSFirebaseMpnBuilder,f=l.LSMpnDevice,p=l.LSMpnSubscription,g=l.LSSafariMpnBuilder,v=l.LSConsoleLogLevel,S=l.LSConsoleLoggerProvider,b=function(t){this.delegate=t};b.prototype={setContentLength:function(t){this.delegate.setContentLength(t)},getContentLength:function(){return this.delegate.getContentLength()},setIdleTimeout:function(t){this.delegate.setIdleTimeout(t)},getIdleTimeout:function(){return this.delegate.getIdleTimeout()},setKeepaliveInterval:function(t){this.delegate.setKeepaliveInterval(t)},getKeepaliveInterval:function(){return this.delegate.getKeepaliveInterval()},setRequestedMaxBandwidth:function(t){this.delegate.setRequestedMaxBandwidth(t)},getRequestedMaxBandwidth:function(){return this.delegate.getRequestedMaxBandwidth()},getRealMaxBandwidth:function(){return this.delegate.getRealMaxBandwidth()},setPollingInterval:function(t){this.delegate.setPollingInterval(t)},getPollingInterval:function(){return this.delegate.getPollingInterval()},setReconnectTimeout:function(t){this.delegate.setReconnectTimeout(t)},getReconnectTimeout:function(){return this.delegate.getReconnectTimeout()},setStalledTimeout:function(t){this.delegate.setStalledTimeout(t)},getStalledTimeout:function(){return this.delegate.getStalledTimeout()},setRetryDelay:function(t){this.delegate.setRetryDelay(t)},getRetryDelay:function(){return this.delegate.getRetryDelay()},setFirstRetryMaxDelay:function(t){this.delegate.setFirstRetryMaxDelay(t)},getFirstRetryMaxDelay:function(){return this.delegate.getFirstRetryMaxDelay()},setSlowingEnabled:function(t){this.delegate.setSlowingEnabled(t)},isSlowingEnabled:function(){return this.delegate.isSlowingEnabled()},setForcedTransport:function(t){this.delegate.setForcedTransport(t)},getForcedTransport:function(){return this.delegate.getForcedTransport()},setServerInstanceAddressIgnored:function(t){this.delegate.setServerInstanceAddressIgnored(t)},isServerInstanceAddressIgnored:function(){return this.delegate.isServerInstanceAddressIgnored()},setCookieHandlingRequired:function(t){this.delegate.setCookieHandlingRequired(t)},isCookieHandlingRequired:function(){return this.delegate.isCookieHandlingRequired()},setReverseHeartbeatInterval:function(t){this.delegate.setReverseHeartbeatInterval(t)},getReverseHeartbeatInterval:function(){return this.delegate.getReverseHeartbeatInterval()},setHttpExtraHeaders:function(t){this.delegate.setHttpExtraHeaders(t)},getHttpExtraHeaders:function(){return this.delegate.getHttpExtraHeaders()},setHttpExtraHeadersOnSessionCreationOnly:function(t){this.delegate.setHttpExtraHeadersOnSessionCreationOnly(t)},isHttpExtraHeadersOnSessionCreationOnly:function(){return this.delegate.isHttpExtraHeadersOnSessionCreationOnly()},setSessionRecoveryTimeout:function(t){this.delegate.setSessionRecoveryTimeout(t)},getSessionRecoveryTimeout:function(){return this.delegate.getSessionRecoveryTimeout()}};var E=function(t){this.delegate=t};E.prototype={setServerAddress:function(t){this.delegate.setServerAddress(t)},getServerAddress:function(){return this.delegate.getServerAddress()},setAdapterSet:function(t){this.delegate.setAdapterSet(t)},getAdapterSet:function(){return this.delegate.getAdapterSet()},setUser:function(t){this.delegate.setUser(t)},getUser:function(){return this.delegate.getUser()},setPassword:function(t){this.delegate.setPassword(t)},getServerInstanceAddress:function(){return this.delegate.getServerInstanceAddress()},getServerSocketName:function(){return this.delegate.getServerSocketName()},getSessionId:function(){return this.delegate.getSessionId()},getClientIp:function(){return this.delegate.getClientIp()}};var y=function(t,e){this.delegate=new _(t,e),this.connectionOptions=new b(this.delegate.connectionOptions),this.connectionDetails=new E(this.delegate.connectionDetails)};y.setLoggerProvider=function(t){_.setLoggerProvider(t)},y.LIB_NAME=_.LIB_NAME,y.LIB_VERSION=_.LIB_VERSION,y.prototype={connect:function(){this.delegate.connect()},disconnect:function(){this.delegate.disconnect()},getStatus:function(){return this.delegate.getStatus()},sendMessage:function(t,e,s,i,n){this.delegate.sendMessage(t,e,s,i,n)},getSubscriptions:function(){return this.delegate.getSubscriptionWrappers()},subscribe:function(t){this.delegate.subscribe(t.delegate)},unsubscribe:function(t){this.delegate.unsubscribe(t.delegate)},addListener:function(t){this.delegate.addListener(t)},removeListener:function(t){this.delegate.removeListener(t)},getListeners:function(){return this.delegate.getListeners()},registerForMpn:function(t){this.delegate.registerForMpn(t.delegate)},subscribeMpn:function(t,e){this.delegate.subscribeMpn(t.delegate,e)},unsubscribeMpn:function(t){this.delegate.unsubscribeMpn(t.delegate)},unsubscribeMpnSubscriptions:function(t){this.delegate.unsubscribeMpnSubscriptions(t)},getMpnSubscriptions:function(t){return this.delegate.getMpnSubscriptionWrappers(t)},findMpnSubscription:function(t){return this.delegate.findMpnSubscriptionWrapper(t)}};var w=function(t,e,s){this.delegate=new d(t,e,s,this)};w.prototype={isActive:function(){return this.delegate.isActive()},isSubscribed:function(){return this.delegate.isSubscribed()},setItems:function(t){this.delegate.setItems(t)},getItems:function(){return this.delegate.getItems()},setItemGroup:function(t){this.delegate.setItemGroup(t)},getItemGroup:function(){return this.delegate.getItemGroup()},setFields:function(t){this.delegate.setFields(t)},getFields:function(){return this.delegate.getFields()},setFieldSchema:function(t){this.delegate.setFieldSchema(t)},getFieldSchema:function(){return this.delegate.getFieldSchema()},getMode:function(){return this.delegate.getMode()},setDataAdapter:function(t){this.delegate.setDataAdapter(t)},getDataAdapter:function(){return this.delegate.getDataAdapter()},setSelector:function(t){this.delegate.setSelector(t)},getSelector:function(){return this.delegate.getSelector()},setRequestedMaxFrequency:function(t){this.delegate.setRequestedMaxFrequency(t)},getRequestedMaxFrequency:function(){return this.delegate.getRequestedMaxFrequency()},setRequestedBufferSize:function(t){this.delegate.setRequestedBufferSize(t)},getRequestedBufferSize:function(){return this.delegate.getRequestedBufferSize()},setRequestedSnapshot:function(t){this.delegate.setRequestedSnapshot(t)},getRequestedSnapshot:function(){return this.delegate.getRequestedSnapshot()},setCommandSecondLevelFields:function(t){this.delegate.setCommandSecondLevelFields(t)},getCommandSecondLevelFields:function(){return this.delegate.getCommandSecondLevelFields()},setCommandSecondLevelFieldSchema:function(t){this.delegate.setCommandSecondLevelFieldSchema(t)},getCommandSecondLevelFieldSchema:function(){return this.delegate.getCommandSecondLevelFieldSchema()},setCommandSecondLevelDataAdapter:function(t){this.delegate.setCommandSecondLevelDataAdapter(t)},getCommandSecondLevelDataAdapter:function(){return this.delegate.getCommandSecondLevelDataAdapter()},getValue:function(t,e){return this.delegate.getValue(t,e)},getCommandValue:function(t,e,s){return this.delegate.getCommandValue(t,e,s)},getKeyPosition:function(){return this.delegate.getKeyPosition()},getCommandPosition:function(){return this.delegate.getCommandPosition()},addListener:function(t){this.delegate.addListener(t)},removeListener:function(t){this.delegate.removeListener(t)},getListeners:function(){return this.delegate.getListeners()}};var R=function(){};R.TRACE=v.TRACE,R.DEBUG=v.DEBUG,R.INFO=v.INFO,R.WARN=v.WARN,R.ERROR=v.ERROR,R.FATAL=v.FATAL;var T=function(t){this.delegate=new S(t)};T.prototype.getLogger=function(t){return this.delegate.getLogger(t)};var I=function(t,e,s){this.delegate=new f(t,e,s)};I.prototype={addListener:function(t){this.delegate.addListener(t)},removeListener:function(t){this.delegate.removeListener(t)},getListeners:function(){return this.delegate.getListeners()},getPlatform:function(){return this.delegate.getPlatform()},getApplicationId:function(){return this.delegate.getApplicationId()},getDeviceToken:function(){return this.delegate.getDeviceToken()},getPreviousDeviceToken:function(){return this.delegate.getPreviousDeviceToken()},isRegistered:function(){return this.delegate.isRegistered()},isSuspended:function(){return this.delegate.isSuspended()},getStatus:function(){return this.delegate.getStatus()},getStatusTimestamp:function(){return this.delegate.getStatusTimestamp()},getDeviceId:function(){return this.delegate.getDeviceId()}};var x=function(){var t=arguments[0],e=arguments[1],s=arguments[2];this.delegate=new p(t,e,s,this)};x.prototype={addListener:function(t){this.delegate.addListener(t)},removeListener:function(t){this.delegate.removeListener(t)},getListeners:function(){return this.delegate.getListeners()},getNotificationFormat:function(){return this.delegate.getNotificationFormat()},getActualNotificationFormat:function(){return this.delegate.getActualNotificationFormat()},setNotificationFormat:function(t){this.delegate.setNotificationFormat(t)},getTriggerExpression:function(){return this.delegate.getTriggerExpression()},getActualTriggerExpression:function(){return this.delegate.getActualTriggerExpression()},setTriggerExpression:function(t){this.delegate.setTriggerExpression(t)},isActive:function(){return this.delegate.isActive()},isSubscribed:function(){return this.delegate.isSubscribed()},isTriggered:function(){return this.delegate.isTriggered()},getStatus:function(){return this.delegate.getStatus()},getStatusTimestamp:function(){return this.delegate.getStatusTimestamp()},setItems:function(t){this.delegate.setItems(t)},getItems:function(){return this.delegate.getItems()},setItemGroup:function(t){this.delegate.setItemGroup(t)},getItemGroup:function(){return this.delegate.getItemGroup()},setFields:function(t){this.delegate.setFields(t)},getFields:function(){return this.delegate.getFields()},setFieldSchema:function(t){this.delegate.setFieldSchema(t)},getFieldSchema:function(){return this.delegate.getFieldSchema()},setDataAdapter:function(t){this.delegate.setDataAdapter(t)},getDataAdapter:function(){return this.delegate.getDataAdapter()},setRequestedBufferSize:function(t){this.delegate.setRequestedBufferSize(t)},getRequestedBufferSize:function(){return this.delegate.getRequestedBufferSize()},setRequestedMaxFrequency:function(t){this.delegate.setRequestedMaxFrequency(t)},getRequestedMaxFrequency:function(){return this.delegate.getRequestedMaxFrequency()},getMode:function(){return this.delegate.getMode()},getSubscriptionId:function(){return this.delegate.getSubscriptionId()}};var C=function(t){this.delegate=new g(t)};C.prototype={build:function(){return this.delegate.build()},getTitle:function(){return this.delegate.getTitle()},setTitle:function(t){return this.delegate.setTitle(t),this},getBody:function(){return this.delegate.getBody()},setBody:function(t){return this.delegate.setBody(t),this},getAction:function(){return this.delegate.getAction()},setAction:function(t){return this.delegate.setAction(t),this},getUrlArguments:function(){return this.delegate.getUrlArguments()},setUrlArguments:function(t){return this.delegate.setUrlArguments(t),this}};var D=function(t){this.delegate=new m(t)};return D.prototype={build:function(){return this.delegate.build()},getHeaders:function(){return this.delegate.getHeaders()},setHeaders:function(t){return this.delegate.setHeaders(t),this},getTitle:function(){return this.delegate.getTitle()},setTitle:function(t){return this.delegate.setTitle(t),this},getBody:function(){return this.delegate.getBody()},setBody:function(t){return this.delegate.setBody(t),this},getIcon:function(){return this.delegate.getIcon()},setIcon:function(t){return this.delegate.setIcon(t),this},getData:function(){return this.delegate.getData()},setData:function(t){return this.delegate.setData(t),this}},t.ClientListener=r,t.ClientMessageListener=a,t.ConsoleLogLevel=R,t.ConsoleLoggerProvider=T,t.FirebaseMpnBuilder=D,t.ItemUpdate=o,t.LightstreamerClient=y,t.Logger=i,t.LoggerProvider=n,t.MpnDevice=I,t.MpnDeviceListener=c,t.MpnSubscription=x,t.MpnSubscriptionListener=u,t.SafariMpnBuilder=C,t.Subscription=w,t.SubscriptionListener=h,Object.defineProperty(t,"__esModule",{value:!0}),t}({}),s);if("function"==typeof define&&define.amd)define("lightstreamer",["module"],(function(t){var e=t.config().ns?t.config().ns+"/":"";define(e+"LightstreamerClient",(function(){return i.LightstreamerClient})),define(e+"Subscription",(function(){return i.Subscription})),define(e+"ConsoleLogLevel",(function(){return i.ConsoleLogLevel})),define(e+"ConsoleLoggerProvider",(function(){return i.ConsoleLoggerProvider})),define(e+"MpnDevice",(function(){return i.MpnDevice})),define(e+"MpnSubscription",(function(){return i.MpnSubscription})),define(e+"SafariMpnBuilder",(function(){return i.SafariMpnBuilder})),define(e+"FirebaseMpnBuilder",(function(){return i.FirebaseMpnBuilder})),define(e+"Logger",(function(){return i.Logger})),define(e+"LoggerProvider",(function(){return i.LoggerProvider})),define(e+"ClientListener",(function(){return i.ClientListener})),define(e+"ClientMessageListener",(function(){return i.ClientMessageListener})),define(e+"ItemUpdate",(function(){return i.ItemUpdate})),define(e+"SubscriptionListener",(function(){return i.SubscriptionListener})),define(e+"MpnDeviceListener",(function(){return i.MpnDeviceListener})),define(e+"MpnSubscriptionListener",(function(){return i.MpnSubscriptionListener}))})),require(["lightstreamer"]);else{var n=function(t,e){if(!t)return e;for(var s=t.split("."),i=e||window,n=0;n<s.length;n++){var r=s[n],a=i[r];a&&"object"==typeof a||(a=i[r]={}),i=a}return i}(function(){if("undefined"==typeof window||void 0===window.document)return null;for(var t=window.document.getElementsByTagName("script"),e=0,s=t.length;e<s;e++)if("data-lightstreamer-ns"in t[e].attributes)return t[e].attributes["data-lightstreamer-ns"].value;return null}(),t);n.LightstreamerClient=i.LightstreamerClient,n.Subscription=i.Subscription,n.ConsoleLogLevel=i.ConsoleLogLevel,n.ConsoleLoggerProvider=i.ConsoleLoggerProvider,n.MpnDevice=i.MpnDevice,n.MpnSubscription=i.MpnSubscription,n.SafariMpnBuilder=i.SafariMpnBuilder,n.FirebaseMpnBuilder=i.FirebaseMpnBuilder,n.Logger=i.Logger,n.LoggerProvider=i.LoggerProvider,n.ClientListener=i.ClientListener,n.ClientMessageListener=i.ClientMessageListener,n.ItemUpdate=i.ItemUpdate,n.SubscriptionListener=i.SubscriptionListener,n.MpnDeviceListener=i.MpnDeviceListener,n.MpnSubscriptionListener=i.MpnSubscriptionListener}}("undefined"!=typeof self?self:this);
//# sourceMappingURL=lightstreamer-mpn.min.js.map
